/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* DAG Instruction Selector for the WebAssembly target                        *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

// *** NOTE: This file is #included into the middle of the target
// *** instruction selector class.  These functions are really methods.

// If GET_DAGISEL_DECL is #defined with any value, only function
// declarations will be included when this file is included.
// If GET_DAGISEL_BODY is #defined, its value should be the name of
// the instruction selector class. Function bodies will be emitted
// and each function's name will be qualified with the name of the
// class.
//
// When neither of the GET_DAGISEL* macros is defined, the functions
// are emitted inline.

#if defined(GET_DAGISEL_DECL) && defined(GET_DAGISEL_BODY)
#error GET_DAGISEL_DECL and GET_DAGISEL_BODY cannot be both defined, undef both for inline definitions
#endif

#ifdef GET_DAGISEL_BODY
#define LOCAL_DAGISEL_STRINGIZE(X) LOCAL_DAGISEL_STRINGIZE_(X)
#define LOCAL_DAGISEL_STRINGIZE_(X) #X
static_assert(sizeof(LOCAL_DAGISEL_STRINGIZE(GET_DAGISEL_BODY)) > 1,
   "GET_DAGISEL_BODY is empty: it should be defined with the class name");
#undef LOCAL_DAGISEL_STRINGIZE_
#undef LOCAL_DAGISEL_STRINGIZE
#endif

#if !defined(GET_DAGISEL_DECL) && !defined(GET_DAGISEL_BODY)
#define DAGISEL_INLINE 1
#else
#define DAGISEL_INLINE 0
#endif

#if !DAGISEL_INLINE
#define DAGISEL_CLASS_COLONCOLON GET_DAGISEL_BODY ::
#else
#define DAGISEL_CLASS_COLONCOLON
#endif

#ifdef GET_DAGISEL_DECL
void SelectCode(SDNode *N);
#endif
#if defined(GET_DAGISEL_BODY) || DAGISEL_INLINE
void DAGISEL_CLASS_COLONCOLON SelectCode(SDNode *N)
{
  // Some target values are emitted as 2 bytes, TARGET_VAL handles
  // this.
  #define TARGET_VAL(X) X & 255, unsigned(X) >> 8
  static const unsigned char MatcherTable[] = {
/*     0*/ OPC_SwitchOpcode /*116 cases */, 44|128,9/*1196*/, TARGET_VAL(ISD::ZERO_EXTEND),// ->1201
/*     5*/  OPC_Scope, 32|128,9/*1184*/, /*->1192*/ // 2 children in Scope
/*     8*/   OPC_MoveChild0,
/*     9*/   OPC_SwitchOpcode /*9 cases */, 124, TARGET_VAL(ISD::AssertZext),// ->137
/*    13*/    OPC_MoveChild0,
/*    14*/    OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_CMP_SWAP),
/*    17*/    OPC_RecordMemRef,
/*    18*/    OPC_RecordNode, // #0 = 'atomic_cmp_swap' chained node
/*    19*/    OPC_CheckFoldableChainNode,
/*    20*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*    21*/    OPC_Scope, 56, /*->79*/ // 2 children in Scope
/*    23*/     OPC_CheckChild1TypeI32,
/*    24*/     OPC_MoveChild2,
/*    25*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*    28*/     OPC_RecordChild0, // #2 = $exp
/*    29*/     OPC_MoveSibling3,
/*    30*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*    33*/     OPC_RecordChild0, // #3 = $new
/*    34*/     OPC_MoveParent,
/*    35*/     OPC_Scope, 20, /*->57*/ // 2 children in Scope
/*    37*/      OPC_CheckPredicate1,  // Predicate_atomic_cmp_swap_i8
/*    38*/      OPC_MoveParent,
/*    39*/      OPC_MoveParent,
/*    40*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*    41*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*    43*/      OPC_EmitMergeInputChains1_0,
/*    44*/      OPC_EmitInteger32, 0, 
/*    46*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 5/*#Ops*/, 6, 4, 5, 2, 3, 
                // Src: (zext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_i8>>)) - Complexity = 25
                // Dst: (ATOMIC_RMW8_U_CMPXCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*    57*/     /*Scope*/ 20, /*->78*/
/*    58*/      OPC_CheckPredicate2,  // Predicate_atomic_cmp_swap_i16
/*    59*/      OPC_MoveParent,
/*    60*/      OPC_MoveParent,
/*    61*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*    62*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*    64*/      OPC_EmitMergeInputChains1_0,
/*    65*/      OPC_EmitInteger32, 0, 
/*    67*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 5/*#Ops*/, 6, 4, 5, 2, 3, 
                // Src: (zext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_i16>>)) - Complexity = 25
                // Dst: (ATOMIC_RMW16_U_CMPXCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*    78*/     0, /*End of Scope*/
/*    79*/    /*Scope*/ 56, /*->136*/
/*    80*/     OPC_CheckChild1TypeI64,
/*    81*/     OPC_MoveChild2,
/*    82*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*    85*/     OPC_RecordChild0, // #2 = $exp
/*    86*/     OPC_MoveSibling3,
/*    87*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*    90*/     OPC_RecordChild0, // #3 = $new
/*    91*/     OPC_MoveParent,
/*    92*/     OPC_Scope, 20, /*->114*/ // 2 children in Scope
/*    94*/      OPC_CheckPredicate1,  // Predicate_atomic_cmp_swap_i8
/*    95*/      OPC_MoveParent,
/*    96*/      OPC_MoveParent,
/*    97*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*    98*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*   100*/      OPC_EmitMergeInputChains1_0,
/*   101*/      OPC_EmitInteger32, 0, 
/*   103*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 5/*#Ops*/, 6, 4, 5, 2, 3, 
                // Src: (zext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_i8>>)) - Complexity = 25
                // Dst: (ATOMIC_RMW8_U_CMPXCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*   114*/     /*Scope*/ 20, /*->135*/
/*   115*/      OPC_CheckPredicate2,  // Predicate_atomic_cmp_swap_i16
/*   116*/      OPC_MoveParent,
/*   117*/      OPC_MoveParent,
/*   118*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   119*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*   121*/      OPC_EmitMergeInputChains1_0,
/*   122*/      OPC_EmitInteger32, 0, 
/*   124*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 5/*#Ops*/, 6, 4, 5, 2, 3, 
                // Src: (zext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_i16>>)) - Complexity = 25
                // Dst: (ATOMIC_RMW16_U_CMPXCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*   135*/     0, /*End of Scope*/
/*   136*/    0, /*End of Scope*/
/*   137*/   /*SwitchOpcode*/ 69, TARGET_VAL(ISD::ATOMIC_CMP_SWAP),// ->209
/*   140*/    OPC_RecordMemRef,
/*   141*/    OPC_RecordNode, // #0 = 'atomic_cmp_swap' chained node
/*   142*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*   143*/    OPC_Scope, 31, /*->176*/ // 2 children in Scope
/*   145*/     OPC_CheckChild1TypeI32,
/*   146*/     OPC_MoveChild2,
/*   147*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   150*/     OPC_RecordChild0, // #2 = $exp
/*   151*/     OPC_MoveSibling3,
/*   152*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   155*/     OPC_RecordChild0, // #3 = $new
/*   156*/     OPC_MoveParent,
/*   157*/     OPC_CheckPredicate3,  // Predicate_atomic_cmp_swap_i32
/*   158*/     OPC_MoveParent,
/*   159*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   160*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*   162*/     OPC_EmitMergeInputChains1_0,
/*   163*/     OPC_EmitInteger32, 0, 
/*   165*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i64, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (zext:{ *:[i64] } (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_i32>>) - Complexity = 22
               // Dst: (ATOMIC_RMW32_U_CMPXCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*   176*/    /*Scope*/ 31, /*->208*/
/*   177*/     OPC_CheckChild1TypeI64,
/*   178*/     OPC_MoveChild2,
/*   179*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   182*/     OPC_RecordChild0, // #2 = $exp
/*   183*/     OPC_MoveSibling3,
/*   184*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   187*/     OPC_RecordChild0, // #3 = $new
/*   188*/     OPC_MoveParent,
/*   189*/     OPC_CheckPredicate3,  // Predicate_atomic_cmp_swap_i32
/*   190*/     OPC_MoveParent,
/*   191*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   192*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*   194*/     OPC_EmitMergeInputChains1_0,
/*   195*/     OPC_EmitInteger32, 0, 
/*   197*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i64, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (zext:{ *:[i64] } (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_i32>>) - Complexity = 22
               // Dst: (ATOMIC_RMW32_U_CMPXCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*   208*/    0, /*End of Scope*/
/*   209*/   /*SwitchOpcode*/ 11|128,1/*139*/, TARGET_VAL(ISD::ATOMIC_LOAD_ADD),// ->352
/*   213*/    OPC_RecordMemRef,
/*   214*/    OPC_RecordNode, // #0 = 'atomic_load_add' chained node
/*   215*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*   216*/    OPC_Scope, 66, /*->284*/ // 2 children in Scope
/*   218*/     OPC_CheckChild1TypeI32,
/*   219*/     OPC_MoveChild2,
/*   220*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   223*/     OPC_RecordChild0, // #2 = $val
/*   224*/     OPC_MoveParent,
/*   225*/     OPC_Scope, 18, /*->245*/ // 3 children in Scope
/*   227*/      OPC_CheckPredicate1,  // Predicate_atomic_load_add_i8
/*   228*/      OPC_MoveParent,
/*   229*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   230*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   232*/      OPC_EmitMergeInputChains1_0,
/*   233*/      OPC_EmitInteger32, 0, 
/*   235*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_ADD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   245*/     /*Scope*/ 18, /*->264*/
/*   246*/      OPC_CheckPredicate2,  // Predicate_atomic_load_add_i16
/*   247*/      OPC_MoveParent,
/*   248*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   249*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   251*/      OPC_EmitMergeInputChains1_0,
/*   252*/      OPC_EmitInteger32, 0, 
/*   254*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_ADD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   264*/     /*Scope*/ 18, /*->283*/
/*   265*/      OPC_CheckPredicate3,  // Predicate_atomic_load_add_i32
/*   266*/      OPC_MoveParent,
/*   267*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   268*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   270*/      OPC_EmitMergeInputChains1_0,
/*   271*/      OPC_EmitInteger32, 0, 
/*   273*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_i32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_ADD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   283*/     0, /*End of Scope*/
/*   284*/    /*Scope*/ 66, /*->351*/
/*   285*/     OPC_CheckChild1TypeI64,
/*   286*/     OPC_MoveChild2,
/*   287*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   290*/     OPC_RecordChild0, // #2 = $val
/*   291*/     OPC_MoveParent,
/*   292*/     OPC_Scope, 18, /*->312*/ // 3 children in Scope
/*   294*/      OPC_CheckPredicate1,  // Predicate_atomic_load_add_i8
/*   295*/      OPC_MoveParent,
/*   296*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   297*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   299*/      OPC_EmitMergeInputChains1_0,
/*   300*/      OPC_EmitInteger32, 0, 
/*   302*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_ADD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   312*/     /*Scope*/ 18, /*->331*/
/*   313*/      OPC_CheckPredicate2,  // Predicate_atomic_load_add_i16
/*   314*/      OPC_MoveParent,
/*   315*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   316*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   318*/      OPC_EmitMergeInputChains1_0,
/*   319*/      OPC_EmitInteger32, 0, 
/*   321*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_ADD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   331*/     /*Scope*/ 18, /*->350*/
/*   332*/      OPC_CheckPredicate3,  // Predicate_atomic_load_add_i32
/*   333*/      OPC_MoveParent,
/*   334*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   335*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   337*/      OPC_EmitMergeInputChains1_0,
/*   338*/      OPC_EmitInteger32, 0, 
/*   340*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_i32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_ADD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   350*/     0, /*End of Scope*/
/*   351*/    0, /*End of Scope*/
/*   352*/   /*SwitchOpcode*/ 11|128,1/*139*/, TARGET_VAL(ISD::ATOMIC_LOAD_SUB),// ->495
/*   356*/    OPC_RecordMemRef,
/*   357*/    OPC_RecordNode, // #0 = 'atomic_load_sub' chained node
/*   358*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*   359*/    OPC_Scope, 66, /*->427*/ // 2 children in Scope
/*   361*/     OPC_CheckChild1TypeI32,
/*   362*/     OPC_MoveChild2,
/*   363*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   366*/     OPC_RecordChild0, // #2 = $val
/*   367*/     OPC_MoveParent,
/*   368*/     OPC_Scope, 18, /*->388*/ // 3 children in Scope
/*   370*/      OPC_CheckPredicate1,  // Predicate_atomic_load_sub_i8
/*   371*/      OPC_MoveParent,
/*   372*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   373*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   375*/      OPC_EmitMergeInputChains1_0,
/*   376*/      OPC_EmitInteger32, 0, 
/*   378*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_SUB_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   388*/     /*Scope*/ 18, /*->407*/
/*   389*/      OPC_CheckPredicate2,  // Predicate_atomic_load_sub_i16
/*   390*/      OPC_MoveParent,
/*   391*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   392*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   394*/      OPC_EmitMergeInputChains1_0,
/*   395*/      OPC_EmitInteger32, 0, 
/*   397*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_SUB_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   407*/     /*Scope*/ 18, /*->426*/
/*   408*/      OPC_CheckPredicate3,  // Predicate_atomic_load_sub_i32
/*   409*/      OPC_MoveParent,
/*   410*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   411*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   413*/      OPC_EmitMergeInputChains1_0,
/*   414*/      OPC_EmitInteger32, 0, 
/*   416*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_i32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_SUB_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   426*/     0, /*End of Scope*/
/*   427*/    /*Scope*/ 66, /*->494*/
/*   428*/     OPC_CheckChild1TypeI64,
/*   429*/     OPC_MoveChild2,
/*   430*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   433*/     OPC_RecordChild0, // #2 = $val
/*   434*/     OPC_MoveParent,
/*   435*/     OPC_Scope, 18, /*->455*/ // 3 children in Scope
/*   437*/      OPC_CheckPredicate1,  // Predicate_atomic_load_sub_i8
/*   438*/      OPC_MoveParent,
/*   439*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   440*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   442*/      OPC_EmitMergeInputChains1_0,
/*   443*/      OPC_EmitInteger32, 0, 
/*   445*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_SUB_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   455*/     /*Scope*/ 18, /*->474*/
/*   456*/      OPC_CheckPredicate2,  // Predicate_atomic_load_sub_i16
/*   457*/      OPC_MoveParent,
/*   458*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   459*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   461*/      OPC_EmitMergeInputChains1_0,
/*   462*/      OPC_EmitInteger32, 0, 
/*   464*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_SUB_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   474*/     /*Scope*/ 18, /*->493*/
/*   475*/      OPC_CheckPredicate3,  // Predicate_atomic_load_sub_i32
/*   476*/      OPC_MoveParent,
/*   477*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   478*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   480*/      OPC_EmitMergeInputChains1_0,
/*   481*/      OPC_EmitInteger32, 0, 
/*   483*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_i32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_SUB_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   493*/     0, /*End of Scope*/
/*   494*/    0, /*End of Scope*/
/*   495*/   /*SwitchOpcode*/ 11|128,1/*139*/, TARGET_VAL(ISD::ATOMIC_LOAD_AND),// ->638
/*   499*/    OPC_RecordMemRef,
/*   500*/    OPC_RecordNode, // #0 = 'atomic_load_and' chained node
/*   501*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*   502*/    OPC_Scope, 66, /*->570*/ // 2 children in Scope
/*   504*/     OPC_CheckChild1TypeI32,
/*   505*/     OPC_MoveChild2,
/*   506*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   509*/     OPC_RecordChild0, // #2 = $val
/*   510*/     OPC_MoveParent,
/*   511*/     OPC_Scope, 18, /*->531*/ // 3 children in Scope
/*   513*/      OPC_CheckPredicate1,  // Predicate_atomic_load_and_i8
/*   514*/      OPC_MoveParent,
/*   515*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   516*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   518*/      OPC_EmitMergeInputChains1_0,
/*   519*/      OPC_EmitInteger32, 0, 
/*   521*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_AND_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   531*/     /*Scope*/ 18, /*->550*/
/*   532*/      OPC_CheckPredicate2,  // Predicate_atomic_load_and_i16
/*   533*/      OPC_MoveParent,
/*   534*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   535*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   537*/      OPC_EmitMergeInputChains1_0,
/*   538*/      OPC_EmitInteger32, 0, 
/*   540*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_AND_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   550*/     /*Scope*/ 18, /*->569*/
/*   551*/      OPC_CheckPredicate3,  // Predicate_atomic_load_and_i32
/*   552*/      OPC_MoveParent,
/*   553*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   554*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   556*/      OPC_EmitMergeInputChains1_0,
/*   557*/      OPC_EmitInteger32, 0, 
/*   559*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_i32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_AND_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   569*/     0, /*End of Scope*/
/*   570*/    /*Scope*/ 66, /*->637*/
/*   571*/     OPC_CheckChild1TypeI64,
/*   572*/     OPC_MoveChild2,
/*   573*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   576*/     OPC_RecordChild0, // #2 = $val
/*   577*/     OPC_MoveParent,
/*   578*/     OPC_Scope, 18, /*->598*/ // 3 children in Scope
/*   580*/      OPC_CheckPredicate1,  // Predicate_atomic_load_and_i8
/*   581*/      OPC_MoveParent,
/*   582*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   583*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   585*/      OPC_EmitMergeInputChains1_0,
/*   586*/      OPC_EmitInteger32, 0, 
/*   588*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_AND_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   598*/     /*Scope*/ 18, /*->617*/
/*   599*/      OPC_CheckPredicate2,  // Predicate_atomic_load_and_i16
/*   600*/      OPC_MoveParent,
/*   601*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   602*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   604*/      OPC_EmitMergeInputChains1_0,
/*   605*/      OPC_EmitInteger32, 0, 
/*   607*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_AND_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   617*/     /*Scope*/ 18, /*->636*/
/*   618*/      OPC_CheckPredicate3,  // Predicate_atomic_load_and_i32
/*   619*/      OPC_MoveParent,
/*   620*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   621*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   623*/      OPC_EmitMergeInputChains1_0,
/*   624*/      OPC_EmitInteger32, 0, 
/*   626*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_i32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_AND_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   636*/     0, /*End of Scope*/
/*   637*/    0, /*End of Scope*/
/*   638*/   /*SwitchOpcode*/ 11|128,1/*139*/, TARGET_VAL(ISD::ATOMIC_LOAD_OR),// ->781
/*   642*/    OPC_RecordMemRef,
/*   643*/    OPC_RecordNode, // #0 = 'atomic_load_or' chained node
/*   644*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*   645*/    OPC_Scope, 66, /*->713*/ // 2 children in Scope
/*   647*/     OPC_CheckChild1TypeI32,
/*   648*/     OPC_MoveChild2,
/*   649*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   652*/     OPC_RecordChild0, // #2 = $val
/*   653*/     OPC_MoveParent,
/*   654*/     OPC_Scope, 18, /*->674*/ // 3 children in Scope
/*   656*/      OPC_CheckPredicate1,  // Predicate_atomic_load_or_i8
/*   657*/      OPC_MoveParent,
/*   658*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   659*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   661*/      OPC_EmitMergeInputChains1_0,
/*   662*/      OPC_EmitInteger32, 0, 
/*   664*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_OR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   674*/     /*Scope*/ 18, /*->693*/
/*   675*/      OPC_CheckPredicate2,  // Predicate_atomic_load_or_i16
/*   676*/      OPC_MoveParent,
/*   677*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   678*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   680*/      OPC_EmitMergeInputChains1_0,
/*   681*/      OPC_EmitInteger32, 0, 
/*   683*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_OR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   693*/     /*Scope*/ 18, /*->712*/
/*   694*/      OPC_CheckPredicate3,  // Predicate_atomic_load_or_i32
/*   695*/      OPC_MoveParent,
/*   696*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   697*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   699*/      OPC_EmitMergeInputChains1_0,
/*   700*/      OPC_EmitInteger32, 0, 
/*   702*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_i32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_OR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   712*/     0, /*End of Scope*/
/*   713*/    /*Scope*/ 66, /*->780*/
/*   714*/     OPC_CheckChild1TypeI64,
/*   715*/     OPC_MoveChild2,
/*   716*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   719*/     OPC_RecordChild0, // #2 = $val
/*   720*/     OPC_MoveParent,
/*   721*/     OPC_Scope, 18, /*->741*/ // 3 children in Scope
/*   723*/      OPC_CheckPredicate1,  // Predicate_atomic_load_or_i8
/*   724*/      OPC_MoveParent,
/*   725*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   726*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   728*/      OPC_EmitMergeInputChains1_0,
/*   729*/      OPC_EmitInteger32, 0, 
/*   731*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_OR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   741*/     /*Scope*/ 18, /*->760*/
/*   742*/      OPC_CheckPredicate2,  // Predicate_atomic_load_or_i16
/*   743*/      OPC_MoveParent,
/*   744*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   745*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   747*/      OPC_EmitMergeInputChains1_0,
/*   748*/      OPC_EmitInteger32, 0, 
/*   750*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_OR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   760*/     /*Scope*/ 18, /*->779*/
/*   761*/      OPC_CheckPredicate3,  // Predicate_atomic_load_or_i32
/*   762*/      OPC_MoveParent,
/*   763*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   764*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   766*/      OPC_EmitMergeInputChains1_0,
/*   767*/      OPC_EmitInteger32, 0, 
/*   769*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_i32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_OR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   779*/     0, /*End of Scope*/
/*   780*/    0, /*End of Scope*/
/*   781*/   /*SwitchOpcode*/ 11|128,1/*139*/, TARGET_VAL(ISD::ATOMIC_LOAD_XOR),// ->924
/*   785*/    OPC_RecordMemRef,
/*   786*/    OPC_RecordNode, // #0 = 'atomic_load_xor' chained node
/*   787*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*   788*/    OPC_Scope, 66, /*->856*/ // 2 children in Scope
/*   790*/     OPC_CheckChild1TypeI32,
/*   791*/     OPC_MoveChild2,
/*   792*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   795*/     OPC_RecordChild0, // #2 = $val
/*   796*/     OPC_MoveParent,
/*   797*/     OPC_Scope, 18, /*->817*/ // 3 children in Scope
/*   799*/      OPC_CheckPredicate1,  // Predicate_atomic_load_xor_i8
/*   800*/      OPC_MoveParent,
/*   801*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   802*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   804*/      OPC_EmitMergeInputChains1_0,
/*   805*/      OPC_EmitInteger32, 0, 
/*   807*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_XOR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   817*/     /*Scope*/ 18, /*->836*/
/*   818*/      OPC_CheckPredicate2,  // Predicate_atomic_load_xor_i16
/*   819*/      OPC_MoveParent,
/*   820*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   821*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   823*/      OPC_EmitMergeInputChains1_0,
/*   824*/      OPC_EmitInteger32, 0, 
/*   826*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_XOR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   836*/     /*Scope*/ 18, /*->855*/
/*   837*/      OPC_CheckPredicate3,  // Predicate_atomic_load_xor_i32
/*   838*/      OPC_MoveParent,
/*   839*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   840*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   842*/      OPC_EmitMergeInputChains1_0,
/*   843*/      OPC_EmitInteger32, 0, 
/*   845*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_i32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_XOR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   855*/     0, /*End of Scope*/
/*   856*/    /*Scope*/ 66, /*->923*/
/*   857*/     OPC_CheckChild1TypeI64,
/*   858*/     OPC_MoveChild2,
/*   859*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   862*/     OPC_RecordChild0, // #2 = $val
/*   863*/     OPC_MoveParent,
/*   864*/     OPC_Scope, 18, /*->884*/ // 3 children in Scope
/*   866*/      OPC_CheckPredicate1,  // Predicate_atomic_load_xor_i8
/*   867*/      OPC_MoveParent,
/*   868*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   869*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   871*/      OPC_EmitMergeInputChains1_0,
/*   872*/      OPC_EmitInteger32, 0, 
/*   874*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_XOR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   884*/     /*Scope*/ 18, /*->903*/
/*   885*/      OPC_CheckPredicate2,  // Predicate_atomic_load_xor_i16
/*   886*/      OPC_MoveParent,
/*   887*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   888*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   890*/      OPC_EmitMergeInputChains1_0,
/*   891*/      OPC_EmitInteger32, 0, 
/*   893*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_XOR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   903*/     /*Scope*/ 18, /*->922*/
/*   904*/      OPC_CheckPredicate3,  // Predicate_atomic_load_xor_i32
/*   905*/      OPC_MoveParent,
/*   906*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   907*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   909*/      OPC_EmitMergeInputChains1_0,
/*   910*/      OPC_EmitInteger32, 0, 
/*   912*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_i32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_XOR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   922*/     0, /*End of Scope*/
/*   923*/    0, /*End of Scope*/
/*   924*/   /*SwitchOpcode*/ 11|128,1/*139*/, TARGET_VAL(ISD::ATOMIC_SWAP),// ->1067
/*   928*/    OPC_RecordMemRef,
/*   929*/    OPC_RecordNode, // #0 = 'atomic_swap' chained node
/*   930*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*   931*/    OPC_Scope, 66, /*->999*/ // 2 children in Scope
/*   933*/     OPC_CheckChild1TypeI32,
/*   934*/     OPC_MoveChild2,
/*   935*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   938*/     OPC_RecordChild0, // #2 = $val
/*   939*/     OPC_MoveParent,
/*   940*/     OPC_Scope, 18, /*->960*/ // 3 children in Scope
/*   942*/      OPC_CheckPredicate1,  // Predicate_atomic_swap_i8
/*   943*/      OPC_MoveParent,
/*   944*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   945*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   947*/      OPC_EmitMergeInputChains1_0,
/*   948*/      OPC_EmitInteger32, 0, 
/*   950*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_XCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   960*/     /*Scope*/ 18, /*->979*/
/*   961*/      OPC_CheckPredicate2,  // Predicate_atomic_swap_i16
/*   962*/      OPC_MoveParent,
/*   963*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   964*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   966*/      OPC_EmitMergeInputChains1_0,
/*   967*/      OPC_EmitInteger32, 0, 
/*   969*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_XCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   979*/     /*Scope*/ 18, /*->998*/
/*   980*/      OPC_CheckPredicate3,  // Predicate_atomic_swap_i32
/*   981*/      OPC_MoveParent,
/*   982*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   983*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   985*/      OPC_EmitMergeInputChains1_0,
/*   986*/      OPC_EmitInteger32, 0, 
/*   988*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_i32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_XCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   998*/     0, /*End of Scope*/
/*   999*/    /*Scope*/ 66, /*->1066*/
/*  1000*/     OPC_CheckChild1TypeI64,
/*  1001*/     OPC_MoveChild2,
/*  1002*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1005*/     OPC_RecordChild0, // #2 = $val
/*  1006*/     OPC_MoveParent,
/*  1007*/     OPC_Scope, 18, /*->1027*/ // 3 children in Scope
/*  1009*/      OPC_CheckPredicate1,  // Predicate_atomic_swap_i8
/*  1010*/      OPC_MoveParent,
/*  1011*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1012*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1014*/      OPC_EmitMergeInputChains1_0,
/*  1015*/      OPC_EmitInteger32, 0, 
/*  1017*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_XCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1027*/     /*Scope*/ 18, /*->1046*/
/*  1028*/      OPC_CheckPredicate2,  // Predicate_atomic_swap_i16
/*  1029*/      OPC_MoveParent,
/*  1030*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1031*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1033*/      OPC_EmitMergeInputChains1_0,
/*  1034*/      OPC_EmitInteger32, 0, 
/*  1036*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_XCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1046*/     /*Scope*/ 18, /*->1065*/
/*  1047*/      OPC_CheckPredicate3,  // Predicate_atomic_swap_i32
/*  1048*/      OPC_MoveParent,
/*  1049*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1050*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1052*/      OPC_EmitMergeInputChains1_0,
/*  1053*/      OPC_EmitInteger32, 0, 
/*  1055*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_i32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_XCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1065*/     0, /*End of Scope*/
/*  1066*/    0, /*End of Scope*/
/*  1067*/   /*SwitchOpcode*/ 121, TARGET_VAL(ISD::ATOMIC_LOAD),// ->1191
/*  1070*/    OPC_RecordMemRef,
/*  1071*/    OPC_RecordNode, // #0 = 'atomic_load' chained node
/*  1072*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  1073*/    OPC_Scope, 57, /*->1132*/ // 2 children in Scope
/*  1075*/     OPC_CheckChild1TypeI32,
/*  1076*/     OPC_Scope, 17, /*->1095*/ // 3 children in Scope
/*  1078*/      OPC_CheckPredicate1,  // Predicate_atomic_load_8
/*  1079*/      OPC_MoveParent,
/*  1080*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  1081*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  1083*/      OPC_EmitMergeInputChains1_0,
/*  1084*/      OPC_EmitInteger32, 0, 
/*  1086*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_8>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD8_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  1095*/     /*Scope*/ 17, /*->1113*/
/*  1096*/      OPC_CheckPredicate2,  // Predicate_atomic_load_16
/*  1097*/      OPC_MoveParent,
/*  1098*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  1099*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  1101*/      OPC_EmitMergeInputChains1_0,
/*  1102*/      OPC_EmitInteger32, 0, 
/*  1104*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_16>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD16_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  1113*/     /*Scope*/ 17, /*->1131*/
/*  1114*/      OPC_CheckPredicate3,  // Predicate_atomic_load_32
/*  1115*/      OPC_MoveParent,
/*  1116*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  1117*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  1119*/      OPC_EmitMergeInputChains1_0,
/*  1120*/      OPC_EmitInteger32, 0, 
/*  1122*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD32_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_32>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD32_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  1131*/     0, /*End of Scope*/
/*  1132*/    /*Scope*/ 57, /*->1190*/
/*  1133*/     OPC_CheckChild1TypeI64,
/*  1134*/     OPC_Scope, 17, /*->1153*/ // 3 children in Scope
/*  1136*/      OPC_CheckPredicate1,  // Predicate_atomic_load_8
/*  1137*/      OPC_MoveParent,
/*  1138*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  1139*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  1141*/      OPC_EmitMergeInputChains1_0,
/*  1142*/      OPC_EmitInteger32, 0, 
/*  1144*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_8>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD8_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  1153*/     /*Scope*/ 17, /*->1171*/
/*  1154*/      OPC_CheckPredicate2,  // Predicate_atomic_load_16
/*  1155*/      OPC_MoveParent,
/*  1156*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  1157*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  1159*/      OPC_EmitMergeInputChains1_0,
/*  1160*/      OPC_EmitInteger32, 0, 
/*  1162*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_16>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD16_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  1171*/     /*Scope*/ 17, /*->1189*/
/*  1172*/      OPC_CheckPredicate3,  // Predicate_atomic_load_32
/*  1173*/      OPC_MoveParent,
/*  1174*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  1175*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  1177*/      OPC_EmitMergeInputChains1_0,
/*  1178*/      OPC_EmitInteger32, 0, 
/*  1180*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD32_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_32>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD32_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  1189*/     0, /*End of Scope*/
/*  1190*/    0, /*End of Scope*/
/*  1191*/   0, // EndSwitchOpcode
/*  1192*/  /*Scope*/ 7, /*->1200*/
/*  1193*/   OPC_RecordChild0, // #0 = $src
/*  1194*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_EXTEND_U_I32),
                 MVT::i64, 1/*#Ops*/, 0, 
             // Src: (zext:{ *:[i64] } I32:{ *:[i32] }:$src) - Complexity = 3
             // Dst: (I64_EXTEND_U_I32:{ *:[i64] } I32:{ *:[i32] }:$src)
/*  1200*/  0, /*End of Scope*/
/*  1201*/ /*SwitchOpcode*/ 86|128,6/*854*/, TARGET_VAL(ISD::ANY_EXTEND),// ->2059
/*  1205*/  OPC_Scope, 74|128,6/*842*/, /*->2050*/ // 2 children in Scope
/*  1208*/   OPC_MoveChild0,
/*  1209*/   OPC_SwitchOpcode /*8 cases */, 124, TARGET_VAL(ISD::AssertZext),// ->1337
/*  1213*/    OPC_MoveChild0,
/*  1214*/    OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_CMP_SWAP),
/*  1217*/    OPC_RecordMemRef,
/*  1218*/    OPC_RecordNode, // #0 = 'atomic_cmp_swap' chained node
/*  1219*/    OPC_CheckFoldableChainNode,
/*  1220*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  1221*/    OPC_Scope, 56, /*->1279*/ // 2 children in Scope
/*  1223*/     OPC_CheckChild1TypeI32,
/*  1224*/     OPC_MoveChild2,
/*  1225*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1228*/     OPC_RecordChild0, // #2 = $exp
/*  1229*/     OPC_MoveSibling3,
/*  1230*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1233*/     OPC_RecordChild0, // #3 = $new
/*  1234*/     OPC_MoveParent,
/*  1235*/     OPC_Scope, 20, /*->1257*/ // 2 children in Scope
/*  1237*/      OPC_CheckPredicate1,  // Predicate_atomic_cmp_swap_i8
/*  1238*/      OPC_MoveParent,
/*  1239*/      OPC_MoveParent,
/*  1240*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1241*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  1243*/      OPC_EmitMergeInputChains1_0,
/*  1244*/      OPC_EmitInteger32, 0, 
/*  1246*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 5/*#Ops*/, 6, 4, 5, 2, 3, 
                // Src: (anyext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_i8>>)) - Complexity = 25
                // Dst: (ATOMIC_RMW8_U_CMPXCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*  1257*/     /*Scope*/ 20, /*->1278*/
/*  1258*/      OPC_CheckPredicate2,  // Predicate_atomic_cmp_swap_i16
/*  1259*/      OPC_MoveParent,
/*  1260*/      OPC_MoveParent,
/*  1261*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1262*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  1264*/      OPC_EmitMergeInputChains1_0,
/*  1265*/      OPC_EmitInteger32, 0, 
/*  1267*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 5/*#Ops*/, 6, 4, 5, 2, 3, 
                // Src: (anyext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_i16>>)) - Complexity = 25
                // Dst: (ATOMIC_RMW16_U_CMPXCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*  1278*/     0, /*End of Scope*/
/*  1279*/    /*Scope*/ 56, /*->1336*/
/*  1280*/     OPC_CheckChild1TypeI64,
/*  1281*/     OPC_MoveChild2,
/*  1282*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1285*/     OPC_RecordChild0, // #2 = $exp
/*  1286*/     OPC_MoveSibling3,
/*  1287*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1290*/     OPC_RecordChild0, // #3 = $new
/*  1291*/     OPC_MoveParent,
/*  1292*/     OPC_Scope, 20, /*->1314*/ // 2 children in Scope
/*  1294*/      OPC_CheckPredicate1,  // Predicate_atomic_cmp_swap_i8
/*  1295*/      OPC_MoveParent,
/*  1296*/      OPC_MoveParent,
/*  1297*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1298*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  1300*/      OPC_EmitMergeInputChains1_0,
/*  1301*/      OPC_EmitInteger32, 0, 
/*  1303*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 5/*#Ops*/, 6, 4, 5, 2, 3, 
                // Src: (anyext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_i8>>)) - Complexity = 25
                // Dst: (ATOMIC_RMW8_U_CMPXCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*  1314*/     /*Scope*/ 20, /*->1335*/
/*  1315*/      OPC_CheckPredicate2,  // Predicate_atomic_cmp_swap_i16
/*  1316*/      OPC_MoveParent,
/*  1317*/      OPC_MoveParent,
/*  1318*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1319*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  1321*/      OPC_EmitMergeInputChains1_0,
/*  1322*/      OPC_EmitInteger32, 0, 
/*  1324*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 5/*#Ops*/, 6, 4, 5, 2, 3, 
                // Src: (anyext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_i16>>)) - Complexity = 25
                // Dst: (ATOMIC_RMW16_U_CMPXCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*  1335*/     0, /*End of Scope*/
/*  1336*/    0, /*End of Scope*/
/*  1337*/   /*SwitchOpcode*/ 101, TARGET_VAL(ISD::ATOMIC_LOAD_ADD),// ->1441
/*  1340*/    OPC_RecordMemRef,
/*  1341*/    OPC_RecordNode, // #0 = 'atomic_load_add' chained node
/*  1342*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  1343*/    OPC_Scope, 47, /*->1392*/ // 2 children in Scope
/*  1345*/     OPC_CheckChild1TypeI32,
/*  1346*/     OPC_MoveChild2,
/*  1347*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1350*/     OPC_RecordChild0, // #2 = $val
/*  1351*/     OPC_MoveParent,
/*  1352*/     OPC_Scope, 18, /*->1372*/ // 2 children in Scope
/*  1354*/      OPC_CheckPredicate1,  // Predicate_atomic_load_add_i8
/*  1355*/      OPC_MoveParent,
/*  1356*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1357*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1359*/      OPC_EmitMergeInputChains1_0,
/*  1360*/      OPC_EmitInteger32, 0, 
/*  1362*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_ADD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1372*/     /*Scope*/ 18, /*->1391*/
/*  1373*/      OPC_CheckPredicate2,  // Predicate_atomic_load_add_i16
/*  1374*/      OPC_MoveParent,
/*  1375*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1376*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1378*/      OPC_EmitMergeInputChains1_0,
/*  1379*/      OPC_EmitInteger32, 0, 
/*  1381*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_ADD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1391*/     0, /*End of Scope*/
/*  1392*/    /*Scope*/ 47, /*->1440*/
/*  1393*/     OPC_CheckChild1TypeI64,
/*  1394*/     OPC_MoveChild2,
/*  1395*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1398*/     OPC_RecordChild0, // #2 = $val
/*  1399*/     OPC_MoveParent,
/*  1400*/     OPC_Scope, 18, /*->1420*/ // 2 children in Scope
/*  1402*/      OPC_CheckPredicate1,  // Predicate_atomic_load_add_i8
/*  1403*/      OPC_MoveParent,
/*  1404*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1405*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1407*/      OPC_EmitMergeInputChains1_0,
/*  1408*/      OPC_EmitInteger32, 0, 
/*  1410*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_ADD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1420*/     /*Scope*/ 18, /*->1439*/
/*  1421*/      OPC_CheckPredicate2,  // Predicate_atomic_load_add_i16
/*  1422*/      OPC_MoveParent,
/*  1423*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1424*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1426*/      OPC_EmitMergeInputChains1_0,
/*  1427*/      OPC_EmitInteger32, 0, 
/*  1429*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_ADD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1439*/     0, /*End of Scope*/
/*  1440*/    0, /*End of Scope*/
/*  1441*/   /*SwitchOpcode*/ 101, TARGET_VAL(ISD::ATOMIC_LOAD_SUB),// ->1545
/*  1444*/    OPC_RecordMemRef,
/*  1445*/    OPC_RecordNode, // #0 = 'atomic_load_sub' chained node
/*  1446*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  1447*/    OPC_Scope, 47, /*->1496*/ // 2 children in Scope
/*  1449*/     OPC_CheckChild1TypeI32,
/*  1450*/     OPC_MoveChild2,
/*  1451*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1454*/     OPC_RecordChild0, // #2 = $val
/*  1455*/     OPC_MoveParent,
/*  1456*/     OPC_Scope, 18, /*->1476*/ // 2 children in Scope
/*  1458*/      OPC_CheckPredicate1,  // Predicate_atomic_load_sub_i8
/*  1459*/      OPC_MoveParent,
/*  1460*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1461*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1463*/      OPC_EmitMergeInputChains1_0,
/*  1464*/      OPC_EmitInteger32, 0, 
/*  1466*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_SUB_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1476*/     /*Scope*/ 18, /*->1495*/
/*  1477*/      OPC_CheckPredicate2,  // Predicate_atomic_load_sub_i16
/*  1478*/      OPC_MoveParent,
/*  1479*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1480*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1482*/      OPC_EmitMergeInputChains1_0,
/*  1483*/      OPC_EmitInteger32, 0, 
/*  1485*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_SUB_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1495*/     0, /*End of Scope*/
/*  1496*/    /*Scope*/ 47, /*->1544*/
/*  1497*/     OPC_CheckChild1TypeI64,
/*  1498*/     OPC_MoveChild2,
/*  1499*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1502*/     OPC_RecordChild0, // #2 = $val
/*  1503*/     OPC_MoveParent,
/*  1504*/     OPC_Scope, 18, /*->1524*/ // 2 children in Scope
/*  1506*/      OPC_CheckPredicate1,  // Predicate_atomic_load_sub_i8
/*  1507*/      OPC_MoveParent,
/*  1508*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1509*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1511*/      OPC_EmitMergeInputChains1_0,
/*  1512*/      OPC_EmitInteger32, 0, 
/*  1514*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_SUB_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1524*/     /*Scope*/ 18, /*->1543*/
/*  1525*/      OPC_CheckPredicate2,  // Predicate_atomic_load_sub_i16
/*  1526*/      OPC_MoveParent,
/*  1527*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1528*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1530*/      OPC_EmitMergeInputChains1_0,
/*  1531*/      OPC_EmitInteger32, 0, 
/*  1533*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_SUB_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1543*/     0, /*End of Scope*/
/*  1544*/    0, /*End of Scope*/
/*  1545*/   /*SwitchOpcode*/ 101, TARGET_VAL(ISD::ATOMIC_LOAD_AND),// ->1649
/*  1548*/    OPC_RecordMemRef,
/*  1549*/    OPC_RecordNode, // #0 = 'atomic_load_and' chained node
/*  1550*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  1551*/    OPC_Scope, 47, /*->1600*/ // 2 children in Scope
/*  1553*/     OPC_CheckChild1TypeI32,
/*  1554*/     OPC_MoveChild2,
/*  1555*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1558*/     OPC_RecordChild0, // #2 = $val
/*  1559*/     OPC_MoveParent,
/*  1560*/     OPC_Scope, 18, /*->1580*/ // 2 children in Scope
/*  1562*/      OPC_CheckPredicate1,  // Predicate_atomic_load_and_i8
/*  1563*/      OPC_MoveParent,
/*  1564*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1565*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1567*/      OPC_EmitMergeInputChains1_0,
/*  1568*/      OPC_EmitInteger32, 0, 
/*  1570*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_AND_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1580*/     /*Scope*/ 18, /*->1599*/
/*  1581*/      OPC_CheckPredicate2,  // Predicate_atomic_load_and_i16
/*  1582*/      OPC_MoveParent,
/*  1583*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1584*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1586*/      OPC_EmitMergeInputChains1_0,
/*  1587*/      OPC_EmitInteger32, 0, 
/*  1589*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_AND_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1599*/     0, /*End of Scope*/
/*  1600*/    /*Scope*/ 47, /*->1648*/
/*  1601*/     OPC_CheckChild1TypeI64,
/*  1602*/     OPC_MoveChild2,
/*  1603*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1606*/     OPC_RecordChild0, // #2 = $val
/*  1607*/     OPC_MoveParent,
/*  1608*/     OPC_Scope, 18, /*->1628*/ // 2 children in Scope
/*  1610*/      OPC_CheckPredicate1,  // Predicate_atomic_load_and_i8
/*  1611*/      OPC_MoveParent,
/*  1612*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1613*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1615*/      OPC_EmitMergeInputChains1_0,
/*  1616*/      OPC_EmitInteger32, 0, 
/*  1618*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_AND_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1628*/     /*Scope*/ 18, /*->1647*/
/*  1629*/      OPC_CheckPredicate2,  // Predicate_atomic_load_and_i16
/*  1630*/      OPC_MoveParent,
/*  1631*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1632*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1634*/      OPC_EmitMergeInputChains1_0,
/*  1635*/      OPC_EmitInteger32, 0, 
/*  1637*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_AND_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1647*/     0, /*End of Scope*/
/*  1648*/    0, /*End of Scope*/
/*  1649*/   /*SwitchOpcode*/ 101, TARGET_VAL(ISD::ATOMIC_LOAD_OR),// ->1753
/*  1652*/    OPC_RecordMemRef,
/*  1653*/    OPC_RecordNode, // #0 = 'atomic_load_or' chained node
/*  1654*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  1655*/    OPC_Scope, 47, /*->1704*/ // 2 children in Scope
/*  1657*/     OPC_CheckChild1TypeI32,
/*  1658*/     OPC_MoveChild2,
/*  1659*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1662*/     OPC_RecordChild0, // #2 = $val
/*  1663*/     OPC_MoveParent,
/*  1664*/     OPC_Scope, 18, /*->1684*/ // 2 children in Scope
/*  1666*/      OPC_CheckPredicate1,  // Predicate_atomic_load_or_i8
/*  1667*/      OPC_MoveParent,
/*  1668*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1669*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1671*/      OPC_EmitMergeInputChains1_0,
/*  1672*/      OPC_EmitInteger32, 0, 
/*  1674*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_OR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1684*/     /*Scope*/ 18, /*->1703*/
/*  1685*/      OPC_CheckPredicate2,  // Predicate_atomic_load_or_i16
/*  1686*/      OPC_MoveParent,
/*  1687*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1688*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1690*/      OPC_EmitMergeInputChains1_0,
/*  1691*/      OPC_EmitInteger32, 0, 
/*  1693*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_OR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1703*/     0, /*End of Scope*/
/*  1704*/    /*Scope*/ 47, /*->1752*/
/*  1705*/     OPC_CheckChild1TypeI64,
/*  1706*/     OPC_MoveChild2,
/*  1707*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1710*/     OPC_RecordChild0, // #2 = $val
/*  1711*/     OPC_MoveParent,
/*  1712*/     OPC_Scope, 18, /*->1732*/ // 2 children in Scope
/*  1714*/      OPC_CheckPredicate1,  // Predicate_atomic_load_or_i8
/*  1715*/      OPC_MoveParent,
/*  1716*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1717*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1719*/      OPC_EmitMergeInputChains1_0,
/*  1720*/      OPC_EmitInteger32, 0, 
/*  1722*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_OR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1732*/     /*Scope*/ 18, /*->1751*/
/*  1733*/      OPC_CheckPredicate2,  // Predicate_atomic_load_or_i16
/*  1734*/      OPC_MoveParent,
/*  1735*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1736*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1738*/      OPC_EmitMergeInputChains1_0,
/*  1739*/      OPC_EmitInteger32, 0, 
/*  1741*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_OR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1751*/     0, /*End of Scope*/
/*  1752*/    0, /*End of Scope*/
/*  1753*/   /*SwitchOpcode*/ 101, TARGET_VAL(ISD::ATOMIC_LOAD_XOR),// ->1857
/*  1756*/    OPC_RecordMemRef,
/*  1757*/    OPC_RecordNode, // #0 = 'atomic_load_xor' chained node
/*  1758*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  1759*/    OPC_Scope, 47, /*->1808*/ // 2 children in Scope
/*  1761*/     OPC_CheckChild1TypeI32,
/*  1762*/     OPC_MoveChild2,
/*  1763*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1766*/     OPC_RecordChild0, // #2 = $val
/*  1767*/     OPC_MoveParent,
/*  1768*/     OPC_Scope, 18, /*->1788*/ // 2 children in Scope
/*  1770*/      OPC_CheckPredicate1,  // Predicate_atomic_load_xor_i8
/*  1771*/      OPC_MoveParent,
/*  1772*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1773*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1775*/      OPC_EmitMergeInputChains1_0,
/*  1776*/      OPC_EmitInteger32, 0, 
/*  1778*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_XOR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1788*/     /*Scope*/ 18, /*->1807*/
/*  1789*/      OPC_CheckPredicate2,  // Predicate_atomic_load_xor_i16
/*  1790*/      OPC_MoveParent,
/*  1791*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1792*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1794*/      OPC_EmitMergeInputChains1_0,
/*  1795*/      OPC_EmitInteger32, 0, 
/*  1797*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_XOR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1807*/     0, /*End of Scope*/
/*  1808*/    /*Scope*/ 47, /*->1856*/
/*  1809*/     OPC_CheckChild1TypeI64,
/*  1810*/     OPC_MoveChild2,
/*  1811*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1814*/     OPC_RecordChild0, // #2 = $val
/*  1815*/     OPC_MoveParent,
/*  1816*/     OPC_Scope, 18, /*->1836*/ // 2 children in Scope
/*  1818*/      OPC_CheckPredicate1,  // Predicate_atomic_load_xor_i8
/*  1819*/      OPC_MoveParent,
/*  1820*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1821*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1823*/      OPC_EmitMergeInputChains1_0,
/*  1824*/      OPC_EmitInteger32, 0, 
/*  1826*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_XOR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1836*/     /*Scope*/ 18, /*->1855*/
/*  1837*/      OPC_CheckPredicate2,  // Predicate_atomic_load_xor_i16
/*  1838*/      OPC_MoveParent,
/*  1839*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1840*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1842*/      OPC_EmitMergeInputChains1_0,
/*  1843*/      OPC_EmitInteger32, 0, 
/*  1845*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_XOR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1855*/     0, /*End of Scope*/
/*  1856*/    0, /*End of Scope*/
/*  1857*/   /*SwitchOpcode*/ 101, TARGET_VAL(ISD::ATOMIC_SWAP),// ->1961
/*  1860*/    OPC_RecordMemRef,
/*  1861*/    OPC_RecordNode, // #0 = 'atomic_swap' chained node
/*  1862*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  1863*/    OPC_Scope, 47, /*->1912*/ // 2 children in Scope
/*  1865*/     OPC_CheckChild1TypeI32,
/*  1866*/     OPC_MoveChild2,
/*  1867*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1870*/     OPC_RecordChild0, // #2 = $val
/*  1871*/     OPC_MoveParent,
/*  1872*/     OPC_Scope, 18, /*->1892*/ // 2 children in Scope
/*  1874*/      OPC_CheckPredicate1,  // Predicate_atomic_swap_i8
/*  1875*/      OPC_MoveParent,
/*  1876*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1877*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1879*/      OPC_EmitMergeInputChains1_0,
/*  1880*/      OPC_EmitInteger32, 0, 
/*  1882*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_XCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1892*/     /*Scope*/ 18, /*->1911*/
/*  1893*/      OPC_CheckPredicate2,  // Predicate_atomic_swap_i16
/*  1894*/      OPC_MoveParent,
/*  1895*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1896*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1898*/      OPC_EmitMergeInputChains1_0,
/*  1899*/      OPC_EmitInteger32, 0, 
/*  1901*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_XCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1911*/     0, /*End of Scope*/
/*  1912*/    /*Scope*/ 47, /*->1960*/
/*  1913*/     OPC_CheckChild1TypeI64,
/*  1914*/     OPC_MoveChild2,
/*  1915*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1918*/     OPC_RecordChild0, // #2 = $val
/*  1919*/     OPC_MoveParent,
/*  1920*/     OPC_Scope, 18, /*->1940*/ // 2 children in Scope
/*  1922*/      OPC_CheckPredicate1,  // Predicate_atomic_swap_i8
/*  1923*/      OPC_MoveParent,
/*  1924*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1925*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1927*/      OPC_EmitMergeInputChains1_0,
/*  1928*/      OPC_EmitInteger32, 0, 
/*  1930*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_XCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1940*/     /*Scope*/ 18, /*->1959*/
/*  1941*/      OPC_CheckPredicate2,  // Predicate_atomic_swap_i16
/*  1942*/      OPC_MoveParent,
/*  1943*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1944*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1946*/      OPC_EmitMergeInputChains1_0,
/*  1947*/      OPC_EmitInteger32, 0, 
/*  1949*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_XCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1959*/     0, /*End of Scope*/
/*  1960*/    0, /*End of Scope*/
/*  1961*/   /*SwitchOpcode*/ 85, TARGET_VAL(ISD::ATOMIC_LOAD),// ->2049
/*  1964*/    OPC_RecordMemRef,
/*  1965*/    OPC_RecordNode, // #0 = 'atomic_load' chained node
/*  1966*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  1967*/    OPC_Scope, 39, /*->2008*/ // 2 children in Scope
/*  1969*/     OPC_CheckChild1TypeI32,
/*  1970*/     OPC_Scope, 17, /*->1989*/ // 2 children in Scope
/*  1972*/      OPC_CheckPredicate1,  // Predicate_atomic_load_8
/*  1973*/      OPC_MoveParent,
/*  1974*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  1975*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  1977*/      OPC_EmitMergeInputChains1_0,
/*  1978*/      OPC_EmitInteger32, 0, 
/*  1980*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_8>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD8_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  1989*/     /*Scope*/ 17, /*->2007*/
/*  1990*/      OPC_CheckPredicate2,  // Predicate_atomic_load_16
/*  1991*/      OPC_MoveParent,
/*  1992*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  1993*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  1995*/      OPC_EmitMergeInputChains1_0,
/*  1996*/      OPC_EmitInteger32, 0, 
/*  1998*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_16>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD16_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  2007*/     0, /*End of Scope*/
/*  2008*/    /*Scope*/ 39, /*->2048*/
/*  2009*/     OPC_CheckChild1TypeI64,
/*  2010*/     OPC_Scope, 17, /*->2029*/ // 2 children in Scope
/*  2012*/      OPC_CheckPredicate1,  // Predicate_atomic_load_8
/*  2013*/      OPC_MoveParent,
/*  2014*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  2015*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  2017*/      OPC_EmitMergeInputChains1_0,
/*  2018*/      OPC_EmitInteger32, 0, 
/*  2020*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_8>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD8_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  2029*/     /*Scope*/ 17, /*->2047*/
/*  2030*/      OPC_CheckPredicate2,  // Predicate_atomic_load_16
/*  2031*/      OPC_MoveParent,
/*  2032*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  2033*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  2035*/      OPC_EmitMergeInputChains1_0,
/*  2036*/      OPC_EmitInteger32, 0, 
/*  2038*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_16>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD16_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  2047*/     0, /*End of Scope*/
/*  2048*/    0, /*End of Scope*/
/*  2049*/   0, // EndSwitchOpcode
/*  2050*/  /*Scope*/ 7, /*->2058*/
/*  2051*/   OPC_RecordChild0, // #0 = $src
/*  2052*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_EXTEND_U_I32),
                 MVT::i64, 1/*#Ops*/, 0, 
             // Src: (anyext:{ *:[i64] } I32:{ *:[i32] }:$src) - Complexity = 3
             // Dst: (I64_EXTEND_U_I32:{ *:[i64] } I32:{ *:[i32] }:$src)
/*  2058*/  0, /*End of Scope*/
/*  2059*/ /*SwitchOpcode*/ 22|128,7/*918*/, TARGET_VAL(ISD::STORE),// ->2981
/*  2063*/  OPC_RecordMemRef,
/*  2064*/  OPC_RecordNode, // #0 = 'st' chained node
/*  2065*/  OPC_Scope, 127|128,1/*255*/, /*->2323*/ // 2 children in Scope
/*  2068*/   OPC_MoveChild1,
/*  2069*/   OPC_CheckOpcode, TARGET_VAL(ISD::EXTRACT_VECTOR_ELT),
/*  2072*/   OPC_RecordChild0, // #1 = $vec
/*  2073*/   OPC_Scope, 64, /*->2139*/ // 4 children in Scope
/*  2075*/    OPC_CheckChild0Type, MVT::v16i8,
/*  2077*/    OPC_RecordChild1, // #2 = $idx
/*  2078*/    OPC_MoveChild1,
/*  2079*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  2082*/    OPC_CheckPredicate, 11, // Predicate_LaneIdx16
/*  2084*/    OPC_CheckTypeI32,
/*  2085*/    OPC_MoveParent,
/*  2086*/    OPC_CheckTypeI32,
/*  2087*/    OPC_MoveParent,
/*  2088*/    OPC_RecordChild2, // #3 = $AddrOps32:offset:addr
/*  2089*/    OPC_Scope, 23, /*->2114*/ // 2 children in Scope
/*  2091*/     OPC_CheckChild2TypeI32,
/*  2092*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2093*/     OPC_CheckPredicate, 12, // Predicate_truncstore
/*  2095*/     OPC_CheckPredicate, 19, // Predicate_truncstorei8
/*  2097*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  2098*/     OPC_CheckComplexPat0, /*#*/3, // SelectAddrOperands32:$ #4 #5
/*  2100*/     OPC_EmitMergeInputChains1_0,
/*  2101*/     OPC_EmitInteger32, 0, 
/*  2103*/     OPC_EmitConvertToTarget2,
/*  2104*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_LANE_I8x16_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   5/*#Ops*/, 6, 4, 7, 5, 1, 
               // Src: (st (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx), (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 21
               // Dst: (STORE_LANE_I8x16_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v16i8] }:$vec)
/*  2114*/    /*Scope*/ 23, /*->2138*/
/*  2115*/     OPC_CheckChild2TypeI64,
/*  2116*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2117*/     OPC_CheckPredicate, 12, // Predicate_truncstore
/*  2119*/     OPC_CheckPredicate, 19, // Predicate_truncstorei8
/*  2121*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  2122*/     OPC_CheckComplexPat1, /*#*/3, // SelectAddrOperands64:$ #4 #5
/*  2124*/     OPC_EmitMergeInputChains1_0,
/*  2125*/     OPC_EmitInteger32, 0, 
/*  2127*/     OPC_EmitConvertToTarget2,
/*  2128*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_LANE_I8x16_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   5/*#Ops*/, 6, 4, 7, 5, 1, 
               // Src: (st (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx), (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 21
               // Dst: (STORE_LANE_I8x16_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v16i8] }:$vec)
/*  2138*/    0, /*End of Scope*/
/*  2139*/   /*Scope*/ 64, /*->2204*/
/*  2140*/    OPC_CheckChild0Type, MVT::v8i16,
/*  2142*/    OPC_RecordChild1, // #2 = $idx
/*  2143*/    OPC_MoveChild1,
/*  2144*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  2147*/    OPC_CheckPredicate, 16, // Predicate_LaneIdx8
/*  2149*/    OPC_CheckTypeI32,
/*  2150*/    OPC_MoveParent,
/*  2151*/    OPC_CheckTypeI32,
/*  2152*/    OPC_MoveParent,
/*  2153*/    OPC_RecordChild2, // #3 = $AddrOps32:offset:addr
/*  2154*/    OPC_Scope, 23, /*->2179*/ // 2 children in Scope
/*  2156*/     OPC_CheckChild2TypeI32,
/*  2157*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2158*/     OPC_CheckPredicate, 12, // Predicate_truncstore
/*  2160*/     OPC_CheckPredicate, 20, // Predicate_truncstorei16
/*  2162*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  2163*/     OPC_CheckComplexPat0, /*#*/3, // SelectAddrOperands32:$ #4 #5
/*  2165*/     OPC_EmitMergeInputChains1_0,
/*  2166*/     OPC_EmitInteger32, 0, 
/*  2168*/     OPC_EmitConvertToTarget2,
/*  2169*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_LANE_I16x8_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   5/*#Ops*/, 6, 4, 7, 5, 1, 
               // Src: (st (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx), (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 21
               // Dst: (STORE_LANE_I16x8_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v8i16] }:$vec)
/*  2179*/    /*Scope*/ 23, /*->2203*/
/*  2180*/     OPC_CheckChild2TypeI64,
/*  2181*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2182*/     OPC_CheckPredicate, 12, // Predicate_truncstore
/*  2184*/     OPC_CheckPredicate, 20, // Predicate_truncstorei16
/*  2186*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  2187*/     OPC_CheckComplexPat1, /*#*/3, // SelectAddrOperands64:$ #4 #5
/*  2189*/     OPC_EmitMergeInputChains1_0,
/*  2190*/     OPC_EmitInteger32, 0, 
/*  2192*/     OPC_EmitConvertToTarget2,
/*  2193*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_LANE_I16x8_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   5/*#Ops*/, 6, 4, 7, 5, 1, 
               // Src: (st (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx), (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 21
               // Dst: (STORE_LANE_I16x8_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v8i16] }:$vec)
/*  2203*/    0, /*End of Scope*/
/*  2204*/   /*Scope*/ 58, /*->2263*/
/*  2205*/    OPC_CheckChild0Type, MVT::v4i32,
/*  2207*/    OPC_RecordChild1, // #2 = $idx
/*  2208*/    OPC_MoveChild1,
/*  2209*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  2212*/    OPC_CheckPredicate, 17, // Predicate_LaneIdx4
/*  2214*/    OPC_CheckTypeI32,
/*  2215*/    OPC_MoveParent,
/*  2216*/    OPC_CheckTypeI32,
/*  2217*/    OPC_MoveParent,
/*  2218*/    OPC_RecordChild2, // #3 = $AddrOps32:offset:addr
/*  2219*/    OPC_Scope, 20, /*->2241*/ // 2 children in Scope
/*  2221*/     OPC_CheckChild2TypeI32,
/*  2222*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2223*/     OPC_CheckPredicate5,  // Predicate_store
/*  2224*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  2225*/     OPC_CheckComplexPat0, /*#*/3, // SelectAddrOperands32:$ #4 #5
/*  2227*/     OPC_EmitMergeInputChains1_0,
/*  2228*/     OPC_EmitInteger32, 0, 
/*  2230*/     OPC_EmitConvertToTarget2,
/*  2231*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_LANE_I32x4_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   5/*#Ops*/, 6, 4, 7, 5, 1, 
               // Src: (st (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx), (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 21
               // Dst: (STORE_LANE_I32x4_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v4i32] }:$vec)
/*  2241*/    /*Scope*/ 20, /*->2262*/
/*  2242*/     OPC_CheckChild2TypeI64,
/*  2243*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2244*/     OPC_CheckPredicate5,  // Predicate_store
/*  2245*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  2246*/     OPC_CheckComplexPat1, /*#*/3, // SelectAddrOperands64:$ #4 #5
/*  2248*/     OPC_EmitMergeInputChains1_0,
/*  2249*/     OPC_EmitInteger32, 0, 
/*  2251*/     OPC_EmitConvertToTarget2,
/*  2252*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_LANE_I32x4_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   5/*#Ops*/, 6, 4, 7, 5, 1, 
               // Src: (st (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx), (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 21
               // Dst: (STORE_LANE_I32x4_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v4i32] }:$vec)
/*  2262*/    0, /*End of Scope*/
/*  2263*/   /*Scope*/ 58, /*->2322*/
/*  2264*/    OPC_CheckChild0Type, MVT::v2i64,
/*  2266*/    OPC_RecordChild1, // #2 = $idx
/*  2267*/    OPC_MoveChild1,
/*  2268*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  2271*/    OPC_CheckPredicate, 18, // Predicate_LaneIdx2
/*  2273*/    OPC_CheckTypeI32,
/*  2274*/    OPC_MoveParent,
/*  2275*/    OPC_CheckTypeI64,
/*  2276*/    OPC_MoveParent,
/*  2277*/    OPC_RecordChild2, // #3 = $AddrOps32:offset:addr
/*  2278*/    OPC_Scope, 20, /*->2300*/ // 2 children in Scope
/*  2280*/     OPC_CheckChild2TypeI32,
/*  2281*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2282*/     OPC_CheckPredicate5,  // Predicate_store
/*  2283*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  2284*/     OPC_CheckComplexPat0, /*#*/3, // SelectAddrOperands32:$ #4 #5
/*  2286*/     OPC_EmitMergeInputChains1_0,
/*  2287*/     OPC_EmitInteger32, 0, 
/*  2289*/     OPC_EmitConvertToTarget2,
/*  2290*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_LANE_I64x2_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   5/*#Ops*/, 6, 4, 7, 5, 1, 
               // Src: (st (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx), (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 21
               // Dst: (STORE_LANE_I64x2_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v2i64] }:$vec)
/*  2300*/    /*Scope*/ 20, /*->2321*/
/*  2301*/     OPC_CheckChild2TypeI64,
/*  2302*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2303*/     OPC_CheckPredicate5,  // Predicate_store
/*  2304*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  2305*/     OPC_CheckComplexPat1, /*#*/3, // SelectAddrOperands64:$ #4 #5
/*  2307*/     OPC_EmitMergeInputChains1_0,
/*  2308*/     OPC_EmitInteger32, 0, 
/*  2310*/     OPC_EmitConvertToTarget2,
/*  2311*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_LANE_I64x2_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   5/*#Ops*/, 6, 4, 7, 5, 1, 
               // Src: (st (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx), (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 21
               // Dst: (STORE_LANE_I64x2_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v2i64] }:$vec)
/*  2321*/    0, /*End of Scope*/
/*  2322*/   0, /*End of Scope*/
/*  2323*/  /*Scope*/ 15|128,5/*655*/, /*->2980*/
/*  2325*/   OPC_RecordChild1, // #1 = $val
/*  2326*/   OPC_Scope, 2|128,1/*130*/, /*->2459*/ // 10 children in Scope
/*  2329*/    OPC_CheckChild1TypeI32,
/*  2330*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  2331*/    OPC_Scope, 62, /*->2395*/ // 2 children in Scope
/*  2333*/     OPC_CheckChild2TypeI32,
/*  2334*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2335*/     OPC_Scope, 16, /*->2353*/ // 2 children in Scope
/*  2337*/      OPC_CheckPredicate5,  // Predicate_store
/*  2338*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  2339*/      OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2341*/      OPC_EmitMergeInputChains1_0,
/*  2342*/      OPC_EmitInteger32, 0, 
/*  2344*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (st i32:{ *:[i32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
                // Dst: (STORE_I32_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/*  2353*/     /*Scope*/ 40, /*->2394*/
/*  2354*/      OPC_CheckPredicate, 12, // Predicate_truncstore
/*  2356*/      OPC_Scope, 17, /*->2375*/ // 2 children in Scope
/*  2358*/       OPC_CheckPredicate, 19, // Predicate_truncstorei8
/*  2360*/       OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  2361*/       OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2363*/       OPC_EmitMergeInputChains1_0,
/*  2364*/       OPC_EmitInteger32, 0, 
/*  2366*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE8_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i32:{ *:[i32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 13
                 // Dst: (STORE8_I32_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/*  2375*/      /*Scope*/ 17, /*->2393*/
/*  2376*/       OPC_CheckPredicate, 20, // Predicate_truncstorei16
/*  2378*/       OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  2379*/       OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2381*/       OPC_EmitMergeInputChains1_0,
/*  2382*/       OPC_EmitInteger32, 0, 
/*  2384*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE16_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i32:{ *:[i32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 13
                 // Dst: (STORE16_I32_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/*  2393*/      0, /*End of Scope*/
/*  2394*/     0, /*End of Scope*/
/*  2395*/    /*Scope*/ 62, /*->2458*/
/*  2396*/     OPC_CheckChild2TypeI64,
/*  2397*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2398*/     OPC_Scope, 16, /*->2416*/ // 2 children in Scope
/*  2400*/      OPC_CheckPredicate5,  // Predicate_store
/*  2401*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  2402*/      OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2404*/      OPC_EmitMergeInputChains1_0,
/*  2405*/      OPC_EmitInteger32, 0, 
/*  2407*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (st i32:{ *:[i32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
                // Dst: (STORE_I32_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/*  2416*/     /*Scope*/ 40, /*->2457*/
/*  2417*/      OPC_CheckPredicate, 12, // Predicate_truncstore
/*  2419*/      OPC_Scope, 17, /*->2438*/ // 2 children in Scope
/*  2421*/       OPC_CheckPredicate, 19, // Predicate_truncstorei8
/*  2423*/       OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  2424*/       OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2426*/       OPC_EmitMergeInputChains1_0,
/*  2427*/       OPC_EmitInteger32, 0, 
/*  2429*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE8_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i32:{ *:[i32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 13
                 // Dst: (STORE8_I32_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/*  2438*/      /*Scope*/ 17, /*->2456*/
/*  2439*/       OPC_CheckPredicate, 20, // Predicate_truncstorei16
/*  2441*/       OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  2442*/       OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2444*/       OPC_EmitMergeInputChains1_0,
/*  2445*/       OPC_EmitInteger32, 0, 
/*  2447*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE16_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i32:{ *:[i32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 13
                 // Dst: (STORE16_I32_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/*  2456*/      0, /*End of Scope*/
/*  2457*/     0, /*End of Scope*/
/*  2458*/    0, /*End of Scope*/
/*  2459*/   /*Scope*/ 38|128,1/*166*/, /*->2627*/
/*  2461*/    OPC_CheckChild1TypeI64,
/*  2462*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  2463*/    OPC_Scope, 80, /*->2545*/ // 2 children in Scope
/*  2465*/     OPC_CheckChild2TypeI32,
/*  2466*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2467*/     OPC_Scope, 16, /*->2485*/ // 2 children in Scope
/*  2469*/      OPC_CheckPredicate5,  // Predicate_store
/*  2470*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  2471*/      OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2473*/      OPC_EmitMergeInputChains1_0,
/*  2474*/      OPC_EmitInteger32, 0, 
/*  2476*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (st i64:{ *:[i64] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
                // Dst: (STORE_I64_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  2485*/     /*Scope*/ 58, /*->2544*/
/*  2486*/      OPC_CheckPredicate, 12, // Predicate_truncstore
/*  2488*/      OPC_Scope, 17, /*->2507*/ // 3 children in Scope
/*  2490*/       OPC_CheckPredicate, 19, // Predicate_truncstorei8
/*  2492*/       OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  2493*/       OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2495*/       OPC_EmitMergeInputChains1_0,
/*  2496*/       OPC_EmitInteger32, 0, 
/*  2498*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE8_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i64:{ *:[i64] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 13
                 // Dst: (STORE8_I64_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  2507*/      /*Scope*/ 17, /*->2525*/
/*  2508*/       OPC_CheckPredicate, 20, // Predicate_truncstorei16
/*  2510*/       OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  2511*/       OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2513*/       OPC_EmitMergeInputChains1_0,
/*  2514*/       OPC_EmitInteger32, 0, 
/*  2516*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE16_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i64:{ *:[i64] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 13
                 // Dst: (STORE16_I64_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  2525*/      /*Scope*/ 17, /*->2543*/
/*  2526*/       OPC_CheckPredicate, 25, // Predicate_truncstorei32
/*  2528*/       OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  2529*/       OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2531*/       OPC_EmitMergeInputChains1_0,
/*  2532*/       OPC_EmitInteger32, 0, 
/*  2534*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE32_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i64:{ *:[i64] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>> - Complexity = 13
                 // Dst: (STORE32_I64_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  2543*/      0, /*End of Scope*/
/*  2544*/     0, /*End of Scope*/
/*  2545*/    /*Scope*/ 80, /*->2626*/
/*  2546*/     OPC_CheckChild2TypeI64,
/*  2547*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2548*/     OPC_Scope, 16, /*->2566*/ // 2 children in Scope
/*  2550*/      OPC_CheckPredicate5,  // Predicate_store
/*  2551*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  2552*/      OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2554*/      OPC_EmitMergeInputChains1_0,
/*  2555*/      OPC_EmitInteger32, 0, 
/*  2557*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (st i64:{ *:[i64] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
                // Dst: (STORE_I64_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  2566*/     /*Scope*/ 58, /*->2625*/
/*  2567*/      OPC_CheckPredicate, 12, // Predicate_truncstore
/*  2569*/      OPC_Scope, 17, /*->2588*/ // 3 children in Scope
/*  2571*/       OPC_CheckPredicate, 19, // Predicate_truncstorei8
/*  2573*/       OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  2574*/       OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2576*/       OPC_EmitMergeInputChains1_0,
/*  2577*/       OPC_EmitInteger32, 0, 
/*  2579*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE8_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i64:{ *:[i64] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 13
                 // Dst: (STORE8_I64_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  2588*/      /*Scope*/ 17, /*->2606*/
/*  2589*/       OPC_CheckPredicate, 20, // Predicate_truncstorei16
/*  2591*/       OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  2592*/       OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2594*/       OPC_EmitMergeInputChains1_0,
/*  2595*/       OPC_EmitInteger32, 0, 
/*  2597*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE16_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i64:{ *:[i64] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 13
                 // Dst: (STORE16_I64_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  2606*/      /*Scope*/ 17, /*->2624*/
/*  2607*/       OPC_CheckPredicate, 25, // Predicate_truncstorei32
/*  2609*/       OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  2610*/       OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2612*/       OPC_EmitMergeInputChains1_0,
/*  2613*/       OPC_EmitInteger32, 0, 
/*  2615*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE32_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i64:{ *:[i64] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>> - Complexity = 13
                 // Dst: (STORE32_I64_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  2624*/      0, /*End of Scope*/
/*  2625*/     0, /*End of Scope*/
/*  2626*/    0, /*End of Scope*/
/*  2627*/   /*Scope*/ 43, /*->2671*/
/*  2628*/    OPC_CheckChild1Type, MVT::f32,
/*  2630*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  2631*/    OPC_Scope, 18, /*->2651*/ // 2 children in Scope
/*  2633*/     OPC_CheckChild2TypeI32,
/*  2634*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2635*/     OPC_CheckPredicate5,  // Predicate_store
/*  2636*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  2637*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2639*/     OPC_EmitMergeInputChains1_0,
/*  2640*/     OPC_EmitInteger32, 0, 
/*  2642*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st f32:{ *:[f32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_F32_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, f32:{ *:[f32] }:$val)
/*  2651*/    /*Scope*/ 18, /*->2670*/
/*  2652*/     OPC_CheckChild2TypeI64,
/*  2653*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2654*/     OPC_CheckPredicate5,  // Predicate_store
/*  2655*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  2656*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2658*/     OPC_EmitMergeInputChains1_0,
/*  2659*/     OPC_EmitInteger32, 0, 
/*  2661*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st f32:{ *:[f32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_F32_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, f32:{ *:[f32] }:$val)
/*  2670*/    0, /*End of Scope*/
/*  2671*/   /*Scope*/ 43, /*->2715*/
/*  2672*/    OPC_CheckChild1Type, MVT::f64,
/*  2674*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  2675*/    OPC_Scope, 18, /*->2695*/ // 2 children in Scope
/*  2677*/     OPC_CheckChild2TypeI32,
/*  2678*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2679*/     OPC_CheckPredicate5,  // Predicate_store
/*  2680*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  2681*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2683*/     OPC_EmitMergeInputChains1_0,
/*  2684*/     OPC_EmitInteger32, 0, 
/*  2686*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st f64:{ *:[f64] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_F64_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, f64:{ *:[f64] }:$val)
/*  2695*/    /*Scope*/ 18, /*->2714*/
/*  2696*/     OPC_CheckChild2TypeI64,
/*  2697*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2698*/     OPC_CheckPredicate5,  // Predicate_store
/*  2699*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  2700*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2702*/     OPC_EmitMergeInputChains1_0,
/*  2703*/     OPC_EmitInteger32, 0, 
/*  2705*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st f64:{ *:[f64] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_F64_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, f64:{ *:[f64] }:$val)
/*  2714*/    0, /*End of Scope*/
/*  2715*/   /*Scope*/ 43, /*->2759*/
/*  2716*/    OPC_CheckChild1Type, MVT::v16i8,
/*  2718*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  2719*/    OPC_Scope, 18, /*->2739*/ // 2 children in Scope
/*  2721*/     OPC_CheckChild2TypeI32,
/*  2722*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2723*/     OPC_CheckPredicate5,  // Predicate_store
/*  2724*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  2725*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2727*/     OPC_EmitMergeInputChains1_0,
/*  2728*/     OPC_EmitInteger32, 0, 
/*  2730*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v16i8:{ *:[v16i8] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, v16i8:{ *:[v16i8] }:$val)
/*  2739*/    /*Scope*/ 18, /*->2758*/
/*  2740*/     OPC_CheckChild2TypeI64,
/*  2741*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2742*/     OPC_CheckPredicate5,  // Predicate_store
/*  2743*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  2744*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2746*/     OPC_EmitMergeInputChains1_0,
/*  2747*/     OPC_EmitInteger32, 0, 
/*  2749*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v16i8:{ *:[v16i8] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, v16i8:{ *:[v16i8] }:$val)
/*  2758*/    0, /*End of Scope*/
/*  2759*/   /*Scope*/ 43, /*->2803*/
/*  2760*/    OPC_CheckChild1Type, MVT::v8i16,
/*  2762*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  2763*/    OPC_Scope, 18, /*->2783*/ // 2 children in Scope
/*  2765*/     OPC_CheckChild2TypeI32,
/*  2766*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2767*/     OPC_CheckPredicate5,  // Predicate_store
/*  2768*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  2769*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2771*/     OPC_EmitMergeInputChains1_0,
/*  2772*/     OPC_EmitInteger32, 0, 
/*  2774*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v8i16:{ *:[v8i16] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, v8i16:{ *:[v8i16] }:$val)
/*  2783*/    /*Scope*/ 18, /*->2802*/
/*  2784*/     OPC_CheckChild2TypeI64,
/*  2785*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2786*/     OPC_CheckPredicate5,  // Predicate_store
/*  2787*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  2788*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2790*/     OPC_EmitMergeInputChains1_0,
/*  2791*/     OPC_EmitInteger32, 0, 
/*  2793*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v8i16:{ *:[v8i16] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, v8i16:{ *:[v8i16] }:$val)
/*  2802*/    0, /*End of Scope*/
/*  2803*/   /*Scope*/ 43, /*->2847*/
/*  2804*/    OPC_CheckChild1Type, MVT::v4i32,
/*  2806*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  2807*/    OPC_Scope, 18, /*->2827*/ // 2 children in Scope
/*  2809*/     OPC_CheckChild2TypeI32,
/*  2810*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2811*/     OPC_CheckPredicate5,  // Predicate_store
/*  2812*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  2813*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2815*/     OPC_EmitMergeInputChains1_0,
/*  2816*/     OPC_EmitInteger32, 0, 
/*  2818*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v4i32:{ *:[v4i32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, v4i32:{ *:[v4i32] }:$val)
/*  2827*/    /*Scope*/ 18, /*->2846*/
/*  2828*/     OPC_CheckChild2TypeI64,
/*  2829*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2830*/     OPC_CheckPredicate5,  // Predicate_store
/*  2831*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  2832*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2834*/     OPC_EmitMergeInputChains1_0,
/*  2835*/     OPC_EmitInteger32, 0, 
/*  2837*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v4i32:{ *:[v4i32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, v4i32:{ *:[v4i32] }:$val)
/*  2846*/    0, /*End of Scope*/
/*  2847*/   /*Scope*/ 43, /*->2891*/
/*  2848*/    OPC_CheckChild1Type, MVT::v2i64,
/*  2850*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  2851*/    OPC_Scope, 18, /*->2871*/ // 2 children in Scope
/*  2853*/     OPC_CheckChild2TypeI32,
/*  2854*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2855*/     OPC_CheckPredicate5,  // Predicate_store
/*  2856*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  2857*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2859*/     OPC_EmitMergeInputChains1_0,
/*  2860*/     OPC_EmitInteger32, 0, 
/*  2862*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v2i64:{ *:[v2i64] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, v2i64:{ *:[v2i64] }:$val)
/*  2871*/    /*Scope*/ 18, /*->2890*/
/*  2872*/     OPC_CheckChild2TypeI64,
/*  2873*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2874*/     OPC_CheckPredicate5,  // Predicate_store
/*  2875*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  2876*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2878*/     OPC_EmitMergeInputChains1_0,
/*  2879*/     OPC_EmitInteger32, 0, 
/*  2881*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v2i64:{ *:[v2i64] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, v2i64:{ *:[v2i64] }:$val)
/*  2890*/    0, /*End of Scope*/
/*  2891*/   /*Scope*/ 43, /*->2935*/
/*  2892*/    OPC_CheckChild1Type, MVT::v4f32,
/*  2894*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  2895*/    OPC_Scope, 18, /*->2915*/ // 2 children in Scope
/*  2897*/     OPC_CheckChild2TypeI32,
/*  2898*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2899*/     OPC_CheckPredicate5,  // Predicate_store
/*  2900*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  2901*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2903*/     OPC_EmitMergeInputChains1_0,
/*  2904*/     OPC_EmitInteger32, 0, 
/*  2906*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v4f32:{ *:[v4f32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, v4f32:{ *:[v4f32] }:$val)
/*  2915*/    /*Scope*/ 18, /*->2934*/
/*  2916*/     OPC_CheckChild2TypeI64,
/*  2917*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2918*/     OPC_CheckPredicate5,  // Predicate_store
/*  2919*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  2920*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2922*/     OPC_EmitMergeInputChains1_0,
/*  2923*/     OPC_EmitInteger32, 0, 
/*  2925*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v4f32:{ *:[v4f32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, v4f32:{ *:[v4f32] }:$val)
/*  2934*/    0, /*End of Scope*/
/*  2935*/   /*Scope*/ 43, /*->2979*/
/*  2936*/    OPC_CheckChild1Type, MVT::v2f64,
/*  2938*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  2939*/    OPC_Scope, 18, /*->2959*/ // 2 children in Scope
/*  2941*/     OPC_CheckChild2TypeI32,
/*  2942*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2943*/     OPC_CheckPredicate5,  // Predicate_store
/*  2944*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  2945*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2947*/     OPC_EmitMergeInputChains1_0,
/*  2948*/     OPC_EmitInteger32, 0, 
/*  2950*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v2f64:{ *:[v2f64] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, v2f64:{ *:[v2f64] }:$val)
/*  2959*/    /*Scope*/ 18, /*->2978*/
/*  2960*/     OPC_CheckChild2TypeI64,
/*  2961*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2962*/     OPC_CheckPredicate5,  // Predicate_store
/*  2963*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  2964*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2966*/     OPC_EmitMergeInputChains1_0,
/*  2967*/     OPC_EmitInteger32, 0, 
/*  2969*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v2f64:{ *:[v2f64] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, v2f64:{ *:[v2f64] }:$val)
/*  2978*/    0, /*End of Scope*/
/*  2979*/   0, /*End of Scope*/
/*  2980*/  0, /*End of Scope*/
/*  2981*/ /*SwitchOpcode*/ 22|128,2/*278*/, TARGET_VAL(ISD::INTRINSIC_VOID),// ->3263
/*  2985*/  OPC_Scope, 40, /*->3027*/ // 3 children in Scope
/*  2987*/   OPC_RecordNode, // #0 = 'intrinsic_void' chained node
/*  2988*/   OPC_CheckChild1Integer, 14|128,62|128,1/*24334*/, 
/*  2992*/   OPC_MoveChild2,
/*  2993*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  2996*/   OPC_RecordChild0, // #1 = $table1
/*  2997*/   OPC_MoveChild0,
/*  2998*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3001*/   OPC_MoveParent,
/*  3002*/   OPC_MoveSibling3,
/*  3003*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3006*/   OPC_RecordChild0, // #2 = $table2
/*  3007*/   OPC_MoveChild0,
/*  3008*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3011*/   OPC_MoveParent,
/*  3012*/   OPC_MoveParent,
/*  3013*/   OPC_RecordChild4, // #3 = $d
/*  3014*/   OPC_RecordChild5, // #4 = $s
/*  3015*/   OPC_RecordChild6, // #5 = $n
/*  3016*/   OPC_CheckPatternPredicate5, // (Subtarget->hasReferenceTypes())
/*  3017*/   OPC_EmitMergeInputChains1_0,
/*  3018*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::TABLE_COPY),
                 5/*#Ops*/, 1, 2, 3, 4, 5, 
             // Src: (intrinsic_void 12167:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table1), (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table2), I32:{ *:[i32] }:$d, I32:{ *:[i32] }:$s, I32:{ *:[i32] }:$n) - Complexity = 20
             // Dst: (TABLE_COPY (tglobaladdr:{ *:[i32] }):$table1, (tglobaladdr:{ *:[i32] }):$table2, I32:{ *:[i32] }:$d, I32:{ *:[i32] }:$s, I32:{ *:[i32] }:$n)
/*  3027*/  /*Scope*/ 44, /*->3072*/
/*  3028*/   OPC_RecordMemRef,
/*  3029*/   OPC_RecordNode, // #0 = 'intrinsic_void' chained node
/*  3030*/   OPC_CheckChild1Integer, 6|128,62|128,1/*24326*/, 
/*  3034*/   OPC_RecordChild2, // #1 = $val
/*  3035*/   OPC_RecordChild3, // #2 = $AddrOps32:offset:addr
/*  3036*/   OPC_Scope, 16, /*->3054*/ // 2 children in Scope
/*  3038*/    OPC_CheckChild3TypeI32,
/*  3039*/    OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  3040*/    OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  3042*/    OPC_EmitMergeInputChains1_0,
/*  3043*/    OPC_EmitInteger32, 0, 
/*  3045*/    OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F16_F32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  4/*#Ops*/, 5, 3, 4, 1, 
              // Src: (intrinsic_void 12163:{ *:[iPTR] }, f32:{ *:[f32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)) - Complexity = 17
              // Dst: (STORE_F16_F32_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, f32:{ *:[f32] }:$val)
/*  3054*/   /*Scope*/ 16, /*->3071*/
/*  3055*/    OPC_CheckChild3TypeI64,
/*  3056*/    OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  3057*/    OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  3059*/    OPC_EmitMergeInputChains1_0,
/*  3060*/    OPC_EmitInteger32, 0, 
/*  3062*/    OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F16_F32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  4/*#Ops*/, 5, 3, 4, 1, 
              // Src: (intrinsic_void 12163:{ *:[iPTR] }, f32:{ *:[f32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)) - Complexity = 17
              // Dst: (STORE_F16_F32_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, f32:{ *:[f32] }:$val)
/*  3071*/   0, /*End of Scope*/
/*  3072*/  /*Scope*/ 60|128,1/*188*/, /*->3262*/
/*  3074*/   OPC_RecordNode, // #0 = 'intrinsic_void' chained node
/*  3075*/   OPC_Scope, 26, /*->3103*/ // 7 children in Scope
/*  3077*/    OPC_CheckChild1Integer, 38|128,62|128,1/*24358*/, 
/*  3081*/    OPC_MoveChild2,
/*  3082*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3085*/    OPC_RecordChild0, // #1 = $table
/*  3086*/    OPC_MoveChild0,
/*  3087*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3090*/    OPC_MoveParent,
/*  3091*/    OPC_MoveParent,
/*  3092*/    OPC_RecordChild3, // #2 = $i
/*  3093*/    OPC_RecordChild4, // #3 = $val
/*  3094*/    OPC_CheckPatternPredicate5, // (Subtarget->hasReferenceTypes())
/*  3095*/    OPC_EmitMergeInputChains1_0,
/*  3096*/    OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::TABLE_SET_FUNCREF),
                  3/*#Ops*/, 1, 2, 3, 
              // Src: (intrinsic_void 12179:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), I32:{ *:[i32] }:$i, FUNCREF:{ *:[funcref] }:$val) - Complexity = 14
              // Dst: (TABLE_SET_FUNCREF (tglobaladdr:{ *:[i32] }):$table, I32:{ *:[i32] }:$i, FUNCREF:{ *:[funcref] }:$val)
/*  3103*/   /*Scope*/ 28, /*->3132*/
/*  3104*/    OPC_CheckChild1Integer, 20|128,62|128,1/*24340*/, 
/*  3108*/    OPC_MoveChild2,
/*  3109*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3112*/    OPC_RecordChild0, // #1 = $table
/*  3113*/    OPC_MoveChild0,
/*  3114*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3117*/    OPC_MoveParent,
/*  3118*/    OPC_MoveParent,
/*  3119*/    OPC_RecordChild3, // #2 = $i
/*  3120*/    OPC_RecordChild4, // #3 = $val
/*  3121*/    OPC_RecordChild5, // #4 = $n
/*  3122*/    OPC_CheckPatternPredicate5, // (Subtarget->hasReferenceTypes())
/*  3123*/    OPC_EmitMergeInputChains1_0,
/*  3124*/    OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::TABLE_FILL_FUNCREF),
                  4/*#Ops*/, 1, 2, 3, 4, 
              // Src: (intrinsic_void 12170:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), I32:{ *:[i32] }:$i, FUNCREF:{ *:[funcref] }:$val, I32:{ *:[i32] }:$n) - Complexity = 14
              // Dst: (TABLE_FILL_FUNCREF (tglobaladdr:{ *:[i32] }):$table, I32:{ *:[i32] }:$i, FUNCREF:{ *:[funcref] }:$val, I32:{ *:[i32] }:$n)
/*  3132*/   /*Scope*/ 26, /*->3159*/
/*  3133*/    OPC_CheckChild1Integer, 36|128,62|128,1/*24356*/, 
/*  3137*/    OPC_MoveChild2,
/*  3138*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3141*/    OPC_RecordChild0, // #1 = $table
/*  3142*/    OPC_MoveChild0,
/*  3143*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3146*/    OPC_MoveParent,
/*  3147*/    OPC_MoveParent,
/*  3148*/    OPC_RecordChild3, // #2 = $i
/*  3149*/    OPC_RecordChild4, // #3 = $val
/*  3150*/    OPC_CheckPatternPredicate5, // (Subtarget->hasReferenceTypes())
/*  3151*/    OPC_EmitMergeInputChains1_0,
/*  3152*/    OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::TABLE_SET_EXTERNREF),
                  3/*#Ops*/, 1, 2, 3, 
              // Src: (intrinsic_void 12178:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), I32:{ *:[i32] }:$i, EXTERNREF:{ *:[externref] }:$val) - Complexity = 14
              // Dst: (TABLE_SET_EXTERNREF (tglobaladdr:{ *:[i32] }):$table, I32:{ *:[i32] }:$i, EXTERNREF:{ *:[externref] }:$val)
/*  3159*/   /*Scope*/ 28, /*->3188*/
/*  3160*/    OPC_CheckChild1Integer, 18|128,62|128,1/*24338*/, 
/*  3164*/    OPC_MoveChild2,
/*  3165*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3168*/    OPC_RecordChild0, // #1 = $table
/*  3169*/    OPC_MoveChild0,
/*  3170*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3173*/    OPC_MoveParent,
/*  3174*/    OPC_MoveParent,
/*  3175*/    OPC_RecordChild3, // #2 = $i
/*  3176*/    OPC_RecordChild4, // #3 = $val
/*  3177*/    OPC_RecordChild5, // #4 = $n
/*  3178*/    OPC_CheckPatternPredicate5, // (Subtarget->hasReferenceTypes())
/*  3179*/    OPC_EmitMergeInputChains1_0,
/*  3180*/    OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::TABLE_FILL_EXTERNREF),
                  4/*#Ops*/, 1, 2, 3, 4, 
              // Src: (intrinsic_void 12169:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), I32:{ *:[i32] }:$i, EXTERNREF:{ *:[externref] }:$val, I32:{ *:[i32] }:$n) - Complexity = 14
              // Dst: (TABLE_FILL_EXTERNREF (tglobaladdr:{ *:[i32] }):$table, I32:{ *:[i32] }:$i, EXTERNREF:{ *:[externref] }:$val, I32:{ *:[i32] }:$n)
/*  3188*/   /*Scope*/ 27, /*->3216*/
/*  3189*/    OPC_CheckChild1Integer, 34|128,62|128,1/*24354*/, 
/*  3193*/    OPC_MoveChild2,
/*  3194*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3197*/    OPC_RecordChild0, // #1 = $table
/*  3198*/    OPC_MoveChild0,
/*  3199*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3202*/    OPC_MoveParent,
/*  3203*/    OPC_MoveParent,
/*  3204*/    OPC_RecordChild3, // #2 = $i
/*  3205*/    OPC_RecordChild4, // #3 = $val
/*  3206*/    OPC_CheckPatternPredicate, 8, // (Subtarget->hasExceptionHandling()) && (Subtarget->hasReferenceTypes())
/*  3208*/    OPC_EmitMergeInputChains1_0,
/*  3209*/    OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::TABLE_SET_EXNREF),
                  3/*#Ops*/, 1, 2, 3, 
              // Src: (intrinsic_void 12177:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), I32:{ *:[i32] }:$i, EXNREF:{ *:[exnref] }:$val) - Complexity = 14
              // Dst: (TABLE_SET_EXNREF (tglobaladdr:{ *:[i32] }):$table, I32:{ *:[i32] }:$i, EXNREF:{ *:[exnref] }:$val)
/*  3216*/   /*Scope*/ 29, /*->3246*/
/*  3217*/    OPC_CheckChild1Integer, 16|128,62|128,1/*24336*/, 
/*  3221*/    OPC_MoveChild2,
/*  3222*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3225*/    OPC_RecordChild0, // #1 = $table
/*  3226*/    OPC_MoveChild0,
/*  3227*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3230*/    OPC_MoveParent,
/*  3231*/    OPC_MoveParent,
/*  3232*/    OPC_RecordChild3, // #2 = $i
/*  3233*/    OPC_RecordChild4, // #3 = $val
/*  3234*/    OPC_RecordChild5, // #4 = $n
/*  3235*/    OPC_CheckPatternPredicate, 8, // (Subtarget->hasExceptionHandling()) && (Subtarget->hasReferenceTypes())
/*  3237*/    OPC_EmitMergeInputChains1_0,
/*  3238*/    OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::TABLE_FILL_EXNREF),
                  4/*#Ops*/, 1, 2, 3, 4, 
              // Src: (intrinsic_void 12168:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), I32:{ *:[i32] }:$i, EXNREF:{ *:[exnref] }:$val, I32:{ *:[i32] }:$n) - Complexity = 14
              // Dst: (TABLE_FILL_EXNREF (tglobaladdr:{ *:[i32] }):$table, I32:{ *:[i32] }:$i, EXNREF:{ *:[exnref] }:$val, I32:{ *:[i32] }:$n)
/*  3246*/   /*Scope*/ 14, /*->3261*/
/*  3247*/    OPC_CheckChild1Integer, 0|128,62|128,1/*24320*/, 
/*  3251*/    OPC_CheckPatternPredicate, 16, // (Subtarget->hasExceptionHandling())
/*  3253*/    OPC_EmitMergeInputChains1_0,
/*  3254*/    OPC_EmitInteger32, 0, 
/*  3256*/    OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::RETHROW),
                  1/*#Ops*/, 1, 
              // Src: (intrinsic_void 12160:{ *:[iPTR] }) - Complexity = 8
              // Dst: (RETHROW 0:{ *:[i32] })
/*  3261*/   0, /*End of Scope*/
/*  3262*/  0, /*End of Scope*/
/*  3263*/ /*SwitchOpcode*/ 78|128,3/*462*/, TARGET_VAL(ISD::INTRINSIC_W_CHAIN),// ->3729
/*  3267*/  OPC_Scope, 22|128,1/*150*/, /*->3420*/ // 3 children in Scope
/*  3270*/   OPC_RecordMemRef,
/*  3271*/   OPC_RecordNode, // #0 = 'intrinsic_w_chain' chained node
/*  3272*/   OPC_Scope, 45, /*->3319*/ // 3 children in Scope
/*  3274*/    OPC_CheckChild1Integer, 68|128,61|128,1/*24260*/, 
/*  3278*/    OPC_RecordChild2, // #1 = $AddrOps32:offset:addr
/*  3279*/    OPC_Scope, 18, /*->3299*/ // 2 children in Scope
/*  3281*/     OPC_CheckChild2TypeI32,
/*  3282*/     OPC_RecordChild3, // #2 = $count
/*  3283*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3284*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  3286*/     OPC_EmitMergeInputChains1_0,
/*  3287*/     OPC_EmitInteger32, 0, 
/*  3289*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_NOTIFY_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (intrinsic_w_chain:{ *:[i32] } 12130:{ *:[iPTR] }, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), I32:{ *:[i32] }:$count) - Complexity = 17
               // Dst: (MEMORY_ATOMIC_NOTIFY_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$count)
/*  3299*/    /*Scope*/ 18, /*->3318*/
/*  3300*/     OPC_CheckChild2TypeI64,
/*  3301*/     OPC_RecordChild3, // #2 = $count
/*  3302*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3303*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  3305*/     OPC_EmitMergeInputChains1_0,
/*  3306*/     OPC_EmitInteger32, 0, 
/*  3308*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_NOTIFY_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (intrinsic_w_chain:{ *:[i32] } 12130:{ *:[iPTR] }, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), I32:{ *:[i32] }:$count) - Complexity = 17
               // Dst: (MEMORY_ATOMIC_NOTIFY_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$count)
/*  3318*/    0, /*End of Scope*/
/*  3319*/   /*Scope*/ 49, /*->3369*/
/*  3320*/    OPC_CheckChild1Integer, 70|128,61|128,1/*24262*/, 
/*  3324*/    OPC_RecordChild2, // #1 = $AddrOps32:offset:addr
/*  3325*/    OPC_Scope, 20, /*->3347*/ // 2 children in Scope
/*  3327*/     OPC_CheckChild2TypeI32,
/*  3328*/     OPC_RecordChild3, // #2 = $exp
/*  3329*/     OPC_RecordChild4, // #3 = $timeout
/*  3330*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3331*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  3333*/     OPC_EmitMergeInputChains1_0,
/*  3334*/     OPC_EmitInteger32, 0, 
/*  3336*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_WAIT32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (intrinsic_w_chain:{ *:[i32] } 12131:{ *:[iPTR] }, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$exp, I64:{ *:[i64] }:$timeout) - Complexity = 17
               // Dst: (MEMORY_ATOMIC_WAIT32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i64] }:$timeout)
/*  3347*/    /*Scope*/ 20, /*->3368*/
/*  3348*/     OPC_CheckChild2TypeI64,
/*  3349*/     OPC_RecordChild3, // #2 = $exp
/*  3350*/     OPC_RecordChild4, // #3 = $timeout
/*  3351*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3352*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  3354*/     OPC_EmitMergeInputChains1_0,
/*  3355*/     OPC_EmitInteger32, 0, 
/*  3357*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_WAIT32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (intrinsic_w_chain:{ *:[i32] } 12131:{ *:[iPTR] }, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$exp, I64:{ *:[i64] }:$timeout) - Complexity = 17
               // Dst: (MEMORY_ATOMIC_WAIT32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i64] }:$timeout)
/*  3368*/    0, /*End of Scope*/
/*  3369*/   /*Scope*/ 49, /*->3419*/
/*  3370*/    OPC_CheckChild1Integer, 72|128,61|128,1/*24264*/, 
/*  3374*/    OPC_RecordChild2, // #1 = $AddrOps32:offset:addr
/*  3375*/    OPC_Scope, 20, /*->3397*/ // 2 children in Scope
/*  3377*/     OPC_CheckChild2TypeI32,
/*  3378*/     OPC_RecordChild3, // #2 = $exp
/*  3379*/     OPC_RecordChild4, // #3 = $timeout
/*  3380*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3381*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  3383*/     OPC_EmitMergeInputChains1_0,
/*  3384*/     OPC_EmitInteger32, 0, 
/*  3386*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_WAIT64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (intrinsic_w_chain:{ *:[i32] } 12132:{ *:[iPTR] }, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$exp, I64:{ *:[i64] }:$timeout) - Complexity = 17
               // Dst: (MEMORY_ATOMIC_WAIT64_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$timeout)
/*  3397*/    /*Scope*/ 20, /*->3418*/
/*  3398*/     OPC_CheckChild2TypeI64,
/*  3399*/     OPC_RecordChild3, // #2 = $exp
/*  3400*/     OPC_RecordChild4, // #3 = $timeout
/*  3401*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3402*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  3404*/     OPC_EmitMergeInputChains1_0,
/*  3405*/     OPC_EmitInteger32, 0, 
/*  3407*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_WAIT64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (intrinsic_w_chain:{ *:[i32] } 12132:{ *:[iPTR] }, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i64:{ *:[i64] }:$exp, I64:{ *:[i64] }:$timeout) - Complexity = 17
               // Dst: (MEMORY_ATOMIC_WAIT64_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$timeout)
/*  3418*/    0, /*End of Scope*/
/*  3419*/   0, /*End of Scope*/
/*  3420*/  /*Scope*/ 6|128,2/*262*/, /*->3684*/
/*  3422*/   OPC_RecordNode, // #0 = 'intrinsic_w_chain' chained node
/*  3423*/   OPC_Scope, 25, /*->3450*/ // 9 children in Scope
/*  3425*/    OPC_CheckChild1Integer, 26|128,62|128,1/*24346*/, 
/*  3429*/    OPC_MoveChild2,
/*  3430*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3433*/    OPC_RecordChild0, // #1 = $table
/*  3434*/    OPC_MoveChild0,
/*  3435*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3438*/    OPC_MoveParent,
/*  3439*/    OPC_MoveParent,
/*  3440*/    OPC_RecordChild3, // #2 = $i
/*  3441*/    OPC_CheckPatternPredicate5, // (Subtarget->hasReferenceTypes())
/*  3442*/    OPC_EmitMergeInputChains1_0,
/*  3443*/    OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::TABLE_GET_FUNCREF),
                  MVT::funcref, 2/*#Ops*/, 1, 2, 
              // Src: (intrinsic_w_chain:{ *:[funcref] } 12173:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), I32:{ *:[i32] }:$i) - Complexity = 14
              // Dst: (TABLE_GET_FUNCREF:{ *:[funcref] } (tglobaladdr:{ *:[i32] }):$table, I32:{ *:[i32] }:$i)
/*  3450*/   /*Scope*/ 27, /*->3478*/
/*  3451*/    OPC_CheckChild1Integer, 32|128,62|128,1/*24352*/, 
/*  3455*/    OPC_MoveChild2,
/*  3456*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3459*/    OPC_RecordChild0, // #1 = $table
/*  3460*/    OPC_MoveChild0,
/*  3461*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3464*/    OPC_MoveParent,
/*  3465*/    OPC_MoveParent,
/*  3466*/    OPC_RecordChild3, // #2 = $val
/*  3467*/    OPC_RecordChild4, // #3 = $n
/*  3468*/    OPC_CheckPatternPredicate5, // (Subtarget->hasReferenceTypes())
/*  3469*/    OPC_EmitMergeInputChains1_0,
/*  3470*/    OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::TABLE_GROW_FUNCREF),
                  MVT::i32, 3/*#Ops*/, 1, 2, 3, 
              // Src: (intrinsic_w_chain:{ *:[i32] } 12176:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), FUNCREF:{ *:[funcref] }:$val, I32:{ *:[i32] }:$n) - Complexity = 14
              // Dst: (TABLE_GROW_FUNCREF:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$table, FUNCREF:{ *:[funcref] }:$val, I32:{ *:[i32] }:$n)
/*  3478*/   /*Scope*/ 25, /*->3504*/
/*  3479*/    OPC_CheckChild1Integer, 24|128,62|128,1/*24344*/, 
/*  3483*/    OPC_MoveChild2,
/*  3484*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3487*/    OPC_RecordChild0, // #1 = $table
/*  3488*/    OPC_MoveChild0,
/*  3489*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3492*/    OPC_MoveParent,
/*  3493*/    OPC_MoveParent,
/*  3494*/    OPC_RecordChild3, // #2 = $i
/*  3495*/    OPC_CheckPatternPredicate5, // (Subtarget->hasReferenceTypes())
/*  3496*/    OPC_EmitMergeInputChains1_0,
/*  3497*/    OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::TABLE_GET_EXTERNREF),
                  MVT::externref, 2/*#Ops*/, 1, 2, 
              // Src: (intrinsic_w_chain:{ *:[externref] } 12172:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), I32:{ *:[i32] }:$i) - Complexity = 14
              // Dst: (TABLE_GET_EXTERNREF:{ *:[externref] } (tglobaladdr:{ *:[i32] }):$table, I32:{ *:[i32] }:$i)
/*  3504*/   /*Scope*/ 27, /*->3532*/
/*  3505*/    OPC_CheckChild1Integer, 30|128,62|128,1/*24350*/, 
/*  3509*/    OPC_MoveChild2,
/*  3510*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3513*/    OPC_RecordChild0, // #1 = $table
/*  3514*/    OPC_MoveChild0,
/*  3515*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3518*/    OPC_MoveParent,
/*  3519*/    OPC_MoveParent,
/*  3520*/    OPC_RecordChild3, // #2 = $val
/*  3521*/    OPC_RecordChild4, // #3 = $n
/*  3522*/    OPC_CheckPatternPredicate5, // (Subtarget->hasReferenceTypes())
/*  3523*/    OPC_EmitMergeInputChains1_0,
/*  3524*/    OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::TABLE_GROW_EXTERNREF),
                  MVT::i32, 3/*#Ops*/, 1, 2, 3, 
              // Src: (intrinsic_w_chain:{ *:[i32] } 12175:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), EXTERNREF:{ *:[externref] }:$val, I32:{ *:[i32] }:$n) - Complexity = 14
              // Dst: (TABLE_GROW_EXTERNREF:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$table, EXTERNREF:{ *:[externref] }:$val, I32:{ *:[i32] }:$n)
/*  3532*/   /*Scope*/ 26, /*->3559*/
/*  3533*/    OPC_CheckChild1Integer, 22|128,62|128,1/*24342*/, 
/*  3537*/    OPC_MoveChild2,
/*  3538*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3541*/    OPC_RecordChild0, // #1 = $table
/*  3542*/    OPC_MoveChild0,
/*  3543*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3546*/    OPC_MoveParent,
/*  3547*/    OPC_MoveParent,
/*  3548*/    OPC_RecordChild3, // #2 = $i
/*  3549*/    OPC_CheckPatternPredicate, 8, // (Subtarget->hasExceptionHandling()) && (Subtarget->hasReferenceTypes())
/*  3551*/    OPC_EmitMergeInputChains1_0,
/*  3552*/    OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::TABLE_GET_EXNREF),
                  MVT::exnref, 2/*#Ops*/, 1, 2, 
              // Src: (intrinsic_w_chain:{ *:[exnref] } 12171:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), I32:{ *:[i32] }:$i) - Complexity = 14
              // Dst: (TABLE_GET_EXNREF:{ *:[exnref] } (tglobaladdr:{ *:[i32] }):$table, I32:{ *:[i32] }:$i)
/*  3559*/   /*Scope*/ 28, /*->3588*/
/*  3560*/    OPC_CheckChild1Integer, 28|128,62|128,1/*24348*/, 
/*  3564*/    OPC_MoveChild2,
/*  3565*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3568*/    OPC_RecordChild0, // #1 = $table
/*  3569*/    OPC_MoveChild0,
/*  3570*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3573*/    OPC_MoveParent,
/*  3574*/    OPC_MoveParent,
/*  3575*/    OPC_RecordChild3, // #2 = $val
/*  3576*/    OPC_RecordChild4, // #3 = $n
/*  3577*/    OPC_CheckPatternPredicate, 8, // (Subtarget->hasExceptionHandling()) && (Subtarget->hasReferenceTypes())
/*  3579*/    OPC_EmitMergeInputChains1_0,
/*  3580*/    OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::TABLE_GROW_EXNREF),
                  MVT::i32, 3/*#Ops*/, 1, 2, 3, 
              // Src: (intrinsic_w_chain:{ *:[i32] } 12174:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), EXNREF:{ *:[exnref] }:$val, I32:{ *:[i32] }:$n) - Complexity = 14
              // Dst: (TABLE_GROW_EXNREF:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$table, EXNREF:{ *:[exnref] }:$val, I32:{ *:[i32] }:$n)
/*  3588*/   /*Scope*/ 23, /*->3612*/
/*  3589*/    OPC_CheckChild1Integer, 40|128,62|128,1/*24360*/, 
/*  3593*/    OPC_MoveChild2,
/*  3594*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3597*/    OPC_RecordChild0, // #1 = $table
/*  3598*/    OPC_MoveChild0,
/*  3599*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3602*/    OPC_MoveParent,
/*  3603*/    OPC_MoveParent,
/*  3604*/    OPC_CheckPatternPredicate5, // (Subtarget->hasReferenceTypes())
/*  3605*/    OPC_EmitMergeInputChains1_0,
/*  3606*/    OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::TABLE_SIZE),
                  MVT::i32, 1/*#Ops*/, 1, 
              // Src: (intrinsic_w_chain:{ *:[i32] } 12180:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table)) - Complexity = 14
              // Dst: (TABLE_SIZE:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$table)
/*  3612*/   /*Scope*/ 32, /*->3645*/
/*  3613*/    OPC_CheckChild1Integer, 76|128,61|128,1/*24268*/, 
/*  3617*/    OPC_RecordChild2, // #1 = $flags
/*  3618*/    OPC_MoveChild2,
/*  3619*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  3622*/    OPC_MoveParent,
/*  3623*/    OPC_SwitchType /*2 cases */, 8, MVT::i32,// ->3634
/*  3626*/     OPC_EmitMergeInputChains1_0,
/*  3627*/     OPC_EmitConvertToTarget1,
/*  3628*/     OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::anonymous_7391MEMORY_SIZE_A32),
                   MVT::i32, 1/*#Ops*/, 2, 
               // Src: (intrinsic_w_chain:{ *:[i32] } 12134:{ *:[iPTR] }, (imm:{ *:[i32] }):$flags) - Complexity = 11
               // Dst: (anonymous_7391MEMORY_SIZE_A32:{ *:[i32] } (imm:{ *:[i32] }):$flags)
/*  3634*/    /*SwitchType*/ 8, MVT::i64,// ->3644
/*  3636*/     OPC_EmitMergeInputChains1_0,
/*  3637*/     OPC_EmitConvertToTarget1,
/*  3638*/     OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::anonymous_7392MEMORY_SIZE_A64),
                   MVT::i64, 1/*#Ops*/, 2, 
               // Src: (intrinsic_w_chain:{ *:[i64] } 12134:{ *:[iPTR] }, (imm:{ *:[i32] }):$flags) - Complexity = 11
               // Dst: (anonymous_7392MEMORY_SIZE_A64:{ *:[i64] } (imm:{ *:[i32] }):$flags)
/*  3644*/    0, // EndSwitchType
/*  3645*/   /*Scope*/ 37, /*->3683*/
/*  3646*/    OPC_CheckChild1Integer, 74|128,61|128,1/*24266*/, 
/*  3650*/    OPC_RecordChild2, // #1 = $flags
/*  3651*/    OPC_MoveChild2,
/*  3652*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  3655*/    OPC_MoveParent,
/*  3656*/    OPC_RecordChild3, // #2 = $delta
/*  3657*/    OPC_SwitchType /*2 cases */, 10, MVT::i32,// ->3670
/*  3660*/     OPC_CheckChild3TypeI32,
/*  3661*/     OPC_EmitMergeInputChains1_0,
/*  3662*/     OPC_EmitConvertToTarget1,
/*  3663*/     OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::anonymous_7391MEMORY_GROW_A32),
                   MVT::i32, 2/*#Ops*/, 3, 2, 
               // Src: (intrinsic_w_chain:{ *:[i32] } 12133:{ *:[iPTR] }, (imm:{ *:[i32] }):$flags, I32:{ *:[i32] }:$delta) - Complexity = 11
               // Dst: (anonymous_7391MEMORY_GROW_A32:{ *:[i32] } (imm:{ *:[i32] }):$flags, I32:{ *:[i32] }:$delta)
/*  3670*/    /*SwitchType*/ 10, MVT::i64,// ->3682
/*  3672*/     OPC_CheckChild3TypeI64,
/*  3673*/     OPC_EmitMergeInputChains1_0,
/*  3674*/     OPC_EmitConvertToTarget1,
/*  3675*/     OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::anonymous_7392MEMORY_GROW_A64),
                   MVT::i64, 2/*#Ops*/, 3, 2, 
               // Src: (intrinsic_w_chain:{ *:[i64] } 12133:{ *:[iPTR] }, (imm:{ *:[i32] }):$flags, I64:{ *:[i64] }:$delta) - Complexity = 11
               // Dst: (anonymous_7392MEMORY_GROW_A64:{ *:[i64] } (imm:{ *:[i32] }):$flags, I64:{ *:[i64] }:$delta)
/*  3682*/    0, // EndSwitchType
/*  3683*/   0, /*End of Scope*/
/*  3684*/  /*Scope*/ 43, /*->3728*/
/*  3685*/   OPC_RecordMemRef,
/*  3686*/   OPC_RecordNode, // #0 = 'intrinsic_w_chain' chained node
/*  3687*/   OPC_CheckChild1Integer, 64|128,61|128,1/*24256*/, 
/*  3691*/   OPC_RecordChild2, // #1 = $AddrOps32:offset:addr
/*  3692*/   OPC_Scope, 16, /*->3710*/ // 2 children in Scope
/*  3694*/    OPC_CheckChild2TypeI32,
/*  3695*/    OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  3696*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  3698*/    OPC_EmitMergeInputChains1_0,
/*  3699*/    OPC_EmitInteger32, 0, 
/*  3701*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F16_F32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::f32, 3/*#Ops*/, 4, 2, 3, 
              // Src: (intrinsic_w_chain:{ *:[f32] } 12128:{ *:[iPTR] }, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)) - Complexity = 17
              // Dst: (LOAD_F16_F32_A32:{ *:[f32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  3710*/   /*Scope*/ 16, /*->3727*/
/*  3711*/    OPC_CheckChild2TypeI64,
/*  3712*/    OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  3713*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  3715*/    OPC_EmitMergeInputChains1_0,
/*  3716*/    OPC_EmitInteger32, 0, 
/*  3718*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F16_F32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::f32, 3/*#Ops*/, 4, 2, 3, 
              // Src: (intrinsic_w_chain:{ *:[f32] } 12128:{ *:[iPTR] }, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)) - Complexity = 17
              // Dst: (LOAD_F16_F32_A64:{ *:[f32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  3727*/   0, /*End of Scope*/
/*  3728*/  0, /*End of Scope*/
/*  3729*/ /*SwitchOpcode*/ 29|128,2/*285*/, TARGET_VAL(ISD::ATOMIC_STORE),// ->4018
/*  3733*/  OPC_RecordMemRef,
/*  3734*/  OPC_RecordNode, // #0 = 'atomic_store' chained node
/*  3735*/  OPC_Scope, 119, /*->3856*/ // 2 children in Scope
/*  3737*/   OPC_MoveChild1,
/*  3738*/   OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  3741*/   OPC_RecordChild0, // #1 = $val
/*  3742*/   OPC_MoveParent,
/*  3743*/   OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  3744*/   OPC_Scope, 54, /*->3800*/ // 2 children in Scope
/*  3746*/    OPC_CheckChild2TypeI32,
/*  3747*/    OPC_Scope, 16, /*->3765*/ // 3 children in Scope
/*  3749*/     OPC_CheckPredicate1,  // Predicate_atomic_store_8
/*  3750*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3751*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  3753*/     OPC_EmitMergeInputChains1_0,
/*  3754*/     OPC_EmitInteger32, 0, 
/*  3756*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE8_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (atomic_store (trunc:{ *:[i32] } i64:{ *:[i64] }:$val), (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_store_8>> - Complexity = 16
               // Dst: (ATOMIC_STORE8_I64_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  3765*/    /*Scope*/ 16, /*->3782*/
/*  3766*/     OPC_CheckPredicate2,  // Predicate_atomic_store_16
/*  3767*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3768*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  3770*/     OPC_EmitMergeInputChains1_0,
/*  3771*/     OPC_EmitInteger32, 0, 
/*  3773*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE16_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (atomic_store (trunc:{ *:[i32] } i64:{ *:[i64] }:$val), (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_store_16>> - Complexity = 16
               // Dst: (ATOMIC_STORE16_I64_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  3782*/    /*Scope*/ 16, /*->3799*/
/*  3783*/     OPC_CheckPredicate3,  // Predicate_atomic_store_32
/*  3784*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3785*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  3787*/     OPC_EmitMergeInputChains1_0,
/*  3788*/     OPC_EmitInteger32, 0, 
/*  3790*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE32_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (atomic_store (trunc:{ *:[i32] } i64:{ *:[i64] }:$val), (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_store_32>> - Complexity = 16
               // Dst: (ATOMIC_STORE32_I64_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  3799*/    0, /*End of Scope*/
/*  3800*/   /*Scope*/ 54, /*->3855*/
/*  3801*/    OPC_CheckChild2TypeI64,
/*  3802*/    OPC_Scope, 16, /*->3820*/ // 3 children in Scope
/*  3804*/     OPC_CheckPredicate1,  // Predicate_atomic_store_8
/*  3805*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3806*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  3808*/     OPC_EmitMergeInputChains1_0,
/*  3809*/     OPC_EmitInteger32, 0, 
/*  3811*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE8_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (atomic_store (trunc:{ *:[i32] } i64:{ *:[i64] }:$val), (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_store_8>> - Complexity = 16
               // Dst: (ATOMIC_STORE8_I64_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  3820*/    /*Scope*/ 16, /*->3837*/
/*  3821*/     OPC_CheckPredicate2,  // Predicate_atomic_store_16
/*  3822*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3823*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  3825*/     OPC_EmitMergeInputChains1_0,
/*  3826*/     OPC_EmitInteger32, 0, 
/*  3828*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE16_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (atomic_store (trunc:{ *:[i32] } i64:{ *:[i64] }:$val), (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_store_16>> - Complexity = 16
               // Dst: (ATOMIC_STORE16_I64_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  3837*/    /*Scope*/ 16, /*->3854*/
/*  3838*/     OPC_CheckPredicate3,  // Predicate_atomic_store_32
/*  3839*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3840*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  3842*/     OPC_EmitMergeInputChains1_0,
/*  3843*/     OPC_EmitInteger32, 0, 
/*  3845*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE32_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (atomic_store (trunc:{ *:[i32] } i64:{ *:[i64] }:$val), (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_store_32>> - Complexity = 16
               // Dst: (ATOMIC_STORE32_I64_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  3854*/    0, /*End of Scope*/
/*  3855*/   0, /*End of Scope*/
/*  3856*/  /*Scope*/ 31|128,1/*159*/, /*->4017*/
/*  3858*/   OPC_RecordChild1, // #1 = $val
/*  3859*/   OPC_Scope, 114, /*->3975*/ // 2 children in Scope
/*  3861*/    OPC_CheckChild1TypeI32,
/*  3862*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  3863*/    OPC_Scope, 54, /*->3919*/ // 2 children in Scope
/*  3865*/     OPC_CheckChild2TypeI32,
/*  3866*/     OPC_Scope, 16, /*->3884*/ // 3 children in Scope
/*  3868*/      OPC_CheckPredicate3,  // Predicate_atomic_store_32
/*  3869*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3870*/      OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  3872*/      OPC_EmitMergeInputChains1_0,
/*  3873*/      OPC_EmitInteger32, 0, 
/*  3875*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (atomic_store i32:{ *:[i32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_store_32>> - Complexity = 13
                // Dst: (ATOMIC_STORE_I32_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  3884*/     /*Scope*/ 16, /*->3901*/
/*  3885*/      OPC_CheckPredicate1,  // Predicate_atomic_store_8
/*  3886*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3887*/      OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  3889*/      OPC_EmitMergeInputChains1_0,
/*  3890*/      OPC_EmitInteger32, 0, 
/*  3892*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE8_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (atomic_store i32:{ *:[i32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_store_8>> - Complexity = 13
                // Dst: (ATOMIC_STORE8_I32_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  3901*/     /*Scope*/ 16, /*->3918*/
/*  3902*/      OPC_CheckPredicate2,  // Predicate_atomic_store_16
/*  3903*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3904*/      OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  3906*/      OPC_EmitMergeInputChains1_0,
/*  3907*/      OPC_EmitInteger32, 0, 
/*  3909*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE16_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (atomic_store i32:{ *:[i32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_store_16>> - Complexity = 13
                // Dst: (ATOMIC_STORE16_I32_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  3918*/     0, /*End of Scope*/
/*  3919*/    /*Scope*/ 54, /*->3974*/
/*  3920*/     OPC_CheckChild2TypeI64,
/*  3921*/     OPC_Scope, 16, /*->3939*/ // 3 children in Scope
/*  3923*/      OPC_CheckPredicate3,  // Predicate_atomic_store_32
/*  3924*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3925*/      OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  3927*/      OPC_EmitMergeInputChains1_0,
/*  3928*/      OPC_EmitInteger32, 0, 
/*  3930*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (atomic_store i32:{ *:[i32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_store_32>> - Complexity = 13
                // Dst: (ATOMIC_STORE_I32_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  3939*/     /*Scope*/ 16, /*->3956*/
/*  3940*/      OPC_CheckPredicate1,  // Predicate_atomic_store_8
/*  3941*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3942*/      OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  3944*/      OPC_EmitMergeInputChains1_0,
/*  3945*/      OPC_EmitInteger32, 0, 
/*  3947*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE8_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (atomic_store i32:{ *:[i32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_store_8>> - Complexity = 13
                // Dst: (ATOMIC_STORE8_I32_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  3956*/     /*Scope*/ 16, /*->3973*/
/*  3957*/      OPC_CheckPredicate2,  // Predicate_atomic_store_16
/*  3958*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3959*/      OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  3961*/      OPC_EmitMergeInputChains1_0,
/*  3962*/      OPC_EmitInteger32, 0, 
/*  3964*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE16_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (atomic_store i32:{ *:[i32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_store_16>> - Complexity = 13
                // Dst: (ATOMIC_STORE16_I32_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  3973*/     0, /*End of Scope*/
/*  3974*/    0, /*End of Scope*/
/*  3975*/   /*Scope*/ 40, /*->4016*/
/*  3976*/    OPC_CheckChild1TypeI64,
/*  3977*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  3978*/    OPC_Scope, 17, /*->3997*/ // 2 children in Scope
/*  3980*/     OPC_CheckChild2TypeI32,
/*  3981*/     OPC_CheckPredicate6,  // Predicate_atomic_store_64
/*  3982*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3983*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  3985*/     OPC_EmitMergeInputChains1_0,
/*  3986*/     OPC_EmitInteger32, 0, 
/*  3988*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (atomic_store i64:{ *:[i64] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_store_64>> - Complexity = 13
               // Dst: (ATOMIC_STORE_I64_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  3997*/    /*Scope*/ 17, /*->4015*/
/*  3998*/     OPC_CheckChild2TypeI64,
/*  3999*/     OPC_CheckPredicate6,  // Predicate_atomic_store_64
/*  4000*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  4001*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  4003*/     OPC_EmitMergeInputChains1_0,
/*  4004*/     OPC_EmitInteger32, 0, 
/*  4006*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (atomic_store i64:{ *:[i64] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_store_64>> - Complexity = 13
               // Dst: (ATOMIC_STORE_I64_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  4015*/    0, /*End of Scope*/
/*  4016*/   0, /*End of Scope*/
/*  4017*/  0, /*End of Scope*/
/*  4018*/ /*SwitchOpcode*/ 90|128,2/*346*/, TARGET_VAL(ISD::AND),// ->4368
/*  4022*/  OPC_Scope, 118, /*->4142*/ // 6 children in Scope
/*  4024*/   OPC_MoveChild0,
/*  4025*/   OPC_CheckOpcode, TARGET_VAL(ISD::INTRINSIC_WO_CHAIN),
/*  4028*/   OPC_Scope, 55, /*->4085*/ // 2 children in Scope
/*  4030*/    OPC_CheckChild0Integer, 40|128,61|128,1/*24232*/, 
/*  4034*/    OPC_RecordChild1, // #0 = $x
/*  4035*/    OPC_Scope, 11, /*->4048*/ // 4 children in Scope
/*  4037*/     OPC_CheckChild1Type, MVT::v16i8,
/*  4039*/     OPC_MoveParent,
/*  4040*/     OPC_CheckChild1Integer, 2, 
/*  4042*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (and:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12116:{ *:[iPTR] }, V128:{ *:[v16i8] }:$x), 1:{ *:[i32] }) - Complexity = 16
               // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v16i8] }:$x)
/*  4048*/    /*Scope*/ 11, /*->4060*/
/*  4049*/     OPC_CheckChild1Type, MVT::v8i16,
/*  4051*/     OPC_MoveParent,
/*  4052*/     OPC_CheckChild1Integer, 2, 
/*  4054*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (and:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12116:{ *:[iPTR] }, V128:{ *:[v8i16] }:$x), 1:{ *:[i32] }) - Complexity = 16
               // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v8i16] }:$x)
/*  4060*/    /*Scope*/ 11, /*->4072*/
/*  4061*/     OPC_CheckChild1Type, MVT::v4i32,
/*  4063*/     OPC_MoveParent,
/*  4064*/     OPC_CheckChild1Integer, 2, 
/*  4066*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (and:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12116:{ *:[iPTR] }, V128:{ *:[v4i32] }:$x), 1:{ *:[i32] }) - Complexity = 16
               // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v4i32] }:$x)
/*  4072*/    /*Scope*/ 11, /*->4084*/
/*  4073*/     OPC_CheckChild1Type, MVT::v2i64,
/*  4075*/     OPC_MoveParent,
/*  4076*/     OPC_CheckChild1Integer, 2, 
/*  4078*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (and:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12116:{ *:[iPTR] }, V128:{ *:[v2i64] }:$x), 1:{ *:[i32] }) - Complexity = 16
               // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v2i64] }:$x)
/*  4084*/    0, /*End of Scope*/
/*  4085*/   /*Scope*/ 55, /*->4141*/
/*  4086*/    OPC_CheckChild0Integer, 38|128,61|128,1/*24230*/, 
/*  4090*/    OPC_RecordChild1, // #0 = $x
/*  4091*/    OPC_Scope, 11, /*->4104*/ // 4 children in Scope
/*  4093*/     OPC_CheckChild1Type, MVT::v16i8,
/*  4095*/     OPC_MoveParent,
/*  4096*/     OPC_CheckChild1Integer, 2, 
/*  4098*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I8x16),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (and:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12115:{ *:[iPTR] }, V128:{ *:[v16i8] }:$x), 1:{ *:[i32] }) - Complexity = 16
               // Dst: (ALLTRUE_I8x16:{ *:[i32] } ?:{ *:[v16i8] }:$x)
/*  4104*/    /*Scope*/ 11, /*->4116*/
/*  4105*/     OPC_CheckChild1Type, MVT::v8i16,
/*  4107*/     OPC_MoveParent,
/*  4108*/     OPC_CheckChild1Integer, 2, 
/*  4110*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I16x8),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (and:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12115:{ *:[iPTR] }, V128:{ *:[v8i16] }:$x), 1:{ *:[i32] }) - Complexity = 16
               // Dst: (ALLTRUE_I16x8:{ *:[i32] } ?:{ *:[v8i16] }:$x)
/*  4116*/    /*Scope*/ 11, /*->4128*/
/*  4117*/     OPC_CheckChild1Type, MVT::v4i32,
/*  4119*/     OPC_MoveParent,
/*  4120*/     OPC_CheckChild1Integer, 2, 
/*  4122*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I32x4),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (and:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12115:{ *:[iPTR] }, V128:{ *:[v4i32] }:$x), 1:{ *:[i32] }) - Complexity = 16
               // Dst: (ALLTRUE_I32x4:{ *:[i32] } ?:{ *:[v4i32] }:$x)
/*  4128*/    /*Scope*/ 11, /*->4140*/
/*  4129*/     OPC_CheckChild1Type, MVT::v2i64,
/*  4131*/     OPC_MoveParent,
/*  4132*/     OPC_CheckChild1Integer, 2, 
/*  4134*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I64x2),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (and:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12115:{ *:[iPTR] }, V128:{ *:[v2i64] }:$x), 1:{ *:[i32] }) - Complexity = 16
               // Dst: (ALLTRUE_I64x2:{ *:[i32] } ?:{ *:[v2i64] }:$x)
/*  4140*/    0, /*End of Scope*/
/*  4141*/   0, /*End of Scope*/
/*  4142*/  /*Scope*/ 29, /*->4172*/
/*  4143*/   OPC_CheckAndImm, 127|128,1/*255*/, 
/*  4146*/   OPC_MoveChild0,
/*  4147*/   OPC_CheckOpcode, TARGET_VAL(ISD::EXTRACT_VECTOR_ELT),
/*  4150*/   OPC_RecordChild0, // #0 = $vec
/*  4151*/   OPC_CheckChild0Type, MVT::v16i8,
/*  4153*/   OPC_RecordChild1, // #1 = $idx
/*  4154*/   OPC_MoveChild1,
/*  4155*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  4158*/   OPC_CheckPredicate, 11, // Predicate_LaneIdx16
/*  4160*/   OPC_CheckTypeI32,
/*  4161*/   OPC_MoveParent,
/*  4162*/   OPC_MoveParent,
/*  4163*/   OPC_CheckTypeI32,
/*  4164*/   OPC_EmitConvertToTarget1,
/*  4165*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_I8x16_u),
                 MVT::i32, 2/*#Ops*/, 0, 2, 
             // Src: (and:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx), 255:{ *:[i32] }) - Complexity = 15
             // Dst: (EXTRACT_LANE_I8x16_u:{ *:[i32] } ?:{ *:[v16i8] }:$vec, (imm:{ *:[i32] }):$idx)
/*  4172*/  /*Scope*/ 30, /*->4203*/
/*  4173*/   OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/*  4177*/   OPC_MoveChild0,
/*  4178*/   OPC_CheckOpcode, TARGET_VAL(ISD::EXTRACT_VECTOR_ELT),
/*  4181*/   OPC_RecordChild0, // #0 = $vec
/*  4182*/   OPC_CheckChild0Type, MVT::v8i16,
/*  4184*/   OPC_RecordChild1, // #1 = $idx
/*  4185*/   OPC_MoveChild1,
/*  4186*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  4189*/   OPC_CheckPredicate, 16, // Predicate_LaneIdx8
/*  4191*/   OPC_CheckTypeI32,
/*  4192*/   OPC_MoveParent,
/*  4193*/   OPC_MoveParent,
/*  4194*/   OPC_CheckTypeI32,
/*  4195*/   OPC_EmitConvertToTarget1,
/*  4196*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_I16x8_u),
                 MVT::i32, 2/*#Ops*/, 0, 2, 
             // Src: (and:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx), 65535:{ *:[i32] }) - Complexity = 15
             // Dst: (EXTRACT_LANE_I16x8_u:{ *:[i32] } ?:{ *:[v8i16] }:$vec, (imm:{ *:[i32] }):$idx)
/*  4203*/  /*Scope*/ 73, /*->4277*/
/*  4204*/   OPC_RecordChild0, // #0 = $lhs
/*  4205*/   OPC_Scope, 21, /*->4228*/ // 2 children in Scope
/*  4207*/    OPC_RecordChild1, // #1 = $rhs
/*  4208*/    OPC_SwitchType /*2 cases */, 7, MVT::i32,// ->4218
/*  4211*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AND_I32),
                   MVT::i32, 2/*#Ops*/, 0, 1, 
               // Src: (and:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
               // Dst: (AND_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4218*/    /*SwitchType*/ 7, MVT::i64,// ->4227
/*  4220*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AND_I64),
                   MVT::i64, 2/*#Ops*/, 0, 1, 
               // Src: (and:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
               // Dst: (AND_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  4227*/    0, // EndSwitchType
/*  4228*/   /*Scope*/ 47, /*->4276*/
/*  4229*/    OPC_MoveChild1,
/*  4230*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/*  4233*/    OPC_RecordChild0, // #1 = $rhs
/*  4234*/    OPC_MoveChild1,
/*  4235*/    OPC_CheckImmAllOnesV,
/*  4236*/    OPC_MoveParent,
/*  4237*/    OPC_MoveParent,
/*  4238*/    OPC_SwitchType /*4 cases */, 7, MVT::v16i8,// ->4248
/*  4241*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANDNOT),
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$rhs, immAllOnesV:{ *:[v16i8] })) - Complexity = 10
               // Dst: (ANDNOT:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs)
/*  4248*/    /*SwitchType*/ 7, MVT::v8i16,// ->4257
/*  4250*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANDNOT),
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$rhs, immAllOnesV:{ *:[v8i16] })) - Complexity = 10
               // Dst: (ANDNOT:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/*  4257*/    /*SwitchType*/ 7, MVT::v4i32,// ->4266
/*  4259*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANDNOT),
                   MVT::v4i32, 2/*#Ops*/, 0, 1, 
               // Src: (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$rhs, immAllOnesV:{ *:[v4i32] })) - Complexity = 10
               // Dst: (ANDNOT:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs)
/*  4266*/    /*SwitchType*/ 7, MVT::v2i64,// ->4275
/*  4268*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANDNOT),
                   MVT::v2i64, 2/*#Ops*/, 0, 1, 
               // Src: (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$rhs, immAllOnesV:{ *:[v2i64] })) - Complexity = 10
               // Dst: (ANDNOT:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs)
/*  4275*/    0, // EndSwitchType
/*  4276*/   0, /*End of Scope*/
/*  4277*/  /*Scope*/ 48, /*->4326*/
/*  4278*/   OPC_MoveChild0,
/*  4279*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/*  4282*/   OPC_RecordChild0, // #0 = $rhs
/*  4283*/   OPC_MoveChild1,
/*  4284*/   OPC_CheckImmAllOnesV,
/*  4285*/   OPC_MoveParent,
/*  4286*/   OPC_MoveParent,
/*  4287*/   OPC_RecordChild1, // #1 = $lhs
/*  4288*/   OPC_SwitchType /*4 cases */, 7, MVT::v16i8,// ->4298
/*  4291*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANDNOT),
                  MVT::v16i8, 2/*#Ops*/, 1, 0, 
              // Src: (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$rhs, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$lhs) - Complexity = 10
              // Dst: (ANDNOT:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs)
/*  4298*/   /*SwitchType*/ 7, MVT::v8i16,// ->4307
/*  4300*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANDNOT),
                  MVT::v8i16, 2/*#Ops*/, 1, 0, 
              // Src: (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$rhs, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$lhs) - Complexity = 10
              // Dst: (ANDNOT:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/*  4307*/   /*SwitchType*/ 7, MVT::v4i32,// ->4316
/*  4309*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANDNOT),
                  MVT::v4i32, 2/*#Ops*/, 1, 0, 
              // Src: (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$rhs, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$lhs) - Complexity = 10
              // Dst: (ANDNOT:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs)
/*  4316*/   /*SwitchType*/ 7, MVT::v2i64,// ->4325
/*  4318*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANDNOT),
                  MVT::v2i64, 2/*#Ops*/, 1, 0, 
              // Src: (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$rhs, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$lhs) - Complexity = 10
              // Dst: (ANDNOT:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs)
/*  4325*/   0, // EndSwitchType
/*  4326*/  /*Scope*/ 40, /*->4367*/
/*  4327*/   OPC_RecordChild0, // #0 = $lhs
/*  4328*/   OPC_RecordChild1, // #1 = $rhs
/*  4329*/   OPC_SwitchType /*4 cases */, 7, MVT::v16i8,// ->4339
/*  4332*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AND),
                  MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
              // Dst: (AND:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs)
/*  4339*/   /*SwitchType*/ 7, MVT::v8i16,// ->4348
/*  4341*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AND),
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
              // Dst: (AND:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/*  4348*/   /*SwitchType*/ 7, MVT::v4i32,// ->4357
/*  4350*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AND),
                  MVT::v4i32, 2/*#Ops*/, 0, 1, 
              // Src: (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
              // Dst: (AND:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs)
/*  4357*/   /*SwitchType*/ 7, MVT::v2i64,// ->4366
/*  4359*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AND),
                  MVT::v2i64, 2/*#Ops*/, 0, 1, 
              // Src: (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 3
              // Dst: (AND:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs)
/*  4366*/   0, // EndSwitchType
/*  4367*/  0, /*End of Scope*/
/*  4368*/ /*SwitchOpcode*/ 124|128,11/*1532*/, TARGET_VAL(ISD::SETCC),// ->5904
/*  4372*/  OPC_Scope, 126|128,1/*254*/, /*->4629*/ // 2 children in Scope
/*  4375*/   OPC_MoveChild0,
/*  4376*/   OPC_CheckOpcode, TARGET_VAL(ISD::INTRINSIC_WO_CHAIN),
/*  4379*/   OPC_Scope, 123, /*->4504*/ // 2 children in Scope
/*  4381*/    OPC_CheckChild0Integer, 40|128,61|128,1/*24232*/, 
/*  4385*/    OPC_RecordChild1, // #0 = $x
/*  4386*/    OPC_Scope, 28, /*->4416*/ // 4 children in Scope
/*  4388*/     OPC_CheckChild1Type, MVT::v16i8,
/*  4390*/     OPC_MoveParent,
/*  4391*/     OPC_CheckTypeI32,
/*  4392*/     OPC_Scope, 10, /*->4404*/ // 2 children in Scope
/*  4394*/      OPC_CheckChild1Integer, 0, 
/*  4396*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  4398*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12116:{ *:[iPTR] }, V128:{ *:[v16i8] }:$x), 0:{ *:[i32] }, SETNE:{ *:[Other] }) - Complexity = 16
                // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v16i8] }:$x)
/*  4404*/     /*Scope*/ 10, /*->4415*/
/*  4405*/      OPC_CheckChild1Integer, 2, 
/*  4407*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4409*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12116:{ *:[iPTR] }, V128:{ *:[v16i8] }:$x), 1:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 16
                // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v16i8] }:$x)
/*  4415*/     0, /*End of Scope*/
/*  4416*/    /*Scope*/ 28, /*->4445*/
/*  4417*/     OPC_CheckChild1Type, MVT::v8i16,
/*  4419*/     OPC_MoveParent,
/*  4420*/     OPC_CheckTypeI32,
/*  4421*/     OPC_Scope, 10, /*->4433*/ // 2 children in Scope
/*  4423*/      OPC_CheckChild1Integer, 0, 
/*  4425*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  4427*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12116:{ *:[iPTR] }, V128:{ *:[v8i16] }:$x), 0:{ *:[i32] }, SETNE:{ *:[Other] }) - Complexity = 16
                // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v8i16] }:$x)
/*  4433*/     /*Scope*/ 10, /*->4444*/
/*  4434*/      OPC_CheckChild1Integer, 2, 
/*  4436*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4438*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12116:{ *:[iPTR] }, V128:{ *:[v8i16] }:$x), 1:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 16
                // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v8i16] }:$x)
/*  4444*/     0, /*End of Scope*/
/*  4445*/    /*Scope*/ 28, /*->4474*/
/*  4446*/     OPC_CheckChild1Type, MVT::v4i32,
/*  4448*/     OPC_MoveParent,
/*  4449*/     OPC_CheckTypeI32,
/*  4450*/     OPC_Scope, 10, /*->4462*/ // 2 children in Scope
/*  4452*/      OPC_CheckChild1Integer, 0, 
/*  4454*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  4456*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12116:{ *:[iPTR] }, V128:{ *:[v4i32] }:$x), 0:{ *:[i32] }, SETNE:{ *:[Other] }) - Complexity = 16
                // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v4i32] }:$x)
/*  4462*/     /*Scope*/ 10, /*->4473*/
/*  4463*/      OPC_CheckChild1Integer, 2, 
/*  4465*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4467*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12116:{ *:[iPTR] }, V128:{ *:[v4i32] }:$x), 1:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 16
                // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v4i32] }:$x)
/*  4473*/     0, /*End of Scope*/
/*  4474*/    /*Scope*/ 28, /*->4503*/
/*  4475*/     OPC_CheckChild1Type, MVT::v2i64,
/*  4477*/     OPC_MoveParent,
/*  4478*/     OPC_CheckTypeI32,
/*  4479*/     OPC_Scope, 10, /*->4491*/ // 2 children in Scope
/*  4481*/      OPC_CheckChild1Integer, 0, 
/*  4483*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  4485*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12116:{ *:[iPTR] }, V128:{ *:[v2i64] }:$x), 0:{ *:[i32] }, SETNE:{ *:[Other] }) - Complexity = 16
                // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v2i64] }:$x)
/*  4491*/     /*Scope*/ 10, /*->4502*/
/*  4492*/      OPC_CheckChild1Integer, 2, 
/*  4494*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4496*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12116:{ *:[iPTR] }, V128:{ *:[v2i64] }:$x), 1:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 16
                // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v2i64] }:$x)
/*  4502*/     0, /*End of Scope*/
/*  4503*/    0, /*End of Scope*/
/*  4504*/   /*Scope*/ 123, /*->4628*/
/*  4505*/    OPC_CheckChild0Integer, 38|128,61|128,1/*24230*/, 
/*  4509*/    OPC_RecordChild1, // #0 = $x
/*  4510*/    OPC_Scope, 28, /*->4540*/ // 4 children in Scope
/*  4512*/     OPC_CheckChild1Type, MVT::v16i8,
/*  4514*/     OPC_MoveParent,
/*  4515*/     OPC_CheckTypeI32,
/*  4516*/     OPC_Scope, 10, /*->4528*/ // 2 children in Scope
/*  4518*/      OPC_CheckChild1Integer, 0, 
/*  4520*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  4522*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I8x16),
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12115:{ *:[iPTR] }, V128:{ *:[v16i8] }:$x), 0:{ *:[i32] }, SETNE:{ *:[Other] }) - Complexity = 16
                // Dst: (ALLTRUE_I8x16:{ *:[i32] } ?:{ *:[v16i8] }:$x)
/*  4528*/     /*Scope*/ 10, /*->4539*/
/*  4529*/      OPC_CheckChild1Integer, 2, 
/*  4531*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4533*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I8x16),
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12115:{ *:[iPTR] }, V128:{ *:[v16i8] }:$x), 1:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 16
                // Dst: (ALLTRUE_I8x16:{ *:[i32] } ?:{ *:[v16i8] }:$x)
/*  4539*/     0, /*End of Scope*/
/*  4540*/    /*Scope*/ 28, /*->4569*/
/*  4541*/     OPC_CheckChild1Type, MVT::v8i16,
/*  4543*/     OPC_MoveParent,
/*  4544*/     OPC_CheckTypeI32,
/*  4545*/     OPC_Scope, 10, /*->4557*/ // 2 children in Scope
/*  4547*/      OPC_CheckChild1Integer, 0, 
/*  4549*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  4551*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I16x8),
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12115:{ *:[iPTR] }, V128:{ *:[v8i16] }:$x), 0:{ *:[i32] }, SETNE:{ *:[Other] }) - Complexity = 16
                // Dst: (ALLTRUE_I16x8:{ *:[i32] } ?:{ *:[v8i16] }:$x)
/*  4557*/     /*Scope*/ 10, /*->4568*/
/*  4558*/      OPC_CheckChild1Integer, 2, 
/*  4560*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4562*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I16x8),
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12115:{ *:[iPTR] }, V128:{ *:[v8i16] }:$x), 1:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 16
                // Dst: (ALLTRUE_I16x8:{ *:[i32] } ?:{ *:[v8i16] }:$x)
/*  4568*/     0, /*End of Scope*/
/*  4569*/    /*Scope*/ 28, /*->4598*/
/*  4570*/     OPC_CheckChild1Type, MVT::v4i32,
/*  4572*/     OPC_MoveParent,
/*  4573*/     OPC_CheckTypeI32,
/*  4574*/     OPC_Scope, 10, /*->4586*/ // 2 children in Scope
/*  4576*/      OPC_CheckChild1Integer, 0, 
/*  4578*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  4580*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I32x4),
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12115:{ *:[iPTR] }, V128:{ *:[v4i32] }:$x), 0:{ *:[i32] }, SETNE:{ *:[Other] }) - Complexity = 16
                // Dst: (ALLTRUE_I32x4:{ *:[i32] } ?:{ *:[v4i32] }:$x)
/*  4586*/     /*Scope*/ 10, /*->4597*/
/*  4587*/      OPC_CheckChild1Integer, 2, 
/*  4589*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4591*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I32x4),
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12115:{ *:[iPTR] }, V128:{ *:[v4i32] }:$x), 1:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 16
                // Dst: (ALLTRUE_I32x4:{ *:[i32] } ?:{ *:[v4i32] }:$x)
/*  4597*/     0, /*End of Scope*/
/*  4598*/    /*Scope*/ 28, /*->4627*/
/*  4599*/     OPC_CheckChild1Type, MVT::v2i64,
/*  4601*/     OPC_MoveParent,
/*  4602*/     OPC_CheckTypeI32,
/*  4603*/     OPC_Scope, 10, /*->4615*/ // 2 children in Scope
/*  4605*/      OPC_CheckChild1Integer, 0, 
/*  4607*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  4609*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I64x2),
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12115:{ *:[iPTR] }, V128:{ *:[v2i64] }:$x), 0:{ *:[i32] }, SETNE:{ *:[Other] }) - Complexity = 16
                // Dst: (ALLTRUE_I64x2:{ *:[i32] } ?:{ *:[v2i64] }:$x)
/*  4615*/     /*Scope*/ 10, /*->4626*/
/*  4616*/      OPC_CheckChild1Integer, 2, 
/*  4618*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4620*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I64x2),
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12115:{ *:[iPTR] }, V128:{ *:[v2i64] }:$x), 1:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 16
                // Dst: (ALLTRUE_I64x2:{ *:[i32] } ?:{ *:[v2i64] }:$x)
/*  4626*/     0, /*End of Scope*/
/*  4627*/    0, /*End of Scope*/
/*  4628*/   0, /*End of Scope*/
/*  4629*/  /*Scope*/ 120|128,9/*1272*/, /*->5903*/
/*  4631*/   OPC_RecordChild0, // #0 = $src
/*  4632*/   OPC_SwitchType /*5 cases */, 108|128,3/*492*/, MVT::i32,// ->5128
/*  4636*/    OPC_Scope, 118, /*->4756*/ // 4 children in Scope
/*  4638*/     OPC_CheckChild0TypeI32,
/*  4639*/     OPC_Scope, 10, /*->4651*/ // 2 children in Scope
/*  4641*/      OPC_CheckChild1Integer, 0, 
/*  4643*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4645*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQZ_I32),
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$src, 0:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 8
                // Dst: (EQZ_I32:{ *:[i32] } I32:{ *:[i32] }:$src)
/*  4651*/     /*Scope*/ 103, /*->4755*/
/*  4652*/      OPC_RecordChild1, // #1 = $rhs
/*  4653*/      OPC_Scope, 9, /*->4664*/ // 10 children in Scope
/*  4655*/       OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4657*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_I32),
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                 // Dst: (EQ_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4664*/      /*Scope*/ 9, /*->4674*/
/*  4665*/       OPC_CheckChild2CondCode, ISD::SETNE,
/*  4667*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_I32),
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                 // Dst: (NE_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4674*/      /*Scope*/ 9, /*->4684*/
/*  4675*/       OPC_CheckChild2CondCode, ISD::SETLT,
/*  4677*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_S_I32),
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                 // Dst: (LT_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4684*/      /*Scope*/ 9, /*->4694*/
/*  4685*/       OPC_CheckChild2CondCode, ISD::SETULT,
/*  4687*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_U_I32),
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETULT:{ *:[Other] }) - Complexity = 3
                 // Dst: (LT_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4694*/      /*Scope*/ 9, /*->4704*/
/*  4695*/       OPC_CheckChild2CondCode, ISD::SETGT,
/*  4697*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_S_I32),
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                 // Dst: (GT_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4704*/      /*Scope*/ 9, /*->4714*/
/*  4705*/       OPC_CheckChild2CondCode, ISD::SETUGT,
/*  4707*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_U_I32),
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETUGT:{ *:[Other] }) - Complexity = 3
                 // Dst: (GT_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4714*/      /*Scope*/ 9, /*->4724*/
/*  4715*/       OPC_CheckChild2CondCode, ISD::SETLE,
/*  4717*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_S_I32),
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                 // Dst: (LE_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4724*/      /*Scope*/ 9, /*->4734*/
/*  4725*/       OPC_CheckChild2CondCode, ISD::SETULE,
/*  4727*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_U_I32),
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETULE:{ *:[Other] }) - Complexity = 3
                 // Dst: (LE_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4734*/      /*Scope*/ 9, /*->4744*/
/*  4735*/       OPC_CheckChild2CondCode, ISD::SETGE,
/*  4737*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_S_I32),
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                 // Dst: (GE_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4744*/      /*Scope*/ 9, /*->4754*/
/*  4745*/       OPC_CheckChild2CondCode, ISD::SETUGE,
/*  4747*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_U_I32),
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETUGE:{ *:[Other] }) - Complexity = 3
                 // Dst: (GE_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4754*/      0, /*End of Scope*/
/*  4755*/     0, /*End of Scope*/
/*  4756*/    /*Scope*/ 118, /*->4875*/
/*  4757*/     OPC_CheckChild0TypeI64,
/*  4758*/     OPC_Scope, 10, /*->4770*/ // 2 children in Scope
/*  4760*/      OPC_CheckChild1Integer, 0, 
/*  4762*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4764*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQZ_I64),
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$src, 0:{ *:[i64] }, SETEQ:{ *:[Other] }) - Complexity = 8
                // Dst: (EQZ_I64:{ *:[i32] } I64:{ *:[i64] }:$src)
/*  4770*/     /*Scope*/ 103, /*->4874*/
/*  4771*/      OPC_RecordChild1, // #1 = $rhs
/*  4772*/      OPC_Scope, 9, /*->4783*/ // 10 children in Scope
/*  4774*/       OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4776*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_I64),
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                 // Dst: (EQ_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  4783*/      /*Scope*/ 9, /*->4793*/
/*  4784*/       OPC_CheckChild2CondCode, ISD::SETNE,
/*  4786*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_I64),
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                 // Dst: (NE_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  4793*/      /*Scope*/ 9, /*->4803*/
/*  4794*/       OPC_CheckChild2CondCode, ISD::SETLT,
/*  4796*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_S_I64),
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                 // Dst: (LT_S_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  4803*/      /*Scope*/ 9, /*->4813*/
/*  4804*/       OPC_CheckChild2CondCode, ISD::SETULT,
/*  4806*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_U_I64),
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETULT:{ *:[Other] }) - Complexity = 3
                 // Dst: (LT_U_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  4813*/      /*Scope*/ 9, /*->4823*/
/*  4814*/       OPC_CheckChild2CondCode, ISD::SETGT,
/*  4816*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_S_I64),
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                 // Dst: (GT_S_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  4823*/      /*Scope*/ 9, /*->4833*/
/*  4824*/       OPC_CheckChild2CondCode, ISD::SETUGT,
/*  4826*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_U_I64),
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETUGT:{ *:[Other] }) - Complexity = 3
                 // Dst: (GT_U_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  4833*/      /*Scope*/ 9, /*->4843*/
/*  4834*/       OPC_CheckChild2CondCode, ISD::SETLE,
/*  4836*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_S_I64),
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                 // Dst: (LE_S_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  4843*/      /*Scope*/ 9, /*->4853*/
/*  4844*/       OPC_CheckChild2CondCode, ISD::SETULE,
/*  4846*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_U_I64),
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETULE:{ *:[Other] }) - Complexity = 3
                 // Dst: (LE_U_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  4853*/      /*Scope*/ 9, /*->4863*/
/*  4854*/       OPC_CheckChild2CondCode, ISD::SETGE,
/*  4856*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_S_I64),
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                 // Dst: (GE_S_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  4863*/      /*Scope*/ 9, /*->4873*/
/*  4864*/       OPC_CheckChild2CondCode, ISD::SETUGE,
/*  4866*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_U_I64),
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETUGE:{ *:[Other] }) - Complexity = 3
                 // Dst: (GE_U_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  4873*/      0, /*End of Scope*/
/*  4874*/     0, /*End of Scope*/
/*  4875*/    /*Scope*/ 125, /*->5001*/
/*  4876*/     OPC_CheckChild0Type, MVT::f32,
/*  4878*/     OPC_RecordChild1, // #1 = $rhs
/*  4879*/     OPC_Scope, 9, /*->4890*/ // 12 children in Scope
/*  4881*/      OPC_CheckChild2CondCode, ISD::SETOEQ,
/*  4883*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_F32),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, SETOEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F32:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/*  4890*/     /*Scope*/ 9, /*->4900*/
/*  4891*/      OPC_CheckChild2CondCode, ISD::SETUNE,
/*  4893*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_F32),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, SETUNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F32:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/*  4900*/     /*Scope*/ 9, /*->4910*/
/*  4901*/      OPC_CheckChild2CondCode, ISD::SETOLT,
/*  4903*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_F32),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, SETOLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F32:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/*  4910*/     /*Scope*/ 9, /*->4920*/
/*  4911*/      OPC_CheckChild2CondCode, ISD::SETOLE,
/*  4913*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_F32),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, SETOLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F32:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/*  4920*/     /*Scope*/ 9, /*->4930*/
/*  4921*/      OPC_CheckChild2CondCode, ISD::SETOGT,
/*  4923*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_F32),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, SETOGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F32:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/*  4930*/     /*Scope*/ 9, /*->4940*/
/*  4931*/      OPC_CheckChild2CondCode, ISD::SETOGE,
/*  4933*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_F32),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, SETOGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F32:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/*  4940*/     /*Scope*/ 9, /*->4950*/
/*  4941*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4943*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_F32),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F32:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)
/*  4950*/     /*Scope*/ 9, /*->4960*/
/*  4951*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  4953*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_F32),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F32:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)
/*  4960*/     /*Scope*/ 9, /*->4970*/
/*  4961*/      OPC_CheckChild2CondCode, ISD::SETLT,
/*  4963*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_F32),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F32:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)
/*  4970*/     /*Scope*/ 9, /*->4980*/
/*  4971*/      OPC_CheckChild2CondCode, ISD::SETLE,
/*  4973*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_F32),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F32:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)
/*  4980*/     /*Scope*/ 9, /*->4990*/
/*  4981*/      OPC_CheckChild2CondCode, ISD::SETGT,
/*  4983*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_F32),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F32:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)
/*  4990*/     /*Scope*/ 9, /*->5000*/
/*  4991*/      OPC_CheckChild2CondCode, ISD::SETGE,
/*  4993*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_F32),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F32:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)
/*  5000*/     0, /*End of Scope*/
/*  5001*/    /*Scope*/ 125, /*->5127*/
/*  5002*/     OPC_CheckChild0Type, MVT::f64,
/*  5004*/     OPC_RecordChild1, // #1 = $rhs
/*  5005*/     OPC_Scope, 9, /*->5016*/ // 12 children in Scope
/*  5007*/      OPC_CheckChild2CondCode, ISD::SETOEQ,
/*  5009*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_F64),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, SETOEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F64:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/*  5016*/     /*Scope*/ 9, /*->5026*/
/*  5017*/      OPC_CheckChild2CondCode, ISD::SETUNE,
/*  5019*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_F64),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, SETUNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F64:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/*  5026*/     /*Scope*/ 9, /*->5036*/
/*  5027*/      OPC_CheckChild2CondCode, ISD::SETOLT,
/*  5029*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_F64),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, SETOLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F64:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/*  5036*/     /*Scope*/ 9, /*->5046*/
/*  5037*/      OPC_CheckChild2CondCode, ISD::SETOLE,
/*  5039*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_F64),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, SETOLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F64:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/*  5046*/     /*Scope*/ 9, /*->5056*/
/*  5047*/      OPC_CheckChild2CondCode, ISD::SETOGT,
/*  5049*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_F64),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, SETOGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F64:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/*  5056*/     /*Scope*/ 9, /*->5066*/
/*  5057*/      OPC_CheckChild2CondCode, ISD::SETOGE,
/*  5059*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_F64),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, SETOGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F64:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/*  5066*/     /*Scope*/ 9, /*->5076*/
/*  5067*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  5069*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_F64),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F64:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)
/*  5076*/     /*Scope*/ 9, /*->5086*/
/*  5077*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  5079*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_F64),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F64:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)
/*  5086*/     /*Scope*/ 9, /*->5096*/
/*  5087*/      OPC_CheckChild2CondCode, ISD::SETLT,
/*  5089*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_F64),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F64:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)
/*  5096*/     /*Scope*/ 9, /*->5106*/
/*  5097*/      OPC_CheckChild2CondCode, ISD::SETLE,
/*  5099*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_F64),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F64:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)
/*  5106*/     /*Scope*/ 9, /*->5116*/
/*  5107*/      OPC_CheckChild2CondCode, ISD::SETGT,
/*  5109*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_F64),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F64:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)
/*  5116*/     /*Scope*/ 9, /*->5126*/
/*  5117*/      OPC_CheckChild2CondCode, ISD::SETGE,
/*  5119*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_F64),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F64:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)
/*  5126*/     0, /*End of Scope*/
/*  5127*/    0, /*End of Scope*/
/*  5128*/   /*SwitchType*/ 115, MVT::v16i8,// ->5245
/*  5130*/    OPC_CheckChild0Type, MVT::v16i8,
/*  5132*/    OPC_RecordChild1, // #1 = $rhs
/*  5133*/    OPC_Scope, 10, /*->5145*/ // 10 children in Scope
/*  5135*/     OPC_CheckChild2CondCode, ISD::SETEQ,
/*  5137*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5138*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_I8x16),
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
               // Dst: (EQ_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5145*/    /*Scope*/ 10, /*->5156*/
/*  5146*/     OPC_CheckChild2CondCode, ISD::SETNE,
/*  5148*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5149*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_I8x16),
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
               // Dst: (NE_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5156*/    /*Scope*/ 10, /*->5167*/
/*  5157*/     OPC_CheckChild2CondCode, ISD::SETLT,
/*  5159*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5160*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_S_I8x16),
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
               // Dst: (LT_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5167*/    /*Scope*/ 10, /*->5178*/
/*  5168*/     OPC_CheckChild2CondCode, ISD::SETULT,
/*  5170*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5171*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_U_I8x16),
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETULT:{ *:[Other] }) - Complexity = 3
               // Dst: (LT_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5178*/    /*Scope*/ 10, /*->5189*/
/*  5179*/     OPC_CheckChild2CondCode, ISD::SETGT,
/*  5181*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5182*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_S_I8x16),
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
               // Dst: (GT_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5189*/    /*Scope*/ 10, /*->5200*/
/*  5190*/     OPC_CheckChild2CondCode, ISD::SETUGT,
/*  5192*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5193*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_U_I8x16),
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETUGT:{ *:[Other] }) - Complexity = 3
               // Dst: (GT_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5200*/    /*Scope*/ 10, /*->5211*/
/*  5201*/     OPC_CheckChild2CondCode, ISD::SETLE,
/*  5203*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5204*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_S_I8x16),
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
               // Dst: (LE_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5211*/    /*Scope*/ 10, /*->5222*/
/*  5212*/     OPC_CheckChild2CondCode, ISD::SETULE,
/*  5214*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5215*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_U_I8x16),
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETULE:{ *:[Other] }) - Complexity = 3
               // Dst: (LE_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5222*/    /*Scope*/ 10, /*->5233*/
/*  5223*/     OPC_CheckChild2CondCode, ISD::SETGE,
/*  5225*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5226*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_S_I8x16),
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
               // Dst: (GE_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5233*/    /*Scope*/ 10, /*->5244*/
/*  5234*/     OPC_CheckChild2CondCode, ISD::SETUGE,
/*  5236*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5237*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_U_I8x16),
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETUGE:{ *:[Other] }) - Complexity = 3
               // Dst: (GE_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5244*/    0, /*End of Scope*/
/*  5245*/   /*SwitchType*/ 62|128,1/*190*/, MVT::v8i16,// ->5438
/*  5248*/    OPC_Scope, 115, /*->5365*/ // 2 children in Scope
/*  5250*/     OPC_CheckChild0Type, MVT::v8i16,
/*  5252*/     OPC_RecordChild1, // #1 = $rhs
/*  5253*/     OPC_Scope, 10, /*->5265*/ // 10 children in Scope
/*  5255*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  5257*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5258*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_I16x8),
                    MVT::v8i16, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5265*/     /*Scope*/ 10, /*->5276*/
/*  5266*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  5268*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5269*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_I16x8),
                    MVT::v8i16, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5276*/     /*Scope*/ 10, /*->5287*/
/*  5277*/      OPC_CheckChild2CondCode, ISD::SETLT,
/*  5279*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5280*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_S_I16x8),
                    MVT::v8i16, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5287*/     /*Scope*/ 10, /*->5298*/
/*  5288*/      OPC_CheckChild2CondCode, ISD::SETULT,
/*  5290*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5291*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_U_I16x8),
                    MVT::v8i16, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETULT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5298*/     /*Scope*/ 10, /*->5309*/
/*  5299*/      OPC_CheckChild2CondCode, ISD::SETGT,
/*  5301*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5302*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_S_I16x8),
                    MVT::v8i16, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5309*/     /*Scope*/ 10, /*->5320*/
/*  5310*/      OPC_CheckChild2CondCode, ISD::SETUGT,
/*  5312*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5313*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_U_I16x8),
                    MVT::v8i16, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETUGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5320*/     /*Scope*/ 10, /*->5331*/
/*  5321*/      OPC_CheckChild2CondCode, ISD::SETLE,
/*  5323*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5324*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_S_I16x8),
                    MVT::v8i16, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5331*/     /*Scope*/ 10, /*->5342*/
/*  5332*/      OPC_CheckChild2CondCode, ISD::SETULE,
/*  5334*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5335*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_U_I16x8),
                    MVT::v8i16, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETULE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5342*/     /*Scope*/ 10, /*->5353*/
/*  5343*/      OPC_CheckChild2CondCode, ISD::SETGE,
/*  5345*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5346*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_S_I16x8),
                    MVT::v8i16, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5353*/     /*Scope*/ 10, /*->5364*/
/*  5354*/      OPC_CheckChild2CondCode, ISD::SETUGE,
/*  5356*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5357*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_U_I16x8),
                    MVT::v8i16, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETUGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5364*/     0, /*End of Scope*/
/*  5365*/    /*Scope*/ 71, /*->5437*/
/*  5366*/     OPC_CheckChild0Type, MVT::v8f16,
/*  5368*/     OPC_RecordChild1, // #1 = $rhs
/*  5369*/     OPC_Scope, 10, /*->5381*/ // 6 children in Scope
/*  5371*/      OPC_CheckChild2CondCode, ISD::SETOEQ,
/*  5373*/      OPC_CheckPatternPredicate6, // (Subtarget->hasHalfPrecision()) && (Subtarget->hasSIMD128())
/*  5374*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_F16x8),
                    MVT::v8i16, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETOEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F16x8:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/*  5381*/     /*Scope*/ 10, /*->5392*/
/*  5382*/      OPC_CheckChild2CondCode, ISD::SETUNE,
/*  5384*/      OPC_CheckPatternPredicate6, // (Subtarget->hasHalfPrecision()) && (Subtarget->hasSIMD128())
/*  5385*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_F16x8),
                    MVT::v8i16, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETUNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F16x8:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/*  5392*/     /*Scope*/ 10, /*->5403*/
/*  5393*/      OPC_CheckChild2CondCode, ISD::SETOLT,
/*  5395*/      OPC_CheckPatternPredicate6, // (Subtarget->hasHalfPrecision()) && (Subtarget->hasSIMD128())
/*  5396*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_F16x8),
                    MVT::v8i16, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETOLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F16x8:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/*  5403*/     /*Scope*/ 10, /*->5414*/
/*  5404*/      OPC_CheckChild2CondCode, ISD::SETOGT,
/*  5406*/      OPC_CheckPatternPredicate6, // (Subtarget->hasHalfPrecision()) && (Subtarget->hasSIMD128())
/*  5407*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_F16x8),
                    MVT::v8i16, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETOGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F16x8:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/*  5414*/     /*Scope*/ 10, /*->5425*/
/*  5415*/      OPC_CheckChild2CondCode, ISD::SETOLE,
/*  5417*/      OPC_CheckPatternPredicate6, // (Subtarget->hasHalfPrecision()) && (Subtarget->hasSIMD128())
/*  5418*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_F16x8),
                    MVT::v8i16, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETOLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F16x8:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/*  5425*/     /*Scope*/ 10, /*->5436*/
/*  5426*/      OPC_CheckChild2CondCode, ISD::SETOGE,
/*  5428*/      OPC_CheckPatternPredicate6, // (Subtarget->hasHalfPrecision()) && (Subtarget->hasSIMD128())
/*  5429*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_F16x8),
                    MVT::v8i16, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETOGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F16x8:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/*  5436*/     0, /*End of Scope*/
/*  5437*/    0, /*End of Scope*/
/*  5438*/   /*SwitchType*/ 123|128,1/*251*/, MVT::v4i32,// ->5692
/*  5441*/    OPC_Scope, 115, /*->5558*/ // 2 children in Scope
/*  5443*/     OPC_CheckChild0Type, MVT::v4i32,
/*  5445*/     OPC_RecordChild1, // #1 = $rhs
/*  5446*/     OPC_Scope, 10, /*->5458*/ // 10 children in Scope
/*  5448*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  5450*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5451*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_I32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  5458*/     /*Scope*/ 10, /*->5469*/
/*  5459*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  5461*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5462*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_I32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  5469*/     /*Scope*/ 10, /*->5480*/
/*  5470*/      OPC_CheckChild2CondCode, ISD::SETLT,
/*  5472*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5473*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_S_I32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_S_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  5480*/     /*Scope*/ 10, /*->5491*/
/*  5481*/      OPC_CheckChild2CondCode, ISD::SETULT,
/*  5483*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5484*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_U_I32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETULT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_U_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  5491*/     /*Scope*/ 10, /*->5502*/
/*  5492*/      OPC_CheckChild2CondCode, ISD::SETGT,
/*  5494*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5495*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_S_I32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_S_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  5502*/     /*Scope*/ 10, /*->5513*/
/*  5503*/      OPC_CheckChild2CondCode, ISD::SETUGT,
/*  5505*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5506*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_U_I32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETUGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_U_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  5513*/     /*Scope*/ 10, /*->5524*/
/*  5514*/      OPC_CheckChild2CondCode, ISD::SETLE,
/*  5516*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5517*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_S_I32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_S_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  5524*/     /*Scope*/ 10, /*->5535*/
/*  5525*/      OPC_CheckChild2CondCode, ISD::SETULE,
/*  5527*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5528*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_U_I32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETULE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_U_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  5535*/     /*Scope*/ 10, /*->5546*/
/*  5536*/      OPC_CheckChild2CondCode, ISD::SETGE,
/*  5538*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5539*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_S_I32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_S_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  5546*/     /*Scope*/ 10, /*->5557*/
/*  5547*/      OPC_CheckChild2CondCode, ISD::SETUGE,
/*  5549*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5550*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_U_I32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETUGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_U_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  5557*/     0, /*End of Scope*/
/*  5558*/    /*Scope*/ 3|128,1/*131*/, /*->5691*/
/*  5560*/     OPC_CheckChild0Type, MVT::v4f32,
/*  5562*/     OPC_RecordChild1, // #1 = $rhs
/*  5563*/     OPC_Scope, 10, /*->5575*/ // 12 children in Scope
/*  5565*/      OPC_CheckChild2CondCode, ISD::SETOEQ,
/*  5567*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5568*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_F32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/*  5575*/     /*Scope*/ 10, /*->5586*/
/*  5576*/      OPC_CheckChild2CondCode, ISD::SETUNE,
/*  5578*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5579*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_F32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETUNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/*  5586*/     /*Scope*/ 10, /*->5597*/
/*  5587*/      OPC_CheckChild2CondCode, ISD::SETOLT,
/*  5589*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5590*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_F32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/*  5597*/     /*Scope*/ 10, /*->5608*/
/*  5598*/      OPC_CheckChild2CondCode, ISD::SETOGT,
/*  5600*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5601*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_F32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/*  5608*/     /*Scope*/ 10, /*->5619*/
/*  5609*/      OPC_CheckChild2CondCode, ISD::SETOLE,
/*  5611*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5612*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_F32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/*  5619*/     /*Scope*/ 10, /*->5630*/
/*  5620*/      OPC_CheckChild2CondCode, ISD::SETOGE,
/*  5622*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5623*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_F32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/*  5630*/     /*Scope*/ 9, /*->5640*/
/*  5631*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  5633*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_F32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F32x4:{ *:[v4i32] } ?:{ *:[v4f32] }:$lhs, ?:{ *:[v4f32] }:$rhs)
/*  5640*/     /*Scope*/ 9, /*->5650*/
/*  5641*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  5643*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_F32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F32x4:{ *:[v4i32] } ?:{ *:[v4f32] }:$lhs, ?:{ *:[v4f32] }:$rhs)
/*  5650*/     /*Scope*/ 9, /*->5660*/
/*  5651*/      OPC_CheckChild2CondCode, ISD::SETLT,
/*  5653*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_F32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F32x4:{ *:[v4i32] } ?:{ *:[v4f32] }:$lhs, ?:{ *:[v4f32] }:$rhs)
/*  5660*/     /*Scope*/ 9, /*->5670*/
/*  5661*/      OPC_CheckChild2CondCode, ISD::SETGT,
/*  5663*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_F32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F32x4:{ *:[v4i32] } ?:{ *:[v4f32] }:$lhs, ?:{ *:[v4f32] }:$rhs)
/*  5670*/     /*Scope*/ 9, /*->5680*/
/*  5671*/      OPC_CheckChild2CondCode, ISD::SETLE,
/*  5673*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_F32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F32x4:{ *:[v4i32] } ?:{ *:[v4f32] }:$lhs, ?:{ *:[v4f32] }:$rhs)
/*  5680*/     /*Scope*/ 9, /*->5690*/
/*  5681*/      OPC_CheckChild2CondCode, ISD::SETGE,
/*  5683*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_F32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F32x4:{ *:[v4i32] } ?:{ *:[v4f32] }:$lhs, ?:{ *:[v4f32] }:$rhs)
/*  5690*/     0, /*End of Scope*/
/*  5691*/    0, /*End of Scope*/
/*  5692*/   /*SwitchType*/ 79|128,1/*207*/, MVT::v2i64,// ->5902
/*  5695*/    OPC_Scope, 71, /*->5768*/ // 2 children in Scope
/*  5697*/     OPC_CheckChild0Type, MVT::v2i64,
/*  5699*/     OPC_RecordChild1, // #1 = $rhs
/*  5700*/     OPC_Scope, 10, /*->5712*/ // 6 children in Scope
/*  5702*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  5704*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5705*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_I64x2),
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/*  5712*/     /*Scope*/ 10, /*->5723*/
/*  5713*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  5715*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5716*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_I64x2),
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/*  5723*/     /*Scope*/ 10, /*->5734*/
/*  5724*/      OPC_CheckChild2CondCode, ISD::SETLT,
/*  5726*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5727*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_S_I64x2),
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_S_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/*  5734*/     /*Scope*/ 10, /*->5745*/
/*  5735*/      OPC_CheckChild2CondCode, ISD::SETGT,
/*  5737*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5738*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_S_I64x2),
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_S_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/*  5745*/     /*Scope*/ 10, /*->5756*/
/*  5746*/      OPC_CheckChild2CondCode, ISD::SETLE,
/*  5748*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5749*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_S_I64x2),
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_S_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/*  5756*/     /*Scope*/ 10, /*->5767*/
/*  5757*/      OPC_CheckChild2CondCode, ISD::SETGE,
/*  5759*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5760*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_S_I64x2),
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_S_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/*  5767*/     0, /*End of Scope*/
/*  5768*/    /*Scope*/ 3|128,1/*131*/, /*->5901*/
/*  5770*/     OPC_CheckChild0Type, MVT::v2f64,
/*  5772*/     OPC_RecordChild1, // #1 = $rhs
/*  5773*/     OPC_Scope, 10, /*->5785*/ // 12 children in Scope
/*  5775*/      OPC_CheckChild2CondCode, ISD::SETOEQ,
/*  5777*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5778*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_F64x2),
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F64x2:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/*  5785*/     /*Scope*/ 10, /*->5796*/
/*  5786*/      OPC_CheckChild2CondCode, ISD::SETUNE,
/*  5788*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5789*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_F64x2),
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETUNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F64x2:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/*  5796*/     /*Scope*/ 10, /*->5807*/
/*  5797*/      OPC_CheckChild2CondCode, ISD::SETOLT,
/*  5799*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5800*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_F64x2),
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F64x2:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/*  5807*/     /*Scope*/ 10, /*->5818*/
/*  5808*/      OPC_CheckChild2CondCode, ISD::SETOGT,
/*  5810*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5811*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_F64x2),
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F64x2:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/*  5818*/     /*Scope*/ 10, /*->5829*/
/*  5819*/      OPC_CheckChild2CondCode, ISD::SETOLE,
/*  5821*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5822*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_F64x2),
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F64x2:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/*  5829*/     /*Scope*/ 10, /*->5840*/
/*  5830*/      OPC_CheckChild2CondCode, ISD::SETOGE,
/*  5832*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5833*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_F64x2),
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F64x2:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/*  5840*/     /*Scope*/ 9, /*->5850*/
/*  5841*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  5843*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_F64x2),
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F64x2:{ *:[v2i64] } ?:{ *:[v2f64] }:$lhs, ?:{ *:[v2f64] }:$rhs)
/*  5850*/     /*Scope*/ 9, /*->5860*/
/*  5851*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  5853*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_F64x2),
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F64x2:{ *:[v2i64] } ?:{ *:[v2f64] }:$lhs, ?:{ *:[v2f64] }:$rhs)
/*  5860*/     /*Scope*/ 9, /*->5870*/
/*  5861*/      OPC_CheckChild2CondCode, ISD::SETLT,
/*  5863*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_F64x2),
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F64x2:{ *:[v2i64] } ?:{ *:[v2f64] }:$lhs, ?:{ *:[v2f64] }:$rhs)
/*  5870*/     /*Scope*/ 9, /*->5880*/
/*  5871*/      OPC_CheckChild2CondCode, ISD::SETGT,
/*  5873*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_F64x2),
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F64x2:{ *:[v2i64] } ?:{ *:[v2f64] }:$lhs, ?:{ *:[v2f64] }:$rhs)
/*  5880*/     /*Scope*/ 9, /*->5890*/
/*  5881*/      OPC_CheckChild2CondCode, ISD::SETLE,
/*  5883*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_F64x2),
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F64x2:{ *:[v2i64] } ?:{ *:[v2f64] }:$lhs, ?:{ *:[v2f64] }:$rhs)
/*  5890*/     /*Scope*/ 9, /*->5900*/
/*  5891*/      OPC_CheckChild2CondCode, ISD::SETGE,
/*  5893*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_F64x2),
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F64x2:{ *:[v2i64] } ?:{ *:[v2f64] }:$lhs, ?:{ *:[v2f64] }:$rhs)
/*  5900*/     0, /*End of Scope*/
/*  5901*/    0, /*End of Scope*/
/*  5902*/   0, // EndSwitchType
/*  5903*/  0, /*End of Scope*/
/*  5904*/ /*SwitchOpcode*/ 17|128,11/*1425*/, TARGET_VAL(ISD::LOAD),// ->7333
/*  5908*/  OPC_RecordMemRef,
/*  5909*/  OPC_RecordNode, // #0 = 'ld' chained node
/*  5910*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  5911*/  OPC_Scope, 68|128,5/*708*/, /*->6622*/ // 2 children in Scope
/*  5914*/   OPC_CheckChild1TypeI32,
/*  5915*/   OPC_CheckPredicate, 9, // Predicate_unindexedload
/*  5917*/   OPC_Scope, 37, /*->5956*/ // 16 children in Scope
/*  5919*/    OPC_CheckPredicate7,  // Predicate_load
/*  5920*/    OPC_SwitchType /*2 cases */, 15, MVT::i32,// ->5938
/*  5923*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  5924*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  5926*/     OPC_EmitMergeInputChains1_0,
/*  5927*/     OPC_EmitInteger32, 0, 
/*  5929*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  5938*/    /*SwitchType*/ 15, MVT::i64,// ->5955
/*  5940*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  5941*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  5943*/     OPC_EmitMergeInputChains1_0,
/*  5944*/     OPC_EmitInteger32, 0, 
/*  5946*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i64, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  5955*/    0, // EndSwitchType
/*  5956*/   /*Scope*/ 97, /*->6054*/
/*  5957*/    OPC_CheckPredicate, 13, // Predicate_sextload
/*  5959*/    OPC_SwitchType /*2 cases */, 36, MVT::i32,// ->5998
/*  5962*/     OPC_Scope, 16, /*->5980*/ // 2 children in Scope
/*  5964*/      OPC_CheckPredicate1,  // Predicate_sextloadi8
/*  5965*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  5966*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  5968*/      OPC_EmitMergeInputChains1_0,
/*  5969*/      OPC_EmitInteger32, 0, 
/*  5971*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_S_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>> - Complexity = 13
                // Dst: (LOAD8_S_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  5980*/     /*Scope*/ 16, /*->5997*/
/*  5981*/      OPC_CheckPredicate2,  // Predicate_sextloadi16
/*  5982*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  5983*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  5985*/      OPC_EmitMergeInputChains1_0,
/*  5986*/      OPC_EmitInteger32, 0, 
/*  5988*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_S_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>> - Complexity = 13
                // Dst: (LOAD16_S_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  5997*/     0, /*End of Scope*/
/*  5998*/    /*SwitchType*/ 53, MVT::i64,// ->6053
/*  6000*/     OPC_Scope, 16, /*->6018*/ // 3 children in Scope
/*  6002*/      OPC_CheckPredicate1,  // Predicate_sextloadi8
/*  6003*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6004*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6006*/      OPC_EmitMergeInputChains1_0,
/*  6007*/      OPC_EmitInteger32, 0, 
/*  6009*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_S_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>> - Complexity = 13
                // Dst: (LOAD8_S_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6018*/     /*Scope*/ 16, /*->6035*/
/*  6019*/      OPC_CheckPredicate2,  // Predicate_sextloadi16
/*  6020*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6021*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6023*/      OPC_EmitMergeInputChains1_0,
/*  6024*/      OPC_EmitInteger32, 0, 
/*  6026*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_S_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>> - Complexity = 13
                // Dst: (LOAD16_S_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6035*/     /*Scope*/ 16, /*->6052*/
/*  6036*/      OPC_CheckPredicate3,  // Predicate_sextloadi32
/*  6037*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6038*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6040*/      OPC_EmitMergeInputChains1_0,
/*  6041*/      OPC_EmitInteger32, 0, 
/*  6043*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_S_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>> - Complexity = 13
                // Dst: (LOAD32_S_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6052*/     0, /*End of Scope*/
/*  6053*/    0, // EndSwitchType
/*  6054*/   /*Scope*/ 97, /*->6152*/
/*  6055*/    OPC_CheckPredicate, 14, // Predicate_zextload
/*  6057*/    OPC_SwitchType /*2 cases */, 36, MVT::i32,// ->6096
/*  6060*/     OPC_Scope, 16, /*->6078*/ // 2 children in Scope
/*  6062*/      OPC_CheckPredicate1,  // Predicate_zextloadi8
/*  6063*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6064*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6066*/      OPC_EmitMergeInputChains1_0,
/*  6067*/      OPC_EmitInteger32, 0, 
/*  6069*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>> - Complexity = 13
                // Dst: (LOAD8_U_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6078*/     /*Scope*/ 16, /*->6095*/
/*  6079*/      OPC_CheckPredicate2,  // Predicate_zextloadi16
/*  6080*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6081*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6083*/      OPC_EmitMergeInputChains1_0,
/*  6084*/      OPC_EmitInteger32, 0, 
/*  6086*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>> - Complexity = 13
                // Dst: (LOAD16_U_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6095*/     0, /*End of Scope*/
/*  6096*/    /*SwitchType*/ 53, MVT::i64,// ->6151
/*  6098*/     OPC_Scope, 16, /*->6116*/ // 3 children in Scope
/*  6100*/      OPC_CheckPredicate1,  // Predicate_zextloadi8
/*  6101*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6102*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6104*/      OPC_EmitMergeInputChains1_0,
/*  6105*/      OPC_EmitInteger32, 0, 
/*  6107*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>> - Complexity = 13
                // Dst: (LOAD8_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6116*/     /*Scope*/ 16, /*->6133*/
/*  6117*/      OPC_CheckPredicate2,  // Predicate_zextloadi16
/*  6118*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6119*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6121*/      OPC_EmitMergeInputChains1_0,
/*  6122*/      OPC_EmitInteger32, 0, 
/*  6124*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>> - Complexity = 13
                // Dst: (LOAD16_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6133*/     /*Scope*/ 16, /*->6150*/
/*  6134*/      OPC_CheckPredicate3,  // Predicate_zextloadi32
/*  6135*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6136*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6138*/      OPC_EmitMergeInputChains1_0,
/*  6139*/      OPC_EmitInteger32, 0, 
/*  6141*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>> - Complexity = 13
                // Dst: (LOAD32_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6150*/     0, /*End of Scope*/
/*  6151*/    0, // EndSwitchType
/*  6152*/   /*Scope*/ 97, /*->6250*/
/*  6153*/    OPC_CheckPredicate, 10, // Predicate_extload
/*  6155*/    OPC_SwitchType /*2 cases */, 36, MVT::i32,// ->6194
/*  6158*/     OPC_Scope, 16, /*->6176*/ // 2 children in Scope
/*  6160*/      OPC_CheckPredicate1,  // Predicate_extloadi8
/*  6161*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6162*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6164*/      OPC_EmitMergeInputChains1_0,
/*  6165*/      OPC_EmitInteger32, 0, 
/*  6167*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>> - Complexity = 13
                // Dst: (LOAD8_U_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6176*/     /*Scope*/ 16, /*->6193*/
/*  6177*/      OPC_CheckPredicate2,  // Predicate_extloadi16
/*  6178*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6179*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6181*/      OPC_EmitMergeInputChains1_0,
/*  6182*/      OPC_EmitInteger32, 0, 
/*  6184*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>> - Complexity = 13
                // Dst: (LOAD16_U_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6193*/     0, /*End of Scope*/
/*  6194*/    /*SwitchType*/ 53, MVT::i64,// ->6249
/*  6196*/     OPC_Scope, 16, /*->6214*/ // 3 children in Scope
/*  6198*/      OPC_CheckPredicate1,  // Predicate_extloadi8
/*  6199*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6200*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6202*/      OPC_EmitMergeInputChains1_0,
/*  6203*/      OPC_EmitInteger32, 0, 
/*  6205*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>> - Complexity = 13
                // Dst: (LOAD8_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6214*/     /*Scope*/ 16, /*->6231*/
/*  6215*/      OPC_CheckPredicate2,  // Predicate_extloadi16
/*  6216*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6217*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6219*/      OPC_EmitMergeInputChains1_0,
/*  6220*/      OPC_EmitInteger32, 0, 
/*  6222*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>> - Complexity = 13
                // Dst: (LOAD16_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6231*/     /*Scope*/ 16, /*->6248*/
/*  6232*/      OPC_CheckPredicate3,  // Predicate_extloadi32
/*  6233*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6234*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6236*/      OPC_EmitMergeInputChains1_0,
/*  6237*/      OPC_EmitInteger32, 0, 
/*  6239*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>> - Complexity = 13
                // Dst: (LOAD32_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6248*/     0, /*End of Scope*/
/*  6249*/    0, // EndSwitchType
/*  6250*/   /*Scope*/ 105, /*->6356*/
/*  6251*/    OPC_CheckPredicate7,  // Predicate_load
/*  6252*/    OPC_SwitchType /*6 cases */, 15, MVT::f32,// ->6270
/*  6255*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6256*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6258*/     OPC_EmitMergeInputChains1_0,
/*  6259*/     OPC_EmitInteger32, 0, 
/*  6261*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::f32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[f32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_F32_A32:{ *:[f32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6270*/    /*SwitchType*/ 15, MVT::f64,// ->6287
/*  6272*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6273*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6275*/     OPC_EmitMergeInputChains1_0,
/*  6276*/     OPC_EmitInteger32, 0, 
/*  6278*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::f64, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[f64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_F64_A32:{ *:[f64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6287*/    /*SwitchType*/ 15, MVT::v16i8,// ->6304
/*  6289*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6290*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6292*/     OPC_EmitMergeInputChains1_0,
/*  6293*/     OPC_EmitInteger32, 0, 
/*  6295*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v16i8, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v16i8] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A32:{ *:[v16i8] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6304*/    /*SwitchType*/ 15, MVT::v8i16,// ->6321
/*  6306*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6307*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6309*/     OPC_EmitMergeInputChains1_0,
/*  6310*/     OPC_EmitInteger32, 0, 
/*  6312*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v8i16, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v8i16] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A32:{ *:[v8i16] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6321*/    /*SwitchType*/ 15, MVT::v4i32,// ->6338
/*  6323*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6324*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6326*/     OPC_EmitMergeInputChains1_0,
/*  6327*/     OPC_EmitInteger32, 0, 
/*  6329*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v4i32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v4i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A32:{ *:[v4i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6338*/    /*SwitchType*/ 15, MVT::v2i64,// ->6355
/*  6340*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6341*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6343*/     OPC_EmitMergeInputChains1_0,
/*  6344*/     OPC_EmitInteger32, 0, 
/*  6346*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v2i64, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v2i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A32:{ *:[v2i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6355*/    0, // EndSwitchType
/*  6356*/   /*Scope*/ 21, /*->6378*/
/*  6357*/    OPC_CheckPredicate, 13, // Predicate_sextload
/*  6359*/    OPC_CheckPredicate, 21, // Predicate_sextloadvi8
/*  6361*/    OPC_CheckType, MVT::v8i16,
/*  6363*/    OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6364*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6366*/    OPC_EmitMergeInputChains1_0,
/*  6367*/    OPC_EmitInteger32, 0, 
/*  6369*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I16x8_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v8i16, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v8i16] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadvi8>> - Complexity = 13
              // Dst: (LOAD_EXTEND_S_I16x8_A32:{ *:[v8i16] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6378*/   /*Scope*/ 21, /*->6400*/
/*  6379*/    OPC_CheckPredicate, 14, // Predicate_zextload
/*  6381*/    OPC_CheckPredicate, 21, // Predicate_zextloadvi8
/*  6383*/    OPC_CheckType, MVT::v8i16,
/*  6385*/    OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6386*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6388*/    OPC_EmitMergeInputChains1_0,
/*  6389*/    OPC_EmitInteger32, 0, 
/*  6391*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I16x8_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v8i16, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v8i16] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadvi8>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I16x8_A32:{ *:[v8i16] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6400*/   /*Scope*/ 21, /*->6422*/
/*  6401*/    OPC_CheckPredicate, 10, // Predicate_extload
/*  6403*/    OPC_CheckPredicate, 21, // Predicate_extloadvi8
/*  6405*/    OPC_CheckType, MVT::v8i16,
/*  6407*/    OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6408*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6410*/    OPC_EmitMergeInputChains1_0,
/*  6411*/    OPC_EmitInteger32, 0, 
/*  6413*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I16x8_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v8i16, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v8i16] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadvi8>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I16x8_A32:{ *:[v8i16] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6422*/   /*Scope*/ 21, /*->6444*/
/*  6423*/    OPC_CheckPredicate, 13, // Predicate_sextload
/*  6425*/    OPC_CheckPredicate, 22, // Predicate_sextloadvi16
/*  6427*/    OPC_CheckType, MVT::v4i32,
/*  6429*/    OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6430*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6432*/    OPC_EmitMergeInputChains1_0,
/*  6433*/    OPC_EmitInteger32, 0, 
/*  6435*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I32x4_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v4i32, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v4i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadvi16>> - Complexity = 13
              // Dst: (LOAD_EXTEND_S_I32x4_A32:{ *:[v4i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6444*/   /*Scope*/ 21, /*->6466*/
/*  6445*/    OPC_CheckPredicate, 14, // Predicate_zextload
/*  6447*/    OPC_CheckPredicate, 22, // Predicate_zextloadvi16
/*  6449*/    OPC_CheckType, MVT::v4i32,
/*  6451*/    OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6452*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6454*/    OPC_EmitMergeInputChains1_0,
/*  6455*/    OPC_EmitInteger32, 0, 
/*  6457*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I32x4_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v4i32, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v4i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadvi16>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I32x4_A32:{ *:[v4i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6466*/   /*Scope*/ 21, /*->6488*/
/*  6467*/    OPC_CheckPredicate, 10, // Predicate_extload
/*  6469*/    OPC_CheckPredicate, 22, // Predicate_extloadvi16
/*  6471*/    OPC_CheckType, MVT::v4i32,
/*  6473*/    OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6474*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6476*/    OPC_EmitMergeInputChains1_0,
/*  6477*/    OPC_EmitInteger32, 0, 
/*  6479*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I32x4_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v4i32, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v4i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadvi16>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I32x4_A32:{ *:[v4i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6488*/   /*Scope*/ 21, /*->6510*/
/*  6489*/    OPC_CheckPredicate, 13, // Predicate_sextload
/*  6491*/    OPC_CheckPredicate, 23, // Predicate_sextloadvi32
/*  6493*/    OPC_CheckType, MVT::v2i64,
/*  6495*/    OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6496*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6498*/    OPC_EmitMergeInputChains1_0,
/*  6499*/    OPC_EmitInteger32, 0, 
/*  6501*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I64x2_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v2i64, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v2i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadvi32>> - Complexity = 13
              // Dst: (LOAD_EXTEND_S_I64x2_A32:{ *:[v2i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6510*/   /*Scope*/ 21, /*->6532*/
/*  6511*/    OPC_CheckPredicate, 14, // Predicate_zextload
/*  6513*/    OPC_CheckPredicate, 23, // Predicate_zextloadvi32
/*  6515*/    OPC_CheckType, MVT::v2i64,
/*  6517*/    OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6518*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6520*/    OPC_EmitMergeInputChains1_0,
/*  6521*/    OPC_EmitInteger32, 0, 
/*  6523*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I64x2_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v2i64, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v2i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadvi32>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I64x2_A32:{ *:[v2i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6532*/   /*Scope*/ 21, /*->6554*/
/*  6533*/    OPC_CheckPredicate, 10, // Predicate_extload
/*  6535*/    OPC_CheckPredicate, 23, // Predicate_extloadvi32
/*  6537*/    OPC_CheckType, MVT::v2i64,
/*  6539*/    OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6540*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6542*/    OPC_EmitMergeInputChains1_0,
/*  6543*/    OPC_EmitInteger32, 0, 
/*  6545*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I64x2_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v2i64, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v2i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadvi32>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I64x2_A32:{ *:[v2i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6554*/   /*Scope*/ 37, /*->6592*/
/*  6555*/    OPC_CheckPredicate7,  // Predicate_load
/*  6556*/    OPC_SwitchType /*2 cases */, 15, MVT::v4f32,// ->6574
/*  6559*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6560*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6562*/     OPC_EmitMergeInputChains1_0,
/*  6563*/     OPC_EmitInteger32, 0, 
/*  6565*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v4f32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v4f32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A32:{ *:[v4f32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6574*/    /*SwitchType*/ 15, MVT::v2f64,// ->6591
/*  6576*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6577*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6579*/     OPC_EmitMergeInputChains1_0,
/*  6580*/     OPC_EmitInteger32, 0, 
/*  6582*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v2f64, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v2f64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A32:{ *:[v2f64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6591*/    0, // EndSwitchType
/*  6592*/   /*Scope*/ 28, /*->6621*/
/*  6593*/    OPC_CheckPredicate, 10, // Predicate_extload
/*  6595*/    OPC_CheckType, MVT::v2f64,
/*  6597*/    OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6598*/    OPC_EmitMergeInputChains1_0,
/*  6599*/    OPC_EmitInteger32, 0, 
/*  6601*/    OPC_EmitInteger32, 0, 
/*  6603*/    OPC_EmitNode1, TARGET_VAL(WebAssembly::LOAD_ZERO_I64x2_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v16i8, 3/*#Ops*/, 2, 3, 1,  // Results = #4
/*  6612*/    OPC_EmitNode1None, TARGET_VAL(WebAssembly::promote_low_F64x2),
                  MVT::v2f64, 1/*#Ops*/, 4,  // Results = #5
/*  6618*/    OPC_CompleteMatch, 1, 5, 
               // Src: (ld:{ *:[v2f64] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_extload>> - Complexity = 4
               // Dst: (promote_low_F64x2:{ *:[v2f64] } (LOAD_ZERO_I64x2_A32:{ *:[v16i8] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr))
/*  6621*/   0, /*End of Scope*/
/*  6622*/  /*Scope*/ 68|128,5/*708*/, /*->7332*/
/*  6624*/   OPC_CheckChild1TypeI64,
/*  6625*/   OPC_CheckPredicate, 9, // Predicate_unindexedload
/*  6627*/   OPC_Scope, 37, /*->6666*/ // 16 children in Scope
/*  6629*/    OPC_CheckPredicate7,  // Predicate_load
/*  6630*/    OPC_SwitchType /*2 cases */, 15, MVT::i32,// ->6648
/*  6633*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  6634*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6636*/     OPC_EmitMergeInputChains1_0,
/*  6637*/     OPC_EmitInteger32, 0, 
/*  6639*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6648*/    /*SwitchType*/ 15, MVT::i64,// ->6665
/*  6650*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  6651*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6653*/     OPC_EmitMergeInputChains1_0,
/*  6654*/     OPC_EmitInteger32, 0, 
/*  6656*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i64, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6665*/    0, // EndSwitchType
/*  6666*/   /*Scope*/ 97, /*->6764*/
/*  6667*/    OPC_CheckPredicate, 13, // Predicate_sextload
/*  6669*/    OPC_SwitchType /*2 cases */, 36, MVT::i32,// ->6708
/*  6672*/     OPC_Scope, 16, /*->6690*/ // 2 children in Scope
/*  6674*/      OPC_CheckPredicate1,  // Predicate_sextloadi8
/*  6675*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  6676*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6678*/      OPC_EmitMergeInputChains1_0,
/*  6679*/      OPC_EmitInteger32, 0, 
/*  6681*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_S_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>> - Complexity = 13
                // Dst: (LOAD8_S_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6690*/     /*Scope*/ 16, /*->6707*/
/*  6691*/      OPC_CheckPredicate2,  // Predicate_sextloadi16
/*  6692*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  6693*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6695*/      OPC_EmitMergeInputChains1_0,
/*  6696*/      OPC_EmitInteger32, 0, 
/*  6698*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_S_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>> - Complexity = 13
                // Dst: (LOAD16_S_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6707*/     0, /*End of Scope*/
/*  6708*/    /*SwitchType*/ 53, MVT::i64,// ->6763
/*  6710*/     OPC_Scope, 16, /*->6728*/ // 3 children in Scope
/*  6712*/      OPC_CheckPredicate1,  // Predicate_sextloadi8
/*  6713*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  6714*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6716*/      OPC_EmitMergeInputChains1_0,
/*  6717*/      OPC_EmitInteger32, 0, 
/*  6719*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_S_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>> - Complexity = 13
                // Dst: (LOAD8_S_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6728*/     /*Scope*/ 16, /*->6745*/
/*  6729*/      OPC_CheckPredicate2,  // Predicate_sextloadi16
/*  6730*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  6731*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6733*/      OPC_EmitMergeInputChains1_0,
/*  6734*/      OPC_EmitInteger32, 0, 
/*  6736*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_S_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>> - Complexity = 13
                // Dst: (LOAD16_S_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6745*/     /*Scope*/ 16, /*->6762*/
/*  6746*/      OPC_CheckPredicate3,  // Predicate_sextloadi32
/*  6747*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  6748*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6750*/      OPC_EmitMergeInputChains1_0,
/*  6751*/      OPC_EmitInteger32, 0, 
/*  6753*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_S_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>> - Complexity = 13
                // Dst: (LOAD32_S_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6762*/     0, /*End of Scope*/
/*  6763*/    0, // EndSwitchType
/*  6764*/   /*Scope*/ 97, /*->6862*/
/*  6765*/    OPC_CheckPredicate, 14, // Predicate_zextload
/*  6767*/    OPC_SwitchType /*2 cases */, 36, MVT::i32,// ->6806
/*  6770*/     OPC_Scope, 16, /*->6788*/ // 2 children in Scope
/*  6772*/      OPC_CheckPredicate1,  // Predicate_zextloadi8
/*  6773*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  6774*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6776*/      OPC_EmitMergeInputChains1_0,
/*  6777*/      OPC_EmitInteger32, 0, 
/*  6779*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>> - Complexity = 13
                // Dst: (LOAD8_U_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6788*/     /*Scope*/ 16, /*->6805*/
/*  6789*/      OPC_CheckPredicate2,  // Predicate_zextloadi16
/*  6790*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  6791*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6793*/      OPC_EmitMergeInputChains1_0,
/*  6794*/      OPC_EmitInteger32, 0, 
/*  6796*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>> - Complexity = 13
                // Dst: (LOAD16_U_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6805*/     0, /*End of Scope*/
/*  6806*/    /*SwitchType*/ 53, MVT::i64,// ->6861
/*  6808*/     OPC_Scope, 16, /*->6826*/ // 3 children in Scope
/*  6810*/      OPC_CheckPredicate1,  // Predicate_zextloadi8
/*  6811*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  6812*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6814*/      OPC_EmitMergeInputChains1_0,
/*  6815*/      OPC_EmitInteger32, 0, 
/*  6817*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>> - Complexity = 13
                // Dst: (LOAD8_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6826*/     /*Scope*/ 16, /*->6843*/
/*  6827*/      OPC_CheckPredicate2,  // Predicate_zextloadi16
/*  6828*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  6829*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6831*/      OPC_EmitMergeInputChains1_0,
/*  6832*/      OPC_EmitInteger32, 0, 
/*  6834*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>> - Complexity = 13
                // Dst: (LOAD16_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6843*/     /*Scope*/ 16, /*->6860*/
/*  6844*/      OPC_CheckPredicate3,  // Predicate_zextloadi32
/*  6845*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  6846*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6848*/      OPC_EmitMergeInputChains1_0,
/*  6849*/      OPC_EmitInteger32, 0, 
/*  6851*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>> - Complexity = 13
                // Dst: (LOAD32_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6860*/     0, /*End of Scope*/
/*  6861*/    0, // EndSwitchType
/*  6862*/   /*Scope*/ 97, /*->6960*/
/*  6863*/    OPC_CheckPredicate, 10, // Predicate_extload
/*  6865*/    OPC_SwitchType /*2 cases */, 36, MVT::i32,// ->6904
/*  6868*/     OPC_Scope, 16, /*->6886*/ // 2 children in Scope
/*  6870*/      OPC_CheckPredicate1,  // Predicate_extloadi8
/*  6871*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  6872*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6874*/      OPC_EmitMergeInputChains1_0,
/*  6875*/      OPC_EmitInteger32, 0, 
/*  6877*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>> - Complexity = 13
                // Dst: (LOAD8_U_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6886*/     /*Scope*/ 16, /*->6903*/
/*  6887*/      OPC_CheckPredicate2,  // Predicate_extloadi16
/*  6888*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  6889*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6891*/      OPC_EmitMergeInputChains1_0,
/*  6892*/      OPC_EmitInteger32, 0, 
/*  6894*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>> - Complexity = 13
                // Dst: (LOAD16_U_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6903*/     0, /*End of Scope*/
/*  6904*/    /*SwitchType*/ 53, MVT::i64,// ->6959
/*  6906*/     OPC_Scope, 16, /*->6924*/ // 3 children in Scope
/*  6908*/      OPC_CheckPredicate1,  // Predicate_extloadi8
/*  6909*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  6910*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6912*/      OPC_EmitMergeInputChains1_0,
/*  6913*/      OPC_EmitInteger32, 0, 
/*  6915*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>> - Complexity = 13
                // Dst: (LOAD8_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6924*/     /*Scope*/ 16, /*->6941*/
/*  6925*/      OPC_CheckPredicate2,  // Predicate_extloadi16
/*  6926*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  6927*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6929*/      OPC_EmitMergeInputChains1_0,
/*  6930*/      OPC_EmitInteger32, 0, 
/*  6932*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>> - Complexity = 13
                // Dst: (LOAD16_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6941*/     /*Scope*/ 16, /*->6958*/
/*  6942*/      OPC_CheckPredicate3,  // Predicate_extloadi32
/*  6943*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  6944*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6946*/      OPC_EmitMergeInputChains1_0,
/*  6947*/      OPC_EmitInteger32, 0, 
/*  6949*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>> - Complexity = 13
                // Dst: (LOAD32_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6958*/     0, /*End of Scope*/
/*  6959*/    0, // EndSwitchType
/*  6960*/   /*Scope*/ 105, /*->7066*/
/*  6961*/    OPC_CheckPredicate7,  // Predicate_load
/*  6962*/    OPC_SwitchType /*6 cases */, 15, MVT::f32,// ->6980
/*  6965*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  6966*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6968*/     OPC_EmitMergeInputChains1_0,
/*  6969*/     OPC_EmitInteger32, 0, 
/*  6971*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::f32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[f32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_F32_A64:{ *:[f32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6980*/    /*SwitchType*/ 15, MVT::f64,// ->6997
/*  6982*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  6983*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6985*/     OPC_EmitMergeInputChains1_0,
/*  6986*/     OPC_EmitInteger32, 0, 
/*  6988*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::f64, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[f64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_F64_A64:{ *:[f64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6997*/    /*SwitchType*/ 15, MVT::v16i8,// ->7014
/*  6999*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  7000*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7002*/     OPC_EmitMergeInputChains1_0,
/*  7003*/     OPC_EmitInteger32, 0, 
/*  7005*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v16i8, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v16i8] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A64:{ *:[v16i8] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7014*/    /*SwitchType*/ 15, MVT::v8i16,// ->7031
/*  7016*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  7017*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7019*/     OPC_EmitMergeInputChains1_0,
/*  7020*/     OPC_EmitInteger32, 0, 
/*  7022*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v8i16, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v8i16] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A64:{ *:[v8i16] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7031*/    /*SwitchType*/ 15, MVT::v4i32,// ->7048
/*  7033*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  7034*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7036*/     OPC_EmitMergeInputChains1_0,
/*  7037*/     OPC_EmitInteger32, 0, 
/*  7039*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v4i32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v4i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A64:{ *:[v4i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7048*/    /*SwitchType*/ 15, MVT::v2i64,// ->7065
/*  7050*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  7051*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7053*/     OPC_EmitMergeInputChains1_0,
/*  7054*/     OPC_EmitInteger32, 0, 
/*  7056*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v2i64, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v2i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A64:{ *:[v2i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7065*/    0, // EndSwitchType
/*  7066*/   /*Scope*/ 21, /*->7088*/
/*  7067*/    OPC_CheckPredicate, 13, // Predicate_sextload
/*  7069*/    OPC_CheckPredicate, 21, // Predicate_sextloadvi8
/*  7071*/    OPC_CheckType, MVT::v8i16,
/*  7073*/    OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  7074*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7076*/    OPC_EmitMergeInputChains1_0,
/*  7077*/    OPC_EmitInteger32, 0, 
/*  7079*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I16x8_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v8i16, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v8i16] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadvi8>> - Complexity = 13
              // Dst: (LOAD_EXTEND_S_I16x8_A64:{ *:[v8i16] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7088*/   /*Scope*/ 21, /*->7110*/
/*  7089*/    OPC_CheckPredicate, 14, // Predicate_zextload
/*  7091*/    OPC_CheckPredicate, 21, // Predicate_zextloadvi8
/*  7093*/    OPC_CheckType, MVT::v8i16,
/*  7095*/    OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  7096*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7098*/    OPC_EmitMergeInputChains1_0,
/*  7099*/    OPC_EmitInteger32, 0, 
/*  7101*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I16x8_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v8i16, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v8i16] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadvi8>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I16x8_A64:{ *:[v8i16] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7110*/   /*Scope*/ 21, /*->7132*/
/*  7111*/    OPC_CheckPredicate, 10, // Predicate_extload
/*  7113*/    OPC_CheckPredicate, 21, // Predicate_extloadvi8
/*  7115*/    OPC_CheckType, MVT::v8i16,
/*  7117*/    OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  7118*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7120*/    OPC_EmitMergeInputChains1_0,
/*  7121*/    OPC_EmitInteger32, 0, 
/*  7123*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I16x8_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v8i16, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v8i16] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadvi8>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I16x8_A64:{ *:[v8i16] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7132*/   /*Scope*/ 21, /*->7154*/
/*  7133*/    OPC_CheckPredicate, 13, // Predicate_sextload
/*  7135*/    OPC_CheckPredicate, 22, // Predicate_sextloadvi16
/*  7137*/    OPC_CheckType, MVT::v4i32,
/*  7139*/    OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  7140*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7142*/    OPC_EmitMergeInputChains1_0,
/*  7143*/    OPC_EmitInteger32, 0, 
/*  7145*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I32x4_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v4i32, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v4i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadvi16>> - Complexity = 13
              // Dst: (LOAD_EXTEND_S_I32x4_A64:{ *:[v4i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7154*/   /*Scope*/ 21, /*->7176*/
/*  7155*/    OPC_CheckPredicate, 14, // Predicate_zextload
/*  7157*/    OPC_CheckPredicate, 22, // Predicate_zextloadvi16
/*  7159*/    OPC_CheckType, MVT::v4i32,
/*  7161*/    OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  7162*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7164*/    OPC_EmitMergeInputChains1_0,
/*  7165*/    OPC_EmitInteger32, 0, 
/*  7167*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I32x4_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v4i32, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v4i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadvi16>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I32x4_A64:{ *:[v4i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7176*/   /*Scope*/ 21, /*->7198*/
/*  7177*/    OPC_CheckPredicate, 10, // Predicate_extload
/*  7179*/    OPC_CheckPredicate, 22, // Predicate_extloadvi16
/*  7181*/    OPC_CheckType, MVT::v4i32,
/*  7183*/    OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  7184*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7186*/    OPC_EmitMergeInputChains1_0,
/*  7187*/    OPC_EmitInteger32, 0, 
/*  7189*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I32x4_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v4i32, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v4i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadvi16>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I32x4_A64:{ *:[v4i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7198*/   /*Scope*/ 21, /*->7220*/
/*  7199*/    OPC_CheckPredicate, 13, // Predicate_sextload
/*  7201*/    OPC_CheckPredicate, 23, // Predicate_sextloadvi32
/*  7203*/    OPC_CheckType, MVT::v2i64,
/*  7205*/    OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  7206*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7208*/    OPC_EmitMergeInputChains1_0,
/*  7209*/    OPC_EmitInteger32, 0, 
/*  7211*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I64x2_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v2i64, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v2i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadvi32>> - Complexity = 13
              // Dst: (LOAD_EXTEND_S_I64x2_A64:{ *:[v2i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7220*/   /*Scope*/ 21, /*->7242*/
/*  7221*/    OPC_CheckPredicate, 14, // Predicate_zextload
/*  7223*/    OPC_CheckPredicate, 23, // Predicate_zextloadvi32
/*  7225*/    OPC_CheckType, MVT::v2i64,
/*  7227*/    OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  7228*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7230*/    OPC_EmitMergeInputChains1_0,
/*  7231*/    OPC_EmitInteger32, 0, 
/*  7233*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I64x2_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v2i64, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v2i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadvi32>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I64x2_A64:{ *:[v2i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7242*/   /*Scope*/ 21, /*->7264*/
/*  7243*/    OPC_CheckPredicate, 10, // Predicate_extload
/*  7245*/    OPC_CheckPredicate, 23, // Predicate_extloadvi32
/*  7247*/    OPC_CheckType, MVT::v2i64,
/*  7249*/    OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  7250*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7252*/    OPC_EmitMergeInputChains1_0,
/*  7253*/    OPC_EmitInteger32, 0, 
/*  7255*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I64x2_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v2i64, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v2i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadvi32>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I64x2_A64:{ *:[v2i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7264*/   /*Scope*/ 37, /*->7302*/
/*  7265*/    OPC_CheckPredicate7,  // Predicate_load
/*  7266*/    OPC_SwitchType /*2 cases */, 15, MVT::v4f32,// ->7284
/*  7269*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  7270*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7272*/     OPC_EmitMergeInputChains1_0,
/*  7273*/     OPC_EmitInteger32, 0, 
/*  7275*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v4f32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v4f32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A64:{ *:[v4f32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7284*/    /*SwitchType*/ 15, MVT::v2f64,// ->7301
/*  7286*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  7287*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7289*/     OPC_EmitMergeInputChains1_0,
/*  7290*/     OPC_EmitInteger32, 0, 
/*  7292*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v2f64, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v2f64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A64:{ *:[v2f64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7301*/    0, // EndSwitchType
/*  7302*/   /*Scope*/ 28, /*->7331*/
/*  7303*/    OPC_CheckPredicate, 10, // Predicate_extload
/*  7305*/    OPC_CheckType, MVT::v2f64,
/*  7307*/    OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  7308*/    OPC_EmitMergeInputChains1_0,
/*  7309*/    OPC_EmitInteger32, 0, 
/*  7311*/    OPC_EmitInteger64, 0, 
/*  7313*/    OPC_EmitNode1, TARGET_VAL(WebAssembly::LOAD_ZERO_I64x2_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v16i8, 3/*#Ops*/, 2, 3, 1,  // Results = #4
/*  7322*/    OPC_EmitNode1None, TARGET_VAL(WebAssembly::promote_low_F64x2),
                  MVT::v2f64, 1/*#Ops*/, 4,  // Results = #5
/*  7328*/    OPC_CompleteMatch, 1, 5, 
               // Src: (ld:{ *:[v2f64] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_extload>> - Complexity = 4
               // Dst: (promote_low_F64x2:{ *:[v2f64] } (LOAD_ZERO_I64x2_A64:{ *:[v16i8] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr))
/*  7331*/   0, /*End of Scope*/
/*  7332*/  0, /*End of Scope*/
/*  7333*/ /*SwitchOpcode*/ 31|128,1/*159*/, TARGET_VAL(ISD::ATOMIC_LOAD),// ->7496
/*  7337*/  OPC_RecordMemRef,
/*  7338*/  OPC_RecordNode, // #0 = 'atomic_load' chained node
/*  7339*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  7340*/  OPC_Scope, 76, /*->7418*/ // 2 children in Scope
/*  7342*/   OPC_CheckChild1TypeI32,
/*  7343*/   OPC_SwitchType /*2 cases */, 53, MVT::i32,// ->7399
/*  7346*/    OPC_Scope, 16, /*->7364*/ // 3 children in Scope
/*  7348*/     OPC_CheckPredicate3,  // Predicate_atomic_load_32
/*  7349*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  7350*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  7352*/     OPC_EmitMergeInputChains1_0,
/*  7353*/     OPC_EmitInteger32, 0, 
/*  7355*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (atomic_load:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_32>> - Complexity = 13
               // Dst: (ATOMIC_LOAD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  7364*/    /*Scope*/ 16, /*->7381*/
/*  7365*/     OPC_CheckPredicate1,  // Predicate_atomic_load_8
/*  7366*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  7367*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  7369*/     OPC_EmitMergeInputChains1_0,
/*  7370*/     OPC_EmitInteger32, 0, 
/*  7372*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (atomic_load:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_8>> - Complexity = 13
               // Dst: (ATOMIC_LOAD8_U_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  7381*/    /*Scope*/ 16, /*->7398*/
/*  7382*/     OPC_CheckPredicate2,  // Predicate_atomic_load_16
/*  7383*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  7384*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  7386*/     OPC_EmitMergeInputChains1_0,
/*  7387*/     OPC_EmitInteger32, 0, 
/*  7389*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (atomic_load:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_16>> - Complexity = 13
               // Dst: (ATOMIC_LOAD16_U_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  7398*/    0, /*End of Scope*/
/*  7399*/   /*SwitchType*/ 16, MVT::i64,// ->7417
/*  7401*/    OPC_CheckPredicate6,  // Predicate_atomic_load_64
/*  7402*/    OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  7403*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  7405*/    OPC_EmitMergeInputChains1_0,
/*  7406*/    OPC_EmitInteger32, 0, 
/*  7408*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 3/*#Ops*/, 4, 2, 3, 
              // Src: (atomic_load:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_64>> - Complexity = 13
              // Dst: (ATOMIC_LOAD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  7417*/   0, // EndSwitchType
/*  7418*/  /*Scope*/ 76, /*->7495*/
/*  7419*/   OPC_CheckChild1TypeI64,
/*  7420*/   OPC_SwitchType /*2 cases */, 53, MVT::i32,// ->7476
/*  7423*/    OPC_Scope, 16, /*->7441*/ // 3 children in Scope
/*  7425*/     OPC_CheckPredicate3,  // Predicate_atomic_load_32
/*  7426*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  7427*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7429*/     OPC_EmitMergeInputChains1_0,
/*  7430*/     OPC_EmitInteger32, 0, 
/*  7432*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (atomic_load:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_32>> - Complexity = 13
               // Dst: (ATOMIC_LOAD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7441*/    /*Scope*/ 16, /*->7458*/
/*  7442*/     OPC_CheckPredicate1,  // Predicate_atomic_load_8
/*  7443*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  7444*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7446*/     OPC_EmitMergeInputChains1_0,
/*  7447*/     OPC_EmitInteger32, 0, 
/*  7449*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (atomic_load:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_8>> - Complexity = 13
               // Dst: (ATOMIC_LOAD8_U_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7458*/    /*Scope*/ 16, /*->7475*/
/*  7459*/     OPC_CheckPredicate2,  // Predicate_atomic_load_16
/*  7460*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  7461*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7463*/     OPC_EmitMergeInputChains1_0,
/*  7464*/     OPC_EmitInteger32, 0, 
/*  7466*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (atomic_load:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_16>> - Complexity = 13
               // Dst: (ATOMIC_LOAD16_U_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7475*/    0, /*End of Scope*/
/*  7476*/   /*SwitchType*/ 16, MVT::i64,// ->7494
/*  7478*/    OPC_CheckPredicate6,  // Predicate_atomic_load_64
/*  7479*/    OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  7480*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7482*/    OPC_EmitMergeInputChains1_0,
/*  7483*/    OPC_EmitInteger32, 0, 
/*  7485*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 3/*#Ops*/, 4, 2, 3, 
              // Src: (atomic_load:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_64>> - Complexity = 13
              // Dst: (ATOMIC_LOAD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7494*/   0, // EndSwitchType
/*  7495*/  0, /*End of Scope*/
/*  7496*/ /*SwitchOpcode*/ 113|128,1/*241*/, TARGET_VAL(ISD::ATOMIC_LOAD_ADD),// ->7741
/*  7500*/  OPC_RecordMemRef,
/*  7501*/  OPC_RecordNode, // #0 = 'atomic_load_add' chained node
/*  7502*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  7503*/  OPC_Scope, 117, /*->7622*/ // 2 children in Scope
/*  7505*/   OPC_CheckChild1TypeI32,
/*  7506*/   OPC_RecordChild2, // #2 = $val
/*  7507*/   OPC_SwitchType /*2 cases */, 92, MVT::i32,// ->7602
/*  7510*/    OPC_Scope, 17, /*->7529*/ // 5 children in Scope
/*  7512*/     OPC_CheckPredicate3,  // Predicate_atomic_load_add_i32
/*  7513*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7514*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7516*/     OPC_EmitMergeInputChains1_0,
/*  7517*/     OPC_EmitInteger32, 0, 
/*  7519*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_ADD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_i32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_ADD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  7529*/    /*Scope*/ 17, /*->7547*/
/*  7530*/     OPC_CheckPredicate1,  // Predicate_atomic_load_add_i8
/*  7531*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7532*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7534*/     OPC_EmitMergeInputChains1_0,
/*  7535*/     OPC_EmitInteger32, 0, 
/*  7537*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_ADD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  7547*/    /*Scope*/ 17, /*->7565*/
/*  7548*/     OPC_CheckPredicate2,  // Predicate_atomic_load_add_i16
/*  7549*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7550*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7552*/     OPC_EmitMergeInputChains1_0,
/*  7553*/     OPC_EmitInteger32, 0, 
/*  7555*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_ADD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  7565*/    /*Scope*/ 17, /*->7583*/
/*  7566*/     OPC_CheckPredicate1,  // Predicate_atomic_load_add_i8
/*  7567*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7568*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7570*/     OPC_EmitMergeInputChains1_0,
/*  7571*/     OPC_EmitInteger32, 0, 
/*  7573*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_ADD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  7583*/    /*Scope*/ 17, /*->7601*/
/*  7584*/     OPC_CheckPredicate2,  // Predicate_atomic_load_add_i16
/*  7585*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7586*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7588*/     OPC_EmitMergeInputChains1_0,
/*  7589*/     OPC_EmitInteger32, 0, 
/*  7591*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_ADD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  7601*/    0, /*End of Scope*/
/*  7602*/   /*SwitchType*/ 17, MVT::i64,// ->7621
/*  7604*/    OPC_CheckPredicate6,  // Predicate_atomic_load_add_i64
/*  7605*/    OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7606*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7608*/    OPC_EmitMergeInputChains1_0,
/*  7609*/    OPC_EmitInteger32, 0, 
/*  7611*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_add:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_add_i64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_ADD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  7621*/   0, // EndSwitchType
/*  7622*/  /*Scope*/ 117, /*->7740*/
/*  7623*/   OPC_CheckChild1TypeI64,
/*  7624*/   OPC_RecordChild2, // #2 = $val
/*  7625*/   OPC_SwitchType /*2 cases */, 92, MVT::i32,// ->7720
/*  7628*/    OPC_Scope, 17, /*->7647*/ // 5 children in Scope
/*  7630*/     OPC_CheckPredicate3,  // Predicate_atomic_load_add_i32
/*  7631*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7632*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  7634*/     OPC_EmitMergeInputChains1_0,
/*  7635*/     OPC_EmitInteger32, 0, 
/*  7637*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_ADD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_i32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_ADD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  7647*/    /*Scope*/ 17, /*->7665*/
/*  7648*/     OPC_CheckPredicate1,  // Predicate_atomic_load_add_i8
/*  7649*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7650*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  7652*/     OPC_EmitMergeInputChains1_0,
/*  7653*/     OPC_EmitInteger32, 0, 
/*  7655*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_ADD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  7665*/    /*Scope*/ 17, /*->7683*/
/*  7666*/     OPC_CheckPredicate2,  // Predicate_atomic_load_add_i16
/*  7667*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7668*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  7670*/     OPC_EmitMergeInputChains1_0,
/*  7671*/     OPC_EmitInteger32, 0, 
/*  7673*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_ADD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  7683*/    /*Scope*/ 17, /*->7701*/
/*  7684*/     OPC_CheckPredicate1,  // Predicate_atomic_load_add_i8
/*  7685*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7686*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  7688*/     OPC_EmitMergeInputChains1_0,
/*  7689*/     OPC_EmitInteger32, 0, 
/*  7691*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_ADD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  7701*/    /*Scope*/ 17, /*->7719*/
/*  7702*/     OPC_CheckPredicate2,  // Predicate_atomic_load_add_i16
/*  7703*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7704*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  7706*/     OPC_EmitMergeInputChains1_0,
/*  7707*/     OPC_EmitInteger32, 0, 
/*  7709*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_ADD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  7719*/    0, /*End of Scope*/
/*  7720*/   /*SwitchType*/ 17, MVT::i64,// ->7739
/*  7722*/    OPC_CheckPredicate6,  // Predicate_atomic_load_add_i64
/*  7723*/    OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7724*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  7726*/    OPC_EmitMergeInputChains1_0,
/*  7727*/    OPC_EmitInteger32, 0, 
/*  7729*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_add:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_add_i64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_ADD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  7739*/   0, // EndSwitchType
/*  7740*/  0, /*End of Scope*/
/*  7741*/ /*SwitchOpcode*/ 113|128,1/*241*/, TARGET_VAL(ISD::ATOMIC_LOAD_SUB),// ->7986
/*  7745*/  OPC_RecordMemRef,
/*  7746*/  OPC_RecordNode, // #0 = 'atomic_load_sub' chained node
/*  7747*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  7748*/  OPC_Scope, 117, /*->7867*/ // 2 children in Scope
/*  7750*/   OPC_CheckChild1TypeI32,
/*  7751*/   OPC_RecordChild2, // #2 = $val
/*  7752*/   OPC_SwitchType /*2 cases */, 92, MVT::i32,// ->7847
/*  7755*/    OPC_Scope, 17, /*->7774*/ // 5 children in Scope
/*  7757*/     OPC_CheckPredicate3,  // Predicate_atomic_load_sub_i32
/*  7758*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7759*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7761*/     OPC_EmitMergeInputChains1_0,
/*  7762*/     OPC_EmitInteger32, 0, 
/*  7764*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_SUB_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_i32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_SUB_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  7774*/    /*Scope*/ 17, /*->7792*/
/*  7775*/     OPC_CheckPredicate1,  // Predicate_atomic_load_sub_i8
/*  7776*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7777*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7779*/     OPC_EmitMergeInputChains1_0,
/*  7780*/     OPC_EmitInteger32, 0, 
/*  7782*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_SUB_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  7792*/    /*Scope*/ 17, /*->7810*/
/*  7793*/     OPC_CheckPredicate2,  // Predicate_atomic_load_sub_i16
/*  7794*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7795*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7797*/     OPC_EmitMergeInputChains1_0,
/*  7798*/     OPC_EmitInteger32, 0, 
/*  7800*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_SUB_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  7810*/    /*Scope*/ 17, /*->7828*/
/*  7811*/     OPC_CheckPredicate1,  // Predicate_atomic_load_sub_i8
/*  7812*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7813*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7815*/     OPC_EmitMergeInputChains1_0,
/*  7816*/     OPC_EmitInteger32, 0, 
/*  7818*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_SUB_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  7828*/    /*Scope*/ 17, /*->7846*/
/*  7829*/     OPC_CheckPredicate2,  // Predicate_atomic_load_sub_i16
/*  7830*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7831*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7833*/     OPC_EmitMergeInputChains1_0,
/*  7834*/     OPC_EmitInteger32, 0, 
/*  7836*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_SUB_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  7846*/    0, /*End of Scope*/
/*  7847*/   /*SwitchType*/ 17, MVT::i64,// ->7866
/*  7849*/    OPC_CheckPredicate6,  // Predicate_atomic_load_sub_i64
/*  7850*/    OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7851*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7853*/    OPC_EmitMergeInputChains1_0,
/*  7854*/    OPC_EmitInteger32, 0, 
/*  7856*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_sub:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_sub_i64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_SUB_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  7866*/   0, // EndSwitchType
/*  7867*/  /*Scope*/ 117, /*->7985*/
/*  7868*/   OPC_CheckChild1TypeI64,
/*  7869*/   OPC_RecordChild2, // #2 = $val
/*  7870*/   OPC_SwitchType /*2 cases */, 92, MVT::i32,// ->7965
/*  7873*/    OPC_Scope, 17, /*->7892*/ // 5 children in Scope
/*  7875*/     OPC_CheckPredicate3,  // Predicate_atomic_load_sub_i32
/*  7876*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7877*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  7879*/     OPC_EmitMergeInputChains1_0,
/*  7880*/     OPC_EmitInteger32, 0, 
/*  7882*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_SUB_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_i32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_SUB_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  7892*/    /*Scope*/ 17, /*->7910*/
/*  7893*/     OPC_CheckPredicate1,  // Predicate_atomic_load_sub_i8
/*  7894*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7895*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  7897*/     OPC_EmitMergeInputChains1_0,
/*  7898*/     OPC_EmitInteger32, 0, 
/*  7900*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_SUB_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  7910*/    /*Scope*/ 17, /*->7928*/
/*  7911*/     OPC_CheckPredicate2,  // Predicate_atomic_load_sub_i16
/*  7912*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7913*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  7915*/     OPC_EmitMergeInputChains1_0,
/*  7916*/     OPC_EmitInteger32, 0, 
/*  7918*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_SUB_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  7928*/    /*Scope*/ 17, /*->7946*/
/*  7929*/     OPC_CheckPredicate1,  // Predicate_atomic_load_sub_i8
/*  7930*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7931*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  7933*/     OPC_EmitMergeInputChains1_0,
/*  7934*/     OPC_EmitInteger32, 0, 
/*  7936*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_SUB_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  7946*/    /*Scope*/ 17, /*->7964*/
/*  7947*/     OPC_CheckPredicate2,  // Predicate_atomic_load_sub_i16
/*  7948*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7949*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  7951*/     OPC_EmitMergeInputChains1_0,
/*  7952*/     OPC_EmitInteger32, 0, 
/*  7954*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_SUB_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  7964*/    0, /*End of Scope*/
/*  7965*/   /*SwitchType*/ 17, MVT::i64,// ->7984
/*  7967*/    OPC_CheckPredicate6,  // Predicate_atomic_load_sub_i64
/*  7968*/    OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7969*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  7971*/    OPC_EmitMergeInputChains1_0,
/*  7972*/    OPC_EmitInteger32, 0, 
/*  7974*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_sub:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_sub_i64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_SUB_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  7984*/   0, // EndSwitchType
/*  7985*/  0, /*End of Scope*/
/*  7986*/ /*SwitchOpcode*/ 113|128,1/*241*/, TARGET_VAL(ISD::ATOMIC_LOAD_AND),// ->8231
/*  7990*/  OPC_RecordMemRef,
/*  7991*/  OPC_RecordNode, // #0 = 'atomic_load_and' chained node
/*  7992*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  7993*/  OPC_Scope, 117, /*->8112*/ // 2 children in Scope
/*  7995*/   OPC_CheckChild1TypeI32,
/*  7996*/   OPC_RecordChild2, // #2 = $val
/*  7997*/   OPC_SwitchType /*2 cases */, 92, MVT::i32,// ->8092
/*  8000*/    OPC_Scope, 17, /*->8019*/ // 5 children in Scope
/*  8002*/     OPC_CheckPredicate3,  // Predicate_atomic_load_and_i32
/*  8003*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8004*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8006*/     OPC_EmitMergeInputChains1_0,
/*  8007*/     OPC_EmitInteger32, 0, 
/*  8009*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_AND_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_i32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_AND_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8019*/    /*Scope*/ 17, /*->8037*/
/*  8020*/     OPC_CheckPredicate1,  // Predicate_atomic_load_and_i8
/*  8021*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8022*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8024*/     OPC_EmitMergeInputChains1_0,
/*  8025*/     OPC_EmitInteger32, 0, 
/*  8027*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_AND_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8037*/    /*Scope*/ 17, /*->8055*/
/*  8038*/     OPC_CheckPredicate2,  // Predicate_atomic_load_and_i16
/*  8039*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8040*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8042*/     OPC_EmitMergeInputChains1_0,
/*  8043*/     OPC_EmitInteger32, 0, 
/*  8045*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_AND_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8055*/    /*Scope*/ 17, /*->8073*/
/*  8056*/     OPC_CheckPredicate1,  // Predicate_atomic_load_and_i8
/*  8057*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8058*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8060*/     OPC_EmitMergeInputChains1_0,
/*  8061*/     OPC_EmitInteger32, 0, 
/*  8063*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_AND_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8073*/    /*Scope*/ 17, /*->8091*/
/*  8074*/     OPC_CheckPredicate2,  // Predicate_atomic_load_and_i16
/*  8075*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8076*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8078*/     OPC_EmitMergeInputChains1_0,
/*  8079*/     OPC_EmitInteger32, 0, 
/*  8081*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_AND_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8091*/    0, /*End of Scope*/
/*  8092*/   /*SwitchType*/ 17, MVT::i64,// ->8111
/*  8094*/    OPC_CheckPredicate6,  // Predicate_atomic_load_and_i64
/*  8095*/    OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8096*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8098*/    OPC_EmitMergeInputChains1_0,
/*  8099*/    OPC_EmitInteger32, 0, 
/*  8101*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_and:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_and_i64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_AND_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  8111*/   0, // EndSwitchType
/*  8112*/  /*Scope*/ 117, /*->8230*/
/*  8113*/   OPC_CheckChild1TypeI64,
/*  8114*/   OPC_RecordChild2, // #2 = $val
/*  8115*/   OPC_SwitchType /*2 cases */, 92, MVT::i32,// ->8210
/*  8118*/    OPC_Scope, 17, /*->8137*/ // 5 children in Scope
/*  8120*/     OPC_CheckPredicate3,  // Predicate_atomic_load_and_i32
/*  8121*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8122*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8124*/     OPC_EmitMergeInputChains1_0,
/*  8125*/     OPC_EmitInteger32, 0, 
/*  8127*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_AND_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_i32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_AND_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8137*/    /*Scope*/ 17, /*->8155*/
/*  8138*/     OPC_CheckPredicate1,  // Predicate_atomic_load_and_i8
/*  8139*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8140*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8142*/     OPC_EmitMergeInputChains1_0,
/*  8143*/     OPC_EmitInteger32, 0, 
/*  8145*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_AND_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8155*/    /*Scope*/ 17, /*->8173*/
/*  8156*/     OPC_CheckPredicate2,  // Predicate_atomic_load_and_i16
/*  8157*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8158*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8160*/     OPC_EmitMergeInputChains1_0,
/*  8161*/     OPC_EmitInteger32, 0, 
/*  8163*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_AND_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8173*/    /*Scope*/ 17, /*->8191*/
/*  8174*/     OPC_CheckPredicate1,  // Predicate_atomic_load_and_i8
/*  8175*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8176*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8178*/     OPC_EmitMergeInputChains1_0,
/*  8179*/     OPC_EmitInteger32, 0, 
/*  8181*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_AND_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8191*/    /*Scope*/ 17, /*->8209*/
/*  8192*/     OPC_CheckPredicate2,  // Predicate_atomic_load_and_i16
/*  8193*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8194*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8196*/     OPC_EmitMergeInputChains1_0,
/*  8197*/     OPC_EmitInteger32, 0, 
/*  8199*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_AND_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8209*/    0, /*End of Scope*/
/*  8210*/   /*SwitchType*/ 17, MVT::i64,// ->8229
/*  8212*/    OPC_CheckPredicate6,  // Predicate_atomic_load_and_i64
/*  8213*/    OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8214*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8216*/    OPC_EmitMergeInputChains1_0,
/*  8217*/    OPC_EmitInteger32, 0, 
/*  8219*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_and:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_and_i64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_AND_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  8229*/   0, // EndSwitchType
/*  8230*/  0, /*End of Scope*/
/*  8231*/ /*SwitchOpcode*/ 113|128,1/*241*/, TARGET_VAL(ISD::ATOMIC_LOAD_OR),// ->8476
/*  8235*/  OPC_RecordMemRef,
/*  8236*/  OPC_RecordNode, // #0 = 'atomic_load_or' chained node
/*  8237*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  8238*/  OPC_Scope, 117, /*->8357*/ // 2 children in Scope
/*  8240*/   OPC_CheckChild1TypeI32,
/*  8241*/   OPC_RecordChild2, // #2 = $val
/*  8242*/   OPC_SwitchType /*2 cases */, 92, MVT::i32,// ->8337
/*  8245*/    OPC_Scope, 17, /*->8264*/ // 5 children in Scope
/*  8247*/     OPC_CheckPredicate3,  // Predicate_atomic_load_or_i32
/*  8248*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8249*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8251*/     OPC_EmitMergeInputChains1_0,
/*  8252*/     OPC_EmitInteger32, 0, 
/*  8254*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_OR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_i32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_OR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8264*/    /*Scope*/ 17, /*->8282*/
/*  8265*/     OPC_CheckPredicate1,  // Predicate_atomic_load_or_i8
/*  8266*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8267*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8269*/     OPC_EmitMergeInputChains1_0,
/*  8270*/     OPC_EmitInteger32, 0, 
/*  8272*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_OR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8282*/    /*Scope*/ 17, /*->8300*/
/*  8283*/     OPC_CheckPredicate2,  // Predicate_atomic_load_or_i16
/*  8284*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8285*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8287*/     OPC_EmitMergeInputChains1_0,
/*  8288*/     OPC_EmitInteger32, 0, 
/*  8290*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_OR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8300*/    /*Scope*/ 17, /*->8318*/
/*  8301*/     OPC_CheckPredicate1,  // Predicate_atomic_load_or_i8
/*  8302*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8303*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8305*/     OPC_EmitMergeInputChains1_0,
/*  8306*/     OPC_EmitInteger32, 0, 
/*  8308*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_OR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8318*/    /*Scope*/ 17, /*->8336*/
/*  8319*/     OPC_CheckPredicate2,  // Predicate_atomic_load_or_i16
/*  8320*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8321*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8323*/     OPC_EmitMergeInputChains1_0,
/*  8324*/     OPC_EmitInteger32, 0, 
/*  8326*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_OR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8336*/    0, /*End of Scope*/
/*  8337*/   /*SwitchType*/ 17, MVT::i64,// ->8356
/*  8339*/    OPC_CheckPredicate6,  // Predicate_atomic_load_or_i64
/*  8340*/    OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8341*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8343*/    OPC_EmitMergeInputChains1_0,
/*  8344*/    OPC_EmitInteger32, 0, 
/*  8346*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_or:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_or_i64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_OR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  8356*/   0, // EndSwitchType
/*  8357*/  /*Scope*/ 117, /*->8475*/
/*  8358*/   OPC_CheckChild1TypeI64,
/*  8359*/   OPC_RecordChild2, // #2 = $val
/*  8360*/   OPC_SwitchType /*2 cases */, 92, MVT::i32,// ->8455
/*  8363*/    OPC_Scope, 17, /*->8382*/ // 5 children in Scope
/*  8365*/     OPC_CheckPredicate3,  // Predicate_atomic_load_or_i32
/*  8366*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8367*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8369*/     OPC_EmitMergeInputChains1_0,
/*  8370*/     OPC_EmitInteger32, 0, 
/*  8372*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_OR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_i32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_OR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8382*/    /*Scope*/ 17, /*->8400*/
/*  8383*/     OPC_CheckPredicate1,  // Predicate_atomic_load_or_i8
/*  8384*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8385*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8387*/     OPC_EmitMergeInputChains1_0,
/*  8388*/     OPC_EmitInteger32, 0, 
/*  8390*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_OR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8400*/    /*Scope*/ 17, /*->8418*/
/*  8401*/     OPC_CheckPredicate2,  // Predicate_atomic_load_or_i16
/*  8402*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8403*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8405*/     OPC_EmitMergeInputChains1_0,
/*  8406*/     OPC_EmitInteger32, 0, 
/*  8408*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_OR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8418*/    /*Scope*/ 17, /*->8436*/
/*  8419*/     OPC_CheckPredicate1,  // Predicate_atomic_load_or_i8
/*  8420*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8421*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8423*/     OPC_EmitMergeInputChains1_0,
/*  8424*/     OPC_EmitInteger32, 0, 
/*  8426*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_OR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8436*/    /*Scope*/ 17, /*->8454*/
/*  8437*/     OPC_CheckPredicate2,  // Predicate_atomic_load_or_i16
/*  8438*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8439*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8441*/     OPC_EmitMergeInputChains1_0,
/*  8442*/     OPC_EmitInteger32, 0, 
/*  8444*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_OR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8454*/    0, /*End of Scope*/
/*  8455*/   /*SwitchType*/ 17, MVT::i64,// ->8474
/*  8457*/    OPC_CheckPredicate6,  // Predicate_atomic_load_or_i64
/*  8458*/    OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8459*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8461*/    OPC_EmitMergeInputChains1_0,
/*  8462*/    OPC_EmitInteger32, 0, 
/*  8464*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_or:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_or_i64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_OR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  8474*/   0, // EndSwitchType
/*  8475*/  0, /*End of Scope*/
/*  8476*/ /*SwitchOpcode*/ 113|128,1/*241*/, TARGET_VAL(ISD::ATOMIC_LOAD_XOR),// ->8721
/*  8480*/  OPC_RecordMemRef,
/*  8481*/  OPC_RecordNode, // #0 = 'atomic_load_xor' chained node
/*  8482*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  8483*/  OPC_Scope, 117, /*->8602*/ // 2 children in Scope
/*  8485*/   OPC_CheckChild1TypeI32,
/*  8486*/   OPC_RecordChild2, // #2 = $val
/*  8487*/   OPC_SwitchType /*2 cases */, 92, MVT::i32,// ->8582
/*  8490*/    OPC_Scope, 17, /*->8509*/ // 5 children in Scope
/*  8492*/     OPC_CheckPredicate3,  // Predicate_atomic_load_xor_i32
/*  8493*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8494*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8496*/     OPC_EmitMergeInputChains1_0,
/*  8497*/     OPC_EmitInteger32, 0, 
/*  8499*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XOR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_i32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_XOR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8509*/    /*Scope*/ 17, /*->8527*/
/*  8510*/     OPC_CheckPredicate1,  // Predicate_atomic_load_xor_i8
/*  8511*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8512*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8514*/     OPC_EmitMergeInputChains1_0,
/*  8515*/     OPC_EmitInteger32, 0, 
/*  8517*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_XOR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8527*/    /*Scope*/ 17, /*->8545*/
/*  8528*/     OPC_CheckPredicate2,  // Predicate_atomic_load_xor_i16
/*  8529*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8530*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8532*/     OPC_EmitMergeInputChains1_0,
/*  8533*/     OPC_EmitInteger32, 0, 
/*  8535*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_XOR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8545*/    /*Scope*/ 17, /*->8563*/
/*  8546*/     OPC_CheckPredicate1,  // Predicate_atomic_load_xor_i8
/*  8547*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8548*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8550*/     OPC_EmitMergeInputChains1_0,
/*  8551*/     OPC_EmitInteger32, 0, 
/*  8553*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_XOR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8563*/    /*Scope*/ 17, /*->8581*/
/*  8564*/     OPC_CheckPredicate2,  // Predicate_atomic_load_xor_i16
/*  8565*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8566*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8568*/     OPC_EmitMergeInputChains1_0,
/*  8569*/     OPC_EmitInteger32, 0, 
/*  8571*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_XOR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8581*/    0, /*End of Scope*/
/*  8582*/   /*SwitchType*/ 17, MVT::i64,// ->8601
/*  8584*/    OPC_CheckPredicate6,  // Predicate_atomic_load_xor_i64
/*  8585*/    OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8586*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8588*/    OPC_EmitMergeInputChains1_0,
/*  8589*/    OPC_EmitInteger32, 0, 
/*  8591*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_xor:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_xor_i64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_XOR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  8601*/   0, // EndSwitchType
/*  8602*/  /*Scope*/ 117, /*->8720*/
/*  8603*/   OPC_CheckChild1TypeI64,
/*  8604*/   OPC_RecordChild2, // #2 = $val
/*  8605*/   OPC_SwitchType /*2 cases */, 92, MVT::i32,// ->8700
/*  8608*/    OPC_Scope, 17, /*->8627*/ // 5 children in Scope
/*  8610*/     OPC_CheckPredicate3,  // Predicate_atomic_load_xor_i32
/*  8611*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8612*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8614*/     OPC_EmitMergeInputChains1_0,
/*  8615*/     OPC_EmitInteger32, 0, 
/*  8617*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XOR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_i32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_XOR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8627*/    /*Scope*/ 17, /*->8645*/
/*  8628*/     OPC_CheckPredicate1,  // Predicate_atomic_load_xor_i8
/*  8629*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8630*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8632*/     OPC_EmitMergeInputChains1_0,
/*  8633*/     OPC_EmitInteger32, 0, 
/*  8635*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_XOR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8645*/    /*Scope*/ 17, /*->8663*/
/*  8646*/     OPC_CheckPredicate2,  // Predicate_atomic_load_xor_i16
/*  8647*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8648*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8650*/     OPC_EmitMergeInputChains1_0,
/*  8651*/     OPC_EmitInteger32, 0, 
/*  8653*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_XOR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8663*/    /*Scope*/ 17, /*->8681*/
/*  8664*/     OPC_CheckPredicate1,  // Predicate_atomic_load_xor_i8
/*  8665*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8666*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8668*/     OPC_EmitMergeInputChains1_0,
/*  8669*/     OPC_EmitInteger32, 0, 
/*  8671*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_XOR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8681*/    /*Scope*/ 17, /*->8699*/
/*  8682*/     OPC_CheckPredicate2,  // Predicate_atomic_load_xor_i16
/*  8683*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8684*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8686*/     OPC_EmitMergeInputChains1_0,
/*  8687*/     OPC_EmitInteger32, 0, 
/*  8689*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_XOR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8699*/    0, /*End of Scope*/
/*  8700*/   /*SwitchType*/ 17, MVT::i64,// ->8719
/*  8702*/    OPC_CheckPredicate6,  // Predicate_atomic_load_xor_i64
/*  8703*/    OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8704*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8706*/    OPC_EmitMergeInputChains1_0,
/*  8707*/    OPC_EmitInteger32, 0, 
/*  8709*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_xor:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_xor_i64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_XOR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  8719*/   0, // EndSwitchType
/*  8720*/  0, /*End of Scope*/
/*  8721*/ /*SwitchOpcode*/ 113|128,1/*241*/, TARGET_VAL(ISD::ATOMIC_SWAP),// ->8966
/*  8725*/  OPC_RecordMemRef,
/*  8726*/  OPC_RecordNode, // #0 = 'atomic_swap' chained node
/*  8727*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  8728*/  OPC_Scope, 117, /*->8847*/ // 2 children in Scope
/*  8730*/   OPC_CheckChild1TypeI32,
/*  8731*/   OPC_RecordChild2, // #2 = $val
/*  8732*/   OPC_SwitchType /*2 cases */, 92, MVT::i32,// ->8827
/*  8735*/    OPC_Scope, 17, /*->8754*/ // 5 children in Scope
/*  8737*/     OPC_CheckPredicate3,  // Predicate_atomic_swap_i32
/*  8738*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8739*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8741*/     OPC_EmitMergeInputChains1_0,
/*  8742*/     OPC_EmitInteger32, 0, 
/*  8744*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_i32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_XCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8754*/    /*Scope*/ 17, /*->8772*/
/*  8755*/     OPC_CheckPredicate1,  // Predicate_atomic_swap_i8
/*  8756*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8757*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8759*/     OPC_EmitMergeInputChains1_0,
/*  8760*/     OPC_EmitInteger32, 0, 
/*  8762*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_XCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8772*/    /*Scope*/ 17, /*->8790*/
/*  8773*/     OPC_CheckPredicate2,  // Predicate_atomic_swap_i16
/*  8774*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8775*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8777*/     OPC_EmitMergeInputChains1_0,
/*  8778*/     OPC_EmitInteger32, 0, 
/*  8780*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_XCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8790*/    /*Scope*/ 17, /*->8808*/
/*  8791*/     OPC_CheckPredicate1,  // Predicate_atomic_swap_i8
/*  8792*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8793*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8795*/     OPC_EmitMergeInputChains1_0,
/*  8796*/     OPC_EmitInteger32, 0, 
/*  8798*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_XCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8808*/    /*Scope*/ 17, /*->8826*/
/*  8809*/     OPC_CheckPredicate2,  // Predicate_atomic_swap_i16
/*  8810*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8811*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8813*/     OPC_EmitMergeInputChains1_0,
/*  8814*/     OPC_EmitInteger32, 0, 
/*  8816*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_XCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8826*/    0, /*End of Scope*/
/*  8827*/   /*SwitchType*/ 17, MVT::i64,// ->8846
/*  8829*/    OPC_CheckPredicate6,  // Predicate_atomic_swap_i64
/*  8830*/    OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8831*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8833*/    OPC_EmitMergeInputChains1_0,
/*  8834*/    OPC_EmitInteger32, 0, 
/*  8836*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_swap:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_swap_i64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_XCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  8846*/   0, // EndSwitchType
/*  8847*/  /*Scope*/ 117, /*->8965*/
/*  8848*/   OPC_CheckChild1TypeI64,
/*  8849*/   OPC_RecordChild2, // #2 = $val
/*  8850*/   OPC_SwitchType /*2 cases */, 92, MVT::i32,// ->8945
/*  8853*/    OPC_Scope, 17, /*->8872*/ // 5 children in Scope
/*  8855*/     OPC_CheckPredicate3,  // Predicate_atomic_swap_i32
/*  8856*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8857*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8859*/     OPC_EmitMergeInputChains1_0,
/*  8860*/     OPC_EmitInteger32, 0, 
/*  8862*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_i32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_XCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8872*/    /*Scope*/ 17, /*->8890*/
/*  8873*/     OPC_CheckPredicate1,  // Predicate_atomic_swap_i8
/*  8874*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8875*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8877*/     OPC_EmitMergeInputChains1_0,
/*  8878*/     OPC_EmitInteger32, 0, 
/*  8880*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_XCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8890*/    /*Scope*/ 17, /*->8908*/
/*  8891*/     OPC_CheckPredicate2,  // Predicate_atomic_swap_i16
/*  8892*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8893*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8895*/     OPC_EmitMergeInputChains1_0,
/*  8896*/     OPC_EmitInteger32, 0, 
/*  8898*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_XCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8908*/    /*Scope*/ 17, /*->8926*/
/*  8909*/     OPC_CheckPredicate1,  // Predicate_atomic_swap_i8
/*  8910*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8911*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8913*/     OPC_EmitMergeInputChains1_0,
/*  8914*/     OPC_EmitInteger32, 0, 
/*  8916*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_XCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8926*/    /*Scope*/ 17, /*->8944*/
/*  8927*/     OPC_CheckPredicate2,  // Predicate_atomic_swap_i16
/*  8928*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8929*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8931*/     OPC_EmitMergeInputChains1_0,
/*  8932*/     OPC_EmitInteger32, 0, 
/*  8934*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_XCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8944*/    0, /*End of Scope*/
/*  8945*/   /*SwitchType*/ 17, MVT::i64,// ->8964
/*  8947*/    OPC_CheckPredicate6,  // Predicate_atomic_swap_i64
/*  8948*/    OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8949*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8951*/    OPC_EmitMergeInputChains1_0,
/*  8952*/    OPC_EmitInteger32, 0, 
/*  8954*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_swap:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_swap_i64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_XCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  8964*/   0, // EndSwitchType
/*  8965*/  0, /*End of Scope*/
/*  8966*/ /*SwitchOpcode*/ 127|128,1/*255*/, TARGET_VAL(ISD::ATOMIC_CMP_SWAP),// ->9225
/*  8970*/  OPC_RecordMemRef,
/*  8971*/  OPC_RecordNode, // #0 = 'atomic_cmp_swap' chained node
/*  8972*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  8973*/  OPC_Scope, 124, /*->9099*/ // 2 children in Scope
/*  8975*/   OPC_CheckChild1TypeI32,
/*  8976*/   OPC_RecordChild2, // #2 = $exp
/*  8977*/   OPC_RecordChild3, // #3 = $new
/*  8978*/   OPC_SwitchType /*2 cases */, 97, MVT::i32,// ->9078
/*  8981*/    OPC_Scope, 18, /*->9001*/ // 5 children in Scope
/*  8983*/     OPC_CheckPredicate3,  // Predicate_atomic_cmp_swap_i32
/*  8984*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8985*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  8987*/     OPC_EmitMergeInputChains1_0,
/*  8988*/     OPC_EmitInteger32, 0, 
/*  8990*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_CMPXCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_CMPXCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/*  9001*/    /*Scope*/ 18, /*->9020*/
/*  9002*/     OPC_CheckPredicate1,  // Predicate_atomic_cmp_swap_i8
/*  9003*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9004*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  9006*/     OPC_EmitMergeInputChains1_0,
/*  9007*/     OPC_EmitInteger32, 0, 
/*  9009*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_CMPXCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/*  9020*/    /*Scope*/ 18, /*->9039*/
/*  9021*/     OPC_CheckPredicate2,  // Predicate_atomic_cmp_swap_i16
/*  9022*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9023*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  9025*/     OPC_EmitMergeInputChains1_0,
/*  9026*/     OPC_EmitInteger32, 0, 
/*  9028*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_CMPXCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/*  9039*/    /*Scope*/ 18, /*->9058*/
/*  9040*/     OPC_CheckPredicate1,  // Predicate_atomic_cmp_swap_i8
/*  9041*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9042*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  9044*/     OPC_EmitMergeInputChains1_0,
/*  9045*/     OPC_EmitInteger32, 0, 
/*  9047*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_CMPXCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/*  9058*/    /*Scope*/ 18, /*->9077*/
/*  9059*/     OPC_CheckPredicate2,  // Predicate_atomic_cmp_swap_i16
/*  9060*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9061*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  9063*/     OPC_EmitMergeInputChains1_0,
/*  9064*/     OPC_EmitInteger32, 0, 
/*  9066*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_CMPXCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/*  9077*/    0, /*End of Scope*/
/*  9078*/   /*SwitchType*/ 18, MVT::i64,// ->9098
/*  9080*/    OPC_CheckPredicate6,  // Predicate_atomic_cmp_swap_i64
/*  9081*/    OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9082*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  9084*/    OPC_EmitMergeInputChains1_0,
/*  9085*/    OPC_EmitInteger32, 0, 
/*  9087*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 5/*#Ops*/, 6, 4, 5, 2, 3, 
              // Src: (atomic_cmp_swap:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_CMPXCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*  9098*/   0, // EndSwitchType
/*  9099*/  /*Scope*/ 124, /*->9224*/
/*  9100*/   OPC_CheckChild1TypeI64,
/*  9101*/   OPC_RecordChild2, // #2 = $exp
/*  9102*/   OPC_RecordChild3, // #3 = $new
/*  9103*/   OPC_SwitchType /*2 cases */, 97, MVT::i32,// ->9203
/*  9106*/    OPC_Scope, 18, /*->9126*/ // 5 children in Scope
/*  9108*/     OPC_CheckPredicate3,  // Predicate_atomic_cmp_swap_i32
/*  9109*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9110*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  9112*/     OPC_EmitMergeInputChains1_0,
/*  9113*/     OPC_EmitInteger32, 0, 
/*  9115*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_CMPXCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_CMPXCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/*  9126*/    /*Scope*/ 18, /*->9145*/
/*  9127*/     OPC_CheckPredicate1,  // Predicate_atomic_cmp_swap_i8
/*  9128*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9129*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  9131*/     OPC_EmitMergeInputChains1_0,
/*  9132*/     OPC_EmitInteger32, 0, 
/*  9134*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_CMPXCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/*  9145*/    /*Scope*/ 18, /*->9164*/
/*  9146*/     OPC_CheckPredicate2,  // Predicate_atomic_cmp_swap_i16
/*  9147*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9148*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  9150*/     OPC_EmitMergeInputChains1_0,
/*  9151*/     OPC_EmitInteger32, 0, 
/*  9153*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_CMPXCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/*  9164*/    /*Scope*/ 18, /*->9183*/
/*  9165*/     OPC_CheckPredicate1,  // Predicate_atomic_cmp_swap_i8
/*  9166*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9167*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  9169*/     OPC_EmitMergeInputChains1_0,
/*  9170*/     OPC_EmitInteger32, 0, 
/*  9172*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_CMPXCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/*  9183*/    /*Scope*/ 18, /*->9202*/
/*  9184*/     OPC_CheckPredicate2,  // Predicate_atomic_cmp_swap_i16
/*  9185*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9186*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  9188*/     OPC_EmitMergeInputChains1_0,
/*  9189*/     OPC_EmitInteger32, 0, 
/*  9191*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_CMPXCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/*  9202*/    0, /*End of Scope*/
/*  9203*/   /*SwitchType*/ 18, MVT::i64,// ->9223
/*  9205*/    OPC_CheckPredicate6,  // Predicate_atomic_cmp_swap_i64
/*  9206*/    OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9207*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  9209*/    OPC_EmitMergeInputChains1_0,
/*  9210*/    OPC_EmitInteger32, 0, 
/*  9212*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 5/*#Ops*/, 6, 4, 5, 2, 3, 
              // Src: (atomic_cmp_swap:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_CMPXCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*  9223*/   0, // EndSwitchType
/*  9224*/  0, /*End of Scope*/
/*  9225*/ /*SwitchOpcode*/ 89, TARGET_VAL(ISD::BRCOND),// ->9317
/*  9228*/  OPC_RecordNode, // #0 = 'brcond' chained node
/*  9229*/  OPC_Scope, 69, /*->9300*/ // 2 children in Scope
/*  9231*/   OPC_MoveChild1,
/*  9232*/   OPC_SwitchOpcode /*2 cases */, 21, TARGET_VAL(ISD::XOR),// ->9257
/*  9236*/    OPC_RecordChild0, // #1 = $cond
/*  9237*/    OPC_MoveChild0,
/*  9238*/    OPC_CheckPredicate, 26, // Predicate_bool_node
/*  9240*/    OPC_MoveParent,
/*  9241*/    OPC_CheckChild1Integer, 2, 
/*  9243*/    OPC_CheckTypeI32,
/*  9244*/    OPC_MoveSibling2,
/*  9245*/    OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
/*  9248*/    OPC_RecordNode, // #2 = $dst
/*  9249*/    OPC_MoveParent,
/*  9250*/    OPC_EmitMergeInputChains1_0,
/*  9251*/    OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::BR_UNLESS),
                  2/*#Ops*/, 2, 1, 
              // Src: (brcond (xor:{ *:[i32] } I32:{ *:[i32] }<<P:Predicate_bool_node>>:$cond, 1:{ *:[i32] }), (bb:{ *:[Other] }):$dst) - Complexity = 12
              // Dst: (BR_UNLESS bb_op:{ *:[Other] }:$dst, I32:{ *:[i32] }:$cond)
/*  9257*/   /*SwitchOpcode*/ 39, TARGET_VAL(ISD::SETCC),// ->9299
/*  9260*/    OPC_RecordChild0, // #1 = $cond
/*  9261*/    OPC_CheckChild0TypeI32,
/*  9262*/    OPC_CheckChild1Integer, 0, 
/*  9264*/    OPC_CheckTypeI32,
/*  9265*/    OPC_Scope, 15, /*->9282*/ // 2 children in Scope
/*  9267*/     OPC_CheckChild2CondCode, ISD::SETNE,
/*  9269*/     OPC_MoveSibling2,
/*  9270*/     OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
/*  9273*/     OPC_RecordNode, // #2 = $dst
/*  9274*/     OPC_MoveParent,
/*  9275*/     OPC_EmitMergeInputChains1_0,
/*  9276*/     OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::BR_IF),
                   2/*#Ops*/, 2, 1, 
               // Src: (brcond (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), (bb:{ *:[Other] }):$dst) - Complexity = 11
               // Dst: (BR_IF bb_op:{ *:[Other] }:$dst, I32:{ *:[i32] }:$cond)
/*  9282*/    /*Scope*/ 15, /*->9298*/
/*  9283*/     OPC_CheckChild2CondCode, ISD::SETEQ,
/*  9285*/     OPC_MoveSibling2,
/*  9286*/     OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
/*  9289*/     OPC_RecordNode, // #2 = $dst
/*  9290*/     OPC_MoveParent,
/*  9291*/     OPC_EmitMergeInputChains1_0,
/*  9292*/     OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::BR_UNLESS),
                   2/*#Ops*/, 2, 1, 
               // Src: (brcond (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), (bb:{ *:[Other] }):$dst) - Complexity = 11
               // Dst: (BR_UNLESS bb_op:{ *:[Other] }:$dst, I32:{ *:[i32] }:$cond)
/*  9298*/    0, /*End of Scope*/
/*  9299*/   0, // EndSwitchOpcode
/*  9300*/  /*Scope*/ 15, /*->9316*/
/*  9301*/   OPC_RecordChild1, // #1 = $cond
/*  9302*/   OPC_CheckChild1TypeI32,
/*  9303*/   OPC_RecordChild2, // #2 = $dst
/*  9304*/   OPC_MoveChild2,
/*  9305*/   OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
/*  9308*/   OPC_MoveParent,
/*  9309*/   OPC_EmitMergeInputChains1_0,
/*  9310*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::BR_IF),
                 2/*#Ops*/, 2, 1, 
             // Src: (brcond I32:{ *:[i32] }:$cond, (bb:{ *:[Other] }):$dst) - Complexity = 3
             // Dst: (BR_IF (bb:{ *:[Other] }):$dst, I32:{ *:[i32] }:$cond)
/*  9316*/  0, /*End of Scope*/
/*  9317*/ /*SwitchOpcode*/ 59, TARGET_VAL(ISD::SHL),// ->9379
/*  9320*/  OPC_RecordChild0, // #0 = $lhs
/*  9321*/  OPC_Scope, 31, /*->9354*/ // 2 children in Scope
/*  9323*/   OPC_MoveChild1,
/*  9324*/   OPC_SwitchType /*2 cases */, 12, MVT::i32,// ->9339
/*  9327*/    OPC_CheckAndImm, 31, 
/*  9329*/    OPC_RecordChild0, // #1 = $rhs
/*  9330*/    OPC_MoveParent,
/*  9331*/    OPC_CheckTypeI32,
/*  9332*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I32),
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (shl:{ *:[i32] } I32:{ *:[i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
              // Dst: (SHL_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  9339*/   /*SwitchType*/ 12, MVT::i64,// ->9353
/*  9341*/    OPC_CheckAndImm, 63, 
/*  9343*/    OPC_RecordChild0, // #1 = $rhs
/*  9344*/    OPC_MoveParent,
/*  9345*/    OPC_CheckTypeI64,
/*  9346*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I64),
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (shl:{ *:[i64] } I64:{ *:[i64] }:$lhs, (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] })) - Complexity = 11
              // Dst: (SHL_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  9353*/   0, // EndSwitchType
/*  9354*/  /*Scope*/ 23, /*->9378*/
/*  9355*/   OPC_RecordChild1, // #1 = $rhs
/*  9356*/   OPC_SwitchType /*2 cases */, 8, MVT::i32,// ->9367
/*  9359*/    OPC_CheckChild1TypeI32,
/*  9360*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I32),
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (shl:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (SHL_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  9367*/   /*SwitchType*/ 8, MVT::i64,// ->9377
/*  9369*/    OPC_CheckChild1TypeI64,
/*  9370*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I64),
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (shl:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (SHL_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  9377*/   0, // EndSwitchType
/*  9378*/  0, /*End of Scope*/
/*  9379*/ /*SwitchOpcode*/ 59, TARGET_VAL(ISD::SRA),// ->9441
/*  9382*/  OPC_RecordChild0, // #0 = $lhs
/*  9383*/  OPC_Scope, 31, /*->9416*/ // 2 children in Scope
/*  9385*/   OPC_MoveChild1,
/*  9386*/   OPC_SwitchType /*2 cases */, 12, MVT::i32,// ->9401
/*  9389*/    OPC_CheckAndImm, 31, 
/*  9391*/    OPC_RecordChild0, // #1 = $rhs
/*  9392*/    OPC_MoveParent,
/*  9393*/    OPC_CheckTypeI32,
/*  9394*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I32),
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (sra:{ *:[i32] } I32:{ *:[i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
              // Dst: (SHR_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  9401*/   /*SwitchType*/ 12, MVT::i64,// ->9415
/*  9403*/    OPC_CheckAndImm, 63, 
/*  9405*/    OPC_RecordChild0, // #1 = $rhs
/*  9406*/    OPC_MoveParent,
/*  9407*/    OPC_CheckTypeI64,
/*  9408*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I64),
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (sra:{ *:[i64] } I64:{ *:[i64] }:$lhs, (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] })) - Complexity = 11
              // Dst: (SHR_S_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  9415*/   0, // EndSwitchType
/*  9416*/  /*Scope*/ 23, /*->9440*/
/*  9417*/   OPC_RecordChild1, // #1 = $rhs
/*  9418*/   OPC_SwitchType /*2 cases */, 8, MVT::i32,// ->9429
/*  9421*/    OPC_CheckChild1TypeI32,
/*  9422*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I32),
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (sra:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (SHR_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  9429*/   /*SwitchType*/ 8, MVT::i64,// ->9439
/*  9431*/    OPC_CheckChild1TypeI64,
/*  9432*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I64),
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (sra:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (SHR_S_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  9439*/   0, // EndSwitchType
/*  9440*/  0, /*End of Scope*/
/*  9441*/ /*SwitchOpcode*/ 59, TARGET_VAL(ISD::SRL),// ->9503
/*  9444*/  OPC_RecordChild0, // #0 = $lhs
/*  9445*/  OPC_Scope, 31, /*->9478*/ // 2 children in Scope
/*  9447*/   OPC_MoveChild1,
/*  9448*/   OPC_SwitchType /*2 cases */, 12, MVT::i32,// ->9463
/*  9451*/    OPC_CheckAndImm, 31, 
/*  9453*/    OPC_RecordChild0, // #1 = $rhs
/*  9454*/    OPC_MoveParent,
/*  9455*/    OPC_CheckTypeI32,
/*  9456*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I32),
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (srl:{ *:[i32] } I32:{ *:[i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
              // Dst: (SHR_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  9463*/   /*SwitchType*/ 12, MVT::i64,// ->9477
/*  9465*/    OPC_CheckAndImm, 63, 
/*  9467*/    OPC_RecordChild0, // #1 = $rhs
/*  9468*/    OPC_MoveParent,
/*  9469*/    OPC_CheckTypeI64,
/*  9470*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I64),
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (srl:{ *:[i64] } I64:{ *:[i64] }:$lhs, (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] })) - Complexity = 11
              // Dst: (SHR_U_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  9477*/   0, // EndSwitchType
/*  9478*/  /*Scope*/ 23, /*->9502*/
/*  9479*/   OPC_RecordChild1, // #1 = $rhs
/*  9480*/   OPC_SwitchType /*2 cases */, 8, MVT::i32,// ->9491
/*  9483*/    OPC_CheckChild1TypeI32,
/*  9484*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I32),
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (srl:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (SHR_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  9491*/   /*SwitchType*/ 8, MVT::i64,// ->9501
/*  9493*/    OPC_CheckChild1TypeI64,
/*  9494*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I64),
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (srl:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (SHR_U_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  9501*/   0, // EndSwitchType
/*  9502*/  0, /*End of Scope*/
/*  9503*/ /*SwitchOpcode*/ 59, TARGET_VAL(ISD::ROTL),// ->9565
/*  9506*/  OPC_RecordChild0, // #0 = $lhs
/*  9507*/  OPC_Scope, 31, /*->9540*/ // 2 children in Scope
/*  9509*/   OPC_MoveChild1,
/*  9510*/   OPC_SwitchType /*2 cases */, 12, MVT::i32,// ->9525
/*  9513*/    OPC_CheckAndImm, 31, 
/*  9515*/    OPC_RecordChild0, // #1 = $rhs
/*  9516*/    OPC_MoveParent,
/*  9517*/    OPC_CheckTypeI32,
/*  9518*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ROTL_I32),
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (rotl:{ *:[i32] } I32:{ *:[i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
              // Dst: (ROTL_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  9525*/   /*SwitchType*/ 12, MVT::i64,// ->9539
/*  9527*/    OPC_CheckAndImm, 63, 
/*  9529*/    OPC_RecordChild0, // #1 = $rhs
/*  9530*/    OPC_MoveParent,
/*  9531*/    OPC_CheckTypeI64,
/*  9532*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ROTL_I64),
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (rotl:{ *:[i64] } I64:{ *:[i64] }:$lhs, (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] })) - Complexity = 11
              // Dst: (ROTL_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  9539*/   0, // EndSwitchType
/*  9540*/  /*Scope*/ 23, /*->9564*/
/*  9541*/   OPC_RecordChild1, // #1 = $rhs
/*  9542*/   OPC_SwitchType /*2 cases */, 8, MVT::i32,// ->9553
/*  9545*/    OPC_CheckChild1TypeI32,
/*  9546*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ROTL_I32),
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (rotl:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (ROTL_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  9553*/   /*SwitchType*/ 8, MVT::i64,// ->9563
/*  9555*/    OPC_CheckChild1TypeI64,
/*  9556*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ROTL_I64),
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (rotl:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (ROTL_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  9563*/   0, // EndSwitchType
/*  9564*/  0, /*End of Scope*/
/*  9565*/ /*SwitchOpcode*/ 59, TARGET_VAL(ISD::ROTR),// ->9627
/*  9568*/  OPC_RecordChild0, // #0 = $lhs
/*  9569*/  OPC_Scope, 31, /*->9602*/ // 2 children in Scope
/*  9571*/   OPC_MoveChild1,
/*  9572*/   OPC_SwitchType /*2 cases */, 12, MVT::i32,// ->9587
/*  9575*/    OPC_CheckAndImm, 31, 
/*  9577*/    OPC_RecordChild0, // #1 = $rhs
/*  9578*/    OPC_MoveParent,
/*  9579*/    OPC_CheckTypeI32,
/*  9580*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ROTR_I32),
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (rotr:{ *:[i32] } I32:{ *:[i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
              // Dst: (ROTR_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  9587*/   /*SwitchType*/ 12, MVT::i64,// ->9601
/*  9589*/    OPC_CheckAndImm, 63, 
/*  9591*/    OPC_RecordChild0, // #1 = $rhs
/*  9592*/    OPC_MoveParent,
/*  9593*/    OPC_CheckTypeI64,
/*  9594*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ROTR_I64),
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (rotr:{ *:[i64] } I64:{ *:[i64] }:$lhs, (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] })) - Complexity = 11
              // Dst: (ROTR_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  9601*/   0, // EndSwitchType
/*  9602*/  /*Scope*/ 23, /*->9626*/
/*  9603*/   OPC_RecordChild1, // #1 = $rhs
/*  9604*/   OPC_SwitchType /*2 cases */, 8, MVT::i32,// ->9615
/*  9607*/    OPC_CheckChild1TypeI32,
/*  9608*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ROTR_I32),
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (rotr:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (ROTR_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  9615*/   /*SwitchType*/ 8, MVT::i64,// ->9625
/*  9617*/    OPC_CheckChild1TypeI64,
/*  9618*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ROTR_I64),
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (rotr:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (ROTR_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  9625*/   0, // EndSwitchType
/*  9626*/  0, /*End of Scope*/
/*  9627*/ /*SwitchOpcode*/ 23|128,4/*535*/, TARGET_VAL(ISD::SELECT),// ->10166
/*  9631*/  OPC_Scope, 127, /*->9760*/ // 8 children in Scope
/*  9633*/   OPC_MoveChild0,
/*  9634*/   OPC_CheckOpcode, TARGET_VAL(ISD::SETCC),
/*  9637*/   OPC_RecordChild0, // #0 = $cond
/*  9638*/   OPC_CheckChild0TypeI32,
/*  9639*/   OPC_CheckChild1Integer, 0, 
/*  9641*/   OPC_CheckTypeI32,
/*  9642*/   OPC_Scope, 57, /*->9701*/ // 2 children in Scope
/*  9644*/    OPC_CheckChild2CondCode, ISD::SETNE,
/*  9646*/    OPC_MoveParent,
/*  9647*/    OPC_RecordChild1, // #1 = $lhs
/*  9648*/    OPC_RecordChild2, // #2 = $rhs
/*  9649*/    OPC_SwitchType /*5 cases */, 8, MVT::i32,// ->9660
/*  9652*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_I32),
                   MVT::i32, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[i32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 11
               // Dst: (SELECT_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9660*/    /*SwitchType*/ 8, MVT::i64,// ->9670
/*  9662*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_I64),
                   MVT::i64, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[i64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 11
               // Dst: (SELECT_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9670*/    /*SwitchType*/ 8, MVT::funcref,// ->9680
/*  9672*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_FUNCREF),
                   MVT::funcref, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[funcref] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), FUNCREF:{ *:[funcref] }:$lhs, FUNCREF:{ *:[funcref] }:$rhs) - Complexity = 11
               // Dst: (SELECT_FUNCREF:{ *:[funcref] } FUNCREF:{ *:[funcref] }:$lhs, FUNCREF:{ *:[funcref] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9680*/    /*SwitchType*/ 8, MVT::externref,// ->9690
/*  9682*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_EXTERNREF),
                   MVT::externref, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[externref] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), EXTERNREF:{ *:[externref] }:$lhs, EXTERNREF:{ *:[externref] }:$rhs) - Complexity = 11
               // Dst: (SELECT_EXTERNREF:{ *:[externref] } EXTERNREF:{ *:[externref] }:$lhs, EXTERNREF:{ *:[externref] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9690*/    /*SwitchType*/ 8, MVT::exnref,// ->9700
/*  9692*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_EXNREF),
                   MVT::exnref, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[exnref] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), EXNREF:{ *:[exnref] }:$lhs, EXNREF:{ *:[exnref] }:$rhs) - Complexity = 11
               // Dst: (SELECT_EXNREF:{ *:[exnref] } EXNREF:{ *:[exnref] }:$lhs, EXNREF:{ *:[exnref] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9700*/    0, // EndSwitchType
/*  9701*/   /*Scope*/ 57, /*->9759*/
/*  9702*/    OPC_CheckChild2CondCode, ISD::SETEQ,
/*  9704*/    OPC_MoveParent,
/*  9705*/    OPC_RecordChild1, // #1 = $lhs
/*  9706*/    OPC_RecordChild2, // #2 = $rhs
/*  9707*/    OPC_SwitchType /*5 cases */, 8, MVT::i32,// ->9718
/*  9710*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_I32),
                   MVT::i32, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[i32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 11
               // Dst: (SELECT_I32:{ *:[i32] } I32:{ *:[i32] }:$rhs, I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$cond)
/*  9718*/    /*SwitchType*/ 8, MVT::i64,// ->9728
/*  9720*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_I64),
                   MVT::i64, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[i64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 11
               // Dst: (SELECT_I64:{ *:[i64] } I64:{ *:[i64] }:$rhs, I64:{ *:[i64] }:$lhs, I32:{ *:[i32] }:$cond)
/*  9728*/    /*SwitchType*/ 8, MVT::funcref,// ->9738
/*  9730*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_FUNCREF),
                   MVT::funcref, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[funcref] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), FUNCREF:{ *:[funcref] }:$lhs, FUNCREF:{ *:[funcref] }:$rhs) - Complexity = 11
               // Dst: (SELECT_FUNCREF:{ *:[funcref] } FUNCREF:{ *:[funcref] }:$rhs, FUNCREF:{ *:[funcref] }:$lhs, I32:{ *:[i32] }:$cond)
/*  9738*/    /*SwitchType*/ 8, MVT::externref,// ->9748
/*  9740*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_EXTERNREF),
                   MVT::externref, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[externref] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), EXTERNREF:{ *:[externref] }:$lhs, EXTERNREF:{ *:[externref] }:$rhs) - Complexity = 11
               // Dst: (SELECT_EXTERNREF:{ *:[externref] } EXTERNREF:{ *:[externref] }:$rhs, EXTERNREF:{ *:[externref] }:$lhs, I32:{ *:[i32] }:$cond)
/*  9748*/    /*SwitchType*/ 8, MVT::exnref,// ->9758
/*  9750*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_EXNREF),
                   MVT::exnref, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[exnref] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), EXNREF:{ *:[exnref] }:$lhs, EXNREF:{ *:[exnref] }:$rhs) - Complexity = 11
               // Dst: (SELECT_EXNREF:{ *:[exnref] } EXNREF:{ *:[exnref] }:$rhs, EXNREF:{ *:[exnref] }:$lhs, I32:{ *:[i32] }:$cond)
/*  9758*/    0, // EndSwitchType
/*  9759*/   0, /*End of Scope*/
/*  9760*/  /*Scope*/ 59, /*->9820*/
/*  9761*/   OPC_RecordChild0, // #0 = $cond
/*  9762*/   OPC_CheckChild0TypeI32,
/*  9763*/   OPC_RecordChild1, // #1 = $lhs
/*  9764*/   OPC_RecordChild2, // #2 = $rhs
/*  9765*/   OPC_SwitchType /*5 cases */, 8, MVT::i32,// ->9776
/*  9768*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_I32),
                  MVT::i32, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[i32] } I32:{ *:[i32] }:$cond, I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (SELECT_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9776*/   /*SwitchType*/ 8, MVT::i64,// ->9786
/*  9778*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_I64),
                  MVT::i64, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[i64] } I32:{ *:[i32] }:$cond, I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (SELECT_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9786*/   /*SwitchType*/ 9, MVT::funcref,// ->9797
/*  9788*/    OPC_CheckPatternPredicate5, // (Subtarget->hasReferenceTypes())
/*  9789*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_FUNCREF),
                  MVT::funcref, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[funcref] } I32:{ *:[i32] }:$cond, FUNCREF:{ *:[funcref] }:$lhs, FUNCREF:{ *:[funcref] }:$rhs) - Complexity = 3
              // Dst: (SELECT_FUNCREF:{ *:[funcref] } FUNCREF:{ *:[funcref] }:$lhs, FUNCREF:{ *:[funcref] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9797*/   /*SwitchType*/ 9, MVT::externref,// ->9808
/*  9799*/    OPC_CheckPatternPredicate5, // (Subtarget->hasReferenceTypes())
/*  9800*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_EXTERNREF),
                  MVT::externref, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[externref] } I32:{ *:[i32] }:$cond, EXTERNREF:{ *:[externref] }:$lhs, EXTERNREF:{ *:[externref] }:$rhs) - Complexity = 3
              // Dst: (SELECT_EXTERNREF:{ *:[externref] } EXTERNREF:{ *:[externref] }:$lhs, EXTERNREF:{ *:[externref] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9808*/   /*SwitchType*/ 9, MVT::exnref,// ->9819
/*  9810*/    OPC_CheckPatternPredicate5, // (Subtarget->hasReferenceTypes())
/*  9811*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_EXNREF),
                  MVT::exnref, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[exnref] } I32:{ *:[i32] }:$cond, EXNREF:{ *:[exnref] }:$lhs, EXNREF:{ *:[exnref] }:$rhs) - Complexity = 3
              // Dst: (SELECT_EXNREF:{ *:[exnref] } EXNREF:{ *:[exnref] }:$lhs, EXNREF:{ *:[exnref] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9819*/   0, // EndSwitchType
/*  9820*/  /*Scope*/ 67, /*->9888*/
/*  9821*/   OPC_MoveChild0,
/*  9822*/   OPC_CheckOpcode, TARGET_VAL(ISD::SETCC),
/*  9825*/   OPC_RecordChild0, // #0 = $cond
/*  9826*/   OPC_CheckChild0TypeI32,
/*  9827*/   OPC_CheckChild1Integer, 0, 
/*  9829*/   OPC_CheckTypeI32,
/*  9830*/   OPC_Scope, 27, /*->9859*/ // 2 children in Scope
/*  9832*/    OPC_CheckChild2CondCode, ISD::SETNE,
/*  9834*/    OPC_MoveParent,
/*  9835*/    OPC_RecordChild1, // #1 = $lhs
/*  9836*/    OPC_RecordChild2, // #2 = $rhs
/*  9837*/    OPC_SwitchType /*2 cases */, 8, MVT::f32,// ->9848
/*  9840*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_F32),
                   MVT::f32, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[f32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 11
               // Dst: (SELECT_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9848*/    /*SwitchType*/ 8, MVT::f64,// ->9858
/*  9850*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_F64),
                   MVT::f64, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[f64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 11
               // Dst: (SELECT_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9858*/    0, // EndSwitchType
/*  9859*/   /*Scope*/ 27, /*->9887*/
/*  9860*/    OPC_CheckChild2CondCode, ISD::SETEQ,
/*  9862*/    OPC_MoveParent,
/*  9863*/    OPC_RecordChild1, // #1 = $lhs
/*  9864*/    OPC_RecordChild2, // #2 = $rhs
/*  9865*/    OPC_SwitchType /*2 cases */, 8, MVT::f32,// ->9876
/*  9868*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_F32),
                   MVT::f32, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[f32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 11
               // Dst: (SELECT_F32:{ *:[f32] } F32:{ *:[f32] }:$rhs, F32:{ *:[f32] }:$lhs, I32:{ *:[i32] }:$cond)
/*  9876*/    /*SwitchType*/ 8, MVT::f64,// ->9886
/*  9878*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_F64),
                   MVT::f64, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[f64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 11
               // Dst: (SELECT_F64:{ *:[f64] } F64:{ *:[f64] }:$rhs, F64:{ *:[f64] }:$lhs, I32:{ *:[i32] }:$cond)
/*  9886*/    0, // EndSwitchType
/*  9887*/   0, /*End of Scope*/
/*  9888*/  /*Scope*/ 26, /*->9915*/
/*  9889*/   OPC_RecordChild0, // #0 = $cond
/*  9890*/   OPC_CheckChild0TypeI32,
/*  9891*/   OPC_RecordChild1, // #1 = $lhs
/*  9892*/   OPC_RecordChild2, // #2 = $rhs
/*  9893*/   OPC_SwitchType /*2 cases */, 8, MVT::f32,// ->9904
/*  9896*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_F32),
                  MVT::f32, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[f32] } I32:{ *:[i32] }:$cond, F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
              // Dst: (SELECT_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9904*/   /*SwitchType*/ 8, MVT::f64,// ->9914
/*  9906*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_F64),
                  MVT::f64, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[f64] } I32:{ *:[i32] }:$cond, F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
              // Dst: (SELECT_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9914*/   0, // EndSwitchType
/*  9915*/  /*Scope*/ 107, /*->10023*/
/*  9916*/   OPC_MoveChild0,
/*  9917*/   OPC_CheckOpcode, TARGET_VAL(ISD::SETCC),
/*  9920*/   OPC_RecordChild0, // #0 = $cond
/*  9921*/   OPC_CheckChild0TypeI32,
/*  9922*/   OPC_CheckChild1Integer, 0, 
/*  9924*/   OPC_CheckTypeI32,
/*  9925*/   OPC_Scope, 47, /*->9974*/ // 2 children in Scope
/*  9927*/    OPC_CheckChild2CondCode, ISD::SETNE,
/*  9929*/    OPC_MoveParent,
/*  9930*/    OPC_RecordChild1, // #1 = $lhs
/*  9931*/    OPC_RecordChild2, // #2 = $rhs
/*  9932*/    OPC_SwitchType /*4 cases */, 8, MVT::v16i8,// ->9943
/*  9935*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   MVT::v16i8, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[v16i8] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs, ?:{ *:[i32] }:$cond)
/*  9943*/    /*SwitchType*/ 8, MVT::v8i16,// ->9953
/*  9945*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   MVT::v8i16, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[v8i16] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs, ?:{ *:[i32] }:$cond)
/*  9953*/    /*SwitchType*/ 8, MVT::v4i32,// ->9963
/*  9955*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   MVT::v4i32, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[v4i32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs, ?:{ *:[i32] }:$cond)
/*  9963*/    /*SwitchType*/ 8, MVT::v2i64,// ->9973
/*  9965*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   MVT::v2i64, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[v2i64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs, ?:{ *:[i32] }:$cond)
/*  9973*/    0, // EndSwitchType
/*  9974*/   /*Scope*/ 47, /*->10022*/
/*  9975*/    OPC_CheckChild2CondCode, ISD::SETEQ,
/*  9977*/    OPC_MoveParent,
/*  9978*/    OPC_RecordChild1, // #1 = $lhs
/*  9979*/    OPC_RecordChild2, // #2 = $rhs
/*  9980*/    OPC_SwitchType /*4 cases */, 8, MVT::v16i8,// ->9991
/*  9983*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   MVT::v16i8, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[v16i8] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v16i8] } ?:{ *:[v16i8] }:$rhs, ?:{ *:[v16i8] }:$lhs, ?:{ *:[i32] }:$cond)
/*  9991*/    /*SwitchType*/ 8, MVT::v8i16,// ->10001
/*  9993*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   MVT::v8i16, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[v8i16] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v8i16] } ?:{ *:[v8i16] }:$rhs, ?:{ *:[v8i16] }:$lhs, ?:{ *:[i32] }:$cond)
/* 10001*/    /*SwitchType*/ 8, MVT::v4i32,// ->10011
/* 10003*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   MVT::v4i32, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[v4i32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v4i32] } ?:{ *:[v4i32] }:$rhs, ?:{ *:[v4i32] }:$lhs, ?:{ *:[i32] }:$cond)
/* 10011*/    /*SwitchType*/ 8, MVT::v2i64,// ->10021
/* 10013*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   MVT::v2i64, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[v2i64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v2i64] } ?:{ *:[v2i64] }:$rhs, ?:{ *:[v2i64] }:$lhs, ?:{ *:[i32] }:$cond)
/* 10021*/    0, // EndSwitchType
/* 10022*/   0, /*End of Scope*/
/* 10023*/  /*Scope*/ 46, /*->10070*/
/* 10024*/   OPC_RecordChild0, // #0 = $cond
/* 10025*/   OPC_CheckChild0TypeI32,
/* 10026*/   OPC_RecordChild1, // #1 = $lhs
/* 10027*/   OPC_RecordChild2, // #2 = $rhs
/* 10028*/   OPC_SwitchType /*4 cases */, 8, MVT::v16i8,// ->10039
/* 10031*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                  MVT::v16i8, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[v16i8] } I32:{ *:[i32] }:$cond, V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
              // Dst: (SELECT_V128:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs, ?:{ *:[i32] }:$cond)
/* 10039*/   /*SwitchType*/ 8, MVT::v8i16,// ->10049
/* 10041*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                  MVT::v8i16, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[v8i16] } I32:{ *:[i32] }:$cond, V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
              // Dst: (SELECT_V128:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs, ?:{ *:[i32] }:$cond)
/* 10049*/   /*SwitchType*/ 8, MVT::v4i32,// ->10059
/* 10051*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                  MVT::v4i32, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[v4i32] } I32:{ *:[i32] }:$cond, V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
              // Dst: (SELECT_V128:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs, ?:{ *:[i32] }:$cond)
/* 10059*/   /*SwitchType*/ 8, MVT::v2i64,// ->10069
/* 10061*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                  MVT::v2i64, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[v2i64] } I32:{ *:[i32] }:$cond, V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 3
              // Dst: (SELECT_V128:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs, ?:{ *:[i32] }:$cond)
/* 10069*/   0, // EndSwitchType
/* 10070*/  /*Scope*/ 67, /*->10138*/
/* 10071*/   OPC_MoveChild0,
/* 10072*/   OPC_CheckOpcode, TARGET_VAL(ISD::SETCC),
/* 10075*/   OPC_RecordChild0, // #0 = $cond
/* 10076*/   OPC_CheckChild0TypeI32,
/* 10077*/   OPC_CheckChild1Integer, 0, 
/* 10079*/   OPC_CheckTypeI32,
/* 10080*/   OPC_Scope, 27, /*->10109*/ // 2 children in Scope
/* 10082*/    OPC_CheckChild2CondCode, ISD::SETNE,
/* 10084*/    OPC_MoveParent,
/* 10085*/    OPC_RecordChild1, // #1 = $lhs
/* 10086*/    OPC_RecordChild2, // #2 = $rhs
/* 10087*/    OPC_SwitchType /*2 cases */, 8, MVT::v4f32,// ->10098
/* 10090*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   MVT::v4f32, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[v4f32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v4f32] } ?:{ *:[v4f32] }:$lhs, ?:{ *:[v4f32] }:$rhs, ?:{ *:[i32] }:$cond)
/* 10098*/    /*SwitchType*/ 8, MVT::v2f64,// ->10108
/* 10100*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   MVT::v2f64, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[v2f64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v2f64] } ?:{ *:[v2f64] }:$lhs, ?:{ *:[v2f64] }:$rhs, ?:{ *:[i32] }:$cond)
/* 10108*/    0, // EndSwitchType
/* 10109*/   /*Scope*/ 27, /*->10137*/
/* 10110*/    OPC_CheckChild2CondCode, ISD::SETEQ,
/* 10112*/    OPC_MoveParent,
/* 10113*/    OPC_RecordChild1, // #1 = $lhs
/* 10114*/    OPC_RecordChild2, // #2 = $rhs
/* 10115*/    OPC_SwitchType /*2 cases */, 8, MVT::v4f32,// ->10126
/* 10118*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   MVT::v4f32, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[v4f32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v4f32] } ?:{ *:[v4f32] }:$rhs, ?:{ *:[v4f32] }:$lhs, ?:{ *:[i32] }:$cond)
/* 10126*/    /*SwitchType*/ 8, MVT::v2f64,// ->10136
/* 10128*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   MVT::v2f64, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[v2f64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v2f64] } ?:{ *:[v2f64] }:$rhs, ?:{ *:[v2f64] }:$lhs, ?:{ *:[i32] }:$cond)
/* 10136*/    0, // EndSwitchType
/* 10137*/   0, /*End of Scope*/
/* 10138*/  /*Scope*/ 26, /*->10165*/
/* 10139*/   OPC_RecordChild0, // #0 = $cond
/* 10140*/   OPC_CheckChild0TypeI32,
/* 10141*/   OPC_RecordChild1, // #1 = $lhs
/* 10142*/   OPC_RecordChild2, // #2 = $rhs
/* 10143*/   OPC_SwitchType /*2 cases */, 8, MVT::v4f32,// ->10154
/* 10146*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                  MVT::v4f32, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[v4f32] } I32:{ *:[i32] }:$cond, V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 3
              // Dst: (SELECT_V128:{ *:[v4f32] } ?:{ *:[v4f32] }:$lhs, ?:{ *:[v4f32] }:$rhs, ?:{ *:[i32] }:$cond)
/* 10154*/   /*SwitchType*/ 8, MVT::v2f64,// ->10164
/* 10156*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                  MVT::v2f64, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[v2f64] } I32:{ *:[i32] }:$cond, V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 3
              // Dst: (SELECT_V128:{ *:[v2f64] } ?:{ *:[v2f64] }:$lhs, ?:{ *:[v2f64] }:$rhs, ?:{ *:[i32] }:$cond)
/* 10164*/   0, // EndSwitchType
/* 10165*/  0, /*End of Scope*/
/* 10166*/ /*SwitchOpcode*/ 1|128,1/*129*/, TARGET_VAL(ISD::SIGN_EXTEND_INREG),// ->10299
/* 10170*/  OPC_Scope, 57, /*->10229*/ // 2 children in Scope
/* 10172*/   OPC_MoveChild0,
/* 10173*/   OPC_CheckOpcode, TARGET_VAL(ISD::EXTRACT_VECTOR_ELT),
/* 10176*/   OPC_RecordChild0, // #0 = $vec
/* 10177*/   OPC_Scope, 24, /*->10203*/ // 2 children in Scope
/* 10179*/    OPC_CheckChild0Type, MVT::v16i8,
/* 10181*/    OPC_RecordChild1, // #1 = $idx
/* 10182*/    OPC_MoveChild1,
/* 10183*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 10186*/    OPC_CheckPredicate, 11, // Predicate_LaneIdx16
/* 10188*/    OPC_CheckTypeI32,
/* 10189*/    OPC_MoveParent,
/* 10190*/    OPC_MoveSibling1,
/* 10191*/    OPC_CheckValueType, MVT::i8,
/* 10193*/    OPC_MoveParent,
/* 10194*/    OPC_CheckTypeI32,
/* 10195*/    OPC_EmitConvertToTarget1,
/* 10196*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_I8x16_s),
                  MVT::i32, 2/*#Ops*/, 0, 2, 
              // Src: (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx), i8:{ *:[Other] }) - Complexity = 10
              // Dst: (EXTRACT_LANE_I8x16_s:{ *:[i32] } ?:{ *:[v16i8] }:$vec, (imm:{ *:[i32] }):$idx)
/* 10203*/   /*Scope*/ 24, /*->10228*/
/* 10204*/    OPC_CheckChild0Type, MVT::v8i16,
/* 10206*/    OPC_RecordChild1, // #1 = $idx
/* 10207*/    OPC_MoveChild1,
/* 10208*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 10211*/    OPC_CheckPredicate, 16, // Predicate_LaneIdx8
/* 10213*/    OPC_CheckTypeI32,
/* 10214*/    OPC_MoveParent,
/* 10215*/    OPC_MoveSibling1,
/* 10216*/    OPC_CheckValueType, MVT::i16,
/* 10218*/    OPC_MoveParent,
/* 10219*/    OPC_CheckTypeI32,
/* 10220*/    OPC_EmitConvertToTarget1,
/* 10221*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_I16x8_s),
                  MVT::i32, 2/*#Ops*/, 0, 2, 
              // Src: (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx), i16:{ *:[Other] }) - Complexity = 10
              // Dst: (EXTRACT_LANE_I16x8_s:{ *:[i32] } ?:{ *:[v8i16] }:$vec, (imm:{ *:[i32] }):$idx)
/* 10228*/   0, /*End of Scope*/
/* 10229*/  /*Scope*/ 68, /*->10298*/
/* 10230*/   OPC_RecordChild0, // #0 = $src
/* 10231*/   OPC_MoveChild1,
/* 10232*/   OPC_Scope, 25, /*->10259*/ // 3 children in Scope
/* 10234*/    OPC_CheckValueType, MVT::i8,
/* 10236*/    OPC_MoveParent,
/* 10237*/    OPC_SwitchType /*2 cases */, 8, MVT::i32,// ->10248
/* 10240*/     OPC_CheckPatternPredicate, 11, // (Subtarget->hasSignExt())
/* 10242*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_EXTEND8_S_I32),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (sext_inreg:{ *:[i32] } I32:{ *:[i32] }:$src, i8:{ *:[Other] }) - Complexity = 3
               // Dst: (I32_EXTEND8_S_I32:{ *:[i32] } I32:{ *:[i32] }:$src)
/* 10248*/    /*SwitchType*/ 8, MVT::i64,// ->10258
/* 10250*/     OPC_CheckPatternPredicate, 11, // (Subtarget->hasSignExt())
/* 10252*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_EXTEND8_S_I64),
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (sext_inreg:{ *:[i64] } I64:{ *:[i64] }:$src, i8:{ *:[Other] }) - Complexity = 3
               // Dst: (I64_EXTEND8_S_I64:{ *:[i64] } I64:{ *:[i64] }:$src)
/* 10258*/    0, // EndSwitchType
/* 10259*/   /*Scope*/ 25, /*->10285*/
/* 10260*/    OPC_CheckValueType, MVT::i16,
/* 10262*/    OPC_MoveParent,
/* 10263*/    OPC_SwitchType /*2 cases */, 8, MVT::i32,// ->10274
/* 10266*/     OPC_CheckPatternPredicate, 11, // (Subtarget->hasSignExt())
/* 10268*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_EXTEND16_S_I32),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (sext_inreg:{ *:[i32] } I32:{ *:[i32] }:$src, i16:{ *:[Other] }) - Complexity = 3
               // Dst: (I32_EXTEND16_S_I32:{ *:[i32] } I32:{ *:[i32] }:$src)
/* 10274*/    /*SwitchType*/ 8, MVT::i64,// ->10284
/* 10276*/     OPC_CheckPatternPredicate, 11, // (Subtarget->hasSignExt())
/* 10278*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_EXTEND16_S_I64),
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (sext_inreg:{ *:[i64] } I64:{ *:[i64] }:$src, i16:{ *:[Other] }) - Complexity = 3
               // Dst: (I64_EXTEND16_S_I64:{ *:[i64] } I64:{ *:[i64] }:$src)
/* 10284*/    0, // EndSwitchType
/* 10285*/   /*Scope*/ 11, /*->10297*/
/* 10286*/    OPC_CheckValueType, MVT::i32,
/* 10288*/    OPC_MoveParent,
/* 10289*/    OPC_CheckPatternPredicate, 11, // (Subtarget->hasSignExt())
/* 10291*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_EXTEND32_S_I64),
                  MVT::i64, 1/*#Ops*/, 0, 
              // Src: (sext_inreg:{ *:[i64] } I64:{ *:[i64] }:$src, i32:{ *:[Other] }) - Complexity = 3
              // Dst: (I64_EXTEND32_S_I64:{ *:[i64] } I64:{ *:[i64] }:$src)
/* 10297*/   0, /*End of Scope*/
/* 10298*/  0, /*End of Scope*/
/* 10299*/ /*SwitchOpcode*/ 38|128,1/*166*/, TARGET_VAL(WebAssemblyISD::GLOBAL_GET),// ->10469
/* 10303*/  OPC_RecordMemRef,
/* 10304*/  OPC_RecordNode, // #0 = 'WebAssemblyglobal_get' chained node
/* 10305*/  OPC_MoveChild1,
/* 10306*/  OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10309*/  OPC_RecordChild0, // #1 = $addr
/* 10310*/  OPC_MoveChild0,
/* 10311*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10314*/  OPC_MoveParent,
/* 10315*/  OPC_MoveParent,
/* 10316*/  OPC_SwitchType /*14 cases */, 8, MVT::i32,// ->10327
/* 10319*/   OPC_EmitMergeInputChains1_0,
/* 10320*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_I32), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::i32, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[i32] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_I32:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10327*/  /*SwitchType*/ 8, MVT::i64,// ->10337
/* 10329*/   OPC_EmitMergeInputChains1_0,
/* 10330*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_I64), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::i64, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[i64] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_I64:{ *:[i64] } (tglobaladdr:{ *:[i64] }):$addr)
/* 10337*/  /*SwitchType*/ 9, MVT::funcref,// ->10348
/* 10339*/   OPC_CheckPatternPredicate5, // (Subtarget->hasReferenceTypes())
/* 10340*/   OPC_EmitMergeInputChains1_0,
/* 10341*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_FUNCREF), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::funcref, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[funcref] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_FUNCREF:{ *:[funcref] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10348*/  /*SwitchType*/ 9, MVT::externref,// ->10359
/* 10350*/   OPC_CheckPatternPredicate5, // (Subtarget->hasReferenceTypes())
/* 10351*/   OPC_EmitMergeInputChains1_0,
/* 10352*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_EXTERNREF), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::externref, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[externref] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_EXTERNREF:{ *:[externref] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10359*/  /*SwitchType*/ 10, MVT::exnref,// ->10371
/* 10361*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasExceptionHandling()) && (Subtarget->hasReferenceTypes())
/* 10363*/   OPC_EmitMergeInputChains1_0,
/* 10364*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_EXNREF), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::exnref, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[exnref] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_EXNREF:{ *:[exnref] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10371*/  /*SwitchType*/ 8, MVT::f32,// ->10381
/* 10373*/   OPC_EmitMergeInputChains1_0,
/* 10374*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_F32), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::f32, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[f32] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_F32:{ *:[f32] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10381*/  /*SwitchType*/ 8, MVT::f64,// ->10391
/* 10383*/   OPC_EmitMergeInputChains1_0,
/* 10384*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_F64), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::f64, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[f64] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_F64:{ *:[f64] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10391*/  /*SwitchType*/ 9, MVT::v2i64,// ->10402
/* 10393*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10394*/   OPC_EmitMergeInputChains1_0,
/* 10395*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::v2i64, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[v2i64] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_V128:{ *:[v2i64] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10402*/  /*SwitchType*/ 9, MVT::v4i32,// ->10413
/* 10404*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10405*/   OPC_EmitMergeInputChains1_0,
/* 10406*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::v4i32, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[v4i32] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_V128:{ *:[v4i32] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10413*/  /*SwitchType*/ 9, MVT::v16i8,// ->10424
/* 10415*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10416*/   OPC_EmitMergeInputChains1_0,
/* 10417*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::v16i8, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[v16i8] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_V128:{ *:[v16i8] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10424*/  /*SwitchType*/ 9, MVT::v8i16,// ->10435
/* 10426*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10427*/   OPC_EmitMergeInputChains1_0,
/* 10428*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::v8i16, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[v8i16] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_V128:{ *:[v8i16] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10435*/  /*SwitchType*/ 9, MVT::v8f16,// ->10446
/* 10437*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10438*/   OPC_EmitMergeInputChains1_0,
/* 10439*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::v8f16, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[v8f16] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_V128:{ *:[v8f16] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10446*/  /*SwitchType*/ 9, MVT::v4f32,// ->10457
/* 10448*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10449*/   OPC_EmitMergeInputChains1_0,
/* 10450*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::v4f32, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[v4f32] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_V128:{ *:[v4f32] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10457*/  /*SwitchType*/ 9, MVT::v2f64,// ->10468
/* 10459*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10460*/   OPC_EmitMergeInputChains1_0,
/* 10461*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::v2f64, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[v2f64] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_V128:{ *:[v2f64] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10468*/  0, // EndSwitchType
/* 10469*/ /*SwitchOpcode*/ 66|128,2/*322*/, TARGET_VAL(WebAssemblyISD::GLOBAL_SET),// ->10795
/* 10473*/  OPC_RecordMemRef,
/* 10474*/  OPC_RecordNode, // #0 = 'WebAssemblyglobal_set' chained node
/* 10475*/  OPC_RecordChild1, // #1 = $src
/* 10476*/  OPC_Scope, 20, /*->10498*/ // 14 children in Scope
/* 10478*/   OPC_CheckChild1TypeI32,
/* 10479*/   OPC_MoveChild2,
/* 10480*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10483*/   OPC_RecordChild0, // #2 = $addr
/* 10484*/   OPC_MoveChild0,
/* 10485*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10488*/   OPC_MoveParent,
/* 10489*/   OPC_MoveParent,
/* 10490*/   OPC_EmitMergeInputChains1_0,
/* 10491*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_I32), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set i32:{ *:[i32] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_I32 (tglobaladdr:{ *:[i32] }):$addr, i32:{ *:[i32] }:$src)
/* 10498*/  /*Scope*/ 20, /*->10519*/
/* 10499*/   OPC_CheckChild1TypeI64,
/* 10500*/   OPC_MoveChild2,
/* 10501*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10504*/   OPC_RecordChild0, // #2 = $addr
/* 10505*/   OPC_MoveChild0,
/* 10506*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10509*/   OPC_MoveParent,
/* 10510*/   OPC_MoveParent,
/* 10511*/   OPC_EmitMergeInputChains1_0,
/* 10512*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_I64), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set i64:{ *:[i64] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_I64 (tglobaladdr:{ *:[i64] }):$addr, i64:{ *:[i64] }:$src)
/* 10519*/  /*Scope*/ 21, /*->10541*/
/* 10520*/   OPC_CheckChild1Type, MVT::f32,
/* 10522*/   OPC_MoveChild2,
/* 10523*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10526*/   OPC_RecordChild0, // #2 = $addr
/* 10527*/   OPC_MoveChild0,
/* 10528*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10531*/   OPC_MoveParent,
/* 10532*/   OPC_MoveParent,
/* 10533*/   OPC_EmitMergeInputChains1_0,
/* 10534*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_F32), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set f32:{ *:[f32] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_F32 (tglobaladdr:{ *:[i32] }):$addr, f32:{ *:[f32] }:$src)
/* 10541*/  /*Scope*/ 21, /*->10563*/
/* 10542*/   OPC_CheckChild1Type, MVT::f64,
/* 10544*/   OPC_MoveChild2,
/* 10545*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10548*/   OPC_RecordChild0, // #2 = $addr
/* 10549*/   OPC_MoveChild0,
/* 10550*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10553*/   OPC_MoveParent,
/* 10554*/   OPC_MoveParent,
/* 10555*/   OPC_EmitMergeInputChains1_0,
/* 10556*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_F64), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set f64:{ *:[f64] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_F64 (tglobaladdr:{ *:[i32] }):$addr, f64:{ *:[f64] }:$src)
/* 10563*/  /*Scope*/ 22, /*->10586*/
/* 10564*/   OPC_CheckChild1Type, MVT::v8f16,
/* 10566*/   OPC_MoveChild2,
/* 10567*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10570*/   OPC_RecordChild0, // #2 = $addr
/* 10571*/   OPC_MoveChild0,
/* 10572*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10575*/   OPC_MoveParent,
/* 10576*/   OPC_MoveParent,
/* 10577*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10578*/   OPC_EmitMergeInputChains1_0,
/* 10579*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set v8f16:{ *:[v8f16] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_V128 (tglobaladdr:{ *:[i32] }):$addr, v8f16:{ *:[v8f16] }:$src)
/* 10586*/  /*Scope*/ 22, /*->10609*/
/* 10587*/   OPC_CheckChild1Type, MVT::v4f32,
/* 10589*/   OPC_MoveChild2,
/* 10590*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10593*/   OPC_RecordChild0, // #2 = $addr
/* 10594*/   OPC_MoveChild0,
/* 10595*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10598*/   OPC_MoveParent,
/* 10599*/   OPC_MoveParent,
/* 10600*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10601*/   OPC_EmitMergeInputChains1_0,
/* 10602*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set v4f32:{ *:[v4f32] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_V128 (tglobaladdr:{ *:[i32] }):$addr, v4f32:{ *:[v4f32] }:$src)
/* 10609*/  /*Scope*/ 22, /*->10632*/
/* 10610*/   OPC_CheckChild1Type, MVT::v2f64,
/* 10612*/   OPC_MoveChild2,
/* 10613*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10616*/   OPC_RecordChild0, // #2 = $addr
/* 10617*/   OPC_MoveChild0,
/* 10618*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10621*/   OPC_MoveParent,
/* 10622*/   OPC_MoveParent,
/* 10623*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10624*/   OPC_EmitMergeInputChains1_0,
/* 10625*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set v2f64:{ *:[v2f64] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_V128 (tglobaladdr:{ *:[i32] }):$addr, v2f64:{ *:[v2f64] }:$src)
/* 10632*/  /*Scope*/ 22, /*->10655*/
/* 10633*/   OPC_CheckChild1Type, MVT::v2i64,
/* 10635*/   OPC_MoveChild2,
/* 10636*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10639*/   OPC_RecordChild0, // #2 = $addr
/* 10640*/   OPC_MoveChild0,
/* 10641*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10644*/   OPC_MoveParent,
/* 10645*/   OPC_MoveParent,
/* 10646*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10647*/   OPC_EmitMergeInputChains1_0,
/* 10648*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set v2i64:{ *:[v2i64] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_V128 (tglobaladdr:{ *:[i32] }):$addr, v2i64:{ *:[v2i64] }:$src)
/* 10655*/  /*Scope*/ 22, /*->10678*/
/* 10656*/   OPC_CheckChild1Type, MVT::v4i32,
/* 10658*/   OPC_MoveChild2,
/* 10659*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10662*/   OPC_RecordChild0, // #2 = $addr
/* 10663*/   OPC_MoveChild0,
/* 10664*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10667*/   OPC_MoveParent,
/* 10668*/   OPC_MoveParent,
/* 10669*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10670*/   OPC_EmitMergeInputChains1_0,
/* 10671*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set v4i32:{ *:[v4i32] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_V128 (tglobaladdr:{ *:[i32] }):$addr, v4i32:{ *:[v4i32] }:$src)
/* 10678*/  /*Scope*/ 22, /*->10701*/
/* 10679*/   OPC_CheckChild1Type, MVT::v16i8,
/* 10681*/   OPC_MoveChild2,
/* 10682*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10685*/   OPC_RecordChild0, // #2 = $addr
/* 10686*/   OPC_MoveChild0,
/* 10687*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10690*/   OPC_MoveParent,
/* 10691*/   OPC_MoveParent,
/* 10692*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10693*/   OPC_EmitMergeInputChains1_0,
/* 10694*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set v16i8:{ *:[v16i8] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_V128 (tglobaladdr:{ *:[i32] }):$addr, v16i8:{ *:[v16i8] }:$src)
/* 10701*/  /*Scope*/ 22, /*->10724*/
/* 10702*/   OPC_CheckChild1Type, MVT::v8i16,
/* 10704*/   OPC_MoveChild2,
/* 10705*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10708*/   OPC_RecordChild0, // #2 = $addr
/* 10709*/   OPC_MoveChild0,
/* 10710*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10713*/   OPC_MoveParent,
/* 10714*/   OPC_MoveParent,
/* 10715*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10716*/   OPC_EmitMergeInputChains1_0,
/* 10717*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set v8i16:{ *:[v8i16] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_V128 (tglobaladdr:{ *:[i32] }):$addr, v8i16:{ *:[v8i16] }:$src)
/* 10724*/  /*Scope*/ 22, /*->10747*/
/* 10725*/   OPC_CheckChild1Type, MVT::funcref,
/* 10727*/   OPC_MoveChild2,
/* 10728*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10731*/   OPC_RecordChild0, // #2 = $addr
/* 10732*/   OPC_MoveChild0,
/* 10733*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10736*/   OPC_MoveParent,
/* 10737*/   OPC_MoveParent,
/* 10738*/   OPC_CheckPatternPredicate5, // (Subtarget->hasReferenceTypes())
/* 10739*/   OPC_EmitMergeInputChains1_0,
/* 10740*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_FUNCREF), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set funcref:{ *:[funcref] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_FUNCREF (tglobaladdr:{ *:[i32] }):$addr, funcref:{ *:[funcref] }:$src)
/* 10747*/  /*Scope*/ 22, /*->10770*/
/* 10748*/   OPC_CheckChild1Type, MVT::externref,
/* 10750*/   OPC_MoveChild2,
/* 10751*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10754*/   OPC_RecordChild0, // #2 = $addr
/* 10755*/   OPC_MoveChild0,
/* 10756*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10759*/   OPC_MoveParent,
/* 10760*/   OPC_MoveParent,
/* 10761*/   OPC_CheckPatternPredicate5, // (Subtarget->hasReferenceTypes())
/* 10762*/   OPC_EmitMergeInputChains1_0,
/* 10763*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_EXTERNREF), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set externref:{ *:[externref] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_EXTERNREF (tglobaladdr:{ *:[i32] }):$addr, externref:{ *:[externref] }:$src)
/* 10770*/  /*Scope*/ 23, /*->10794*/
/* 10771*/   OPC_CheckChild1Type, MVT::exnref,
/* 10773*/   OPC_MoveChild2,
/* 10774*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10777*/   OPC_RecordChild0, // #2 = $addr
/* 10778*/   OPC_MoveChild0,
/* 10779*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10782*/   OPC_MoveParent,
/* 10783*/   OPC_MoveParent,
/* 10784*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasExceptionHandling()) && (Subtarget->hasReferenceTypes())
/* 10786*/   OPC_EmitMergeInputChains1_0,
/* 10787*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_EXNREF), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set exnref:{ *:[exnref] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_EXNREF (tglobaladdr:{ *:[i32] }):$addr, exnref:{ *:[exnref] }:$src)
/* 10794*/  0, /*End of Scope*/
/* 10795*/ /*SwitchOpcode*/ 21, TARGET_VAL(ISD::CALLSEQ_START),// ->10819
/* 10798*/  OPC_RecordNode, // #0 = 'WebAssemblycallseq_start' chained node
/* 10799*/  OPC_RecordChild1, // #1 = $amt
/* 10800*/  OPC_MoveChild1,
/* 10801*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 10804*/  OPC_MoveSibling2,
/* 10805*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 10808*/  OPC_RecordNode, // #2 = $amt2
/* 10809*/  OPC_MoveParent,
/* 10810*/  OPC_EmitMergeInputChains1_0,
/* 10811*/  OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ADJCALLSTACKDOWN), 0|OPFL_Chain|OPFL_GlueOutput,
                MVT::i32, 2/*#Ops*/, 1, 2, 
            // Src: (WebAssemblycallseq_start (timm:{ *:[iPTR] }):$amt, (timm:{ *:[iPTR] }):$amt2) - Complexity = 9
            // Dst: (ADJCALLSTACKDOWN:{ *:[i32] } (timm:{ *:[i32] }):$amt, (timm:{ *:[i32] }):$amt2)
/* 10819*/ /*SwitchOpcode*/ 22, TARGET_VAL(ISD::CALLSEQ_END),// ->10844
/* 10822*/  OPC_RecordNode, // #0 = 'WebAssemblycallseq_end' chained node
/* 10823*/  OPC_CaptureGlueInput,
/* 10824*/  OPC_RecordChild1, // #1 = $amt
/* 10825*/  OPC_MoveChild1,
/* 10826*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 10829*/  OPC_MoveSibling2,
/* 10830*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 10833*/  OPC_RecordNode, // #2 = $amt2
/* 10834*/  OPC_MoveParent,
/* 10835*/  OPC_EmitMergeInputChains1_0,
/* 10836*/  OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ADJCALLSTACKUP), 0|OPFL_Chain|OPFL_GlueInput|OPFL_GlueOutput,
                MVT::i32, 2/*#Ops*/, 1, 2, 
            // Src: (WebAssemblycallseq_end (timm:{ *:[iPTR] }):$amt, (timm:{ *:[iPTR] }):$amt2) - Complexity = 9
            // Dst: (ADJCALLSTACKUP:{ *:[i32] } (timm:{ *:[i32] }):$amt, (timm:{ *:[i32] }):$amt2)
/* 10844*/ /*SwitchOpcode*/ 57, TARGET_VAL(WebAssemblyISD::MEMORY_COPY),// ->10904
/* 10847*/  OPC_RecordNode, // #0 = 'wasm_memcpy' chained node
/* 10848*/  OPC_RecordChild1, // #1 = $src_idx
/* 10849*/  OPC_MoveChild1,
/* 10850*/  OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 10853*/  OPC_CheckTypeI32,
/* 10854*/  OPC_MoveSibling2,
/* 10855*/  OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 10858*/  OPC_RecordNode, // #2 = $dst_idx
/* 10859*/  OPC_CheckTypeI32,
/* 10860*/  OPC_MoveParent,
/* 10861*/  OPC_RecordChild3, // #3 = $dst
/* 10862*/  OPC_Scope, 19, /*->10883*/ // 2 children in Scope
/* 10864*/   OPC_CheckChild3TypeI32,
/* 10865*/   OPC_RecordChild4, // #4 = $src
/* 10866*/   OPC_CheckChild4TypeI32,
/* 10867*/   OPC_RecordChild5, // #5 = $len
/* 10868*/   OPC_CheckChild5TypeI32,
/* 10869*/   OPC_CheckPatternPredicate, 12, // (Subtarget->hasBulkMemory())
/* 10871*/   OPC_EmitMergeInputChains1_0,
/* 10872*/   OPC_EmitConvertToTarget1,
/* 10873*/   OPC_EmitConvertToTarget2,
/* 10874*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::anonymous_8082MEMORY_COPY_A32),
                 5/*#Ops*/, 6, 7, 3, 4, 5, 
             // Src: (wasm_memcpy (imm:{ *:[i32] }):$src_idx, (imm:{ *:[i32] }):$dst_idx, I32:{ *:[i32] }:$dst, I32:{ *:[i32] }:$src, I32:{ *:[i32] }:$len) - Complexity = 9
             // Dst: (anonymous_8082MEMORY_COPY_A32 (imm:{ *:[i32] }):$src_idx, (imm:{ *:[i32] }):$dst_idx, I32:{ *:[i32] }:$dst, I32:{ *:[i32] }:$src, I32:{ *:[i32] }:$len)
/* 10883*/  /*Scope*/ 19, /*->10903*/
/* 10884*/   OPC_CheckChild3TypeI64,
/* 10885*/   OPC_RecordChild4, // #4 = $src
/* 10886*/   OPC_CheckChild4TypeI64,
/* 10887*/   OPC_RecordChild5, // #5 = $len
/* 10888*/   OPC_CheckChild5TypeI64,
/* 10889*/   OPC_CheckPatternPredicate, 12, // (Subtarget->hasBulkMemory())
/* 10891*/   OPC_EmitMergeInputChains1_0,
/* 10892*/   OPC_EmitConvertToTarget1,
/* 10893*/   OPC_EmitConvertToTarget2,
/* 10894*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::anonymous_8083MEMORY_COPY_A64),
                 5/*#Ops*/, 6, 7, 3, 4, 5, 
             // Src: (wasm_memcpy (imm:{ *:[i32] }):$src_idx, (imm:{ *:[i32] }):$dst_idx, I64:{ *:[i64] }:$dst, I64:{ *:[i64] }:$src, I64:{ *:[i64] }:$len) - Complexity = 9
             // Dst: (anonymous_8083MEMORY_COPY_A64 (imm:{ *:[i32] }):$src_idx, (imm:{ *:[i32] }):$dst_idx, I64:{ *:[i64] }:$dst, I64:{ *:[i64] }:$src, I64:{ *:[i64] }:$len)
/* 10903*/  0, /*End of Scope*/
/* 10904*/ /*SwitchOpcode*/ 54, TARGET_VAL(WebAssemblyISD::TABLE_GET),// ->10961
/* 10907*/  OPC_RecordMemRef,
/* 10908*/  OPC_RecordNode, // #0 = 'WebAssemblyTableGet' chained node
/* 10909*/  OPC_MoveChild1,
/* 10910*/  OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10913*/  OPC_RecordChild0, // #1 = $table
/* 10914*/  OPC_MoveChild0,
/* 10915*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10918*/  OPC_MoveParent,
/* 10919*/  OPC_MoveParent,
/* 10920*/  OPC_RecordChild2, // #2 = $idx
/* 10921*/  OPC_CheckChild2TypeI32,
/* 10922*/  OPC_SwitchType /*3 cases */, 10, MVT::funcref,// ->10935
/* 10925*/   OPC_CheckPatternPredicate5, // (Subtarget->hasReferenceTypes())
/* 10926*/   OPC_EmitMergeInputChains1_0,
/* 10927*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::TABLE_GET_FUNCREF), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::funcref, 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblyTableGet:{ *:[funcref] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), i32:{ *:[i32] }:$idx) - Complexity = 9
             // Dst: (TABLE_GET_FUNCREF:{ *:[funcref] } (tglobaladdr:{ *:[i32] }):$table, i32:{ *:[i32] }:$idx)
/* 10935*/  /*SwitchType*/ 10, MVT::externref,// ->10947
/* 10937*/   OPC_CheckPatternPredicate5, // (Subtarget->hasReferenceTypes())
/* 10938*/   OPC_EmitMergeInputChains1_0,
/* 10939*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::TABLE_GET_EXTERNREF), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::externref, 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblyTableGet:{ *:[externref] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), i32:{ *:[i32] }:$idx) - Complexity = 9
             // Dst: (TABLE_GET_EXTERNREF:{ *:[externref] } (tglobaladdr:{ *:[i32] }):$table, i32:{ *:[i32] }:$idx)
/* 10947*/  /*SwitchType*/ 11, MVT::exnref,// ->10960
/* 10949*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasExceptionHandling()) && (Subtarget->hasReferenceTypes())
/* 10951*/   OPC_EmitMergeInputChains1_0,
/* 10952*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::TABLE_GET_EXNREF), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::exnref, 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblyTableGet:{ *:[exnref] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), i32:{ *:[i32] }:$idx) - Complexity = 9
             // Dst: (TABLE_GET_EXNREF:{ *:[exnref] } (tglobaladdr:{ *:[i32] }):$table, i32:{ *:[i32] }:$idx)
/* 10960*/  0, // EndSwitchType
/* 10961*/ /*SwitchOpcode*/ 83, TARGET_VAL(WebAssemblyISD::TABLE_SET),// ->11047
/* 10964*/  OPC_RecordMemRef,
/* 10965*/  OPC_RecordNode, // #0 = 'WebAssemblyTableSet' chained node
/* 10966*/  OPC_Scope, 56, /*->11024*/ // 2 children in Scope
/* 10968*/   OPC_MoveChild1,
/* 10969*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10972*/   OPC_RecordChild0, // #1 = $table
/* 10973*/   OPC_MoveChild0,
/* 10974*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10977*/   OPC_MoveParent,
/* 10978*/   OPC_MoveParent,
/* 10979*/   OPC_RecordChild2, // #2 = $idx
/* 10980*/   OPC_CheckChild2TypeI32,
/* 10981*/   OPC_RecordChild3, // #3 = $src
/* 10982*/   OPC_Scope, 12, /*->10996*/ // 3 children in Scope
/* 10984*/    OPC_CheckChild3Type, MVT::funcref,
/* 10986*/    OPC_CheckPatternPredicate5, // (Subtarget->hasReferenceTypes())
/* 10987*/    OPC_EmitMergeInputChains1_0,
/* 10988*/    OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::TABLE_SET_FUNCREF), 0|OPFL_Chain|OPFL_MemRefs,
                  3/*#Ops*/, 1, 2, 3, 
              // Src: (WebAssemblyTableSet (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), i32:{ *:[i32] }:$idx, funcref:{ *:[funcref] }:$src) - Complexity = 9
              // Dst: (TABLE_SET_FUNCREF (tglobaladdr:{ *:[i32] }):$table, i32:{ *:[i32] }:$idx, funcref:{ *:[funcref] }:$src)
/* 10996*/   /*Scope*/ 12, /*->11009*/
/* 10997*/    OPC_CheckChild3Type, MVT::externref,
/* 10999*/    OPC_CheckPatternPredicate5, // (Subtarget->hasReferenceTypes())
/* 11000*/    OPC_EmitMergeInputChains1_0,
/* 11001*/    OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::TABLE_SET_EXTERNREF), 0|OPFL_Chain|OPFL_MemRefs,
                  3/*#Ops*/, 1, 2, 3, 
              // Src: (WebAssemblyTableSet (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), i32:{ *:[i32] }:$idx, externref:{ *:[externref] }:$src) - Complexity = 9
              // Dst: (TABLE_SET_EXTERNREF (tglobaladdr:{ *:[i32] }):$table, i32:{ *:[i32] }:$idx, externref:{ *:[externref] }:$src)
/* 11009*/   /*Scope*/ 13, /*->11023*/
/* 11010*/    OPC_CheckChild3Type, MVT::exnref,
/* 11012*/    OPC_CheckPatternPredicate, 8, // (Subtarget->hasExceptionHandling()) && (Subtarget->hasReferenceTypes())
/* 11014*/    OPC_EmitMergeInputChains1_0,
/* 11015*/    OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::TABLE_SET_EXNREF), 0|OPFL_Chain|OPFL_MemRefs,
                  3/*#Ops*/, 1, 2, 3, 
              // Src: (WebAssemblyTableSet (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), i32:{ *:[i32] }:$idx, exnref:{ *:[exnref] }:$src) - Complexity = 9
              // Dst: (TABLE_SET_EXNREF (tglobaladdr:{ *:[i32] }):$table, i32:{ *:[i32] }:$idx, exnref:{ *:[exnref] }:$src)
/* 11023*/   0, /*End of Scope*/
/* 11024*/  /*Scope*/ 21, /*->11046*/
/* 11025*/   OPC_RecordChild1, // #1 = $table
/* 11026*/   OPC_MoveChild1,
/* 11027*/   OPC_CheckOpcode, TARGET_VAL(ISD::MCSymbol),
/* 11030*/   OPC_MoveParent,
/* 11031*/   OPC_RecordChild2, // #2 = $idx
/* 11032*/   OPC_CheckChild2TypeI32,
/* 11033*/   OPC_RecordChild3, // #3 = $r
/* 11034*/   OPC_CheckChild3Type, MVT::funcref,
/* 11036*/   OPC_CheckPatternPredicate5, // (Subtarget->hasReferenceTypes())
/* 11037*/   OPC_EmitMergeInputChains1_0,
/* 11038*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::TABLE_SET_FUNCREF), 0|OPFL_Chain|OPFL_MemRefs,
                 3/*#Ops*/, 1, 2, 3, 
             // Src: (WebAssemblyTableSet (mcsym:{ *:[iPTR] }):$table, i32:{ *:[i32] }:$idx, funcref:{ *:[funcref] }:$r) - Complexity = 6
             // Dst: (TABLE_SET_FUNCREF (mcsym:{ *:[i32] }):$table, i32:{ *:[i32] }:$idx, funcref:{ *:[funcref] }:$r)
/* 11046*/  0, /*End of Scope*/
/* 11047*/ /*SwitchOpcode*/ 7|128,10/*1287*/, TARGET_VAL(ISD::INTRINSIC_WO_CHAIN),// ->12338
/* 11051*/  OPC_Scope, 49, /*->11102*/ // 40 children in Scope
/* 11053*/   OPC_CheckChild0Integer, 54|128,62|128,1/*24374*/, 
/* 11057*/   OPC_RecordChild1, // #0 = $src
/* 11058*/   OPC_Scope, 20, /*->11080*/ // 2 children in Scope
/* 11060*/    OPC_CheckChild1Type, MVT::f32,
/* 11062*/    OPC_SwitchType /*2 cases */, 6, MVT::i32,// ->11071
/* 11065*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_S_F32),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (intrinsic_wo_chain:{ *:[i32] } 12187:{ *:[iPTR] }, F32:{ *:[f32] }:$src) - Complexity = 8
               // Dst: (I32_TRUNC_S_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 11071*/    /*SwitchType*/ 6, MVT::i64,// ->11079
/* 11073*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_S_F32),
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (intrinsic_wo_chain:{ *:[i64] } 12187:{ *:[iPTR] }, F32:{ *:[f32] }:$src) - Complexity = 8
               // Dst: (I64_TRUNC_S_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 11079*/    0, // EndSwitchType
/* 11080*/   /*Scope*/ 20, /*->11101*/
/* 11081*/    OPC_CheckChild1Type, MVT::f64,
/* 11083*/    OPC_SwitchType /*2 cases */, 6, MVT::i32,// ->11092
/* 11086*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_S_F64),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (intrinsic_wo_chain:{ *:[i32] } 12187:{ *:[iPTR] }, F64:{ *:[f64] }:$src) - Complexity = 8
               // Dst: (I32_TRUNC_S_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 11092*/    /*SwitchType*/ 6, MVT::i64,// ->11100
/* 11094*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_S_F64),
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (intrinsic_wo_chain:{ *:[i64] } 12187:{ *:[iPTR] }, F64:{ *:[f64] }:$src) - Complexity = 8
               // Dst: (I64_TRUNC_S_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 11100*/    0, // EndSwitchType
/* 11101*/   0, /*End of Scope*/
/* 11102*/  /*Scope*/ 49, /*->11152*/
/* 11103*/   OPC_CheckChild0Integer, 56|128,62|128,1/*24376*/, 
/* 11107*/   OPC_RecordChild1, // #0 = $src
/* 11108*/   OPC_Scope, 20, /*->11130*/ // 2 children in Scope
/* 11110*/    OPC_CheckChild1Type, MVT::f32,
/* 11112*/    OPC_SwitchType /*2 cases */, 6, MVT::i32,// ->11121
/* 11115*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_U_F32),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (intrinsic_wo_chain:{ *:[i32] } 12188:{ *:[iPTR] }, F32:{ *:[f32] }:$src) - Complexity = 8
               // Dst: (I32_TRUNC_U_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 11121*/    /*SwitchType*/ 6, MVT::i64,// ->11129
/* 11123*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_U_F32),
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (intrinsic_wo_chain:{ *:[i64] } 12188:{ *:[iPTR] }, F32:{ *:[f32] }:$src) - Complexity = 8
               // Dst: (I64_TRUNC_U_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 11129*/    0, // EndSwitchType
/* 11130*/   /*Scope*/ 20, /*->11151*/
/* 11131*/    OPC_CheckChild1Type, MVT::f64,
/* 11133*/    OPC_SwitchType /*2 cases */, 6, MVT::i32,// ->11142
/* 11136*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_U_F64),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (intrinsic_wo_chain:{ *:[i32] } 12188:{ *:[iPTR] }, F64:{ *:[f64] }:$src) - Complexity = 8
               // Dst: (I32_TRUNC_U_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 11142*/    /*SwitchType*/ 6, MVT::i64,// ->11150
/* 11144*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_U_F64),
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (intrinsic_wo_chain:{ *:[i64] } 12188:{ *:[iPTR] }, F64:{ *:[f64] }:$src) - Complexity = 8
               // Dst: (I64_TRUNC_U_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 11150*/    0, // EndSwitchType
/* 11151*/   0, /*End of Scope*/
/* 11152*/  /*Scope*/ 43, /*->11196*/
/* 11153*/   OPC_CheckChild0Integer, 40|128,61|128,1/*24232*/, 
/* 11157*/   OPC_RecordChild1, // #0 = $vec
/* 11158*/   OPC_Scope, 8, /*->11168*/ // 4 children in Scope
/* 11160*/    OPC_CheckChild1Type, MVT::v16i8,
/* 11162*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 12116:{ *:[iPTR] }, V128:{ *:[v16i8] }:$vec) - Complexity = 8
              // Dst: (ANYTRUE:{ *:[i32] } V128:{ *:[v16i8] }:$vec)
/* 11168*/   /*Scope*/ 8, /*->11177*/
/* 11169*/    OPC_CheckChild1Type, MVT::v8i16,
/* 11171*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 12116:{ *:[iPTR] }, V128:{ *:[v8i16] }:$vec) - Complexity = 8
              // Dst: (ANYTRUE:{ *:[i32] } V128:{ *:[v8i16] }:$vec)
/* 11177*/   /*Scope*/ 8, /*->11186*/
/* 11178*/    OPC_CheckChild1Type, MVT::v4i32,
/* 11180*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 12116:{ *:[iPTR] }, V128:{ *:[v4i32] }:$vec) - Complexity = 8
              // Dst: (ANYTRUE:{ *:[i32] } V128:{ *:[v4i32] }:$vec)
/* 11186*/   /*Scope*/ 8, /*->11195*/
/* 11187*/    OPC_CheckChild1Type, MVT::v2i64,
/* 11189*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 12116:{ *:[iPTR] }, V128:{ *:[v2i64] }:$vec) - Complexity = 8
              // Dst: (ANYTRUE:{ *:[i32] } V128:{ *:[v2i64] }:$vec)
/* 11195*/   0, /*End of Scope*/
/* 11196*/  /*Scope*/ 47, /*->11244*/
/* 11197*/   OPC_CheckChild0Integer, 38|128,61|128,1/*24230*/, 
/* 11201*/   OPC_RecordChild1, // #0 = $vec
/* 11202*/   OPC_Scope, 9, /*->11213*/ // 4 children in Scope
/* 11204*/    OPC_CheckChild1Type, MVT::v16i8,
/* 11206*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11207*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I8x16),
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 12115:{ *:[iPTR] }, V128:{ *:[v16i8] }:$vec) - Complexity = 8
              // Dst: (ALLTRUE_I8x16:{ *:[i32] } V128:{ *:[v16i8] }:$vec)
/* 11213*/   /*Scope*/ 9, /*->11223*/
/* 11214*/    OPC_CheckChild1Type, MVT::v8i16,
/* 11216*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11217*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I16x8),
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 12115:{ *:[iPTR] }, V128:{ *:[v8i16] }:$vec) - Complexity = 8
              // Dst: (ALLTRUE_I16x8:{ *:[i32] } V128:{ *:[v8i16] }:$vec)
/* 11223*/   /*Scope*/ 9, /*->11233*/
/* 11224*/    OPC_CheckChild1Type, MVT::v4i32,
/* 11226*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11227*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I32x4),
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 12115:{ *:[iPTR] }, V128:{ *:[v4i32] }:$vec) - Complexity = 8
              // Dst: (ALLTRUE_I32x4:{ *:[i32] } V128:{ *:[v4i32] }:$vec)
/* 11233*/   /*Scope*/ 9, /*->11243*/
/* 11234*/    OPC_CheckChild1Type, MVT::v2i64,
/* 11236*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11237*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I64x2),
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 12115:{ *:[iPTR] }, V128:{ *:[v2i64] }:$vec) - Complexity = 8
              // Dst: (ALLTRUE_I64x2:{ *:[i32] } V128:{ *:[v2i64] }:$vec)
/* 11243*/   0, /*End of Scope*/
/* 11244*/  /*Scope*/ 47, /*->11292*/
/* 11245*/   OPC_CheckChild0Integer, 44|128,61|128,1/*24236*/, 
/* 11249*/   OPC_RecordChild1, // #0 = $vec
/* 11250*/   OPC_Scope, 9, /*->11261*/ // 4 children in Scope
/* 11252*/    OPC_CheckChild1Type, MVT::v16i8,
/* 11254*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11255*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITMASK_I8x16),
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 12118:{ *:[iPTR] }, V128:{ *:[v16i8] }:$vec) - Complexity = 8
              // Dst: (BITMASK_I8x16:{ *:[i32] } V128:{ *:[v16i8] }:$vec)
/* 11261*/   /*Scope*/ 9, /*->11271*/
/* 11262*/    OPC_CheckChild1Type, MVT::v8i16,
/* 11264*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11265*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITMASK_I16x8),
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 12118:{ *:[iPTR] }, V128:{ *:[v8i16] }:$vec) - Complexity = 8
              // Dst: (BITMASK_I16x8:{ *:[i32] } V128:{ *:[v8i16] }:$vec)
/* 11271*/   /*Scope*/ 9, /*->11281*/
/* 11272*/    OPC_CheckChild1Type, MVT::v4i32,
/* 11274*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11275*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITMASK_I32x4),
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 12118:{ *:[iPTR] }, V128:{ *:[v4i32] }:$vec) - Complexity = 8
              // Dst: (BITMASK_I32x4:{ *:[i32] } V128:{ *:[v4i32] }:$vec)
/* 11281*/   /*Scope*/ 9, /*->11291*/
/* 11282*/    OPC_CheckChild1Type, MVT::v2i64,
/* 11284*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11285*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITMASK_I64x2),
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 12118:{ *:[iPTR] }, V128:{ *:[v2i64] }:$vec) - Complexity = 8
              // Dst: (BITMASK_I64x2:{ *:[i32] } V128:{ *:[v2i64] }:$vec)
/* 11291*/   0, /*End of Scope*/
/* 11292*/  /*Scope*/ 10, /*->11303*/
/* 11293*/   OPC_CheckChild0Integer, 98|128,61|128,1/*24290*/, 
/* 11297*/   OPC_CheckPatternPredicate5, // (Subtarget->hasReferenceTypes())
/* 11298*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REF_NULL_FUNCREF),
                 MVT::funcref, 0/*#Ops*/, 
             // Src: (intrinsic_wo_chain:{ *:[funcref] } 12145:{ *:[iPTR] }) - Complexity = 8
             // Dst: (REF_NULL_FUNCREF:{ *:[funcref] })
/* 11303*/  /*Scope*/ 12, /*->11316*/
/* 11304*/   OPC_CheckChild0Integer, 92|128,61|128,1/*24284*/, 
/* 11308*/   OPC_RecordChild1, // #0 = $ref
/* 11309*/   OPC_CheckPatternPredicate5, // (Subtarget->hasReferenceTypes())
/* 11310*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REF_IS_NULL_FUNCREF),
                 MVT::i32, 1/*#Ops*/, 0, 
             // Src: (intrinsic_wo_chain:{ *:[i32] } 12142:{ *:[iPTR] }, FUNCREF:{ *:[funcref] }:$ref) - Complexity = 8
             // Dst: (REF_IS_NULL_FUNCREF:{ *:[i32] } FUNCREF:{ *:[funcref] }:$ref)
/* 11316*/  /*Scope*/ 10, /*->11327*/
/* 11317*/   OPC_CheckChild0Integer, 96|128,61|128,1/*24288*/, 
/* 11321*/   OPC_CheckPatternPredicate5, // (Subtarget->hasReferenceTypes())
/* 11322*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REF_NULL_EXTERNREF),
                 MVT::externref, 0/*#Ops*/, 
             // Src: (intrinsic_wo_chain:{ *:[externref] } 12144:{ *:[iPTR] }) - Complexity = 8
             // Dst: (REF_NULL_EXTERNREF:{ *:[externref] })
/* 11327*/  /*Scope*/ 12, /*->11340*/
/* 11328*/   OPC_CheckChild0Integer, 90|128,61|128,1/*24282*/, 
/* 11332*/   OPC_RecordChild1, // #0 = $ref
/* 11333*/   OPC_CheckPatternPredicate5, // (Subtarget->hasReferenceTypes())
/* 11334*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REF_IS_NULL_EXTERNREF),
                 MVT::i32, 1/*#Ops*/, 0, 
             // Src: (intrinsic_wo_chain:{ *:[i32] } 12141:{ *:[iPTR] }, EXTERNREF:{ *:[externref] }:$ref) - Complexity = 8
             // Dst: (REF_IS_NULL_EXTERNREF:{ *:[i32] } EXTERNREF:{ *:[externref] }:$ref)
/* 11340*/  /*Scope*/ 10, /*->11351*/
/* 11341*/   OPC_CheckChild0Integer, 94|128,61|128,1/*24286*/, 
/* 11345*/   OPC_CheckPatternPredicate5, // (Subtarget->hasReferenceTypes())
/* 11346*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REF_NULL_EXNREF),
                 MVT::exnref, 0/*#Ops*/, 
             // Src: (intrinsic_wo_chain:{ *:[exnref] } 12143:{ *:[iPTR] }) - Complexity = 8
             // Dst: (REF_NULL_EXNREF:{ *:[exnref] })
/* 11351*/  /*Scope*/ 12, /*->11364*/
/* 11352*/   OPC_CheckChild0Integer, 88|128,61|128,1/*24280*/, 
/* 11356*/   OPC_RecordChild1, // #0 = $ref
/* 11357*/   OPC_CheckPatternPredicate5, // (Subtarget->hasReferenceTypes())
/* 11358*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REF_IS_NULL_EXNREF),
                 MVT::i32, 1/*#Ops*/, 0, 
             // Src: (intrinsic_wo_chain:{ *:[i32] } 12140:{ *:[iPTR] }, EXNREF:{ *:[exnref] }:$ref) - Complexity = 8
             // Dst: (REF_IS_NULL_EXNREF:{ *:[i32] } EXNREF:{ *:[exnref] }:$ref)
/* 11364*/  /*Scope*/ 23, /*->11388*/
/* 11365*/   OPC_CheckChild0Integer, 56|128,61|128,1/*24248*/, 
/* 11369*/   OPC_RecordChild1, // #0 = $vec
/* 11370*/   OPC_RecordChild2, // #1 = $idx
/* 11371*/   OPC_MoveChild2,
/* 11372*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 11375*/   OPC_CheckPredicate, 11, // Predicate_LaneIdx16
/* 11377*/   OPC_MoveParent,
/* 11378*/   OPC_CheckPatternPredicate, 17, // (Subtarget->hasHalfPrecision())
/* 11380*/   OPC_EmitConvertToTarget1,
/* 11381*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_F16x8),
                 MVT::f32, 2/*#Ops*/, 0, 2, 
             // Src: (intrinsic_wo_chain:{ *:[f32] } 12124:{ *:[iPTR] }, V128:{ *:[v8f16] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx) - Complexity = 12
             // Dst: (EXTRACT_LANE_F16x8:{ *:[f32] } V128:{ *:[v8f16] }:$vec, (imm:{ *:[i32] }):$idx)
/* 11388*/  /*Scope*/ 13, /*->11402*/
/* 11389*/   OPC_CheckChild0Integer, 12|128,62|128,1/*24332*/, 
/* 11393*/   OPC_RecordChild1, // #0 = $src
/* 11394*/   OPC_RecordChild2, // #1 = $mask
/* 11395*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SWIZZLE),
                 MVT::v16i8, 2/*#Ops*/, 0, 1, 
             // Src: (intrinsic_wo_chain:{ *:[v16i8] } 12166:{ *:[iPTR] }, V128:{ *:[v16i8] }:$src, V128:{ *:[v16i8] }:$mask) - Complexity = 8
             // Dst: (SWIZZLE:{ *:[v16i8] } ?:{ *:[v16i8] }:$src, ?:{ *:[v16i8] }:$mask)
/* 11402*/  /*Scope*/ 115, /*->11518*/
/* 11403*/   OPC_CheckChild0Integer, 46|128,61|128,1/*24238*/, 
/* 11407*/   OPC_RecordChild1, // #0 = $v1
/* 11408*/   OPC_SwitchType /*6 cases */, 16, MVT::v16i8,// ->11427
/* 11411*/    OPC_CheckChild1Type, MVT::v16i8,
/* 11413*/    OPC_RecordChild2, // #1 = $v2
/* 11414*/    OPC_CheckChild2Type, MVT::v16i8,
/* 11416*/    OPC_RecordChild3, // #2 = $c
/* 11417*/    OPC_CheckChild3Type, MVT::v16i8,
/* 11419*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v16i8, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v16i8] } 12119:{ *:[iPTR] }, V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$c) - Complexity = 8
              // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 11427*/   /*SwitchType*/ 16, MVT::v8i16,// ->11445
/* 11429*/    OPC_CheckChild1Type, MVT::v8i16,
/* 11431*/    OPC_RecordChild2, // #1 = $v2
/* 11432*/    OPC_CheckChild2Type, MVT::v8i16,
/* 11434*/    OPC_RecordChild3, // #2 = $c
/* 11435*/    OPC_CheckChild3Type, MVT::v8i16,
/* 11437*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v8i16, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 12119:{ *:[iPTR] }, V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$c) - Complexity = 8
              // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 11445*/   /*SwitchType*/ 16, MVT::v4i32,// ->11463
/* 11447*/    OPC_CheckChild1Type, MVT::v4i32,
/* 11449*/    OPC_RecordChild2, // #1 = $v2
/* 11450*/    OPC_CheckChild2Type, MVT::v4i32,
/* 11452*/    OPC_RecordChild3, // #2 = $c
/* 11453*/    OPC_CheckChild3Type, MVT::v4i32,
/* 11455*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v4i32, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v4i32] } 12119:{ *:[iPTR] }, V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$c) - Complexity = 8
              // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 11463*/   /*SwitchType*/ 16, MVT::v2i64,// ->11481
/* 11465*/    OPC_CheckChild1Type, MVT::v2i64,
/* 11467*/    OPC_RecordChild2, // #1 = $v2
/* 11468*/    OPC_CheckChild2Type, MVT::v2i64,
/* 11470*/    OPC_RecordChild3, // #2 = $c
/* 11471*/    OPC_CheckChild3Type, MVT::v2i64,
/* 11473*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v2i64, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v2i64] } 12119:{ *:[iPTR] }, V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$c) - Complexity = 8
              // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 11481*/   /*SwitchType*/ 16, MVT::v4f32,// ->11499
/* 11483*/    OPC_CheckChild1Type, MVT::v4f32,
/* 11485*/    OPC_RecordChild2, // #1 = $v2
/* 11486*/    OPC_CheckChild2Type, MVT::v4f32,
/* 11488*/    OPC_RecordChild3, // #2 = $c
/* 11489*/    OPC_CheckChild3Type, MVT::v4f32,
/* 11491*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v4f32, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v4f32] } 12119:{ *:[iPTR] }, V128:{ *:[v4f32] }:$v1, V128:{ *:[v4f32] }:$v2, V128:{ *:[v4f32] }:$c) - Complexity = 8
              // Dst: (BITSELECT:{ *:[v4f32] } ?:{ *:[v4f32] }:$v1, ?:{ *:[v4f32] }:$v2, ?:{ *:[v4f32] }:$c)
/* 11499*/   /*SwitchType*/ 16, MVT::v2f64,// ->11517
/* 11501*/    OPC_CheckChild1Type, MVT::v2f64,
/* 11503*/    OPC_RecordChild2, // #1 = $v2
/* 11504*/    OPC_CheckChild2Type, MVT::v2f64,
/* 11506*/    OPC_RecordChild3, // #2 = $c
/* 11507*/    OPC_CheckChild3Type, MVT::v2f64,
/* 11509*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v2f64, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v2f64] } 12119:{ *:[iPTR] }, V128:{ *:[v2f64] }:$v1, V128:{ *:[v2f64] }:$v2, V128:{ *:[v2f64] }:$c) - Complexity = 8
              // Dst: (BITSELECT:{ *:[v2f64] } ?:{ *:[v2f64] }:$v1, ?:{ *:[v2f64] }:$v2, ?:{ *:[v2f64] }:$c)
/* 11517*/   0, // EndSwitchType
/* 11518*/  /*Scope*/ 37, /*->11556*/
/* 11519*/   OPC_CheckChild0Integer, 8|128,62|128,1/*24328*/, 
/* 11523*/   OPC_RecordChild1, // #0 = $lhs
/* 11524*/   OPC_SwitchType /*2 cases */, 13, MVT::v16i8,// ->11540
/* 11527*/    OPC_CheckChild1Type, MVT::v16i8,
/* 11529*/    OPC_RecordChild2, // #1 = $rhs
/* 11530*/    OPC_CheckChild2Type, MVT::v16i8,
/* 11532*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11533*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_SAT_S_I8x16),
                  MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v16i8] } 12164:{ *:[iPTR] }, V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 8
              // Dst: (SUB_SAT_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 11540*/   /*SwitchType*/ 13, MVT::v8i16,// ->11555
/* 11542*/    OPC_CheckChild1Type, MVT::v8i16,
/* 11544*/    OPC_RecordChild2, // #1 = $rhs
/* 11545*/    OPC_CheckChild2Type, MVT::v8i16,
/* 11547*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11548*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_SAT_S_I16x8),
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 12164:{ *:[iPTR] }, V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 8
              // Dst: (SUB_SAT_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 11555*/   0, // EndSwitchType
/* 11556*/  /*Scope*/ 37, /*->11594*/
/* 11557*/   OPC_CheckChild0Integer, 10|128,62|128,1/*24330*/, 
/* 11561*/   OPC_RecordChild1, // #0 = $lhs
/* 11562*/   OPC_SwitchType /*2 cases */, 13, MVT::v16i8,// ->11578
/* 11565*/    OPC_CheckChild1Type, MVT::v16i8,
/* 11567*/    OPC_RecordChild2, // #1 = $rhs
/* 11568*/    OPC_CheckChild2Type, MVT::v16i8,
/* 11570*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11571*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_SAT_U_I8x16),
                  MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v16i8] } 12165:{ *:[iPTR] }, V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 8
              // Dst: (SUB_SAT_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 11578*/   /*SwitchType*/ 13, MVT::v8i16,// ->11593
/* 11580*/    OPC_CheckChild1Type, MVT::v8i16,
/* 11582*/    OPC_RecordChild2, // #1 = $rhs
/* 11583*/    OPC_CheckChild2Type, MVT::v8i16,
/* 11585*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11586*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_SAT_U_I16x8),
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 12165:{ *:[iPTR] }, V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 8
              // Dst: (SUB_SAT_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 11593*/   0, // EndSwitchType
/* 11594*/  /*Scope*/ 37, /*->11632*/
/* 11595*/   OPC_CheckChild0Integer, 42|128,61|128,1/*24234*/, 
/* 11599*/   OPC_RecordChild1, // #0 = $lhs
/* 11600*/   OPC_SwitchType /*2 cases */, 13, MVT::v16i8,// ->11616
/* 11603*/    OPC_CheckChild1Type, MVT::v16i8,
/* 11605*/    OPC_RecordChild2, // #1 = $rhs
/* 11606*/    OPC_CheckChild2Type, MVT::v16i8,
/* 11608*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11609*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AVGR_U_I8x16),
                  MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v16i8] } 12117:{ *:[iPTR] }, V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 8
              // Dst: (AVGR_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 11616*/   /*SwitchType*/ 13, MVT::v8i16,// ->11631
/* 11618*/    OPC_CheckChild1Type, MVT::v8i16,
/* 11620*/    OPC_RecordChild2, // #1 = $rhs
/* 11621*/    OPC_CheckChild2Type, MVT::v8i16,
/* 11623*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11624*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AVGR_U_I16x8),
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 12117:{ *:[iPTR] }, V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 8
              // Dst: (AVGR_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 11631*/   0, // EndSwitchType
/* 11632*/  /*Scope*/ 14, /*->11647*/
/* 11633*/   OPC_CheckChild0Integer, 50|128,61|128,1/*24242*/, 
/* 11637*/   OPC_RecordChild1, // #0 = $lhs
/* 11638*/   OPC_RecordChild2, // #1 = $rhs
/* 11639*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11640*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DOT),
                 MVT::v4i32, 2/*#Ops*/, 0, 1, 
             // Src: (intrinsic_wo_chain:{ *:[v4i32] } 12121:{ *:[iPTR] }, V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 8
             // Dst: (DOT:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 11647*/  /*Scope*/ 37, /*->11685*/
/* 11648*/   OPC_CheckChild0Integer, 78|128,61|128,1/*24270*/, 
/* 11652*/   OPC_RecordChild1, // #0 = $low
/* 11653*/   OPC_SwitchType /*2 cases */, 13, MVT::v16i8,// ->11669
/* 11656*/    OPC_CheckChild1Type, MVT::v8i16,
/* 11658*/    OPC_RecordChild2, // #1 = $high
/* 11659*/    OPC_CheckChild2Type, MVT::v8i16,
/* 11661*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11662*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NARROW_S_I8x16),
                  MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v16i8] } 12135:{ *:[iPTR] }, V128:{ *:[v8i16] }:$low, V128:{ *:[v8i16] }:$high) - Complexity = 8
              // Dst: (NARROW_S_I8x16:{ *:[v16i8] } V128:{ *:[v8i16] }:$low, V128:{ *:[v8i16] }:$high)
/* 11669*/   /*SwitchType*/ 13, MVT::v8i16,// ->11684
/* 11671*/    OPC_CheckChild1Type, MVT::v4i32,
/* 11673*/    OPC_RecordChild2, // #1 = $high
/* 11674*/    OPC_CheckChild2Type, MVT::v4i32,
/* 11676*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11677*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NARROW_S_I16x8),
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 12135:{ *:[iPTR] }, V128:{ *:[v4i32] }:$low, V128:{ *:[v4i32] }:$high) - Complexity = 8
              // Dst: (NARROW_S_I16x8:{ *:[v8i16] } V128:{ *:[v4i32] }:$low, V128:{ *:[v4i32] }:$high)
/* 11684*/   0, // EndSwitchType
/* 11685*/  /*Scope*/ 37, /*->11723*/
/* 11686*/   OPC_CheckChild0Integer, 80|128,61|128,1/*24272*/, 
/* 11690*/   OPC_RecordChild1, // #0 = $low
/* 11691*/   OPC_SwitchType /*2 cases */, 13, MVT::v16i8,// ->11707
/* 11694*/    OPC_CheckChild1Type, MVT::v8i16,
/* 11696*/    OPC_RecordChild2, // #1 = $high
/* 11697*/    OPC_CheckChild2Type, MVT::v8i16,
/* 11699*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11700*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NARROW_U_I8x16),
                  MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v16i8] } 12136:{ *:[iPTR] }, V128:{ *:[v8i16] }:$low, V128:{ *:[v8i16] }:$high) - Complexity = 8
              // Dst: (NARROW_U_I8x16:{ *:[v16i8] } V128:{ *:[v8i16] }:$low, V128:{ *:[v8i16] }:$high)
/* 11707*/   /*SwitchType*/ 13, MVT::v8i16,// ->11722
/* 11709*/    OPC_CheckChild1Type, MVT::v4i32,
/* 11711*/    OPC_RecordChild2, // #1 = $high
/* 11712*/    OPC_CheckChild2Type, MVT::v4i32,
/* 11714*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11715*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NARROW_U_I16x8),
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 12136:{ *:[iPTR] }, V128:{ *:[v4i32] }:$low, V128:{ *:[v4i32] }:$high) - Complexity = 8
              // Dst: (NARROW_U_I16x8:{ *:[v8i16] } V128:{ *:[v4i32] }:$low, V128:{ *:[v4i32] }:$high)
/* 11722*/   0, // EndSwitchType
/* 11723*/  /*Scope*/ 29, /*->11753*/
/* 11724*/   OPC_CheckChild0Integer, 52|128,61|128,1/*24244*/, 
/* 11728*/   OPC_RecordChild1, // #0 = $vec
/* 11729*/   OPC_SwitchType /*2 cases */, 9, MVT::v8i16,// ->11741
/* 11732*/    OPC_CheckChild1Type, MVT::v16i8,
/* 11734*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11735*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::int_wasm_extadd_pairwise_signed_I16x8),
                  MVT::v8i16, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 12122:{ *:[iPTR] }, V128:{ *:[v16i8] }:$vec) - Complexity = 8
              // Dst: (int_wasm_extadd_pairwise_signed_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec)
/* 11741*/   /*SwitchType*/ 9, MVT::v4i32,// ->11752
/* 11743*/    OPC_CheckChild1Type, MVT::v8i16,
/* 11745*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11746*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::int_wasm_extadd_pairwise_signed_I32x4),
                  MVT::v4i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[v4i32] } 12122:{ *:[iPTR] }, V128:{ *:[v8i16] }:$vec) - Complexity = 8
              // Dst: (int_wasm_extadd_pairwise_signed_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec)
/* 11752*/   0, // EndSwitchType
/* 11753*/  /*Scope*/ 29, /*->11783*/
/* 11754*/   OPC_CheckChild0Integer, 54|128,61|128,1/*24246*/, 
/* 11758*/   OPC_RecordChild1, // #0 = $vec
/* 11759*/   OPC_SwitchType /*2 cases */, 9, MVT::v8i16,// ->11771
/* 11762*/    OPC_CheckChild1Type, MVT::v16i8,
/* 11764*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11765*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::int_wasm_extadd_pairwise_unsigned_I16x8),
                  MVT::v8i16, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 12123:{ *:[iPTR] }, V128:{ *:[v16i8] }:$vec) - Complexity = 8
              // Dst: (int_wasm_extadd_pairwise_unsigned_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec)
/* 11771*/   /*SwitchType*/ 9, MVT::v4i32,// ->11782
/* 11773*/    OPC_CheckChild1Type, MVT::v8i16,
/* 11775*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11776*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::int_wasm_extadd_pairwise_unsigned_I32x4),
                  MVT::v4i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[v4i32] } 12123:{ *:[iPTR] }, V128:{ *:[v8i16] }:$vec) - Complexity = 8
              // Dst: (int_wasm_extadd_pairwise_unsigned_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec)
/* 11782*/   0, // EndSwitchType
/* 11783*/  /*Scope*/ 14, /*->11798*/
/* 11784*/   OPC_CheckChild0Integer, 86|128,61|128,1/*24278*/, 
/* 11788*/   OPC_RecordChild1, // #0 = $lhs
/* 11789*/   OPC_RecordChild2, // #1 = $rhs
/* 11790*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11791*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::Q15MULR_SAT_S_I16x8),
                 MVT::v8i16, 2/*#Ops*/, 0, 1, 
             // Src: (intrinsic_wo_chain:{ *:[v8i16] } 12139:{ *:[iPTR] }, V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 8
             // Dst: (Q15MULR_SAT_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 11798*/  /*Scope*/ 14, /*->11813*/
/* 11799*/   OPC_CheckChild0Integer, 118|128,61|128,1/*24310*/, 
/* 11803*/   OPC_RecordChild1, // #0 = $src
/* 11804*/   OPC_RecordChild2, // #1 = $mask
/* 11805*/   OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 11806*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::RELAXED_SWIZZLE),
                 MVT::v16i8, 2/*#Ops*/, 0, 1, 
             // Src: (intrinsic_wo_chain:{ *:[v16i8] } 12155:{ *:[iPTR] }, V128:{ *:[v16i8] }:$src, V128:{ *:[v16i8] }:$mask) - Complexity = 8
             // Dst: (RELAXED_SWIZZLE:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, V128:{ *:[v16i8] }:$mask)
/* 11813*/  /*Scope*/ 12, /*->11826*/
/* 11814*/   OPC_CheckChild0Integer, 120|128,61|128,1/*24312*/, 
/* 11818*/   OPC_RecordChild1, // #0 = $vec
/* 11819*/   OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 11820*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::int_wasm_relaxed_trunc_signed_I32x4),
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (intrinsic_wo_chain:{ *:[v4i32] } 12156:{ *:[iPTR] }, V128:{ *:[v4f32] }:$vec) - Complexity = 8
             // Dst: (int_wasm_relaxed_trunc_signed_I32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$vec)
/* 11826*/  /*Scope*/ 12, /*->11839*/
/* 11827*/   OPC_CheckChild0Integer, 124|128,61|128,1/*24316*/, 
/* 11831*/   OPC_RecordChild1, // #0 = $vec
/* 11832*/   OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 11833*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::int_wasm_relaxed_trunc_unsigned_I32x4),
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (intrinsic_wo_chain:{ *:[v4i32] } 12158:{ *:[iPTR] }, V128:{ *:[v4f32] }:$vec) - Complexity = 8
             // Dst: (int_wasm_relaxed_trunc_unsigned_I32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$vec)
/* 11839*/  /*Scope*/ 12, /*->11852*/
/* 11840*/   OPC_CheckChild0Integer, 122|128,61|128,1/*24314*/, 
/* 11844*/   OPC_RecordChild1, // #0 = $vec
/* 11845*/   OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 11846*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::int_wasm_relaxed_trunc_signed_zero_I32x4),
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (intrinsic_wo_chain:{ *:[v4i32] } 12157:{ *:[iPTR] }, V128:{ *:[v2f64] }:$vec) - Complexity = 8
             // Dst: (int_wasm_relaxed_trunc_signed_zero_I32x4:{ *:[v4i32] } V128:{ *:[v2f64] }:$vec)
/* 11852*/  /*Scope*/ 12, /*->11865*/
/* 11853*/   OPC_CheckChild0Integer, 126|128,61|128,1/*24318*/, 
/* 11857*/   OPC_RecordChild1, // #0 = $vec
/* 11858*/   OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 11859*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::int_wasm_relaxed_trunc_unsigned_zero_I32x4),
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (intrinsic_wo_chain:{ *:[v4i32] } 12159:{ *:[iPTR] }, V128:{ *:[v2f64] }:$vec) - Complexity = 8
             // Dst: (int_wasm_relaxed_trunc_unsigned_zero_I32x4:{ *:[v4i32] } V128:{ *:[v2f64] }:$vec)
/* 11865*/  /*Scope*/ 83, /*->11949*/
/* 11866*/   OPC_CheckChild0Integer, 106|128,61|128,1/*24298*/, 
/* 11870*/   OPC_RecordChild1, // #0 = $a
/* 11871*/   OPC_SwitchType /*4 cases */, 17, MVT::v16i8,// ->11891
/* 11874*/    OPC_CheckChild1Type, MVT::v16i8,
/* 11876*/    OPC_RecordChild2, // #1 = $b
/* 11877*/    OPC_CheckChild2Type, MVT::v16i8,
/* 11879*/    OPC_RecordChild3, // #2 = $c
/* 11880*/    OPC_CheckChild3Type, MVT::v16i8,
/* 11882*/    OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 11883*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LANESELECT_I8x16),
                  MVT::v16i8, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v16i8] } 12149:{ *:[iPTR] }, V128:{ *:[v16i8] }:$a, V128:{ *:[v16i8] }:$b, V128:{ *:[v16i8] }:$c) - Complexity = 8
              // Dst: (LANESELECT_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$a, V128:{ *:[v16i8] }:$b, V128:{ *:[v16i8] }:$c)
/* 11891*/   /*SwitchType*/ 17, MVT::v8i16,// ->11910
/* 11893*/    OPC_CheckChild1Type, MVT::v8i16,
/* 11895*/    OPC_RecordChild2, // #1 = $b
/* 11896*/    OPC_CheckChild2Type, MVT::v8i16,
/* 11898*/    OPC_RecordChild3, // #2 = $c
/* 11899*/    OPC_CheckChild3Type, MVT::v8i16,
/* 11901*/    OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 11902*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LANESELECT_I16x8),
                  MVT::v8i16, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 12149:{ *:[iPTR] }, V128:{ *:[v8i16] }:$a, V128:{ *:[v8i16] }:$b, V128:{ *:[v8i16] }:$c) - Complexity = 8
              // Dst: (LANESELECT_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$a, V128:{ *:[v8i16] }:$b, V128:{ *:[v8i16] }:$c)
/* 11910*/   /*SwitchType*/ 17, MVT::v4i32,// ->11929
/* 11912*/    OPC_CheckChild1Type, MVT::v4i32,
/* 11914*/    OPC_RecordChild2, // #1 = $b
/* 11915*/    OPC_CheckChild2Type, MVT::v4i32,
/* 11917*/    OPC_RecordChild3, // #2 = $c
/* 11918*/    OPC_CheckChild3Type, MVT::v4i32,
/* 11920*/    OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 11921*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LANESELECT_I32x4),
                  MVT::v4i32, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v4i32] } 12149:{ *:[iPTR] }, V128:{ *:[v4i32] }:$a, V128:{ *:[v4i32] }:$b, V128:{ *:[v4i32] }:$c) - Complexity = 8
              // Dst: (LANESELECT_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$a, V128:{ *:[v4i32] }:$b, V128:{ *:[v4i32] }:$c)
/* 11929*/   /*SwitchType*/ 17, MVT::v2i64,// ->11948
/* 11931*/    OPC_CheckChild1Type, MVT::v2i64,
/* 11933*/    OPC_RecordChild2, // #1 = $b
/* 11934*/    OPC_CheckChild2Type, MVT::v2i64,
/* 11936*/    OPC_RecordChild3, // #2 = $c
/* 11937*/    OPC_CheckChild3Type, MVT::v2i64,
/* 11939*/    OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 11940*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LANESELECT_I64x2),
                  MVT::v2i64, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v2i64] } 12149:{ *:[iPTR] }, V128:{ *:[v2i64] }:$a, V128:{ *:[v2i64] }:$b, V128:{ *:[v2i64] }:$c) - Complexity = 8
              // Dst: (LANESELECT_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$a, V128:{ *:[v2i64] }:$b, V128:{ *:[v2i64] }:$c)
/* 11948*/   0, // EndSwitchType
/* 11949*/  /*Scope*/ 14, /*->11964*/
/* 11950*/   OPC_CheckChild0Integer, 116|128,61|128,1/*24308*/, 
/* 11954*/   OPC_RecordChild1, // #0 = $lhs
/* 11955*/   OPC_RecordChild2, // #1 = $rhs
/* 11956*/   OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 11957*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::RELAXED_Q15MULR_S_I16x8),
                 MVT::v8i16, 2/*#Ops*/, 0, 1, 
             // Src: (intrinsic_wo_chain:{ *:[v8i16] } 12154:{ *:[iPTR] }, V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 8
             // Dst: (RELAXED_Q15MULR_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 11964*/  /*Scope*/ 14, /*->11979*/
/* 11965*/   OPC_CheckChild0Integer, 104|128,61|128,1/*24296*/, 
/* 11969*/   OPC_RecordChild1, // #0 = $lhs
/* 11970*/   OPC_RecordChild2, // #1 = $rhs
/* 11971*/   OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 11972*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::RELAXED_DOT),
                 MVT::v8i16, 2/*#Ops*/, 0, 1, 
             // Src: (intrinsic_wo_chain:{ *:[v8i16] } 12148:{ *:[iPTR] }, V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 8
             // Dst: (RELAXED_DOT:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 11979*/  /*Scope*/ 16, /*->11996*/
/* 11980*/   OPC_CheckChild0Integer, 102|128,61|128,1/*24294*/, 
/* 11984*/   OPC_RecordChild1, // #0 = $lhs
/* 11985*/   OPC_RecordChild2, // #1 = $rhs
/* 11986*/   OPC_RecordChild3, // #2 = $acc
/* 11987*/   OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 11988*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::RELAXED_DOT_ADD),
                 MVT::v4i32, 3/*#Ops*/, 0, 1, 2, 
             // Src: (intrinsic_wo_chain:{ *:[v4i32] } 12147:{ *:[iPTR] }, V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, V128:{ *:[v4i32] }:$acc) - Complexity = 8
             // Dst: (RELAXED_DOT_ADD:{ *:[v4i32] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, V128:{ *:[v4i32] }:$acc)
/* 11996*/  /*Scope*/ 13, /*->12010*/
/* 11997*/   OPC_CheckChild0Integer, 4|128,62|128,1/*24324*/, 
/* 12001*/   OPC_RecordChild1, // #0 = $x
/* 12002*/   OPC_CheckPatternPredicate, 17, // (Subtarget->hasHalfPrecision())
/* 12004*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_F16x8),
                 MVT::v8f16, 1/*#Ops*/, 0, 
             // Src: (intrinsic_wo_chain:{ *:[v8f16] } 12162:{ *:[iPTR] }, F32:{ *:[f32] }:$x) - Complexity = 8
             // Dst: (SPLAT_F16x8:{ *:[v8f16] } F32:{ *:[f32] }:$x)
/* 12010*/  /*Scope*/ 49, /*->12060*/
/* 12011*/   OPC_CheckChild0Integer, 84|128,61|128,1/*24276*/, 
/* 12015*/   OPC_RecordChild1, // #0 = $lhs
/* 12016*/   OPC_SwitchType /*3 cases */, 12, MVT::v4f32,// ->12031
/* 12019*/    OPC_CheckChild1Type, MVT::v4f32,
/* 12021*/    OPC_RecordChild2, // #1 = $rhs
/* 12022*/    OPC_CheckChild2Type, MVT::v4f32,
/* 12024*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F32x4),
                  MVT::v4f32, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v4f32] } 12138:{ *:[iPTR] }, V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 8
              // Dst: (PMIN_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 12031*/   /*SwitchType*/ 12, MVT::v2f64,// ->12045
/* 12033*/    OPC_CheckChild1Type, MVT::v2f64,
/* 12035*/    OPC_RecordChild2, // #1 = $rhs
/* 12036*/    OPC_CheckChild2Type, MVT::v2f64,
/* 12038*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F64x2),
                  MVT::v2f64, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v2f64] } 12138:{ *:[iPTR] }, V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 8
              // Dst: (PMIN_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 12045*/   /*SwitchType*/ 12, MVT::v8f16,// ->12059
/* 12047*/    OPC_CheckChild1Type, MVT::v8f16,
/* 12049*/    OPC_RecordChild2, // #1 = $rhs
/* 12050*/    OPC_CheckChild2Type, MVT::v8f16,
/* 12052*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F16x8),
                  MVT::v8f16, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v8f16] } 12138:{ *:[iPTR] }, V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs) - Complexity = 8
              // Dst: (PMIN_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 12059*/   0, // EndSwitchType
/* 12060*/  /*Scope*/ 49, /*->12110*/
/* 12061*/   OPC_CheckChild0Integer, 82|128,61|128,1/*24274*/, 
/* 12065*/   OPC_RecordChild1, // #0 = $lhs
/* 12066*/   OPC_SwitchType /*3 cases */, 12, MVT::v4f32,// ->12081
/* 12069*/    OPC_CheckChild1Type, MVT::v4f32,
/* 12071*/    OPC_RecordChild2, // #1 = $rhs
/* 12072*/    OPC_CheckChild2Type, MVT::v4f32,
/* 12074*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F32x4),
                  MVT::v4f32, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v4f32] } 12137:{ *:[iPTR] }, V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 8
              // Dst: (PMAX_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 12081*/   /*SwitchType*/ 12, MVT::v2f64,// ->12095
/* 12083*/    OPC_CheckChild1Type, MVT::v2f64,
/* 12085*/    OPC_RecordChild2, // #1 = $rhs
/* 12086*/    OPC_CheckChild2Type, MVT::v2f64,
/* 12088*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F64x2),
                  MVT::v2f64, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v2f64] } 12137:{ *:[iPTR] }, V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 8
              // Dst: (PMAX_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 12095*/   /*SwitchType*/ 12, MVT::v8f16,// ->12109
/* 12097*/    OPC_CheckChild1Type, MVT::v8f16,
/* 12099*/    OPC_RecordChild2, // #1 = $rhs
/* 12100*/    OPC_CheckChild2Type, MVT::v8f16,
/* 12102*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F16x8),
                  MVT::v8f16, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v8f16] } 12137:{ *:[iPTR] }, V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs) - Complexity = 8
              // Dst: (PMAX_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 12109*/   0, // EndSwitchType
/* 12110*/  /*Scope*/ 66, /*->12177*/
/* 12111*/   OPC_CheckChild0Integer, 108|128,61|128,1/*24300*/, 
/* 12115*/   OPC_RecordChild1, // #0 = $a
/* 12116*/   OPC_SwitchType /*3 cases */, 18, MVT::v4f32,// ->12137
/* 12119*/    OPC_CheckChild1Type, MVT::v4f32,
/* 12121*/    OPC_RecordChild2, // #1 = $b
/* 12122*/    OPC_CheckChild2Type, MVT::v4f32,
/* 12124*/    OPC_RecordChild3, // #2 = $c
/* 12125*/    OPC_CheckChild3Type, MVT::v4f32,
/* 12127*/    OPC_CheckPatternPredicate, 13, // (Subtarget->hasRelaxedSIMD()) && (Subtarget->hasSIMD128())
/* 12129*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MADD_F32x4),
                  MVT::v4f32, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v4f32] } 12150:{ *:[iPTR] }, V128:{ *:[v4f32] }:$a, V128:{ *:[v4f32] }:$b, V128:{ *:[v4f32] }:$c) - Complexity = 8
              // Dst: (MADD_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$a, V128:{ *:[v4f32] }:$b, V128:{ *:[v4f32] }:$c)
/* 12137*/   /*SwitchType*/ 18, MVT::v2f64,// ->12157
/* 12139*/    OPC_CheckChild1Type, MVT::v2f64,
/* 12141*/    OPC_RecordChild2, // #1 = $b
/* 12142*/    OPC_CheckChild2Type, MVT::v2f64,
/* 12144*/    OPC_RecordChild3, // #2 = $c
/* 12145*/    OPC_CheckChild3Type, MVT::v2f64,
/* 12147*/    OPC_CheckPatternPredicate, 13, // (Subtarget->hasRelaxedSIMD()) && (Subtarget->hasSIMD128())
/* 12149*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MADD_F64x2),
                  MVT::v2f64, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v2f64] } 12150:{ *:[iPTR] }, V128:{ *:[v2f64] }:$a, V128:{ *:[v2f64] }:$b, V128:{ *:[v2f64] }:$c) - Complexity = 8
              // Dst: (MADD_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$a, V128:{ *:[v2f64] }:$b, V128:{ *:[v2f64] }:$c)
/* 12157*/   /*SwitchType*/ 17, MVT::v8f16,// ->12176
/* 12159*/    OPC_CheckChild1Type, MVT::v8f16,
/* 12161*/    OPC_RecordChild2, // #1 = $b
/* 12162*/    OPC_CheckChild2Type, MVT::v8f16,
/* 12164*/    OPC_RecordChild3, // #2 = $c
/* 12165*/    OPC_CheckChild3Type, MVT::v8f16,
/* 12167*/    OPC_CheckPatternPredicate6, // (Subtarget->hasHalfPrecision()) && (Subtarget->hasSIMD128())
/* 12168*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MADD_F16x8),
                  MVT::v8f16, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v8f16] } 12150:{ *:[iPTR] }, V128:{ *:[v8f16] }:$a, V128:{ *:[v8f16] }:$b, V128:{ *:[v8f16] }:$c) - Complexity = 8
              // Dst: (MADD_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$a, V128:{ *:[v8f16] }:$b, V128:{ *:[v8f16] }:$c)
/* 12176*/   0, // EndSwitchType
/* 12177*/  /*Scope*/ 66, /*->12244*/
/* 12178*/   OPC_CheckChild0Integer, 114|128,61|128,1/*24306*/, 
/* 12182*/   OPC_RecordChild1, // #0 = $a
/* 12183*/   OPC_SwitchType /*3 cases */, 18, MVT::v4f32,// ->12204
/* 12186*/    OPC_CheckChild1Type, MVT::v4f32,
/* 12188*/    OPC_RecordChild2, // #1 = $b
/* 12189*/    OPC_CheckChild2Type, MVT::v4f32,
/* 12191*/    OPC_RecordChild3, // #2 = $c
/* 12192*/    OPC_CheckChild3Type, MVT::v4f32,
/* 12194*/    OPC_CheckPatternPredicate, 13, // (Subtarget->hasRelaxedSIMD()) && (Subtarget->hasSIMD128())
/* 12196*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NMADD_F32x4),
                  MVT::v4f32, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v4f32] } 12153:{ *:[iPTR] }, V128:{ *:[v4f32] }:$a, V128:{ *:[v4f32] }:$b, V128:{ *:[v4f32] }:$c) - Complexity = 8
              // Dst: (NMADD_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$a, V128:{ *:[v4f32] }:$b, V128:{ *:[v4f32] }:$c)
/* 12204*/   /*SwitchType*/ 18, MVT::v2f64,// ->12224
/* 12206*/    OPC_CheckChild1Type, MVT::v2f64,
/* 12208*/    OPC_RecordChild2, // #1 = $b
/* 12209*/    OPC_CheckChild2Type, MVT::v2f64,
/* 12211*/    OPC_RecordChild3, // #2 = $c
/* 12212*/    OPC_CheckChild3Type, MVT::v2f64,
/* 12214*/    OPC_CheckPatternPredicate, 13, // (Subtarget->hasRelaxedSIMD()) && (Subtarget->hasSIMD128())
/* 12216*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NMADD_F64x2),
                  MVT::v2f64, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v2f64] } 12153:{ *:[iPTR] }, V128:{ *:[v2f64] }:$a, V128:{ *:[v2f64] }:$b, V128:{ *:[v2f64] }:$c) - Complexity = 8
              // Dst: (NMADD_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$a, V128:{ *:[v2f64] }:$b, V128:{ *:[v2f64] }:$c)
/* 12224*/   /*SwitchType*/ 17, MVT::v8f16,// ->12243
/* 12226*/    OPC_CheckChild1Type, MVT::v8f16,
/* 12228*/    OPC_RecordChild2, // #1 = $b
/* 12229*/    OPC_CheckChild2Type, MVT::v8f16,
/* 12231*/    OPC_RecordChild3, // #2 = $c
/* 12232*/    OPC_CheckChild3Type, MVT::v8f16,
/* 12234*/    OPC_CheckPatternPredicate6, // (Subtarget->hasHalfPrecision()) && (Subtarget->hasSIMD128())
/* 12235*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NMADD_F16x8),
                  MVT::v8f16, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v8f16] } 12153:{ *:[iPTR] }, V128:{ *:[v8f16] }:$a, V128:{ *:[v8f16] }:$b, V128:{ *:[v8f16] }:$c) - Complexity = 8
              // Dst: (NMADD_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$a, V128:{ *:[v8f16] }:$b, V128:{ *:[v8f16] }:$c)
/* 12243*/   0, // EndSwitchType
/* 12244*/  /*Scope*/ 37, /*->12282*/
/* 12245*/   OPC_CheckChild0Integer, 112|128,61|128,1/*24304*/, 
/* 12249*/   OPC_RecordChild1, // #0 = $lhs
/* 12250*/   OPC_SwitchType /*2 cases */, 13, MVT::v4f32,// ->12266
/* 12253*/    OPC_CheckChild1Type, MVT::v4f32,
/* 12255*/    OPC_RecordChild2, // #1 = $rhs
/* 12256*/    OPC_CheckChild2Type, MVT::v4f32,
/* 12258*/    OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 12259*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SIMD_RELAXED_FMIN_F32x4),
                  MVT::v4f32, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v4f32] } 12152:{ *:[iPTR] }, V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 8
              // Dst: (SIMD_RELAXED_FMIN_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 12266*/   /*SwitchType*/ 13, MVT::v2f64,// ->12281
/* 12268*/    OPC_CheckChild1Type, MVT::v2f64,
/* 12270*/    OPC_RecordChild2, // #1 = $rhs
/* 12271*/    OPC_CheckChild2Type, MVT::v2f64,
/* 12273*/    OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 12274*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SIMD_RELAXED_FMIN_F64x2),
                  MVT::v2f64, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v2f64] } 12152:{ *:[iPTR] }, V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 8
              // Dst: (SIMD_RELAXED_FMIN_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 12281*/   0, // EndSwitchType
/* 12282*/  /*Scope*/ 37, /*->12320*/
/* 12283*/   OPC_CheckChild0Integer, 110|128,61|128,1/*24302*/, 
/* 12287*/   OPC_RecordChild1, // #0 = $lhs
/* 12288*/   OPC_SwitchType /*2 cases */, 13, MVT::v4f32,// ->12304
/* 12291*/    OPC_CheckChild1Type, MVT::v4f32,
/* 12293*/    OPC_RecordChild2, // #1 = $rhs
/* 12294*/    OPC_CheckChild2Type, MVT::v4f32,
/* 12296*/    OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 12297*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SIMD_RELAXED_FMAX_F32x4),
                  MVT::v4f32, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v4f32] } 12151:{ *:[iPTR] }, V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 8
              // Dst: (SIMD_RELAXED_FMAX_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 12304*/   /*SwitchType*/ 13, MVT::v2f64,// ->12319
/* 12306*/    OPC_CheckChild1Type, MVT::v2f64,
/* 12308*/    OPC_RecordChild2, // #1 = $rhs
/* 12309*/    OPC_CheckChild2Type, MVT::v2f64,
/* 12311*/    OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 12312*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SIMD_RELAXED_FMAX_F64x2),
                  MVT::v2f64, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v2f64] } 12151:{ *:[iPTR] }, V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 8
              // Dst: (SIMD_RELAXED_FMAX_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 12319*/   0, // EndSwitchType
/* 12320*/  /*Scope*/ 16, /*->12337*/
/* 12321*/   OPC_CheckChild0Integer, 100|128,61|128,1/*24292*/, 
/* 12325*/   OPC_RecordChild1, // #0 = $lhs
/* 12326*/   OPC_RecordChild2, // #1 = $rhs
/* 12327*/   OPC_RecordChild3, // #2 = $acc
/* 12328*/   OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 12329*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::RELAXED_DOT_BFLOAT),
                 MVT::v4f32, 3/*#Ops*/, 0, 1, 2, 
             // Src: (intrinsic_wo_chain:{ *:[v4f32] } 12146:{ *:[iPTR] }, V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, V128:{ *:[v4f32] }:$acc) - Complexity = 8
             // Dst: (RELAXED_DOT_BFLOAT:{ *:[v4f32] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, V128:{ *:[v4f32] }:$acc)
/* 12337*/  0, /*End of Scope*/
/* 12338*/ /*SwitchOpcode*/ 3|128,1/*131*/, TARGET_VAL(ISD::EXTRACT_VECTOR_ELT),// ->12473
/* 12342*/  OPC_RecordChild0, // #0 = $vec
/* 12343*/  OPC_Scope, 20, /*->12365*/ // 6 children in Scope
/* 12345*/   OPC_CheckChild0Type, MVT::v16i8,
/* 12347*/   OPC_RecordChild1, // #1 = $idx
/* 12348*/   OPC_MoveChild1,
/* 12349*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 12352*/   OPC_CheckPredicate, 11, // Predicate_LaneIdx16
/* 12354*/   OPC_CheckTypeI32,
/* 12355*/   OPC_MoveParent,
/* 12356*/   OPC_CheckTypeI32,
/* 12357*/   OPC_EmitConvertToTarget1,
/* 12358*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_I8x16_u),
                 MVT::i32, 2/*#Ops*/, 0, 2, 
             // Src: (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx) - Complexity = 7
             // Dst: (EXTRACT_LANE_I8x16_u:{ *:[i32] } ?:{ *:[v16i8] }:$vec, (imm:{ *:[i32] }):$idx)
/* 12365*/  /*Scope*/ 20, /*->12386*/
/* 12366*/   OPC_CheckChild0Type, MVT::v8i16,
/* 12368*/   OPC_RecordChild1, // #1 = $idx
/* 12369*/   OPC_MoveChild1,
/* 12370*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 12373*/   OPC_CheckPredicate, 16, // Predicate_LaneIdx8
/* 12375*/   OPC_CheckTypeI32,
/* 12376*/   OPC_MoveParent,
/* 12377*/   OPC_CheckTypeI32,
/* 12378*/   OPC_EmitConvertToTarget1,
/* 12379*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_I16x8_u),
                 MVT::i32, 2/*#Ops*/, 0, 2, 
             // Src: (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx) - Complexity = 7
             // Dst: (EXTRACT_LANE_I16x8_u:{ *:[i32] } ?:{ *:[v8i16] }:$vec, (imm:{ *:[i32] }):$idx)
/* 12386*/  /*Scope*/ 20, /*->12407*/
/* 12387*/   OPC_CheckChild0Type, MVT::v4i32,
/* 12389*/   OPC_RecordChild1, // #1 = $idx
/* 12390*/   OPC_MoveChild1,
/* 12391*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 12394*/   OPC_CheckPredicate, 17, // Predicate_LaneIdx4
/* 12396*/   OPC_CheckTypeI32,
/* 12397*/   OPC_MoveParent,
/* 12398*/   OPC_CheckTypeI32,
/* 12399*/   OPC_EmitConvertToTarget1,
/* 12400*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_I32x4),
                 MVT::i32, 2/*#Ops*/, 0, 2, 
             // Src: (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 7
             // Dst: (EXTRACT_LANE_I32x4:{ *:[i32] } ?:{ *:[v4i32] }:$vec, (imm:{ *:[i32] }):$idx)
/* 12407*/  /*Scope*/ 20, /*->12428*/
/* 12408*/   OPC_CheckChild0Type, MVT::v2i64,
/* 12410*/   OPC_RecordChild1, // #1 = $idx
/* 12411*/   OPC_MoveChild1,
/* 12412*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 12415*/   OPC_CheckPredicate, 18, // Predicate_LaneIdx2
/* 12417*/   OPC_CheckTypeI32,
/* 12418*/   OPC_MoveParent,
/* 12419*/   OPC_CheckTypeI64,
/* 12420*/   OPC_EmitConvertToTarget1,
/* 12421*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_I64x2),
                 MVT::i64, 2/*#Ops*/, 0, 2, 
             // Src: (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 7
             // Dst: (EXTRACT_LANE_I64x2:{ *:[i64] } ?:{ *:[v2i64] }:$vec, (imm:{ *:[i32] }):$idx)
/* 12428*/  /*Scope*/ 21, /*->12450*/
/* 12429*/   OPC_CheckChild0Type, MVT::v4f32,
/* 12431*/   OPC_RecordChild1, // #1 = $idx
/* 12432*/   OPC_MoveChild1,
/* 12433*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 12436*/   OPC_CheckPredicate, 17, // Predicate_LaneIdx4
/* 12438*/   OPC_CheckTypeI32,
/* 12439*/   OPC_MoveParent,
/* 12440*/   OPC_CheckType, MVT::f32,
/* 12442*/   OPC_EmitConvertToTarget1,
/* 12443*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_F32x4),
                 MVT::f32, 2/*#Ops*/, 0, 2, 
             // Src: (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 7
             // Dst: (EXTRACT_LANE_F32x4:{ *:[f32] } ?:{ *:[v4f32] }:$vec, (imm:{ *:[i32] }):$idx)
/* 12450*/  /*Scope*/ 21, /*->12472*/
/* 12451*/   OPC_CheckChild0Type, MVT::v2f64,
/* 12453*/   OPC_RecordChild1, // #1 = $idx
/* 12454*/   OPC_MoveChild1,
/* 12455*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 12458*/   OPC_CheckPredicate, 18, // Predicate_LaneIdx2
/* 12460*/   OPC_CheckTypeI32,
/* 12461*/   OPC_MoveParent,
/* 12462*/   OPC_CheckType, MVT::f64,
/* 12464*/   OPC_EmitConvertToTarget1,
/* 12465*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_F64x2),
                 MVT::f64, 2/*#Ops*/, 0, 2, 
             // Src: (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 7
             // Dst: (EXTRACT_LANE_F64x2:{ *:[f64] } ?:{ *:[v2f64] }:$vec, (imm:{ *:[i32] }):$idx)
/* 12472*/  0, /*End of Scope*/
/* 12473*/ /*SwitchOpcode*/ 120, TARGET_VAL(WebAssemblyISD::ARGUMENT),// ->12596
/* 12476*/  OPC_RecordChild0, // #0 = $argno
/* 12477*/  OPC_MoveChild0,
/* 12478*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 12481*/  OPC_MoveParent,
/* 12482*/  OPC_SwitchType /*14 cases */, 6, MVT::i32,// ->12491
/* 12485*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_i32),
                 MVT::i32, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[i32] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_i32:{ *:[i32] } (timm:{ *:[i32] }):$argno)
/* 12491*/  /*SwitchType*/ 6, MVT::i64,// ->12499
/* 12493*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_i64),
                 MVT::i64, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[i64] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_i64:{ *:[i64] } (timm:{ *:[i32] }):$argno)
/* 12499*/  /*SwitchType*/ 6, MVT::funcref,// ->12507
/* 12501*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_funcref),
                 MVT::funcref, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[funcref] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_funcref:{ *:[funcref] } (timm:{ *:[i32] }):$argno)
/* 12507*/  /*SwitchType*/ 6, MVT::externref,// ->12515
/* 12509*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_externref),
                 MVT::externref, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[externref] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_externref:{ *:[externref] } (timm:{ *:[i32] }):$argno)
/* 12515*/  /*SwitchType*/ 6, MVT::exnref,// ->12523
/* 12517*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_exnref),
                 MVT::exnref, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[exnref] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_exnref:{ *:[exnref] } (timm:{ *:[i32] }):$argno)
/* 12523*/  /*SwitchType*/ 6, MVT::f32,// ->12531
/* 12525*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_f32),
                 MVT::f32, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[f32] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_f32:{ *:[f32] } (timm:{ *:[i32] }):$argno)
/* 12531*/  /*SwitchType*/ 6, MVT::f64,// ->12539
/* 12533*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_f64),
                 MVT::f64, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[f64] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_f64:{ *:[f64] } (timm:{ *:[i32] }):$argno)
/* 12539*/  /*SwitchType*/ 6, MVT::v16i8,// ->12547
/* 12541*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_v16i8),
                 MVT::v16i8, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[v16i8] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_v16i8:{ *:[v16i8] } (timm:{ *:[i32] }):$argno)
/* 12547*/  /*SwitchType*/ 6, MVT::v8i16,// ->12555
/* 12549*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_v8i16),
                 MVT::v8i16, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[v8i16] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_v8i16:{ *:[v8i16] } (timm:{ *:[i32] }):$argno)
/* 12555*/  /*SwitchType*/ 6, MVT::v4i32,// ->12563
/* 12557*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_v4i32),
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[v4i32] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_v4i32:{ *:[v4i32] } (timm:{ *:[i32] }):$argno)
/* 12563*/  /*SwitchType*/ 6, MVT::v2i64,// ->12571
/* 12565*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_v2i64),
                 MVT::v2i64, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[v2i64] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_v2i64:{ *:[v2i64] } (timm:{ *:[i32] }):$argno)
/* 12571*/  /*SwitchType*/ 6, MVT::v4f32,// ->12579
/* 12573*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_v4f32),
                 MVT::v4f32, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[v4f32] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_v4f32:{ *:[v4f32] } (timm:{ *:[i32] }):$argno)
/* 12579*/  /*SwitchType*/ 6, MVT::v2f64,// ->12587
/* 12581*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_v2f64),
                 MVT::v2f64, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[v2f64] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_v2f64:{ *:[v2f64] } (timm:{ *:[i32] }):$argno)
/* 12587*/  /*SwitchType*/ 6, MVT::v8f16,// ->12595
/* 12589*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_v8f16),
                 MVT::v8f16, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[v8f16] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_v8f16:{ *:[v8f16] } (timm:{ *:[i32] }):$argno)
/* 12595*/  0, // EndSwitchType
/* 12596*/ /*SwitchOpcode*/ 18|128,1/*146*/, TARGET_VAL(WebAssemblyISD::LOCAL_GET),// ->12746
/* 12600*/  OPC_RecordNode, // #0 = 'WebAssemblylocal_get' chained node
/* 12601*/  OPC_RecordChild1, // #1 = $local
/* 12602*/  OPC_MoveChild1,
/* 12603*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 12606*/  OPC_MoveParent,
/* 12607*/  OPC_SwitchType /*14 cases */, 7, MVT::i32,// ->12617
/* 12610*/   OPC_EmitMergeInputChains1_0,
/* 12611*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_I32),
                 MVT::i32, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[i32] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_I32:{ *:[i32] } (timm:{ *:[i32] }):$local)
/* 12617*/  /*SwitchType*/ 7, MVT::i64,// ->12626
/* 12619*/   OPC_EmitMergeInputChains1_0,
/* 12620*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_I64),
                 MVT::i64, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[i64] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_I64:{ *:[i64] } (timm:{ *:[i32] }):$local)
/* 12626*/  /*SwitchType*/ 8, MVT::funcref,// ->12636
/* 12628*/   OPC_CheckPatternPredicate5, // (Subtarget->hasReferenceTypes())
/* 12629*/   OPC_EmitMergeInputChains1_0,
/* 12630*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_FUNCREF),
                 MVT::funcref, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[funcref] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_FUNCREF:{ *:[funcref] } (timm:{ *:[i32] }):$local)
/* 12636*/  /*SwitchType*/ 8, MVT::externref,// ->12646
/* 12638*/   OPC_CheckPatternPredicate5, // (Subtarget->hasReferenceTypes())
/* 12639*/   OPC_EmitMergeInputChains1_0,
/* 12640*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_EXTERNREF),
                 MVT::externref, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[externref] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_EXTERNREF:{ *:[externref] } (timm:{ *:[i32] }):$local)
/* 12646*/  /*SwitchType*/ 9, MVT::exnref,// ->12657
/* 12648*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasExceptionHandling()) && (Subtarget->hasReferenceTypes())
/* 12650*/   OPC_EmitMergeInputChains1_0,
/* 12651*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_EXNREF),
                 MVT::exnref, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[exnref] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_EXNREF:{ *:[exnref] } (timm:{ *:[i32] }):$local)
/* 12657*/  /*SwitchType*/ 7, MVT::f32,// ->12666
/* 12659*/   OPC_EmitMergeInputChains1_0,
/* 12660*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_F32),
                 MVT::f32, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[f32] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_F32:{ *:[f32] } (timm:{ *:[i32] }):$local)
/* 12666*/  /*SwitchType*/ 7, MVT::f64,// ->12675
/* 12668*/   OPC_EmitMergeInputChains1_0,
/* 12669*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_F64),
                 MVT::f64, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[f64] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_F64:{ *:[f64] } (timm:{ *:[i32] }):$local)
/* 12675*/  /*SwitchType*/ 8, MVT::v2i64,// ->12685
/* 12677*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12678*/   OPC_EmitMergeInputChains1_0,
/* 12679*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_V128),
                 MVT::v2i64, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[v2i64] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_V128:{ *:[v2i64] } (timm:{ *:[i32] }):$local)
/* 12685*/  /*SwitchType*/ 8, MVT::v4i32,// ->12695
/* 12687*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12688*/   OPC_EmitMergeInputChains1_0,
/* 12689*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_V128),
                 MVT::v4i32, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[v4i32] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_V128:{ *:[v4i32] } (timm:{ *:[i32] }):$local)
/* 12695*/  /*SwitchType*/ 8, MVT::v16i8,// ->12705
/* 12697*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12698*/   OPC_EmitMergeInputChains1_0,
/* 12699*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_V128),
                 MVT::v16i8, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[v16i8] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_V128:{ *:[v16i8] } (timm:{ *:[i32] }):$local)
/* 12705*/  /*SwitchType*/ 8, MVT::v8i16,// ->12715
/* 12707*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12708*/   OPC_EmitMergeInputChains1_0,
/* 12709*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_V128),
                 MVT::v8i16, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[v8i16] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_V128:{ *:[v8i16] } (timm:{ *:[i32] }):$local)
/* 12715*/  /*SwitchType*/ 8, MVT::v8f16,// ->12725
/* 12717*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12718*/   OPC_EmitMergeInputChains1_0,
/* 12719*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_V128),
                 MVT::v8f16, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[v8f16] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_V128:{ *:[v8f16] } (timm:{ *:[i32] }):$local)
/* 12725*/  /*SwitchType*/ 8, MVT::v4f32,// ->12735
/* 12727*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12728*/   OPC_EmitMergeInputChains1_0,
/* 12729*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_V128),
                 MVT::v4f32, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[v4f32] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_V128:{ *:[v4f32] } (timm:{ *:[i32] }):$local)
/* 12735*/  /*SwitchType*/ 8, MVT::v2f64,// ->12745
/* 12737*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12738*/   OPC_EmitMergeInputChains1_0,
/* 12739*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_V128),
                 MVT::v2f64, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[v2f64] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_V128:{ *:[v2f64] } (timm:{ *:[i32] }):$local)
/* 12745*/  0, // EndSwitchType
/* 12746*/ /*SwitchOpcode*/ 31|128,1/*159*/, TARGET_VAL(WebAssemblyISD::LOCAL_SET),// ->12909
/* 12750*/  OPC_RecordNode, // #0 = 'WebAssemblylocal_set' chained node
/* 12751*/  OPC_RecordChild1, // #1 = $local
/* 12752*/  OPC_MoveChild1,
/* 12753*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 12756*/  OPC_MoveParent,
/* 12757*/  OPC_RecordChild2, // #2 = $src
/* 12758*/  OPC_Scope, 8, /*->12768*/ // 14 children in Scope
/* 12760*/   OPC_CheckChild2TypeI32,
/* 12761*/   OPC_EmitMergeInputChains1_0,
/* 12762*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_I32),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, i32:{ *:[i32] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_I32 (timm:{ *:[i32] }):$local, i32:{ *:[i32] }:$src)
/* 12768*/  /*Scope*/ 8, /*->12777*/
/* 12769*/   OPC_CheckChild2TypeI64,
/* 12770*/   OPC_EmitMergeInputChains1_0,
/* 12771*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_I64),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, i64:{ *:[i64] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_I64 (timm:{ *:[i32] }):$local, i64:{ *:[i64] }:$src)
/* 12777*/  /*Scope*/ 9, /*->12787*/
/* 12778*/   OPC_CheckChild2Type, MVT::f32,
/* 12780*/   OPC_EmitMergeInputChains1_0,
/* 12781*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_F32),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, f32:{ *:[f32] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_F32 (timm:{ *:[i32] }):$local, f32:{ *:[f32] }:$src)
/* 12787*/  /*Scope*/ 9, /*->12797*/
/* 12788*/   OPC_CheckChild2Type, MVT::f64,
/* 12790*/   OPC_EmitMergeInputChains1_0,
/* 12791*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_F64),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, f64:{ *:[f64] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_F64 (timm:{ *:[i32] }):$local, f64:{ *:[f64] }:$src)
/* 12797*/  /*Scope*/ 10, /*->12808*/
/* 12798*/   OPC_CheckChild2Type, MVT::v8f16,
/* 12800*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12801*/   OPC_EmitMergeInputChains1_0,
/* 12802*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_V128),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, v8f16:{ *:[v8f16] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_V128 (timm:{ *:[i32] }):$local, v8f16:{ *:[v8f16] }:$src)
/* 12808*/  /*Scope*/ 10, /*->12819*/
/* 12809*/   OPC_CheckChild2Type, MVT::v4f32,
/* 12811*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12812*/   OPC_EmitMergeInputChains1_0,
/* 12813*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_V128),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, v4f32:{ *:[v4f32] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_V128 (timm:{ *:[i32] }):$local, v4f32:{ *:[v4f32] }:$src)
/* 12819*/  /*Scope*/ 10, /*->12830*/
/* 12820*/   OPC_CheckChild2Type, MVT::v2f64,
/* 12822*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12823*/   OPC_EmitMergeInputChains1_0,
/* 12824*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_V128),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, v2f64:{ *:[v2f64] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_V128 (timm:{ *:[i32] }):$local, v2f64:{ *:[v2f64] }:$src)
/* 12830*/  /*Scope*/ 10, /*->12841*/
/* 12831*/   OPC_CheckChild2Type, MVT::v2i64,
/* 12833*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12834*/   OPC_EmitMergeInputChains1_0,
/* 12835*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_V128),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, v2i64:{ *:[v2i64] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_V128 (timm:{ *:[i32] }):$local, v2i64:{ *:[v2i64] }:$src)
/* 12841*/  /*Scope*/ 10, /*->12852*/
/* 12842*/   OPC_CheckChild2Type, MVT::v4i32,
/* 12844*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12845*/   OPC_EmitMergeInputChains1_0,
/* 12846*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_V128),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, v4i32:{ *:[v4i32] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_V128 (timm:{ *:[i32] }):$local, v4i32:{ *:[v4i32] }:$src)
/* 12852*/  /*Scope*/ 10, /*->12863*/
/* 12853*/   OPC_CheckChild2Type, MVT::v16i8,
/* 12855*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12856*/   OPC_EmitMergeInputChains1_0,
/* 12857*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_V128),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, v16i8:{ *:[v16i8] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_V128 (timm:{ *:[i32] }):$local, v16i8:{ *:[v16i8] }:$src)
/* 12863*/  /*Scope*/ 10, /*->12874*/
/* 12864*/   OPC_CheckChild2Type, MVT::v8i16,
/* 12866*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12867*/   OPC_EmitMergeInputChains1_0,
/* 12868*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_V128),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, v8i16:{ *:[v8i16] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_V128 (timm:{ *:[i32] }):$local, v8i16:{ *:[v8i16] }:$src)
/* 12874*/  /*Scope*/ 10, /*->12885*/
/* 12875*/   OPC_CheckChild2Type, MVT::funcref,
/* 12877*/   OPC_CheckPatternPredicate5, // (Subtarget->hasReferenceTypes())
/* 12878*/   OPC_EmitMergeInputChains1_0,
/* 12879*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_FUNCREF),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, funcref:{ *:[funcref] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_FUNCREF (timm:{ *:[i32] }):$local, funcref:{ *:[funcref] }:$src)
/* 12885*/  /*Scope*/ 10, /*->12896*/
/* 12886*/   OPC_CheckChild2Type, MVT::externref,
/* 12888*/   OPC_CheckPatternPredicate5, // (Subtarget->hasReferenceTypes())
/* 12889*/   OPC_EmitMergeInputChains1_0,
/* 12890*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_EXTERNREF),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, externref:{ *:[externref] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_EXTERNREF (timm:{ *:[i32] }):$local, externref:{ *:[externref] }:$src)
/* 12896*/  /*Scope*/ 11, /*->12908*/
/* 12897*/   OPC_CheckChild2Type, MVT::exnref,
/* 12899*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasExceptionHandling()) && (Subtarget->hasReferenceTypes())
/* 12901*/   OPC_EmitMergeInputChains1_0,
/* 12902*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_EXNREF),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, exnref:{ *:[exnref] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_EXNREF (timm:{ *:[i32] }):$local, exnref:{ *:[exnref] }:$src)
/* 12908*/  0, /*End of Scope*/
/* 12909*/ /*SwitchOpcode*/ 0|128,1/*128*/, TARGET_VAL(WebAssemblyISD::Wrapper),// ->13041
/* 12913*/  OPC_RecordChild0, // #0 = $addr
/* 12914*/  OPC_MoveChild0,
/* 12915*/  OPC_SwitchOpcode /*3 cases */, 47, TARGET_VAL(ISD::TargetGlobalAddress),// ->12966
/* 12919*/   OPC_MoveParent,
/* 12920*/   OPC_SwitchType /*2 cases */, 20, MVT::i32,// ->12943
/* 12923*/    OPC_Scope, 8, /*->12933*/ // 2 children in Scope
/* 12925*/     OPC_CheckPatternPredicate, 18, // (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 12927*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I32),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (WebAssemblyWrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$addr) - Complexity = 6
               // Dst: (CONST_I32:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$addr)
/* 12933*/    /*Scope*/ 8, /*->12942*/
/* 12934*/     OPC_CheckPatternPredicate, 14, // (!Subtarget->hasAddr64()) && (TM.isPositionIndependent())
/* 12936*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GLOBAL_GET_I32),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (WebAssemblyWrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$addr) - Complexity = 6
               // Dst: (GLOBAL_GET_I32:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$addr)
/* 12942*/    0, /*End of Scope*/
/* 12943*/   /*SwitchType*/ 20, MVT::i64,// ->12965
/* 12945*/    OPC_Scope, 8, /*->12955*/ // 2 children in Scope
/* 12947*/     OPC_CheckPatternPredicate, 19, // (Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 12949*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I64),
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (WebAssemblyWrapper:{ *:[i64] } (tglobaladdr:{ *:[i64] }):$addr) - Complexity = 6
               // Dst: (CONST_I64:{ *:[i64] } (tglobaladdr:{ *:[i64] }):$addr)
/* 12955*/    /*Scope*/ 8, /*->12964*/
/* 12956*/     OPC_CheckPatternPredicate, 15, // (Subtarget->hasAddr64()) && (TM.isPositionIndependent())
/* 12958*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GLOBAL_GET_I64),
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (WebAssemblyWrapper:{ *:[i64] } (tglobaladdr:{ *:[i64] }):$addr) - Complexity = 6
               // Dst: (GLOBAL_GET_I64:{ *:[i64] } (tglobaladdr:{ *:[i64] }):$addr)
/* 12964*/    0, /*End of Scope*/
/* 12965*/   0, // EndSwitchType
/* 12966*/  /*SwitchOpcode*/ 21, TARGET_VAL(ISD::TargetGlobalTLSAddress),// ->12990
/* 12969*/   OPC_MoveParent,
/* 12970*/   OPC_SwitchType /*2 cases */, 7, MVT::i32,// ->12980
/* 12973*/    OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/* 12974*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GLOBAL_GET_I32),
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (WebAssemblyWrapper:{ *:[i32] } (tglobaltlsaddr:{ *:[i32] }):$addr) - Complexity = 6
              // Dst: (GLOBAL_GET_I32:{ *:[i32] } (tglobaltlsaddr:{ *:[i32] }):$addr)
/* 12980*/   /*SwitchType*/ 7, MVT::i64,// ->12989
/* 12982*/    OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/* 12983*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GLOBAL_GET_I64),
                  MVT::i64, 1/*#Ops*/, 0, 
              // Src: (WebAssemblyWrapper:{ *:[i64] } (tglobaltlsaddr:{ *:[i64] }):$addr) - Complexity = 6
              // Dst: (GLOBAL_GET_I64:{ *:[i64] } (tglobaltlsaddr:{ *:[i64] }):$addr)
/* 12989*/   0, // EndSwitchType
/* 12990*/  /*SwitchOpcode*/ 47, TARGET_VAL(ISD::TargetExternalSymbol),// ->13040
/* 12993*/   OPC_MoveParent,
/* 12994*/   OPC_SwitchType /*2 cases */, 20, MVT::i32,// ->13017
/* 12997*/    OPC_Scope, 8, /*->13007*/ // 2 children in Scope
/* 12999*/     OPC_CheckPatternPredicate, 14, // (!Subtarget->hasAddr64()) && (TM.isPositionIndependent())
/* 13001*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GLOBAL_GET_I32),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (WebAssemblyWrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$addr) - Complexity = 6
               // Dst: (GLOBAL_GET_I32:{ *:[i32] } (texternalsym:{ *:[i32] }):$addr)
/* 13007*/    /*Scope*/ 8, /*->13016*/
/* 13008*/     OPC_CheckPatternPredicate, 18, // (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 13010*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I32),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (WebAssemblyWrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$addr) - Complexity = 6
               // Dst: (CONST_I32:{ *:[i32] } (texternalsym:{ *:[i32] }):$addr)
/* 13016*/    0, /*End of Scope*/
/* 13017*/   /*SwitchType*/ 20, MVT::i64,// ->13039
/* 13019*/    OPC_Scope, 8, /*->13029*/ // 2 children in Scope
/* 13021*/     OPC_CheckPatternPredicate, 15, // (Subtarget->hasAddr64()) && (TM.isPositionIndependent())
/* 13023*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GLOBAL_GET_I64),
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (WebAssemblyWrapper:{ *:[i64] } (texternalsym:{ *:[i64] }):$addr) - Complexity = 6
               // Dst: (GLOBAL_GET_I64:{ *:[i64] } (texternalsym:{ *:[i64] }):$addr)
/* 13029*/    /*Scope*/ 8, /*->13038*/
/* 13030*/     OPC_CheckPatternPredicate, 19, // (Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 13032*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I64),
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (WebAssemblyWrapper:{ *:[i64] } (texternalsym:{ *:[i64] }):$addr) - Complexity = 6
               // Dst: (CONST_I64:{ *:[i64] } (texternalsym:{ *:[i64] }):$addr)
/* 13038*/    0, /*End of Scope*/
/* 13039*/   0, // EndSwitchType
/* 13040*/  0, // EndSwitchOpcode
/* 13041*/ /*SwitchOpcode*/ 80, TARGET_VAL(WebAssemblyISD::WrapperREL),// ->13124
/* 13044*/  OPC_RecordChild0, // #0 = $addr
/* 13045*/  OPC_MoveChild0,
/* 13046*/  OPC_SwitchOpcode /*3 cases */, 23, TARGET_VAL(ISD::TargetGlobalAddress),// ->13073
/* 13050*/   OPC_MoveParent,
/* 13051*/   OPC_SwitchType /*2 cases */, 8, MVT::i32,// ->13062
/* 13054*/    OPC_CheckPatternPredicate, 14, // (!Subtarget->hasAddr64()) && (TM.isPositionIndependent())
/* 13056*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I32),
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (WebAssemblyWrapperREL:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$addr) - Complexity = 6
              // Dst: (CONST_I32:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$addr)
/* 13062*/   /*SwitchType*/ 8, MVT::i64,// ->13072
/* 13064*/    OPC_CheckPatternPredicate, 15, // (Subtarget->hasAddr64()) && (TM.isPositionIndependent())
/* 13066*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I64),
                  MVT::i64, 1/*#Ops*/, 0, 
              // Src: (WebAssemblyWrapperREL:{ *:[i64] } (tglobaladdr:{ *:[i64] }):$addr) - Complexity = 6
              // Dst: (CONST_I64:{ *:[i64] } (tglobaladdr:{ *:[i64] }):$addr)
/* 13072*/   0, // EndSwitchType
/* 13073*/  /*SwitchOpcode*/ 21, TARGET_VAL(ISD::TargetGlobalTLSAddress),// ->13097
/* 13076*/   OPC_MoveParent,
/* 13077*/   OPC_SwitchType /*2 cases */, 7, MVT::i32,// ->13087
/* 13080*/    OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/* 13081*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I32),
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (WebAssemblyWrapperREL:{ *:[i32] } (tglobaltlsaddr:{ *:[i32] }):$addr) - Complexity = 6
              // Dst: (CONST_I32:{ *:[i32] } (tglobaltlsaddr:{ *:[i32] }):$addr)
/* 13087*/   /*SwitchType*/ 7, MVT::i64,// ->13096
/* 13089*/    OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/* 13090*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I64),
                  MVT::i64, 1/*#Ops*/, 0, 
              // Src: (WebAssemblyWrapperREL:{ *:[i64] } (tglobaltlsaddr:{ *:[i64] }):$addr) - Complexity = 6
              // Dst: (CONST_I64:{ *:[i64] } (tglobaltlsaddr:{ *:[i64] }):$addr)
/* 13096*/   0, // EndSwitchType
/* 13097*/  /*SwitchOpcode*/ 23, TARGET_VAL(ISD::TargetExternalSymbol),// ->13123
/* 13100*/   OPC_MoveParent,
/* 13101*/   OPC_SwitchType /*2 cases */, 8, MVT::i32,// ->13112
/* 13104*/    OPC_CheckPatternPredicate, 14, // (!Subtarget->hasAddr64()) && (TM.isPositionIndependent())
/* 13106*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I32),
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (WebAssemblyWrapperREL:{ *:[i32] } (texternalsym:{ *:[i32] }):$addr) - Complexity = 6
              // Dst: (CONST_I32:{ *:[i32] } (texternalsym:{ *:[i32] }):$addr)
/* 13112*/   /*SwitchType*/ 8, MVT::i64,// ->13122
/* 13114*/    OPC_CheckPatternPredicate, 15, // (Subtarget->hasAddr64()) && (TM.isPositionIndependent())
/* 13116*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I64),
                  MVT::i64, 1/*#Ops*/, 0, 
              // Src: (WebAssemblyWrapperREL:{ *:[i64] } (texternalsym:{ *:[i64] }):$addr) - Complexity = 6
              // Dst: (CONST_I64:{ *:[i64] } (texternalsym:{ *:[i64] }):$addr)
/* 13122*/   0, // EndSwitchType
/* 13123*/  0, // EndSwitchOpcode
/* 13124*/ /*SwitchOpcode*/ 47, TARGET_VAL(WebAssemblyISD::MEMORY_FILL),// ->13174
/* 13127*/  OPC_RecordNode, // #0 = 'wasm_memset' chained node
/* 13128*/  OPC_RecordChild1, // #1 = $idx
/* 13129*/  OPC_MoveChild1,
/* 13130*/  OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 13133*/  OPC_CheckTypeI32,
/* 13134*/  OPC_MoveParent,
/* 13135*/  OPC_RecordChild2, // #2 = $dst
/* 13136*/  OPC_Scope, 17, /*->13155*/ // 2 children in Scope
/* 13138*/   OPC_CheckChild2TypeI32,
/* 13139*/   OPC_RecordChild3, // #3 = $value
/* 13140*/   OPC_CheckChild3TypeI32,
/* 13141*/   OPC_RecordChild4, // #4 = $size
/* 13142*/   OPC_CheckChild4TypeI32,
/* 13143*/   OPC_CheckPatternPredicate, 12, // (Subtarget->hasBulkMemory())
/* 13145*/   OPC_EmitMergeInputChains1_0,
/* 13146*/   OPC_EmitConvertToTarget1,
/* 13147*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::anonymous_8082MEMORY_FILL_A32),
                 4/*#Ops*/, 5, 2, 3, 4, 
             // Src: (wasm_memset (imm:{ *:[i32] }):$idx, I32:{ *:[i32] }:$dst, I32:{ *:[i32] }:$value, I32:{ *:[i32] }:$size) - Complexity = 6
             // Dst: (anonymous_8082MEMORY_FILL_A32 (imm:{ *:[i32] }):$idx, I32:{ *:[i32] }:$dst, I32:{ *:[i32] }:$value, I32:{ *:[i32] }:$size)
/* 13155*/  /*Scope*/ 17, /*->13173*/
/* 13156*/   OPC_CheckChild2TypeI64,
/* 13157*/   OPC_RecordChild3, // #3 = $value
/* 13158*/   OPC_CheckChild3TypeI32,
/* 13159*/   OPC_RecordChild4, // #4 = $size
/* 13160*/   OPC_CheckChild4TypeI64,
/* 13161*/   OPC_CheckPatternPredicate, 12, // (Subtarget->hasBulkMemory())
/* 13163*/   OPC_EmitMergeInputChains1_0,
/* 13164*/   OPC_EmitConvertToTarget1,
/* 13165*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::anonymous_8083MEMORY_FILL_A64),
                 4/*#Ops*/, 5, 2, 3, 4, 
             // Src: (wasm_memset (imm:{ *:[i32] }):$idx, I64:{ *:[i64] }:$dst, I32:{ *:[i32] }:$value, I64:{ *:[i64] }:$size) - Complexity = 6
             // Dst: (anonymous_8083MEMORY_FILL_A64 (imm:{ *:[i32] }):$idx, I64:{ *:[i64] }:$dst, I32:{ *:[i32] }:$value, I64:{ *:[i64] }:$size)
/* 13173*/  0, /*End of Scope*/
/* 13174*/ /*SwitchOpcode*/ 21, TARGET_VAL(ISD::Constant),// ->13198
/* 13177*/  OPC_RecordNode, // #0 = $imm
/* 13178*/  OPC_SwitchType /*2 cases */, 7, MVT::i32,// ->13188
/* 13181*/   OPC_EmitConvertToTarget0,
/* 13182*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I32),
                 MVT::i32, 1/*#Ops*/, 1, 
             // Src: (imm:{ *:[i32] }):$imm - Complexity = 3
             // Dst: (CONST_I32:{ *:[i32] } (imm:{ *:[i32] }):$imm)
/* 13188*/  /*SwitchType*/ 7, MVT::i64,// ->13197
/* 13190*/   OPC_EmitConvertToTarget0,
/* 13191*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I64),
                 MVT::i64, 1/*#Ops*/, 1, 
             // Src: (imm:{ *:[i64] }):$imm - Complexity = 3
             // Dst: (CONST_I64:{ *:[i64] } (imm:{ *:[i64] }):$imm)
/* 13197*/  0, // EndSwitchType
/* 13198*/ /*SwitchOpcode*/ 13, TARGET_VAL(ISD::BR),// ->13214
/* 13201*/  OPC_RecordNode, // #0 = 'br' chained node
/* 13202*/  OPC_RecordChild1, // #1 = $dst
/* 13203*/  OPC_MoveChild1,
/* 13204*/  OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
/* 13207*/  OPC_MoveParent,
/* 13208*/  OPC_EmitMergeInputChains1_0,
/* 13209*/  OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::BR),
                1/*#Ops*/, 1, 
            // Src: (br (bb:{ *:[Other] }):$dst) - Complexity = 3
            // Dst: (BR (bb:{ *:[Other] }):$dst)
/* 13214*/ /*SwitchOpcode*/ 22, TARGET_VAL(WebAssemblyISD::BR_TABLE),// ->13239
/* 13217*/  OPC_RecordNode, // #0 = 'WebAssemblybr_table' chained node
/* 13218*/  OPC_RecordChild1, // #1 = $index
/* 13219*/  OPC_Scope, 8, /*->13229*/ // 2 children in Scope
/* 13221*/   OPC_CheckChild1TypeI32,
/* 13222*/   OPC_EmitMergeInputChains1_0,
/* 13223*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::BR_TABLE_I32), 0|OPFL_Chain|OPFL_Variadic1,
                 1/*#Ops*/, 1, 
             // Src: (WebAssemblybr_table I32:{ *:[i32] }:$index) - Complexity = 3
             // Dst: (BR_TABLE_I32 I32:{ *:[i32] }:$index)
/* 13229*/  /*Scope*/ 8, /*->13238*/
/* 13230*/   OPC_CheckChild1TypeI64,
/* 13231*/   OPC_EmitMergeInputChains1_0,
/* 13232*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::BR_TABLE_I64), 0|OPFL_Chain|OPFL_Variadic1,
                 1/*#Ops*/, 1, 
             // Src: (WebAssemblybr_table I64:{ *:[i64] }:$index) - Complexity = 3
             // Dst: (BR_TABLE_I64 I64:{ *:[i64] }:$index)
/* 13238*/  0, /*End of Scope*/
/* 13239*/ /*SwitchOpcode*/ 7, TARGET_VAL(WebAssemblyISD::RETURN),// ->13249
/* 13242*/  OPC_RecordNode, // #0 = 'WebAssemblyreturn' chained node
/* 13243*/  OPC_EmitMergeInputChains1_0,
/* 13244*/  OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::RETURN), 0|OPFL_Chain|OPFL_Variadic0,
                0/*#Ops*/, 
            // Src: (WebAssemblyreturn) - Complexity = 3
            // Dst: (RETURN)
/* 13249*/ /*SwitchOpcode*/ 6, TARGET_VAL(ISD::TRAP),// ->13258
/* 13252*/  OPC_RecordNode, // #0 = 'trap' chained node
/* 13253*/  OPC_EmitMergeInputChains1_0,
/* 13254*/  OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::UNREACHABLE),
                0/*#Ops*/, 
            // Src: (trap) - Complexity = 3
            // Dst: (UNREACHABLE)
/* 13258*/ /*SwitchOpcode*/ 6, TARGET_VAL(ISD::DEBUGTRAP),// ->13267
/* 13261*/  OPC_RecordNode, // #0 = 'debugtrap' chained node
/* 13262*/  OPC_EmitMergeInputChains1_0,
/* 13263*/  OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::DEBUG_UNREACHABLE),
                0/*#Ops*/, 
            // Src: (debugtrap) - Complexity = 3
            // Dst: (DEBUG_UNREACHABLE)
/* 13267*/ /*SwitchOpcode*/ 8, TARGET_VAL(ISD::CLEANUPRET),// ->13278
/* 13270*/  OPC_RecordNode, // #0 = 'cleanupret' chained node
/* 13271*/  OPC_CheckPatternPredicate, 16, // (Subtarget->hasExceptionHandling())
/* 13273*/  OPC_EmitMergeInputChains1_0,
/* 13274*/  OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::CLEANUPRET),
                0/*#Ops*/, 
            // Src: (cleanupret) - Complexity = 3
            // Dst: (CLEANUPRET)
/* 13278*/ /*SwitchOpcode*/ 21, TARGET_VAL(ISD::CATCHRET),// ->13302
/* 13281*/  OPC_RecordNode, // #0 = 'catchret' chained node
/* 13282*/  OPC_RecordChild1, // #1 = $dst
/* 13283*/  OPC_MoveChild1,
/* 13284*/  OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
/* 13287*/  OPC_MoveSibling2,
/* 13288*/  OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
/* 13291*/  OPC_RecordNode, // #2 = $from
/* 13292*/  OPC_MoveParent,
/* 13293*/  OPC_CheckPatternPredicate, 16, // (Subtarget->hasExceptionHandling())
/* 13295*/  OPC_EmitMergeInputChains1_0,
/* 13296*/  OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::CATCHRET),
                2/*#Ops*/, 1, 2, 
            // Src: (catchret (bb:{ *:[Other] }):$dst, (bb:{ *:[Other] }):$from) - Complexity = 3
            // Dst: (CATCHRET (bb:{ *:[Other] }):$dst, (bb:{ *:[Other] }):$from)
/* 13302*/ /*SwitchOpcode*/ 62, TARGET_VAL(ISD::ADD),// ->13367
/* 13305*/  OPC_RecordChild0, // #0 = $lhs
/* 13306*/  OPC_RecordChild1, // #1 = $rhs
/* 13307*/  OPC_SwitchType /*6 cases */, 7, MVT::i32,// ->13317
/* 13310*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_I32),
                 MVT::i32, 2/*#Ops*/, 0, 1, 
             // Src: (add:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
             // Dst: (ADD_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 13317*/  /*SwitchType*/ 7, MVT::i64,// ->13326
/* 13319*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_I64),
                 MVT::i64, 2/*#Ops*/, 0, 1, 
             // Src: (add:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
             // Dst: (ADD_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 13326*/  /*SwitchType*/ 8, MVT::v16i8,// ->13336
/* 13328*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13329*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_I8x16),
                 MVT::v16i8, 2/*#Ops*/, 0, 1, 
             // Src: (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
             // Dst: (ADD_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 13336*/  /*SwitchType*/ 8, MVT::v8i16,// ->13346
/* 13338*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13339*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_I16x8),
                 MVT::v8i16, 2/*#Ops*/, 0, 1, 
             // Src: (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
             // Dst: (ADD_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 13346*/  /*SwitchType*/ 8, MVT::v4i32,// ->13356
/* 13348*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13349*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_I32x4),
                 MVT::v4i32, 2/*#Ops*/, 0, 1, 
             // Src: (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
             // Dst: (ADD_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 13356*/  /*SwitchType*/ 8, MVT::v2i64,// ->13366
/* 13358*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13359*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_I64x2),
                 MVT::v2i64, 2/*#Ops*/, 0, 1, 
             // Src: (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 3
             // Dst: (ADD_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/* 13366*/  0, // EndSwitchType
/* 13367*/ /*SwitchOpcode*/ 113, TARGET_VAL(ISD::SUB),// ->13483
/* 13370*/  OPC_Scope, 22, /*->13394*/ // 3 children in Scope
/* 13372*/   OPC_RecordChild0, // #0 = $lhs
/* 13373*/   OPC_RecordChild1, // #1 = $rhs
/* 13374*/   OPC_SwitchType /*2 cases */, 7, MVT::i32,// ->13384
/* 13377*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_I32),
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (sub:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (SUB_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 13384*/   /*SwitchType*/ 7, MVT::i64,// ->13393
/* 13386*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_I64),
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (sub:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (SUB_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 13393*/   0, // EndSwitchType
/* 13394*/  /*Scope*/ 42, /*->13437*/
/* 13395*/   OPC_MoveChild0,
/* 13396*/   OPC_CheckImmAllZerosV,
/* 13397*/   OPC_MoveParent,
/* 13398*/   OPC_RecordChild1, // #0 = $v
/* 13399*/   OPC_SwitchType /*4 cases */, 7, MVT::v16i8,// ->13409
/* 13402*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13403*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEG_I8x16),
                  MVT::v16i8, 1/*#Ops*/, 0, 
              // Src: (sub:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$v) - Complexity = 7
              // Dst: (NEG_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$v)
/* 13409*/   /*SwitchType*/ 7, MVT::v8i16,// ->13418
/* 13411*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13412*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEG_I16x8),
                  MVT::v8i16, 1/*#Ops*/, 0, 
              // Src: (sub:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$v) - Complexity = 7
              // Dst: (NEG_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$v)
/* 13418*/   /*SwitchType*/ 7, MVT::v4i32,// ->13427
/* 13420*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13421*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEG_I32x4),
                  MVT::v4i32, 1/*#Ops*/, 0, 
              // Src: (sub:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$v) - Complexity = 7
              // Dst: (NEG_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$v)
/* 13427*/   /*SwitchType*/ 7, MVT::v2i64,// ->13436
/* 13429*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13430*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEG_I64x2),
                  MVT::v2i64, 1/*#Ops*/, 0, 
              // Src: (sub:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$v) - Complexity = 7
              // Dst: (NEG_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$v)
/* 13436*/   0, // EndSwitchType
/* 13437*/  /*Scope*/ 44, /*->13482*/
/* 13438*/   OPC_RecordChild0, // #0 = $lhs
/* 13439*/   OPC_RecordChild1, // #1 = $rhs
/* 13440*/   OPC_SwitchType /*4 cases */, 8, MVT::v16i8,// ->13451
/* 13443*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13444*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_I8x16),
                  MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (sub:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
              // Dst: (SUB_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 13451*/   /*SwitchType*/ 8, MVT::v8i16,// ->13461
/* 13453*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13454*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_I16x8),
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
              // Dst: (SUB_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 13461*/   /*SwitchType*/ 8, MVT::v4i32,// ->13471
/* 13463*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13464*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_I32x4),
                  MVT::v4i32, 2/*#Ops*/, 0, 1, 
              // Src: (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
              // Dst: (SUB_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 13471*/   /*SwitchType*/ 8, MVT::v2i64,// ->13481
/* 13473*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13474*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_I64x2),
                  MVT::v2i64, 2/*#Ops*/, 0, 1, 
              // Src: (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 3
              // Dst: (SUB_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/* 13481*/   0, // EndSwitchType
/* 13482*/  0, /*End of Scope*/
/* 13483*/ /*SwitchOpcode*/ 85|128,2/*341*/, TARGET_VAL(ISD::MUL),// ->13828
/* 13487*/  OPC_Scope, 22, /*->13511*/ // 3 children in Scope
/* 13489*/   OPC_RecordChild0, // #0 = $lhs
/* 13490*/   OPC_RecordChild1, // #1 = $rhs
/* 13491*/   OPC_SwitchType /*2 cases */, 7, MVT::i32,// ->13501
/* 13494*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_I32),
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (mul:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (MUL_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 13501*/   /*SwitchType*/ 7, MVT::i64,// ->13510
/* 13503*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_I64),
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (mul:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (MUL_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 13510*/   0, // EndSwitchType
/* 13511*/  /*Scope*/ 23|128,2/*279*/, /*->13792*/
/* 13513*/   OPC_MoveChild0,
/* 13514*/   OPC_SwitchOpcode /*4 cases */, 66, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_S),// ->13584
/* 13518*/    OPC_RecordChild0, // #0 = $lhs
/* 13519*/    OPC_Scope, 20, /*->13541*/ // 3 children in Scope
/* 13521*/     OPC_CheckChild0Type, MVT::v16i8,
/* 13523*/     OPC_MoveSibling1,
/* 13524*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_S),
/* 13527*/     OPC_RecordChild0, // #1 = $rhs
/* 13528*/     OPC_CheckChild0Type, MVT::v16i8,
/* 13530*/     OPC_MoveParent,
/* 13531*/     OPC_CheckType, MVT::v8i16,
/* 13533*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13534*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_LOW_S_I16x8),
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v8i16] } (extend_low_s:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs), (extend_low_s:{ *:[v8i16] } V128:{ *:[v16i8] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_LOW_S_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 13541*/    /*Scope*/ 20, /*->13562*/
/* 13542*/     OPC_CheckChild0Type, MVT::v8i16,
/* 13544*/     OPC_MoveSibling1,
/* 13545*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_S),
/* 13548*/     OPC_RecordChild0, // #1 = $rhs
/* 13549*/     OPC_CheckChild0Type, MVT::v8i16,
/* 13551*/     OPC_MoveParent,
/* 13552*/     OPC_CheckType, MVT::v4i32,
/* 13554*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13555*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_LOW_S_I32x4),
                   MVT::v4i32, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v4i32] } (extend_low_s:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs), (extend_low_s:{ *:[v4i32] } V128:{ *:[v8i16] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_LOW_S_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 13562*/    /*Scope*/ 20, /*->13583*/
/* 13563*/     OPC_CheckChild0Type, MVT::v4i32,
/* 13565*/     OPC_MoveSibling1,
/* 13566*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_S),
/* 13569*/     OPC_RecordChild0, // #1 = $rhs
/* 13570*/     OPC_CheckChild0Type, MVT::v4i32,
/* 13572*/     OPC_MoveParent,
/* 13573*/     OPC_CheckType, MVT::v2i64,
/* 13575*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13576*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_LOW_S_I64x2),
                   MVT::v2i64, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v2i64] } (extend_low_s:{ *:[v2i64] } V128:{ *:[v4i32] }:$lhs), (extend_low_s:{ *:[v2i64] } V128:{ *:[v4i32] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_LOW_S_I64x2:{ *:[v2i64] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 13583*/    0, /*End of Scope*/
/* 13584*/   /*SwitchOpcode*/ 66, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_S),// ->13653
/* 13587*/    OPC_RecordChild0, // #0 = $lhs
/* 13588*/    OPC_Scope, 20, /*->13610*/ // 3 children in Scope
/* 13590*/     OPC_CheckChild0Type, MVT::v16i8,
/* 13592*/     OPC_MoveSibling1,
/* 13593*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_S),
/* 13596*/     OPC_RecordChild0, // #1 = $rhs
/* 13597*/     OPC_CheckChild0Type, MVT::v16i8,
/* 13599*/     OPC_MoveParent,
/* 13600*/     OPC_CheckType, MVT::v8i16,
/* 13602*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13603*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_HIGH_S_I16x8),
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v8i16] } (extend_high_s:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs), (extend_high_s:{ *:[v8i16] } V128:{ *:[v16i8] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_HIGH_S_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 13610*/    /*Scope*/ 20, /*->13631*/
/* 13611*/     OPC_CheckChild0Type, MVT::v8i16,
/* 13613*/     OPC_MoveSibling1,
/* 13614*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_S),
/* 13617*/     OPC_RecordChild0, // #1 = $rhs
/* 13618*/     OPC_CheckChild0Type, MVT::v8i16,
/* 13620*/     OPC_MoveParent,
/* 13621*/     OPC_CheckType, MVT::v4i32,
/* 13623*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13624*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_HIGH_S_I32x4),
                   MVT::v4i32, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v4i32] } (extend_high_s:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs), (extend_high_s:{ *:[v4i32] } V128:{ *:[v8i16] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_HIGH_S_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 13631*/    /*Scope*/ 20, /*->13652*/
/* 13632*/     OPC_CheckChild0Type, MVT::v4i32,
/* 13634*/     OPC_MoveSibling1,
/* 13635*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_S),
/* 13638*/     OPC_RecordChild0, // #1 = $rhs
/* 13639*/     OPC_CheckChild0Type, MVT::v4i32,
/* 13641*/     OPC_MoveParent,
/* 13642*/     OPC_CheckType, MVT::v2i64,
/* 13644*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13645*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_HIGH_S_I64x2),
                   MVT::v2i64, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v2i64] } (extend_high_s:{ *:[v2i64] } V128:{ *:[v4i32] }:$lhs), (extend_high_s:{ *:[v2i64] } V128:{ *:[v4i32] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_HIGH_S_I64x2:{ *:[v2i64] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 13652*/    0, /*End of Scope*/
/* 13653*/   /*SwitchOpcode*/ 66, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_U),// ->13722
/* 13656*/    OPC_RecordChild0, // #0 = $lhs
/* 13657*/    OPC_Scope, 20, /*->13679*/ // 3 children in Scope
/* 13659*/     OPC_CheckChild0Type, MVT::v16i8,
/* 13661*/     OPC_MoveSibling1,
/* 13662*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_U),
/* 13665*/     OPC_RecordChild0, // #1 = $rhs
/* 13666*/     OPC_CheckChild0Type, MVT::v16i8,
/* 13668*/     OPC_MoveParent,
/* 13669*/     OPC_CheckType, MVT::v8i16,
/* 13671*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13672*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_LOW_U_I16x8),
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v8i16] } (extend_low_u:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs), (extend_low_u:{ *:[v8i16] } V128:{ *:[v16i8] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_LOW_U_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 13679*/    /*Scope*/ 20, /*->13700*/
/* 13680*/     OPC_CheckChild0Type, MVT::v8i16,
/* 13682*/     OPC_MoveSibling1,
/* 13683*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_U),
/* 13686*/     OPC_RecordChild0, // #1 = $rhs
/* 13687*/     OPC_CheckChild0Type, MVT::v8i16,
/* 13689*/     OPC_MoveParent,
/* 13690*/     OPC_CheckType, MVT::v4i32,
/* 13692*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13693*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_LOW_U_I32x4),
                   MVT::v4i32, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v4i32] } (extend_low_u:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs), (extend_low_u:{ *:[v4i32] } V128:{ *:[v8i16] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_LOW_U_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 13700*/    /*Scope*/ 20, /*->13721*/
/* 13701*/     OPC_CheckChild0Type, MVT::v4i32,
/* 13703*/     OPC_MoveSibling1,
/* 13704*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_U),
/* 13707*/     OPC_RecordChild0, // #1 = $rhs
/* 13708*/     OPC_CheckChild0Type, MVT::v4i32,
/* 13710*/     OPC_MoveParent,
/* 13711*/     OPC_CheckType, MVT::v2i64,
/* 13713*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13714*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_LOW_U_I64x2),
                   MVT::v2i64, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v2i64] } (extend_low_u:{ *:[v2i64] } V128:{ *:[v4i32] }:$lhs), (extend_low_u:{ *:[v2i64] } V128:{ *:[v4i32] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_LOW_U_I64x2:{ *:[v2i64] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 13721*/    0, /*End of Scope*/
/* 13722*/   /*SwitchOpcode*/ 66, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_U),// ->13791
/* 13725*/    OPC_RecordChild0, // #0 = $lhs
/* 13726*/    OPC_Scope, 20, /*->13748*/ // 3 children in Scope
/* 13728*/     OPC_CheckChild0Type, MVT::v16i8,
/* 13730*/     OPC_MoveSibling1,
/* 13731*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_U),
/* 13734*/     OPC_RecordChild0, // #1 = $rhs
/* 13735*/     OPC_CheckChild0Type, MVT::v16i8,
/* 13737*/     OPC_MoveParent,
/* 13738*/     OPC_CheckType, MVT::v8i16,
/* 13740*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13741*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_HIGH_U_I16x8),
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v8i16] } (extend_high_u:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs), (extend_high_u:{ *:[v8i16] } V128:{ *:[v16i8] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_HIGH_U_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 13748*/    /*Scope*/ 20, /*->13769*/
/* 13749*/     OPC_CheckChild0Type, MVT::v8i16,
/* 13751*/     OPC_MoveSibling1,
/* 13752*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_U),
/* 13755*/     OPC_RecordChild0, // #1 = $rhs
/* 13756*/     OPC_CheckChild0Type, MVT::v8i16,
/* 13758*/     OPC_MoveParent,
/* 13759*/     OPC_CheckType, MVT::v4i32,
/* 13761*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13762*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_HIGH_U_I32x4),
                   MVT::v4i32, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v4i32] } (extend_high_u:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs), (extend_high_u:{ *:[v4i32] } V128:{ *:[v8i16] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_HIGH_U_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 13769*/    /*Scope*/ 20, /*->13790*/
/* 13770*/     OPC_CheckChild0Type, MVT::v4i32,
/* 13772*/     OPC_MoveSibling1,
/* 13773*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_U),
/* 13776*/     OPC_RecordChild0, // #1 = $rhs
/* 13777*/     OPC_CheckChild0Type, MVT::v4i32,
/* 13779*/     OPC_MoveParent,
/* 13780*/     OPC_CheckType, MVT::v2i64,
/* 13782*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13783*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_HIGH_U_I64x2),
                   MVT::v2i64, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v2i64] } (extend_high_u:{ *:[v2i64] } V128:{ *:[v4i32] }:$lhs), (extend_high_u:{ *:[v2i64] } V128:{ *:[v4i32] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_HIGH_U_I64x2:{ *:[v2i64] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 13790*/    0, /*End of Scope*/
/* 13791*/   0, // EndSwitchOpcode
/* 13792*/  /*Scope*/ 34, /*->13827*/
/* 13793*/   OPC_RecordChild0, // #0 = $lhs
/* 13794*/   OPC_RecordChild1, // #1 = $rhs
/* 13795*/   OPC_SwitchType /*3 cases */, 8, MVT::v8i16,// ->13806
/* 13798*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13799*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_I16x8),
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (mul:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
              // Dst: (MUL_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 13806*/   /*SwitchType*/ 8, MVT::v4i32,// ->13816
/* 13808*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13809*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_I32x4),
                  MVT::v4i32, 2/*#Ops*/, 0, 1, 
              // Src: (mul:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
              // Dst: (MUL_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 13816*/   /*SwitchType*/ 8, MVT::v2i64,// ->13826
/* 13818*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13819*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_I64x2),
                  MVT::v2i64, 2/*#Ops*/, 0, 1, 
              // Src: (mul:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 3
              // Dst: (MUL_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/* 13826*/   0, // EndSwitchType
/* 13827*/  0, /*End of Scope*/
/* 13828*/ /*SwitchOpcode*/ 22, TARGET_VAL(ISD::SDIV),// ->13853
/* 13831*/  OPC_RecordChild0, // #0 = $lhs
/* 13832*/  OPC_RecordChild1, // #1 = $rhs
/* 13833*/  OPC_SwitchType /*2 cases */, 7, MVT::i32,// ->13843
/* 13836*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DIV_S_I32),
                 MVT::i32, 2/*#Ops*/, 0, 1, 
             // Src: (sdiv:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
             // Dst: (DIV_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 13843*/  /*SwitchType*/ 7, MVT::i64,// ->13852
/* 13845*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DIV_S_I64),
                 MVT::i64, 2/*#Ops*/, 0, 1, 
             // Src: (sdiv:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
             // Dst: (DIV_S_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 13852*/  0, // EndSwitchType
/* 13853*/ /*SwitchOpcode*/ 22, TARGET_VAL(ISD::UDIV),// ->13878
/* 13856*/  OPC_RecordChild0, // #0 = $lhs
/* 13857*/  OPC_RecordChild1, // #1 = $rhs
/* 13858*/  OPC_SwitchType /*2 cases */, 7, MVT::i32,// ->13868
/* 13861*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DIV_U_I32),
                 MVT::i32, 2/*#Ops*/, 0, 1, 
             // Src: (udiv:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
             // Dst: (DIV_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 13868*/  /*SwitchType*/ 7, MVT::i64,// ->13877
/* 13870*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DIV_U_I64),
                 MVT::i64, 2/*#Ops*/, 0, 1, 
             // Src: (udiv:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
             // Dst: (DIV_U_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 13877*/  0, // EndSwitchType
/* 13878*/ /*SwitchOpcode*/ 22, TARGET_VAL(ISD::SREM),// ->13903
/* 13881*/  OPC_RecordChild0, // #0 = $lhs
/* 13882*/  OPC_RecordChild1, // #1 = $rhs
/* 13883*/  OPC_SwitchType /*2 cases */, 7, MVT::i32,// ->13893
/* 13886*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REM_S_I32),
                 MVT::i32, 2/*#Ops*/, 0, 1, 
             // Src: (srem:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
             // Dst: (REM_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 13893*/  /*SwitchType*/ 7, MVT::i64,// ->13902
/* 13895*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REM_S_I64),
                 MVT::i64, 2/*#Ops*/, 0, 1, 
             // Src: (srem:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
             // Dst: (REM_S_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 13902*/  0, // EndSwitchType
/* 13903*/ /*SwitchOpcode*/ 22, TARGET_VAL(ISD::UREM),// ->13928
/* 13906*/  OPC_RecordChild0, // #0 = $lhs
/* 13907*/  OPC_RecordChild1, // #1 = $rhs
/* 13908*/  OPC_SwitchType /*2 cases */, 7, MVT::i32,// ->13918
/* 13911*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REM_U_I32),
                 MVT::i32, 2/*#Ops*/, 0, 1, 
             // Src: (urem:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
             // Dst: (REM_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 13918*/  /*SwitchType*/ 7, MVT::i64,// ->13927
/* 13920*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REM_U_I64),
                 MVT::i64, 2/*#Ops*/, 0, 1, 
             // Src: (urem:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
             // Dst: (REM_U_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 13927*/  0, // EndSwitchType
/* 13928*/ /*SwitchOpcode*/ 56|128,6/*824*/, TARGET_VAL(ISD::OR),// ->14756
/* 13932*/  OPC_Scope, 22, /*->13956*/ // 3 children in Scope
/* 13934*/   OPC_RecordChild0, // #0 = $lhs
/* 13935*/   OPC_RecordChild1, // #1 = $rhs
/* 13936*/   OPC_SwitchType /*2 cases */, 7, MVT::i32,// ->13946
/* 13939*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::OR_I32),
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (or:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (OR_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 13946*/   /*SwitchType*/ 7, MVT::i64,// ->13955
/* 13948*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::OR_I64),
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (or:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (OR_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 13955*/   0, // EndSwitchType
/* 13956*/  /*Scope*/ 116|128,5/*756*/, /*->14714*/
/* 13958*/   OPC_MoveChild0,
/* 13959*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 13962*/   OPC_Scope, 4|128,1/*132*/, /*->14097*/ // 9 children in Scope
/* 13965*/    OPC_RecordChild0, // #0 = $c
/* 13966*/    OPC_RecordChild1, // #1 = $v1
/* 13967*/    OPC_MoveSibling1,
/* 13968*/    OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 13971*/    OPC_Scope, 54, /*->14027*/ // 4 children in Scope
/* 13973*/     OPC_MoveChild0,
/* 13974*/     OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 13977*/     OPC_CheckChild0Same, 0,
/* 13979*/     OPC_MoveChild1,
/* 13980*/     OPC_CheckImmAllOnesV,
/* 13981*/     OPC_MoveParent,
/* 13982*/     OPC_MoveParent,
/* 13983*/     OPC_RecordChild1, // #2 = $v2
/* 13984*/     OPC_MoveParent,
/* 13985*/     OPC_SwitchType /*4 cases */, 8, MVT::v16i8,// ->13996
/* 13988*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v16i8, 3/*#Ops*/, 1, 2, 0, 
                // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, V128:{ *:[v16i8] }:$v1), (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$v2)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 13996*/     /*SwitchType*/ 8, MVT::v8i16,// ->14006
/* 13998*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v8i16, 3/*#Ops*/, 1, 2, 0, 
                // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, V128:{ *:[v8i16] }:$v1), (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$v2)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 14006*/     /*SwitchType*/ 8, MVT::v4i32,// ->14016
/* 14008*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v4i32, 3/*#Ops*/, 1, 2, 0, 
                // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, V128:{ *:[v4i32] }:$v1), (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$v2)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 14016*/     /*SwitchType*/ 8, MVT::v2i64,// ->14026
/* 14018*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v2i64, 3/*#Ops*/, 1, 2, 0, 
                // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, V128:{ *:[v2i64] }:$v1), (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$v2)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 14026*/     0, // EndSwitchType
/* 14027*/    /*Scope*/ 22, /*->14050*/
/* 14028*/     OPC_RecordChild0, // #2 = $v2
/* 14029*/     OPC_MoveChild1,
/* 14030*/     OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14033*/     OPC_CheckChild0Same, 0,
/* 14035*/     OPC_MoveChild1,
/* 14036*/     OPC_CheckImmAllOnesV,
/* 14037*/     OPC_MoveParent,
/* 14038*/     OPC_MoveParent,
/* 14039*/     OPC_MoveParent,
/* 14040*/     OPC_CheckType, MVT::v16i8,
/* 14042*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v16i8, 3/*#Ops*/, 1, 2, 0, 
               // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, V128:{ *:[v16i8] }:$v1), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 14050*/    /*Scope*/ 22, /*->14073*/
/* 14051*/     OPC_MoveChild0,
/* 14052*/     OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14055*/     OPC_CheckChild0Same, 1,
/* 14057*/     OPC_MoveChild1,
/* 14058*/     OPC_CheckImmAllOnesV,
/* 14059*/     OPC_MoveParent,
/* 14060*/     OPC_MoveParent,
/* 14061*/     OPC_RecordChild1, // #2 = $v2
/* 14062*/     OPC_MoveParent,
/* 14063*/     OPC_CheckType, MVT::v16i8,
/* 14065*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v16i8, 3/*#Ops*/, 0, 2, 1, 
               // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$c), (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$v2)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 14073*/    /*Scope*/ 22, /*->14096*/
/* 14074*/     OPC_RecordChild0, // #2 = $v2
/* 14075*/     OPC_MoveChild1,
/* 14076*/     OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14079*/     OPC_CheckChild0Same, 1,
/* 14081*/     OPC_MoveChild1,
/* 14082*/     OPC_CheckImmAllOnesV,
/* 14083*/     OPC_MoveParent,
/* 14084*/     OPC_MoveParent,
/* 14085*/     OPC_MoveParent,
/* 14086*/     OPC_CheckType, MVT::v16i8,
/* 14088*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v16i8, 3/*#Ops*/, 0, 2, 1, 
               // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$c), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 14096*/    0, /*End of Scope*/
/* 14097*/   /*Scope*/ 46, /*->14144*/
/* 14098*/    OPC_MoveChild0,
/* 14099*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14102*/    OPC_RecordChild0, // #0 = $c
/* 14103*/    OPC_MoveChild1,
/* 14104*/    OPC_CheckImmAllOnesV,
/* 14105*/    OPC_MoveParent,
/* 14106*/    OPC_MoveParent,
/* 14107*/    OPC_RecordChild1, // #1 = $v2
/* 14108*/    OPC_MoveSibling1,
/* 14109*/    OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14112*/    OPC_Scope, 14, /*->14128*/ // 2 children in Scope
/* 14114*/     OPC_CheckChild0Same, 0,
/* 14116*/     OPC_RecordChild1, // #2 = $v1
/* 14117*/     OPC_MoveParent,
/* 14118*/     OPC_CheckType, MVT::v16i8,
/* 14120*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v16i8, 3/*#Ops*/, 2, 1, 0, 
               // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$v2), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, V128:{ *:[v16i8] }:$v1)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 14128*/    /*Scope*/ 14, /*->14143*/
/* 14129*/     OPC_RecordChild0, // #2 = $v1
/* 14130*/     OPC_CheckChild1Same, 0,
/* 14132*/     OPC_MoveParent,
/* 14133*/     OPC_CheckType, MVT::v16i8,
/* 14135*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v16i8, 3/*#Ops*/, 2, 1, 0, 
               // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$v2), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$c)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 14143*/    0, /*End of Scope*/
/* 14144*/   /*Scope*/ 126, /*->14271*/
/* 14145*/    OPC_RecordChild0, // #0 = $v2
/* 14146*/    OPC_Scope, 45, /*->14193*/ // 2 children in Scope
/* 14148*/     OPC_MoveChild1,
/* 14149*/     OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14152*/     OPC_RecordChild0, // #1 = $c
/* 14153*/     OPC_MoveChild1,
/* 14154*/     OPC_CheckImmAllOnesV,
/* 14155*/     OPC_MoveParent,
/* 14156*/     OPC_MoveParent,
/* 14157*/     OPC_MoveSibling1,
/* 14158*/     OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14161*/     OPC_Scope, 14, /*->14177*/ // 2 children in Scope
/* 14163*/      OPC_CheckChild0Same, 1,
/* 14165*/      OPC_RecordChild1, // #2 = $v1
/* 14166*/      OPC_MoveParent,
/* 14167*/      OPC_CheckType, MVT::v16i8,
/* 14169*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v16i8, 3/*#Ops*/, 2, 0, 1, 
                // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] })), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, V128:{ *:[v16i8] }:$v1)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 14177*/     /*Scope*/ 14, /*->14192*/
/* 14178*/      OPC_RecordChild0, // #2 = $v1
/* 14179*/      OPC_CheckChild1Same, 1,
/* 14181*/      OPC_MoveParent,
/* 14182*/      OPC_CheckType, MVT::v16i8,
/* 14184*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v16i8, 3/*#Ops*/, 2, 0, 1, 
                // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] })), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$c)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 14192*/     0, /*End of Scope*/
/* 14193*/    /*Scope*/ 76, /*->14270*/
/* 14194*/     OPC_RecordChild1, // #1 = $v1
/* 14195*/     OPC_MoveSibling1,
/* 14196*/     OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14199*/     OPC_Scope, 22, /*->14223*/ // 3 children in Scope
/* 14201*/      OPC_RecordChild0, // #2 = $v2
/* 14202*/      OPC_MoveChild1,
/* 14203*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14206*/      OPC_CheckChild0Same, 0,
/* 14208*/      OPC_MoveChild1,
/* 14209*/      OPC_CheckImmAllOnesV,
/* 14210*/      OPC_MoveParent,
/* 14211*/      OPC_MoveParent,
/* 14212*/      OPC_MoveParent,
/* 14213*/      OPC_CheckType, MVT::v8i16,
/* 14215*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v8i16, 3/*#Ops*/, 1, 2, 0, 
                // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, V128:{ *:[v8i16] }:$v1), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }))) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 14223*/     /*Scope*/ 22, /*->14246*/
/* 14224*/      OPC_MoveChild0,
/* 14225*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14228*/      OPC_CheckChild0Same, 1,
/* 14230*/      OPC_MoveChild1,
/* 14231*/      OPC_CheckImmAllOnesV,
/* 14232*/      OPC_MoveParent,
/* 14233*/      OPC_MoveParent,
/* 14234*/      OPC_RecordChild1, // #2 = $v2
/* 14235*/      OPC_MoveParent,
/* 14236*/      OPC_CheckType, MVT::v8i16,
/* 14238*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v8i16, 3/*#Ops*/, 0, 2, 1, 
                // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$c), (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$v2)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 14246*/     /*Scope*/ 22, /*->14269*/
/* 14247*/      OPC_RecordChild0, // #2 = $v2
/* 14248*/      OPC_MoveChild1,
/* 14249*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14252*/      OPC_CheckChild0Same, 1,
/* 14254*/      OPC_MoveChild1,
/* 14255*/      OPC_CheckImmAllOnesV,
/* 14256*/      OPC_MoveParent,
/* 14257*/      OPC_MoveParent,
/* 14258*/      OPC_MoveParent,
/* 14259*/      OPC_CheckType, MVT::v8i16,
/* 14261*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v8i16, 3/*#Ops*/, 0, 2, 1, 
                // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$c), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }))) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 14269*/     0, /*End of Scope*/
/* 14270*/    0, /*End of Scope*/
/* 14271*/   /*Scope*/ 46, /*->14318*/
/* 14272*/    OPC_MoveChild0,
/* 14273*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14276*/    OPC_RecordChild0, // #0 = $c
/* 14277*/    OPC_MoveChild1,
/* 14278*/    OPC_CheckImmAllOnesV,
/* 14279*/    OPC_MoveParent,
/* 14280*/    OPC_MoveParent,
/* 14281*/    OPC_RecordChild1, // #1 = $v2
/* 14282*/    OPC_MoveSibling1,
/* 14283*/    OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14286*/    OPC_Scope, 14, /*->14302*/ // 2 children in Scope
/* 14288*/     OPC_CheckChild0Same, 0,
/* 14290*/     OPC_RecordChild1, // #2 = $v1
/* 14291*/     OPC_MoveParent,
/* 14292*/     OPC_CheckType, MVT::v8i16,
/* 14294*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v8i16, 3/*#Ops*/, 2, 1, 0, 
               // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$v2), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, V128:{ *:[v8i16] }:$v1)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 14302*/    /*Scope*/ 14, /*->14317*/
/* 14303*/     OPC_RecordChild0, // #2 = $v1
/* 14304*/     OPC_CheckChild1Same, 0,
/* 14306*/     OPC_MoveParent,
/* 14307*/     OPC_CheckType, MVT::v8i16,
/* 14309*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v8i16, 3/*#Ops*/, 2, 1, 0, 
               // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$v2), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$c)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 14317*/    0, /*End of Scope*/
/* 14318*/   /*Scope*/ 126, /*->14445*/
/* 14319*/    OPC_RecordChild0, // #0 = $v2
/* 14320*/    OPC_Scope, 45, /*->14367*/ // 2 children in Scope
/* 14322*/     OPC_MoveChild1,
/* 14323*/     OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14326*/     OPC_RecordChild0, // #1 = $c
/* 14327*/     OPC_MoveChild1,
/* 14328*/     OPC_CheckImmAllOnesV,
/* 14329*/     OPC_MoveParent,
/* 14330*/     OPC_MoveParent,
/* 14331*/     OPC_MoveSibling1,
/* 14332*/     OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14335*/     OPC_Scope, 14, /*->14351*/ // 2 children in Scope
/* 14337*/      OPC_CheckChild0Same, 1,
/* 14339*/      OPC_RecordChild1, // #2 = $v1
/* 14340*/      OPC_MoveParent,
/* 14341*/      OPC_CheckType, MVT::v8i16,
/* 14343*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v8i16, 3/*#Ops*/, 2, 0, 1, 
                // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] })), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, V128:{ *:[v8i16] }:$v1)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 14351*/     /*Scope*/ 14, /*->14366*/
/* 14352*/      OPC_RecordChild0, // #2 = $v1
/* 14353*/      OPC_CheckChild1Same, 1,
/* 14355*/      OPC_MoveParent,
/* 14356*/      OPC_CheckType, MVT::v8i16,
/* 14358*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v8i16, 3/*#Ops*/, 2, 0, 1, 
                // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] })), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$c)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 14366*/     0, /*End of Scope*/
/* 14367*/    /*Scope*/ 76, /*->14444*/
/* 14368*/     OPC_RecordChild1, // #1 = $v1
/* 14369*/     OPC_MoveSibling1,
/* 14370*/     OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14373*/     OPC_Scope, 22, /*->14397*/ // 3 children in Scope
/* 14375*/      OPC_RecordChild0, // #2 = $v2
/* 14376*/      OPC_MoveChild1,
/* 14377*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14380*/      OPC_CheckChild0Same, 0,
/* 14382*/      OPC_MoveChild1,
/* 14383*/      OPC_CheckImmAllOnesV,
/* 14384*/      OPC_MoveParent,
/* 14385*/      OPC_MoveParent,
/* 14386*/      OPC_MoveParent,
/* 14387*/      OPC_CheckType, MVT::v4i32,
/* 14389*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v4i32, 3/*#Ops*/, 1, 2, 0, 
                // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, V128:{ *:[v4i32] }:$v1), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }))) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 14397*/     /*Scope*/ 22, /*->14420*/
/* 14398*/      OPC_MoveChild0,
/* 14399*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14402*/      OPC_CheckChild0Same, 1,
/* 14404*/      OPC_MoveChild1,
/* 14405*/      OPC_CheckImmAllOnesV,
/* 14406*/      OPC_MoveParent,
/* 14407*/      OPC_MoveParent,
/* 14408*/      OPC_RecordChild1, // #2 = $v2
/* 14409*/      OPC_MoveParent,
/* 14410*/      OPC_CheckType, MVT::v4i32,
/* 14412*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v4i32, 3/*#Ops*/, 0, 2, 1, 
                // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$c), (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$v2)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 14420*/     /*Scope*/ 22, /*->14443*/
/* 14421*/      OPC_RecordChild0, // #2 = $v2
/* 14422*/      OPC_MoveChild1,
/* 14423*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14426*/      OPC_CheckChild0Same, 1,
/* 14428*/      OPC_MoveChild1,
/* 14429*/      OPC_CheckImmAllOnesV,
/* 14430*/      OPC_MoveParent,
/* 14431*/      OPC_MoveParent,
/* 14432*/      OPC_MoveParent,
/* 14433*/      OPC_CheckType, MVT::v4i32,
/* 14435*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v4i32, 3/*#Ops*/, 0, 2, 1, 
                // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$c), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }))) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 14443*/     0, /*End of Scope*/
/* 14444*/    0, /*End of Scope*/
/* 14445*/   /*Scope*/ 46, /*->14492*/
/* 14446*/    OPC_MoveChild0,
/* 14447*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14450*/    OPC_RecordChild0, // #0 = $c
/* 14451*/    OPC_MoveChild1,
/* 14452*/    OPC_CheckImmAllOnesV,
/* 14453*/    OPC_MoveParent,
/* 14454*/    OPC_MoveParent,
/* 14455*/    OPC_RecordChild1, // #1 = $v2
/* 14456*/    OPC_MoveSibling1,
/* 14457*/    OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14460*/    OPC_Scope, 14, /*->14476*/ // 2 children in Scope
/* 14462*/     OPC_CheckChild0Same, 0,
/* 14464*/     OPC_RecordChild1, // #2 = $v1
/* 14465*/     OPC_MoveParent,
/* 14466*/     OPC_CheckType, MVT::v4i32,
/* 14468*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v4i32, 3/*#Ops*/, 2, 1, 0, 
               // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$v2), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, V128:{ *:[v4i32] }:$v1)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 14476*/    /*Scope*/ 14, /*->14491*/
/* 14477*/     OPC_RecordChild0, // #2 = $v1
/* 14478*/     OPC_CheckChild1Same, 0,
/* 14480*/     OPC_MoveParent,
/* 14481*/     OPC_CheckType, MVT::v4i32,
/* 14483*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v4i32, 3/*#Ops*/, 2, 1, 0, 
               // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$v2), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$c)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 14491*/    0, /*End of Scope*/
/* 14492*/   /*Scope*/ 126, /*->14619*/
/* 14493*/    OPC_RecordChild0, // #0 = $v2
/* 14494*/    OPC_Scope, 45, /*->14541*/ // 2 children in Scope
/* 14496*/     OPC_MoveChild1,
/* 14497*/     OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14500*/     OPC_RecordChild0, // #1 = $c
/* 14501*/     OPC_MoveChild1,
/* 14502*/     OPC_CheckImmAllOnesV,
/* 14503*/     OPC_MoveParent,
/* 14504*/     OPC_MoveParent,
/* 14505*/     OPC_MoveSibling1,
/* 14506*/     OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14509*/     OPC_Scope, 14, /*->14525*/ // 2 children in Scope
/* 14511*/      OPC_CheckChild0Same, 1,
/* 14513*/      OPC_RecordChild1, // #2 = $v1
/* 14514*/      OPC_MoveParent,
/* 14515*/      OPC_CheckType, MVT::v4i32,
/* 14517*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v4i32, 3/*#Ops*/, 2, 0, 1, 
                // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] })), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, V128:{ *:[v4i32] }:$v1)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 14525*/     /*Scope*/ 14, /*->14540*/
/* 14526*/      OPC_RecordChild0, // #2 = $v1
/* 14527*/      OPC_CheckChild1Same, 1,
/* 14529*/      OPC_MoveParent,
/* 14530*/      OPC_CheckType, MVT::v4i32,
/* 14532*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v4i32, 3/*#Ops*/, 2, 0, 1, 
                // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] })), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$c)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 14540*/     0, /*End of Scope*/
/* 14541*/    /*Scope*/ 76, /*->14618*/
/* 14542*/     OPC_RecordChild1, // #1 = $v1
/* 14543*/     OPC_MoveSibling1,
/* 14544*/     OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14547*/     OPC_Scope, 22, /*->14571*/ // 3 children in Scope
/* 14549*/      OPC_RecordChild0, // #2 = $v2
/* 14550*/      OPC_MoveChild1,
/* 14551*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14554*/      OPC_CheckChild0Same, 0,
/* 14556*/      OPC_MoveChild1,
/* 14557*/      OPC_CheckImmAllOnesV,
/* 14558*/      OPC_MoveParent,
/* 14559*/      OPC_MoveParent,
/* 14560*/      OPC_MoveParent,
/* 14561*/      OPC_CheckType, MVT::v2i64,
/* 14563*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v2i64, 3/*#Ops*/, 1, 2, 0, 
                // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, V128:{ *:[v2i64] }:$v1), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }))) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 14571*/     /*Scope*/ 22, /*->14594*/
/* 14572*/      OPC_MoveChild0,
/* 14573*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14576*/      OPC_CheckChild0Same, 1,
/* 14578*/      OPC_MoveChild1,
/* 14579*/      OPC_CheckImmAllOnesV,
/* 14580*/      OPC_MoveParent,
/* 14581*/      OPC_MoveParent,
/* 14582*/      OPC_RecordChild1, // #2 = $v2
/* 14583*/      OPC_MoveParent,
/* 14584*/      OPC_CheckType, MVT::v2i64,
/* 14586*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v2i64, 3/*#Ops*/, 0, 2, 1, 
                // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$c), (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$v2)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 14594*/     /*Scope*/ 22, /*->14617*/
/* 14595*/      OPC_RecordChild0, // #2 = $v2
/* 14596*/      OPC_MoveChild1,
/* 14597*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14600*/      OPC_CheckChild0Same, 1,
/* 14602*/      OPC_MoveChild1,
/* 14603*/      OPC_CheckImmAllOnesV,
/* 14604*/      OPC_MoveParent,
/* 14605*/      OPC_MoveParent,
/* 14606*/      OPC_MoveParent,
/* 14607*/      OPC_CheckType, MVT::v2i64,
/* 14609*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v2i64, 3/*#Ops*/, 0, 2, 1, 
                // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$c), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }))) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 14617*/     0, /*End of Scope*/
/* 14618*/    0, /*End of Scope*/
/* 14619*/   /*Scope*/ 46, /*->14666*/
/* 14620*/    OPC_MoveChild0,
/* 14621*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14624*/    OPC_RecordChild0, // #0 = $c
/* 14625*/    OPC_MoveChild1,
/* 14626*/    OPC_CheckImmAllOnesV,
/* 14627*/    OPC_MoveParent,
/* 14628*/    OPC_MoveParent,
/* 14629*/    OPC_RecordChild1, // #1 = $v2
/* 14630*/    OPC_MoveSibling1,
/* 14631*/    OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14634*/    OPC_Scope, 14, /*->14650*/ // 2 children in Scope
/* 14636*/     OPC_CheckChild0Same, 0,
/* 14638*/     OPC_RecordChild1, // #2 = $v1
/* 14639*/     OPC_MoveParent,
/* 14640*/     OPC_CheckType, MVT::v2i64,
/* 14642*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v2i64, 3/*#Ops*/, 2, 1, 0, 
               // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$v2), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, V128:{ *:[v2i64] }:$v1)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 14650*/    /*Scope*/ 14, /*->14665*/
/* 14651*/     OPC_RecordChild0, // #2 = $v1
/* 14652*/     OPC_CheckChild1Same, 0,
/* 14654*/     OPC_MoveParent,
/* 14655*/     OPC_CheckType, MVT::v2i64,
/* 14657*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v2i64, 3/*#Ops*/, 2, 1, 0, 
               // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$v2), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$c)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 14665*/    0, /*End of Scope*/
/* 14666*/   /*Scope*/ 46, /*->14713*/
/* 14667*/    OPC_RecordChild0, // #0 = $v2
/* 14668*/    OPC_MoveChild1,
/* 14669*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14672*/    OPC_RecordChild0, // #1 = $c
/* 14673*/    OPC_MoveChild1,
/* 14674*/    OPC_CheckImmAllOnesV,
/* 14675*/    OPC_MoveParent,
/* 14676*/    OPC_MoveParent,
/* 14677*/    OPC_MoveSibling1,
/* 14678*/    OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14681*/    OPC_Scope, 14, /*->14697*/ // 2 children in Scope
/* 14683*/     OPC_CheckChild0Same, 1,
/* 14685*/     OPC_RecordChild1, // #2 = $v1
/* 14686*/     OPC_MoveParent,
/* 14687*/     OPC_CheckType, MVT::v2i64,
/* 14689*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v2i64, 3/*#Ops*/, 2, 0, 1, 
               // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] })), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, V128:{ *:[v2i64] }:$v1)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 14697*/    /*Scope*/ 14, /*->14712*/
/* 14698*/     OPC_RecordChild0, // #2 = $v1
/* 14699*/     OPC_CheckChild1Same, 1,
/* 14701*/     OPC_MoveParent,
/* 14702*/     OPC_CheckType, MVT::v2i64,
/* 14704*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v2i64, 3/*#Ops*/, 2, 0, 1, 
               // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] })), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$c)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 14712*/    0, /*End of Scope*/
/* 14713*/   0, /*End of Scope*/
/* 14714*/  /*Scope*/ 40, /*->14755*/
/* 14715*/   OPC_RecordChild0, // #0 = $lhs
/* 14716*/   OPC_RecordChild1, // #1 = $rhs
/* 14717*/   OPC_SwitchType /*4 cases */, 7, MVT::v16i8,// ->14727
/* 14720*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::OR),
                  MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (or:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
              // Dst: (OR:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs)
/* 14727*/   /*SwitchType*/ 7, MVT::v8i16,// ->14736
/* 14729*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::OR),
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (or:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
              // Dst: (OR:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/* 14736*/   /*SwitchType*/ 7, MVT::v4i32,// ->14745
/* 14738*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::OR),
                  MVT::v4i32, 2/*#Ops*/, 0, 1, 
              // Src: (or:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
              // Dst: (OR:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs)
/* 14745*/   /*SwitchType*/ 7, MVT::v2i64,// ->14754
/* 14747*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::OR),
                  MVT::v2i64, 2/*#Ops*/, 0, 1, 
              // Src: (or:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 3
              // Dst: (OR:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs)
/* 14754*/   0, // EndSwitchType
/* 14755*/  0, /*End of Scope*/
/* 14756*/ /*SwitchOpcode*/ 121|128,11/*1529*/, TARGET_VAL(ISD::XOR),// ->16289
/* 14760*/  OPC_Scope, 22, /*->14784*/ // 17 children in Scope
/* 14762*/   OPC_RecordChild0, // #0 = $lhs
/* 14763*/   OPC_RecordChild1, // #1 = $rhs
/* 14764*/   OPC_SwitchType /*2 cases */, 7, MVT::i32,// ->14774
/* 14767*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::XOR_I32),
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (xor:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (XOR_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 14774*/   /*SwitchType*/ 7, MVT::i64,// ->14783
/* 14776*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::XOR_I64),
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (xor:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (XOR_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 14783*/   0, // EndSwitchType
/* 14784*/  /*Scope*/ 121, /*->14906*/
/* 14785*/   OPC_MoveChild0,
/* 14786*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14789*/   OPC_MoveChild0,
/* 14790*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14793*/   OPC_RecordChild0, // #0 = $v1
/* 14794*/   OPC_Scope, 71, /*->14867*/ // 2 children in Scope
/* 14796*/    OPC_RecordChild1, // #1 = $v2
/* 14797*/    OPC_MoveSibling1,
/* 14798*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14801*/    OPC_RecordChild0, // #2 = $c
/* 14802*/    OPC_MoveChild1,
/* 14803*/    OPC_CheckImmAllOnesV,
/* 14804*/    OPC_MoveParent,
/* 14805*/    OPC_MoveParent,
/* 14806*/    OPC_MoveParent,
/* 14807*/    OPC_Scope, 44, /*->14853*/ // 2 children in Scope
/* 14809*/     OPC_CheckChild1Same, 1,
/* 14811*/     OPC_SwitchType /*4 cases */, 8, MVT::v16i8,// ->14822
/* 14814*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v16i8, 3/*#Ops*/, 1, 0, 2, 
                // Src: (xor:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2), (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] })), V128:{ *:[v16i8] }:$v2) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$c)
/* 14822*/     /*SwitchType*/ 8, MVT::v8i16,// ->14832
/* 14824*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v8i16, 3/*#Ops*/, 1, 0, 2, 
                // Src: (xor:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2), (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] })), V128:{ *:[v8i16] }:$v2) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$c)
/* 14832*/     /*SwitchType*/ 8, MVT::v4i32,// ->14842
/* 14834*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v4i32, 3/*#Ops*/, 1, 0, 2, 
                // Src: (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2), (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] })), V128:{ *:[v4i32] }:$v2) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$c)
/* 14842*/     /*SwitchType*/ 8, MVT::v2i64,// ->14852
/* 14844*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v2i64, 3/*#Ops*/, 1, 0, 2, 
                // Src: (xor:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2), (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] })), V128:{ *:[v2i64] }:$v2) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$c)
/* 14852*/     0, // EndSwitchType
/* 14853*/    /*Scope*/ 12, /*->14866*/
/* 14854*/     OPC_CheckChild1Same, 0,
/* 14856*/     OPC_CheckType, MVT::v16i8,
/* 14858*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v16i8, 3/*#Ops*/, 0, 1, 2, 
               // Src: (xor:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$v1), (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] })), V128:{ *:[v16i8] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$c)
/* 14866*/    0, /*End of Scope*/
/* 14867*/   /*Scope*/ 37, /*->14905*/
/* 14868*/    OPC_MoveChild1,
/* 14869*/    OPC_CheckImmAllOnesV,
/* 14870*/    OPC_MoveParent,
/* 14871*/    OPC_MoveSibling1,
/* 14872*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14875*/    OPC_RecordChild0, // #1 = $v1
/* 14876*/    OPC_RecordChild1, // #2 = $v2
/* 14877*/    OPC_MoveParent,
/* 14878*/    OPC_MoveParent,
/* 14879*/    OPC_CheckType, MVT::v16i8,
/* 14881*/    OPC_Scope, 10, /*->14893*/ // 2 children in Scope
/* 14883*/     OPC_CheckChild1Same, 2,
/* 14885*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v16i8, 3/*#Ops*/, 2, 1, 0, 
               // Src: (xor:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }), (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2)), V128:{ *:[v16i8] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$c)
/* 14893*/    /*Scope*/ 10, /*->14904*/
/* 14894*/     OPC_CheckChild1Same, 1,
/* 14896*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v16i8, 3/*#Ops*/, 1, 2, 0, 
               // Src: (xor:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }), (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$v1)), V128:{ *:[v16i8] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$c)
/* 14904*/    0, /*End of Scope*/
/* 14905*/   0, /*End of Scope*/
/* 14906*/  /*Scope*/ 102, /*->15009*/
/* 14907*/   OPC_RecordChild0, // #0 = $v2
/* 14908*/   OPC_MoveChild1,
/* 14909*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14912*/   OPC_MoveChild0,
/* 14913*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14916*/   OPC_Scope, 23, /*->14941*/ // 3 children in Scope
/* 14918*/    OPC_RecordChild0, // #1 = $v1
/* 14919*/    OPC_CheckChild1Same, 0,
/* 14921*/    OPC_MoveSibling1,
/* 14922*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14925*/    OPC_RecordChild0, // #2 = $c
/* 14926*/    OPC_MoveChild1,
/* 14927*/    OPC_CheckImmAllOnesV,
/* 14928*/    OPC_MoveParent,
/* 14929*/    OPC_MoveParent,
/* 14930*/    OPC_MoveParent,
/* 14931*/    OPC_CheckType, MVT::v16i8,
/* 14933*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v16i8, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2), (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }))) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$c)
/* 14941*/   /*Scope*/ 23, /*->14965*/
/* 14942*/    OPC_CheckChild0Same, 0,
/* 14944*/    OPC_RecordChild1, // #1 = $v1
/* 14945*/    OPC_MoveSibling1,
/* 14946*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14949*/    OPC_RecordChild0, // #2 = $c
/* 14950*/    OPC_MoveChild1,
/* 14951*/    OPC_CheckImmAllOnesV,
/* 14952*/    OPC_MoveParent,
/* 14953*/    OPC_MoveParent,
/* 14954*/    OPC_MoveParent,
/* 14955*/    OPC_CheckType, MVT::v16i8,
/* 14957*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v16i8, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$v1), (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }))) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$c)
/* 14965*/   /*Scope*/ 42, /*->15008*/
/* 14966*/    OPC_RecordChild0, // #1 = $c
/* 14967*/    OPC_MoveChild1,
/* 14968*/    OPC_CheckImmAllOnesV,
/* 14969*/    OPC_MoveParent,
/* 14970*/    OPC_MoveSibling1,
/* 14971*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14974*/    OPC_Scope, 15, /*->14991*/ // 2 children in Scope
/* 14976*/     OPC_RecordChild0, // #2 = $v1
/* 14977*/     OPC_CheckChild1Same, 0,
/* 14979*/     OPC_MoveParent,
/* 14980*/     OPC_MoveParent,
/* 14981*/     OPC_CheckType, MVT::v16i8,
/* 14983*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v16i8, 3/*#Ops*/, 0, 2, 1, 
               // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }), (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$c)
/* 14991*/    /*Scope*/ 15, /*->15007*/
/* 14992*/     OPC_CheckChild0Same, 0,
/* 14994*/     OPC_RecordChild1, // #2 = $v1
/* 14995*/     OPC_MoveParent,
/* 14996*/     OPC_MoveParent,
/* 14997*/     OPC_CheckType, MVT::v16i8,
/* 14999*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v16i8, 3/*#Ops*/, 0, 2, 1, 
               // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }), (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$v1))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$c)
/* 15007*/    0, /*End of Scope*/
/* 15008*/   0, /*End of Scope*/
/* 15009*/  /*Scope*/ 73, /*->15083*/
/* 15010*/   OPC_MoveChild0,
/* 15011*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15014*/   OPC_MoveChild0,
/* 15015*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15018*/   OPC_RecordChild0, // #0 = $v2
/* 15019*/   OPC_Scope, 23, /*->15044*/ // 2 children in Scope
/* 15021*/    OPC_RecordChild1, // #1 = $v1
/* 15022*/    OPC_MoveSibling1,
/* 15023*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15026*/    OPC_RecordChild0, // #2 = $c
/* 15027*/    OPC_MoveChild1,
/* 15028*/    OPC_CheckImmAllOnesV,
/* 15029*/    OPC_MoveParent,
/* 15030*/    OPC_MoveParent,
/* 15031*/    OPC_MoveParent,
/* 15032*/    OPC_CheckChild1Same, 0,
/* 15034*/    OPC_CheckType, MVT::v8i16,
/* 15036*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v8i16, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$v1), (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] })), V128:{ *:[v8i16] }:$v2) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$c)
/* 15044*/   /*Scope*/ 37, /*->15082*/
/* 15045*/    OPC_MoveChild1,
/* 15046*/    OPC_CheckImmAllOnesV,
/* 15047*/    OPC_MoveParent,
/* 15048*/    OPC_MoveSibling1,
/* 15049*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15052*/    OPC_RecordChild0, // #1 = $v1
/* 15053*/    OPC_RecordChild1, // #2 = $v2
/* 15054*/    OPC_MoveParent,
/* 15055*/    OPC_MoveParent,
/* 15056*/    OPC_CheckType, MVT::v8i16,
/* 15058*/    OPC_Scope, 10, /*->15070*/ // 2 children in Scope
/* 15060*/     OPC_CheckChild1Same, 2,
/* 15062*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v8i16, 3/*#Ops*/, 2, 1, 0, 
               // Src: (xor:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }), (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2)), V128:{ *:[v8i16] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$c)
/* 15070*/    /*Scope*/ 10, /*->15081*/
/* 15071*/     OPC_CheckChild1Same, 1,
/* 15073*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v8i16, 3/*#Ops*/, 1, 2, 0, 
               // Src: (xor:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }), (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$v1)), V128:{ *:[v8i16] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$c)
/* 15081*/    0, /*End of Scope*/
/* 15082*/   0, /*End of Scope*/
/* 15083*/  /*Scope*/ 102, /*->15186*/
/* 15084*/   OPC_RecordChild0, // #0 = $v2
/* 15085*/   OPC_MoveChild1,
/* 15086*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15089*/   OPC_MoveChild0,
/* 15090*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15093*/   OPC_Scope, 23, /*->15118*/ // 3 children in Scope
/* 15095*/    OPC_RecordChild0, // #1 = $v1
/* 15096*/    OPC_CheckChild1Same, 0,
/* 15098*/    OPC_MoveSibling1,
/* 15099*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15102*/    OPC_RecordChild0, // #2 = $c
/* 15103*/    OPC_MoveChild1,
/* 15104*/    OPC_CheckImmAllOnesV,
/* 15105*/    OPC_MoveParent,
/* 15106*/    OPC_MoveParent,
/* 15107*/    OPC_MoveParent,
/* 15108*/    OPC_CheckType, MVT::v8i16,
/* 15110*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v8i16, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2), (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }))) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$c)
/* 15118*/   /*Scope*/ 23, /*->15142*/
/* 15119*/    OPC_CheckChild0Same, 0,
/* 15121*/    OPC_RecordChild1, // #1 = $v1
/* 15122*/    OPC_MoveSibling1,
/* 15123*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15126*/    OPC_RecordChild0, // #2 = $c
/* 15127*/    OPC_MoveChild1,
/* 15128*/    OPC_CheckImmAllOnesV,
/* 15129*/    OPC_MoveParent,
/* 15130*/    OPC_MoveParent,
/* 15131*/    OPC_MoveParent,
/* 15132*/    OPC_CheckType, MVT::v8i16,
/* 15134*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v8i16, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$v1), (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }))) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$c)
/* 15142*/   /*Scope*/ 42, /*->15185*/
/* 15143*/    OPC_RecordChild0, // #1 = $c
/* 15144*/    OPC_MoveChild1,
/* 15145*/    OPC_CheckImmAllOnesV,
/* 15146*/    OPC_MoveParent,
/* 15147*/    OPC_MoveSibling1,
/* 15148*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15151*/    OPC_Scope, 15, /*->15168*/ // 2 children in Scope
/* 15153*/     OPC_RecordChild0, // #2 = $v1
/* 15154*/     OPC_CheckChild1Same, 0,
/* 15156*/     OPC_MoveParent,
/* 15157*/     OPC_MoveParent,
/* 15158*/     OPC_CheckType, MVT::v8i16,
/* 15160*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v8i16, 3/*#Ops*/, 0, 2, 1, 
               // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }), (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$c)
/* 15168*/    /*Scope*/ 15, /*->15184*/
/* 15169*/     OPC_CheckChild0Same, 0,
/* 15171*/     OPC_RecordChild1, // #2 = $v1
/* 15172*/     OPC_MoveParent,
/* 15173*/     OPC_MoveParent,
/* 15174*/     OPC_CheckType, MVT::v8i16,
/* 15176*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v8i16, 3/*#Ops*/, 0, 2, 1, 
               // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }), (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$v1))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$c)
/* 15184*/    0, /*End of Scope*/
/* 15185*/   0, /*End of Scope*/
/* 15186*/  /*Scope*/ 73, /*->15260*/
/* 15187*/   OPC_MoveChild0,
/* 15188*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15191*/   OPC_MoveChild0,
/* 15192*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15195*/   OPC_RecordChild0, // #0 = $v2
/* 15196*/   OPC_Scope, 23, /*->15221*/ // 2 children in Scope
/* 15198*/    OPC_RecordChild1, // #1 = $v1
/* 15199*/    OPC_MoveSibling1,
/* 15200*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15203*/    OPC_RecordChild0, // #2 = $c
/* 15204*/    OPC_MoveChild1,
/* 15205*/    OPC_CheckImmAllOnesV,
/* 15206*/    OPC_MoveParent,
/* 15207*/    OPC_MoveParent,
/* 15208*/    OPC_MoveParent,
/* 15209*/    OPC_CheckChild1Same, 0,
/* 15211*/    OPC_CheckType, MVT::v4i32,
/* 15213*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v4i32, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$v1), (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] })), V128:{ *:[v4i32] }:$v2) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$c)
/* 15221*/   /*Scope*/ 37, /*->15259*/
/* 15222*/    OPC_MoveChild1,
/* 15223*/    OPC_CheckImmAllOnesV,
/* 15224*/    OPC_MoveParent,
/* 15225*/    OPC_MoveSibling1,
/* 15226*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15229*/    OPC_RecordChild0, // #1 = $v1
/* 15230*/    OPC_RecordChild1, // #2 = $v2
/* 15231*/    OPC_MoveParent,
/* 15232*/    OPC_MoveParent,
/* 15233*/    OPC_CheckType, MVT::v4i32,
/* 15235*/    OPC_Scope, 10, /*->15247*/ // 2 children in Scope
/* 15237*/     OPC_CheckChild1Same, 2,
/* 15239*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v4i32, 3/*#Ops*/, 2, 1, 0, 
               // Src: (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }), (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2)), V128:{ *:[v4i32] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$c)
/* 15247*/    /*Scope*/ 10, /*->15258*/
/* 15248*/     OPC_CheckChild1Same, 1,
/* 15250*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v4i32, 3/*#Ops*/, 1, 2, 0, 
               // Src: (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }), (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$v1)), V128:{ *:[v4i32] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$c)
/* 15258*/    0, /*End of Scope*/
/* 15259*/   0, /*End of Scope*/
/* 15260*/  /*Scope*/ 102, /*->15363*/
/* 15261*/   OPC_RecordChild0, // #0 = $v2
/* 15262*/   OPC_MoveChild1,
/* 15263*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15266*/   OPC_MoveChild0,
/* 15267*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15270*/   OPC_Scope, 23, /*->15295*/ // 3 children in Scope
/* 15272*/    OPC_RecordChild0, // #1 = $v1
/* 15273*/    OPC_CheckChild1Same, 0,
/* 15275*/    OPC_MoveSibling1,
/* 15276*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15279*/    OPC_RecordChild0, // #2 = $c
/* 15280*/    OPC_MoveChild1,
/* 15281*/    OPC_CheckImmAllOnesV,
/* 15282*/    OPC_MoveParent,
/* 15283*/    OPC_MoveParent,
/* 15284*/    OPC_MoveParent,
/* 15285*/    OPC_CheckType, MVT::v4i32,
/* 15287*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v4i32, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2), (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }))) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$c)
/* 15295*/   /*Scope*/ 23, /*->15319*/
/* 15296*/    OPC_CheckChild0Same, 0,
/* 15298*/    OPC_RecordChild1, // #1 = $v1
/* 15299*/    OPC_MoveSibling1,
/* 15300*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15303*/    OPC_RecordChild0, // #2 = $c
/* 15304*/    OPC_MoveChild1,
/* 15305*/    OPC_CheckImmAllOnesV,
/* 15306*/    OPC_MoveParent,
/* 15307*/    OPC_MoveParent,
/* 15308*/    OPC_MoveParent,
/* 15309*/    OPC_CheckType, MVT::v4i32,
/* 15311*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v4i32, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$v1), (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }))) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$c)
/* 15319*/   /*Scope*/ 42, /*->15362*/
/* 15320*/    OPC_RecordChild0, // #1 = $c
/* 15321*/    OPC_MoveChild1,
/* 15322*/    OPC_CheckImmAllOnesV,
/* 15323*/    OPC_MoveParent,
/* 15324*/    OPC_MoveSibling1,
/* 15325*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15328*/    OPC_Scope, 15, /*->15345*/ // 2 children in Scope
/* 15330*/     OPC_RecordChild0, // #2 = $v1
/* 15331*/     OPC_CheckChild1Same, 0,
/* 15333*/     OPC_MoveParent,
/* 15334*/     OPC_MoveParent,
/* 15335*/     OPC_CheckType, MVT::v4i32,
/* 15337*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v4i32, 3/*#Ops*/, 0, 2, 1, 
               // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }), (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$c)
/* 15345*/    /*Scope*/ 15, /*->15361*/
/* 15346*/     OPC_CheckChild0Same, 0,
/* 15348*/     OPC_RecordChild1, // #2 = $v1
/* 15349*/     OPC_MoveParent,
/* 15350*/     OPC_MoveParent,
/* 15351*/     OPC_CheckType, MVT::v4i32,
/* 15353*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v4i32, 3/*#Ops*/, 0, 2, 1, 
               // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }), (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$v1))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$c)
/* 15361*/    0, /*End of Scope*/
/* 15362*/   0, /*End of Scope*/
/* 15363*/  /*Scope*/ 73, /*->15437*/
/* 15364*/   OPC_MoveChild0,
/* 15365*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15368*/   OPC_MoveChild0,
/* 15369*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15372*/   OPC_RecordChild0, // #0 = $v2
/* 15373*/   OPC_Scope, 23, /*->15398*/ // 2 children in Scope
/* 15375*/    OPC_RecordChild1, // #1 = $v1
/* 15376*/    OPC_MoveSibling1,
/* 15377*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15380*/    OPC_RecordChild0, // #2 = $c
/* 15381*/    OPC_MoveChild1,
/* 15382*/    OPC_CheckImmAllOnesV,
/* 15383*/    OPC_MoveParent,
/* 15384*/    OPC_MoveParent,
/* 15385*/    OPC_MoveParent,
/* 15386*/    OPC_CheckChild1Same, 0,
/* 15388*/    OPC_CheckType, MVT::v2i64,
/* 15390*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v2i64, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$v1), (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] })), V128:{ *:[v2i64] }:$v2) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$c)
/* 15398*/   /*Scope*/ 37, /*->15436*/
/* 15399*/    OPC_MoveChild1,
/* 15400*/    OPC_CheckImmAllOnesV,
/* 15401*/    OPC_MoveParent,
/* 15402*/    OPC_MoveSibling1,
/* 15403*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15406*/    OPC_RecordChild0, // #1 = $v1
/* 15407*/    OPC_RecordChild1, // #2 = $v2
/* 15408*/    OPC_MoveParent,
/* 15409*/    OPC_MoveParent,
/* 15410*/    OPC_CheckType, MVT::v2i64,
/* 15412*/    OPC_Scope, 10, /*->15424*/ // 2 children in Scope
/* 15414*/     OPC_CheckChild1Same, 2,
/* 15416*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v2i64, 3/*#Ops*/, 2, 1, 0, 
               // Src: (xor:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }), (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2)), V128:{ *:[v2i64] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$c)
/* 15424*/    /*Scope*/ 10, /*->15435*/
/* 15425*/     OPC_CheckChild1Same, 1,
/* 15427*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v2i64, 3/*#Ops*/, 1, 2, 0, 
               // Src: (xor:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }), (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$v1)), V128:{ *:[v2i64] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$c)
/* 15435*/    0, /*End of Scope*/
/* 15436*/   0, /*End of Scope*/
/* 15437*/  /*Scope*/ 102, /*->15540*/
/* 15438*/   OPC_RecordChild0, // #0 = $v2
/* 15439*/   OPC_MoveChild1,
/* 15440*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15443*/   OPC_MoveChild0,
/* 15444*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15447*/   OPC_Scope, 23, /*->15472*/ // 3 children in Scope
/* 15449*/    OPC_RecordChild0, // #1 = $v1
/* 15450*/    OPC_CheckChild1Same, 0,
/* 15452*/    OPC_MoveSibling1,
/* 15453*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15456*/    OPC_RecordChild0, // #2 = $c
/* 15457*/    OPC_MoveChild1,
/* 15458*/    OPC_CheckImmAllOnesV,
/* 15459*/    OPC_MoveParent,
/* 15460*/    OPC_MoveParent,
/* 15461*/    OPC_MoveParent,
/* 15462*/    OPC_CheckType, MVT::v2i64,
/* 15464*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v2i64, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2), (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }))) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$c)
/* 15472*/   /*Scope*/ 23, /*->15496*/
/* 15473*/    OPC_CheckChild0Same, 0,
/* 15475*/    OPC_RecordChild1, // #1 = $v1
/* 15476*/    OPC_MoveSibling1,
/* 15477*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15480*/    OPC_RecordChild0, // #2 = $c
/* 15481*/    OPC_MoveChild1,
/* 15482*/    OPC_CheckImmAllOnesV,
/* 15483*/    OPC_MoveParent,
/* 15484*/    OPC_MoveParent,
/* 15485*/    OPC_MoveParent,
/* 15486*/    OPC_CheckType, MVT::v2i64,
/* 15488*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v2i64, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$v1), (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }))) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$c)
/* 15496*/   /*Scope*/ 42, /*->15539*/
/* 15497*/    OPC_RecordChild0, // #1 = $c
/* 15498*/    OPC_MoveChild1,
/* 15499*/    OPC_CheckImmAllOnesV,
/* 15500*/    OPC_MoveParent,
/* 15501*/    OPC_MoveSibling1,
/* 15502*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15505*/    OPC_Scope, 15, /*->15522*/ // 2 children in Scope
/* 15507*/     OPC_RecordChild0, // #2 = $v1
/* 15508*/     OPC_CheckChild1Same, 0,
/* 15510*/     OPC_MoveParent,
/* 15511*/     OPC_MoveParent,
/* 15512*/     OPC_CheckType, MVT::v2i64,
/* 15514*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v2i64, 3/*#Ops*/, 0, 2, 1, 
               // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }), (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$c)
/* 15522*/    /*Scope*/ 15, /*->15538*/
/* 15523*/     OPC_CheckChild0Same, 0,
/* 15525*/     OPC_RecordChild1, // #2 = $v1
/* 15526*/     OPC_MoveParent,
/* 15527*/     OPC_MoveParent,
/* 15528*/     OPC_CheckType, MVT::v2i64,
/* 15530*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v2i64, 3/*#Ops*/, 0, 2, 1, 
               // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }), (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$v1))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$c)
/* 15538*/    0, /*End of Scope*/
/* 15539*/   0, /*End of Scope*/
/* 15540*/  /*Scope*/ 112, /*->15653*/
/* 15541*/   OPC_MoveChild0,
/* 15542*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15545*/   OPC_Scope, 69, /*->15616*/ // 2 children in Scope
/* 15547*/    OPC_MoveChild0,
/* 15548*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15551*/    OPC_RecordChild0, // #0 = $v1
/* 15552*/    OPC_RecordChild1, // #1 = $v2
/* 15553*/    OPC_MoveParent,
/* 15554*/    OPC_RecordChild1, // #2 = $c
/* 15555*/    OPC_MoveParent,
/* 15556*/    OPC_Scope, 44, /*->15602*/ // 2 children in Scope
/* 15558*/     OPC_CheckChild1Same, 1,
/* 15560*/     OPC_SwitchType /*4 cases */, 8, MVT::v16i8,// ->15571
/* 15563*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v16i8, 3/*#Ops*/, 0, 1, 2, 
                // Src: (xor:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2), V128:{ *:[v16i8] }:$c), V128:{ *:[v16i8] }:$v2) - Complexity = 9
                // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 15571*/     /*SwitchType*/ 8, MVT::v8i16,// ->15581
/* 15573*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v8i16, 3/*#Ops*/, 0, 1, 2, 
                // Src: (xor:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2), V128:{ *:[v8i16] }:$c), V128:{ *:[v8i16] }:$v2) - Complexity = 9
                // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 15581*/     /*SwitchType*/ 8, MVT::v4i32,// ->15591
/* 15583*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v4i32, 3/*#Ops*/, 0, 1, 2, 
                // Src: (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2), V128:{ *:[v4i32] }:$c), V128:{ *:[v4i32] }:$v2) - Complexity = 9
                // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 15591*/     /*SwitchType*/ 8, MVT::v2i64,// ->15601
/* 15593*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v2i64, 3/*#Ops*/, 0, 1, 2, 
                // Src: (xor:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2), V128:{ *:[v2i64] }:$c), V128:{ *:[v2i64] }:$v2) - Complexity = 9
                // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 15601*/     0, // EndSwitchType
/* 15602*/    /*Scope*/ 12, /*->15615*/
/* 15603*/     OPC_CheckChild1Same, 0,
/* 15605*/     OPC_CheckType, MVT::v16i8,
/* 15607*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v16i8, 3/*#Ops*/, 1, 0, 2, 
               // Src: (xor:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$v1), V128:{ *:[v16i8] }:$c), V128:{ *:[v16i8] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 15615*/    0, /*End of Scope*/
/* 15616*/   /*Scope*/ 35, /*->15652*/
/* 15617*/    OPC_RecordChild0, // #0 = $c
/* 15618*/    OPC_MoveChild1,
/* 15619*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15622*/    OPC_RecordChild0, // #1 = $v1
/* 15623*/    OPC_RecordChild1, // #2 = $v2
/* 15624*/    OPC_MoveParent,
/* 15625*/    OPC_MoveParent,
/* 15626*/    OPC_CheckType, MVT::v16i8,
/* 15628*/    OPC_Scope, 10, /*->15640*/ // 2 children in Scope
/* 15630*/     OPC_CheckChild1Same, 2,
/* 15632*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v16i8, 3/*#Ops*/, 1, 2, 0, 
               // Src: (xor:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2)), V128:{ *:[v16i8] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 15640*/    /*Scope*/ 10, /*->15651*/
/* 15641*/     OPC_CheckChild1Same, 1,
/* 15643*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v16i8, 3/*#Ops*/, 2, 1, 0, 
               // Src: (xor:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$v1)), V128:{ *:[v16i8] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 15651*/    0, /*End of Scope*/
/* 15652*/   0, /*End of Scope*/
/* 15653*/  /*Scope*/ 88, /*->15742*/
/* 15654*/   OPC_RecordChild0, // #0 = $v2
/* 15655*/   OPC_MoveChild1,
/* 15656*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15659*/   OPC_Scope, 40, /*->15701*/ // 2 children in Scope
/* 15661*/    OPC_MoveChild0,
/* 15662*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15665*/    OPC_Scope, 16, /*->15683*/ // 2 children in Scope
/* 15667*/     OPC_RecordChild0, // #1 = $v1
/* 15668*/     OPC_CheckChild1Same, 0,
/* 15670*/     OPC_MoveParent,
/* 15671*/     OPC_RecordChild1, // #2 = $c
/* 15672*/     OPC_MoveParent,
/* 15673*/     OPC_CheckType, MVT::v16i8,
/* 15675*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v16i8, 3/*#Ops*/, 1, 0, 2, 
               // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2), V128:{ *:[v16i8] }:$c)) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 15683*/    /*Scope*/ 16, /*->15700*/
/* 15684*/     OPC_CheckChild0Same, 0,
/* 15686*/     OPC_RecordChild1, // #1 = $v1
/* 15687*/     OPC_MoveParent,
/* 15688*/     OPC_RecordChild1, // #2 = $c
/* 15689*/     OPC_MoveParent,
/* 15690*/     OPC_CheckType, MVT::v16i8,
/* 15692*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v16i8, 3/*#Ops*/, 1, 0, 2, 
               // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$v1), V128:{ *:[v16i8] }:$c)) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 15700*/    0, /*End of Scope*/
/* 15701*/   /*Scope*/ 39, /*->15741*/
/* 15702*/    OPC_RecordChild0, // #1 = $c
/* 15703*/    OPC_MoveChild1,
/* 15704*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15707*/    OPC_Scope, 15, /*->15724*/ // 2 children in Scope
/* 15709*/     OPC_RecordChild0, // #2 = $v1
/* 15710*/     OPC_CheckChild1Same, 0,
/* 15712*/     OPC_MoveParent,
/* 15713*/     OPC_MoveParent,
/* 15714*/     OPC_CheckType, MVT::v16i8,
/* 15716*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v16i8, 3/*#Ops*/, 2, 0, 1, 
               // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2))) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 15724*/    /*Scope*/ 15, /*->15740*/
/* 15725*/     OPC_CheckChild0Same, 0,
/* 15727*/     OPC_RecordChild1, // #2 = $v1
/* 15728*/     OPC_MoveParent,
/* 15729*/     OPC_MoveParent,
/* 15730*/     OPC_CheckType, MVT::v16i8,
/* 15732*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v16i8, 3/*#Ops*/, 2, 0, 1, 
               // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$v1))) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 15740*/    0, /*End of Scope*/
/* 15741*/   0, /*End of Scope*/
/* 15742*/  /*Scope*/ 64, /*->15807*/
/* 15743*/   OPC_MoveChild0,
/* 15744*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15747*/   OPC_Scope, 21, /*->15770*/ // 2 children in Scope
/* 15749*/    OPC_MoveChild0,
/* 15750*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15753*/    OPC_RecordChild0, // #0 = $v2
/* 15754*/    OPC_RecordChild1, // #1 = $v1
/* 15755*/    OPC_MoveParent,
/* 15756*/    OPC_RecordChild1, // #2 = $c
/* 15757*/    OPC_MoveParent,
/* 15758*/    OPC_CheckChild1Same, 0,
/* 15760*/    OPC_CheckType, MVT::v8i16,
/* 15762*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v8i16, 3/*#Ops*/, 1, 0, 2, 
              // Src: (xor:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$v1), V128:{ *:[v8i16] }:$c), V128:{ *:[v8i16] }:$v2) - Complexity = 9
              // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 15770*/   /*Scope*/ 35, /*->15806*/
/* 15771*/    OPC_RecordChild0, // #0 = $c
/* 15772*/    OPC_MoveChild1,
/* 15773*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15776*/    OPC_RecordChild0, // #1 = $v1
/* 15777*/    OPC_RecordChild1, // #2 = $v2
/* 15778*/    OPC_MoveParent,
/* 15779*/    OPC_MoveParent,
/* 15780*/    OPC_CheckType, MVT::v8i16,
/* 15782*/    OPC_Scope, 10, /*->15794*/ // 2 children in Scope
/* 15784*/     OPC_CheckChild1Same, 2,
/* 15786*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v8i16, 3/*#Ops*/, 1, 2, 0, 
               // Src: (xor:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2)), V128:{ *:[v8i16] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 15794*/    /*Scope*/ 10, /*->15805*/
/* 15795*/     OPC_CheckChild1Same, 1,
/* 15797*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v8i16, 3/*#Ops*/, 2, 1, 0, 
               // Src: (xor:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$v1)), V128:{ *:[v8i16] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 15805*/    0, /*End of Scope*/
/* 15806*/   0, /*End of Scope*/
/* 15807*/  /*Scope*/ 88, /*->15896*/
/* 15808*/   OPC_RecordChild0, // #0 = $v2
/* 15809*/   OPC_MoveChild1,
/* 15810*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15813*/   OPC_Scope, 40, /*->15855*/ // 2 children in Scope
/* 15815*/    OPC_MoveChild0,
/* 15816*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15819*/    OPC_Scope, 16, /*->15837*/ // 2 children in Scope
/* 15821*/     OPC_RecordChild0, // #1 = $v1
/* 15822*/     OPC_CheckChild1Same, 0,
/* 15824*/     OPC_MoveParent,
/* 15825*/     OPC_RecordChild1, // #2 = $c
/* 15826*/     OPC_MoveParent,
/* 15827*/     OPC_CheckType, MVT::v8i16,
/* 15829*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v8i16, 3/*#Ops*/, 1, 0, 2, 
               // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2), V128:{ *:[v8i16] }:$c)) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 15837*/    /*Scope*/ 16, /*->15854*/
/* 15838*/     OPC_CheckChild0Same, 0,
/* 15840*/     OPC_RecordChild1, // #1 = $v1
/* 15841*/     OPC_MoveParent,
/* 15842*/     OPC_RecordChild1, // #2 = $c
/* 15843*/     OPC_MoveParent,
/* 15844*/     OPC_CheckType, MVT::v8i16,
/* 15846*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v8i16, 3/*#Ops*/, 1, 0, 2, 
               // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$v1), V128:{ *:[v8i16] }:$c)) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 15854*/    0, /*End of Scope*/
/* 15855*/   /*Scope*/ 39, /*->15895*/
/* 15856*/    OPC_RecordChild0, // #1 = $c
/* 15857*/    OPC_MoveChild1,
/* 15858*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15861*/    OPC_Scope, 15, /*->15878*/ // 2 children in Scope
/* 15863*/     OPC_RecordChild0, // #2 = $v1
/* 15864*/     OPC_CheckChild1Same, 0,
/* 15866*/     OPC_MoveParent,
/* 15867*/     OPC_MoveParent,
/* 15868*/     OPC_CheckType, MVT::v8i16,
/* 15870*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v8i16, 3/*#Ops*/, 2, 0, 1, 
               // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2))) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 15878*/    /*Scope*/ 15, /*->15894*/
/* 15879*/     OPC_CheckChild0Same, 0,
/* 15881*/     OPC_RecordChild1, // #2 = $v1
/* 15882*/     OPC_MoveParent,
/* 15883*/     OPC_MoveParent,
/* 15884*/     OPC_CheckType, MVT::v8i16,
/* 15886*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v8i16, 3/*#Ops*/, 2, 0, 1, 
               // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$v1))) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 15894*/    0, /*End of Scope*/
/* 15895*/   0, /*End of Scope*/
/* 15896*/  /*Scope*/ 64, /*->15961*/
/* 15897*/   OPC_MoveChild0,
/* 15898*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15901*/   OPC_Scope, 21, /*->15924*/ // 2 children in Scope
/* 15903*/    OPC_MoveChild0,
/* 15904*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15907*/    OPC_RecordChild0, // #0 = $v2
/* 15908*/    OPC_RecordChild1, // #1 = $v1
/* 15909*/    OPC_MoveParent,
/* 15910*/    OPC_RecordChild1, // #2 = $c
/* 15911*/    OPC_MoveParent,
/* 15912*/    OPC_CheckChild1Same, 0,
/* 15914*/    OPC_CheckType, MVT::v4i32,
/* 15916*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v4i32, 3/*#Ops*/, 1, 0, 2, 
              // Src: (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$v1), V128:{ *:[v4i32] }:$c), V128:{ *:[v4i32] }:$v2) - Complexity = 9
              // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 15924*/   /*Scope*/ 35, /*->15960*/
/* 15925*/    OPC_RecordChild0, // #0 = $c
/* 15926*/    OPC_MoveChild1,
/* 15927*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15930*/    OPC_RecordChild0, // #1 = $v1
/* 15931*/    OPC_RecordChild1, // #2 = $v2
/* 15932*/    OPC_MoveParent,
/* 15933*/    OPC_MoveParent,
/* 15934*/    OPC_CheckType, MVT::v4i32,
/* 15936*/    OPC_Scope, 10, /*->15948*/ // 2 children in Scope
/* 15938*/     OPC_CheckChild1Same, 2,
/* 15940*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v4i32, 3/*#Ops*/, 1, 2, 0, 
               // Src: (xor:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2)), V128:{ *:[v4i32] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 15948*/    /*Scope*/ 10, /*->15959*/
/* 15949*/     OPC_CheckChild1Same, 1,
/* 15951*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v4i32, 3/*#Ops*/, 2, 1, 0, 
               // Src: (xor:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$v1)), V128:{ *:[v4i32] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 15959*/    0, /*End of Scope*/
/* 15960*/   0, /*End of Scope*/
/* 15961*/  /*Scope*/ 88, /*->16050*/
/* 15962*/   OPC_RecordChild0, // #0 = $v2
/* 15963*/   OPC_MoveChild1,
/* 15964*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15967*/   OPC_Scope, 40, /*->16009*/ // 2 children in Scope
/* 15969*/    OPC_MoveChild0,
/* 15970*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15973*/    OPC_Scope, 16, /*->15991*/ // 2 children in Scope
/* 15975*/     OPC_RecordChild0, // #1 = $v1
/* 15976*/     OPC_CheckChild1Same, 0,
/* 15978*/     OPC_MoveParent,
/* 15979*/     OPC_RecordChild1, // #2 = $c
/* 15980*/     OPC_MoveParent,
/* 15981*/     OPC_CheckType, MVT::v4i32,
/* 15983*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v4i32, 3/*#Ops*/, 1, 0, 2, 
               // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2), V128:{ *:[v4i32] }:$c)) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 15991*/    /*Scope*/ 16, /*->16008*/
/* 15992*/     OPC_CheckChild0Same, 0,
/* 15994*/     OPC_RecordChild1, // #1 = $v1
/* 15995*/     OPC_MoveParent,
/* 15996*/     OPC_RecordChild1, // #2 = $c
/* 15997*/     OPC_MoveParent,
/* 15998*/     OPC_CheckType, MVT::v4i32,
/* 16000*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v4i32, 3/*#Ops*/, 1, 0, 2, 
               // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$v1), V128:{ *:[v4i32] }:$c)) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 16008*/    0, /*End of Scope*/
/* 16009*/   /*Scope*/ 39, /*->16049*/
/* 16010*/    OPC_RecordChild0, // #1 = $c
/* 16011*/    OPC_MoveChild1,
/* 16012*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16015*/    OPC_Scope, 15, /*->16032*/ // 2 children in Scope
/* 16017*/     OPC_RecordChild0, // #2 = $v1
/* 16018*/     OPC_CheckChild1Same, 0,
/* 16020*/     OPC_MoveParent,
/* 16021*/     OPC_MoveParent,
/* 16022*/     OPC_CheckType, MVT::v4i32,
/* 16024*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v4i32, 3/*#Ops*/, 2, 0, 1, 
               // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2))) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 16032*/    /*Scope*/ 15, /*->16048*/
/* 16033*/     OPC_CheckChild0Same, 0,
/* 16035*/     OPC_RecordChild1, // #2 = $v1
/* 16036*/     OPC_MoveParent,
/* 16037*/     OPC_MoveParent,
/* 16038*/     OPC_CheckType, MVT::v4i32,
/* 16040*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v4i32, 3/*#Ops*/, 2, 0, 1, 
               // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$v1))) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 16048*/    0, /*End of Scope*/
/* 16049*/   0, /*End of Scope*/
/* 16050*/  /*Scope*/ 64, /*->16115*/
/* 16051*/   OPC_MoveChild0,
/* 16052*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 16055*/   OPC_Scope, 21, /*->16078*/ // 2 children in Scope
/* 16057*/    OPC_MoveChild0,
/* 16058*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16061*/    OPC_RecordChild0, // #0 = $v2
/* 16062*/    OPC_RecordChild1, // #1 = $v1
/* 16063*/    OPC_MoveParent,
/* 16064*/    OPC_RecordChild1, // #2 = $c
/* 16065*/    OPC_MoveParent,
/* 16066*/    OPC_CheckChild1Same, 0,
/* 16068*/    OPC_CheckType, MVT::v2i64,
/* 16070*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v2i64, 3/*#Ops*/, 1, 0, 2, 
              // Src: (xor:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$v1), V128:{ *:[v2i64] }:$c), V128:{ *:[v2i64] }:$v2) - Complexity = 9
              // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 16078*/   /*Scope*/ 35, /*->16114*/
/* 16079*/    OPC_RecordChild0, // #0 = $c
/* 16080*/    OPC_MoveChild1,
/* 16081*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16084*/    OPC_RecordChild0, // #1 = $v1
/* 16085*/    OPC_RecordChild1, // #2 = $v2
/* 16086*/    OPC_MoveParent,
/* 16087*/    OPC_MoveParent,
/* 16088*/    OPC_CheckType, MVT::v2i64,
/* 16090*/    OPC_Scope, 10, /*->16102*/ // 2 children in Scope
/* 16092*/     OPC_CheckChild1Same, 2,
/* 16094*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v2i64, 3/*#Ops*/, 1, 2, 0, 
               // Src: (xor:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2)), V128:{ *:[v2i64] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 16102*/    /*Scope*/ 10, /*->16113*/
/* 16103*/     OPC_CheckChild1Same, 1,
/* 16105*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v2i64, 3/*#Ops*/, 2, 1, 0, 
               // Src: (xor:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$v1)), V128:{ *:[v2i64] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 16113*/    0, /*End of Scope*/
/* 16114*/   0, /*End of Scope*/
/* 16115*/  /*Scope*/ 43|128,1/*171*/, /*->16288*/
/* 16117*/   OPC_RecordChild0, // #0 = $v2
/* 16118*/   OPC_Scope, 127, /*->16247*/ // 2 children in Scope
/* 16120*/    OPC_MoveChild1,
/* 16121*/    OPC_Scope, 86, /*->16209*/ // 2 children in Scope
/* 16123*/     OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 16126*/     OPC_Scope, 40, /*->16168*/ // 2 children in Scope
/* 16128*/      OPC_MoveChild0,
/* 16129*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16132*/      OPC_Scope, 16, /*->16150*/ // 2 children in Scope
/* 16134*/       OPC_RecordChild0, // #1 = $v1
/* 16135*/       OPC_CheckChild1Same, 0,
/* 16137*/       OPC_MoveParent,
/* 16138*/       OPC_RecordChild1, // #2 = $c
/* 16139*/       OPC_MoveParent,
/* 16140*/       OPC_CheckType, MVT::v2i64,
/* 16142*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                     MVT::v2i64, 3/*#Ops*/, 1, 0, 2, 
                 // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2), V128:{ *:[v2i64] }:$c)) - Complexity = 9
                 // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 16150*/      /*Scope*/ 16, /*->16167*/
/* 16151*/       OPC_CheckChild0Same, 0,
/* 16153*/       OPC_RecordChild1, // #1 = $v1
/* 16154*/       OPC_MoveParent,
/* 16155*/       OPC_RecordChild1, // #2 = $c
/* 16156*/       OPC_MoveParent,
/* 16157*/       OPC_CheckType, MVT::v2i64,
/* 16159*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                     MVT::v2i64, 3/*#Ops*/, 1, 0, 2, 
                 // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$v1), V128:{ *:[v2i64] }:$c)) - Complexity = 9
                 // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 16167*/      0, /*End of Scope*/
/* 16168*/     /*Scope*/ 39, /*->16208*/
/* 16169*/      OPC_RecordChild0, // #1 = $c
/* 16170*/      OPC_MoveChild1,
/* 16171*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16174*/      OPC_Scope, 15, /*->16191*/ // 2 children in Scope
/* 16176*/       OPC_RecordChild0, // #2 = $v1
/* 16177*/       OPC_CheckChild1Same, 0,
/* 16179*/       OPC_MoveParent,
/* 16180*/       OPC_MoveParent,
/* 16181*/       OPC_CheckType, MVT::v2i64,
/* 16183*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                     MVT::v2i64, 3/*#Ops*/, 2, 0, 1, 
                 // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2))) - Complexity = 9
                 // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 16191*/      /*Scope*/ 15, /*->16207*/
/* 16192*/       OPC_CheckChild0Same, 0,
/* 16194*/       OPC_RecordChild1, // #2 = $v1
/* 16195*/       OPC_MoveParent,
/* 16196*/       OPC_MoveParent,
/* 16197*/       OPC_CheckType, MVT::v2i64,
/* 16199*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                     MVT::v2i64, 3/*#Ops*/, 2, 0, 1, 
                 // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$v1))) - Complexity = 9
                 // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 16207*/      0, /*End of Scope*/
/* 16208*/     0, /*End of Scope*/
/* 16209*/    /*Scope*/ 36, /*->16246*/
/* 16210*/     OPC_CheckImmAllOnesV,
/* 16211*/     OPC_MoveParent,
/* 16212*/     OPC_SwitchType /*4 cases */, 6, MVT::v16i8,// ->16221
/* 16215*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NOT),
                    MVT::v16i8, 1/*#Ops*/, 0, 
                // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v, immAllOnesV:{ *:[v16i8] }) - Complexity = 7
                // Dst: (NOT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v)
/* 16221*/     /*SwitchType*/ 6, MVT::v8i16,// ->16229
/* 16223*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NOT),
                    MVT::v8i16, 1/*#Ops*/, 0, 
                // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v, immAllOnesV:{ *:[v8i16] }) - Complexity = 7
                // Dst: (NOT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v)
/* 16229*/     /*SwitchType*/ 6, MVT::v4i32,// ->16237
/* 16231*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NOT),
                    MVT::v4i32, 1/*#Ops*/, 0, 
                // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v, immAllOnesV:{ *:[v4i32] }) - Complexity = 7
                // Dst: (NOT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v)
/* 16237*/     /*SwitchType*/ 6, MVT::v2i64,// ->16245
/* 16239*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NOT),
                    MVT::v2i64, 1/*#Ops*/, 0, 
                // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v, immAllOnesV:{ *:[v2i64] }) - Complexity = 7
                // Dst: (NOT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v)
/* 16245*/     0, // EndSwitchType
/* 16246*/    0, /*End of Scope*/
/* 16247*/   /*Scope*/ 39, /*->16287*/
/* 16248*/    OPC_RecordChild1, // #1 = $rhs
/* 16249*/    OPC_SwitchType /*4 cases */, 7, MVT::v16i8,// ->16259
/* 16252*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::XOR),
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
               // Dst: (XOR:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs)
/* 16259*/    /*SwitchType*/ 7, MVT::v8i16,// ->16268
/* 16261*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::XOR),
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
               // Dst: (XOR:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/* 16268*/    /*SwitchType*/ 7, MVT::v4i32,// ->16277
/* 16270*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::XOR),
                   MVT::v4i32, 2/*#Ops*/, 0, 1, 
               // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
               // Dst: (XOR:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs)
/* 16277*/    /*SwitchType*/ 7, MVT::v2i64,// ->16286
/* 16279*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::XOR),
                   MVT::v2i64, 2/*#Ops*/, 0, 1, 
               // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 3
               // Dst: (XOR:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs)
/* 16286*/    0, // EndSwitchType
/* 16287*/   0, /*End of Scope*/
/* 16288*/  0, /*End of Scope*/
/* 16289*/ /*SwitchOpcode*/ 21, TARGET_VAL(ISD::CTLZ),// ->16313
/* 16292*/  OPC_RecordChild0, // #0 = $src
/* 16293*/  OPC_SwitchType /*2 cases */, 7, MVT::i32,// ->16303
/* 16296*/   OPC_CheckChild0TypeI32,
/* 16297*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CLZ_I32),
                 MVT::i32, 1/*#Ops*/, 0, 
             // Src: (ctlz:{ *:[i32] } I32:{ *:[i32] }:$src) - Complexity = 3
             // Dst: (CLZ_I32:{ *:[i32] } I32:{ *:[i32] }:$src)
/* 16303*/  /*SwitchType*/ 7, MVT::i64,// ->16312
/* 16305*/   OPC_CheckChild0TypeI64,
/* 16306*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CLZ_I64),
                 MVT::i64, 1/*#Ops*/, 0, 
             // Src: (ctlz:{ *:[i64] } I64:{ *:[i64] }:$src) - Complexity = 3
             // Dst: (CLZ_I64:{ *:[i64] } I64:{ *:[i64] }:$src)
/* 16312*/  0, // EndSwitchType
/* 16313*/ /*SwitchOpcode*/ 21, TARGET_VAL(ISD::CTTZ),// ->16337
/* 16316*/  OPC_RecordChild0, // #0 = $src
/* 16317*/  OPC_SwitchType /*2 cases */, 7, MVT::i32,// ->16327
/* 16320*/   OPC_CheckChild0TypeI32,
/* 16321*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CTZ_I32),
                 MVT::i32, 1/*#Ops*/, 0, 
             // Src: (cttz:{ *:[i32] } I32:{ *:[i32] }:$src) - Complexity = 3
             // Dst: (CTZ_I32:{ *:[i32] } I32:{ *:[i32] }:$src)
/* 16327*/  /*SwitchType*/ 7, MVT::i64,// ->16336
/* 16329*/   OPC_CheckChild0TypeI64,
/* 16330*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CTZ_I64),
                 MVT::i64, 1/*#Ops*/, 0, 
             // Src: (cttz:{ *:[i64] } I64:{ *:[i64] }:$src) - Complexity = 3
             // Dst: (CTZ_I64:{ *:[i64] } I64:{ *:[i64] }:$src)
/* 16336*/  0, // EndSwitchType
/* 16337*/ /*SwitchOpcode*/ 32, TARGET_VAL(ISD::CTPOP),// ->16372
/* 16340*/  OPC_RecordChild0, // #0 = $src
/* 16341*/  OPC_SwitchType /*3 cases */, 7, MVT::i32,// ->16351
/* 16344*/   OPC_CheckChild0TypeI32,
/* 16345*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::POPCNT_I32),
                 MVT::i32, 1/*#Ops*/, 0, 
             // Src: (ctpop:{ *:[i32] } I32:{ *:[i32] }:$src) - Complexity = 3
             // Dst: (POPCNT_I32:{ *:[i32] } I32:{ *:[i32] }:$src)
/* 16351*/  /*SwitchType*/ 7, MVT::i64,// ->16360
/* 16353*/   OPC_CheckChild0TypeI64,
/* 16354*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::POPCNT_I64),
                 MVT::i64, 1/*#Ops*/, 0, 
             // Src: (ctpop:{ *:[i64] } I64:{ *:[i64] }:$src) - Complexity = 3
             // Dst: (POPCNT_I64:{ *:[i64] } I64:{ *:[i64] }:$src)
/* 16360*/  /*SwitchType*/ 9, MVT::v16i8,// ->16371
/* 16362*/   OPC_CheckChild0Type, MVT::v16i8,
/* 16364*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 16365*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::POPCNT_I8x16),
                 MVT::v16i8, 1/*#Ops*/, 0, 
             // Src: (ctpop:{ *:[v16i8] } V128:{ *:[v16i8] }:$v) - Complexity = 3
             // Dst: (POPCNT_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$v)
/* 16371*/  0, // EndSwitchType
/* 16372*/ /*SwitchOpcode*/ 7, TARGET_VAL(ISD::TRUNCATE),// ->16382
/* 16375*/  OPC_RecordChild0, // #0 = $src
/* 16376*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_WRAP_I64),
                MVT::i32, 1/*#Ops*/, 0, 
            // Src: (trunc:{ *:[i32] } I64:{ *:[i64] }:$src) - Complexity = 3
            // Dst: (I32_WRAP_I64:{ *:[i32] } I64:{ *:[i64] }:$src)
/* 16382*/ /*SwitchOpcode*/ 7, TARGET_VAL(ISD::SIGN_EXTEND),// ->16392
/* 16385*/  OPC_RecordChild0, // #0 = $src
/* 16386*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_EXTEND_S_I32),
                MVT::i64, 1/*#Ops*/, 0, 
            // Src: (sext:{ *:[i64] } I32:{ *:[i32] }:$src) - Complexity = 3
            // Dst: (I64_EXTEND_S_I32:{ *:[i64] } I32:{ *:[i32] }:$src)
/* 16392*/ /*SwitchOpcode*/ 111, TARGET_VAL(ISD::FP_TO_SINT),// ->16506
/* 16395*/  OPC_RecordChild0, // #0 = $src
/* 16396*/  OPC_Scope, 48, /*->16446*/ // 3 children in Scope
/* 16398*/   OPC_CheckChild0Type, MVT::f32,
/* 16400*/   OPC_SwitchType /*2 cases */, 20, MVT::i32,// ->16423
/* 16403*/    OPC_Scope, 8, /*->16413*/ // 2 children in Scope
/* 16405*/     OPC_CheckPatternPredicate, 9, // (Subtarget->hasNontrappingFPToInt())
/* 16407*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_S_SAT_F32),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (fp_to_sint:{ *:[i32] } F32:{ *:[f32] }:$src) - Complexity = 3
               // Dst: (I32_TRUNC_S_SAT_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 16413*/    /*Scope*/ 8, /*->16422*/
/* 16414*/     OPC_CheckPatternPredicate, 10, // (!Subtarget->hasNontrappingFPToInt())
/* 16416*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FP_TO_SINT_I32_F32),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (fp_to_sint:{ *:[i32] } F32:{ *:[f32] }:$src) - Complexity = 3
               // Dst: (FP_TO_SINT_I32_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 16422*/    0, /*End of Scope*/
/* 16423*/   /*SwitchType*/ 20, MVT::i64,// ->16445
/* 16425*/    OPC_Scope, 8, /*->16435*/ // 2 children in Scope
/* 16427*/     OPC_CheckPatternPredicate, 9, // (Subtarget->hasNontrappingFPToInt())
/* 16429*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_S_SAT_F32),
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (fp_to_sint:{ *:[i64] } F32:{ *:[f32] }:$src) - Complexity = 3
               // Dst: (I64_TRUNC_S_SAT_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 16435*/    /*Scope*/ 8, /*->16444*/
/* 16436*/     OPC_CheckPatternPredicate, 10, // (!Subtarget->hasNontrappingFPToInt())
/* 16438*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FP_TO_SINT_I64_F32),
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (fp_to_sint:{ *:[i64] } F32:{ *:[f32] }:$src) - Complexity = 3
               // Dst: (FP_TO_SINT_I64_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 16444*/    0, /*End of Scope*/
/* 16445*/   0, // EndSwitchType
/* 16446*/  /*Scope*/ 48, /*->16495*/
/* 16447*/   OPC_CheckChild0Type, MVT::f64,
/* 16449*/   OPC_SwitchType /*2 cases */, 20, MVT::i32,// ->16472
/* 16452*/    OPC_Scope, 8, /*->16462*/ // 2 children in Scope
/* 16454*/     OPC_CheckPatternPredicate, 9, // (Subtarget->hasNontrappingFPToInt())
/* 16456*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_S_SAT_F64),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (fp_to_sint:{ *:[i32] } F64:{ *:[f64] }:$src) - Complexity = 3
               // Dst: (I32_TRUNC_S_SAT_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 16462*/    /*Scope*/ 8, /*->16471*/
/* 16463*/     OPC_CheckPatternPredicate, 10, // (!Subtarget->hasNontrappingFPToInt())
/* 16465*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FP_TO_SINT_I32_F64),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (fp_to_sint:{ *:[i32] } F64:{ *:[f64] }:$src) - Complexity = 3
               // Dst: (FP_TO_SINT_I32_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 16471*/    0, /*End of Scope*/
/* 16472*/   /*SwitchType*/ 20, MVT::i64,// ->16494
/* 16474*/    OPC_Scope, 8, /*->16484*/ // 2 children in Scope
/* 16476*/     OPC_CheckPatternPredicate, 9, // (Subtarget->hasNontrappingFPToInt())
/* 16478*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_S_SAT_F64),
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (fp_to_sint:{ *:[i64] } F64:{ *:[f64] }:$src) - Complexity = 3
               // Dst: (I64_TRUNC_S_SAT_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 16484*/    /*Scope*/ 8, /*->16493*/
/* 16485*/     OPC_CheckPatternPredicate, 10, // (!Subtarget->hasNontrappingFPToInt())
/* 16487*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FP_TO_SINT_I64_F64),
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (fp_to_sint:{ *:[i64] } F64:{ *:[f64] }:$src) - Complexity = 3
               // Dst: (FP_TO_SINT_I64_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 16493*/    0, /*End of Scope*/
/* 16494*/   0, // EndSwitchType
/* 16495*/  /*Scope*/ 9, /*->16505*/
/* 16496*/   OPC_CheckType, MVT::v4i32,
/* 16498*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 16499*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::fp_to_sint_I32x4),
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (fp_to_sint:{ *:[v4i32] } V128:{ *:[v4f32] }:$vec) - Complexity = 3
             // Dst: (fp_to_sint_I32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$vec)
/* 16505*/  0, /*End of Scope*/
/* 16506*/ /*SwitchOpcode*/ 111, TARGET_VAL(ISD::FP_TO_UINT),// ->16620
/* 16509*/  OPC_RecordChild0, // #0 = $src
/* 16510*/  OPC_Scope, 48, /*->16560*/ // 3 children in Scope
/* 16512*/   OPC_CheckChild0Type, MVT::f32,
/* 16514*/   OPC_SwitchType /*2 cases */, 20, MVT::i32,// ->16537
/* 16517*/    OPC_Scope, 8, /*->16527*/ // 2 children in Scope
/* 16519*/     OPC_CheckPatternPredicate, 9, // (Subtarget->hasNontrappingFPToInt())
/* 16521*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_U_SAT_F32),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (fp_to_uint:{ *:[i32] } F32:{ *:[f32] }:$src) - Complexity = 3
               // Dst: (I32_TRUNC_U_SAT_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 16527*/    /*Scope*/ 8, /*->16536*/
/* 16528*/     OPC_CheckPatternPredicate, 10, // (!Subtarget->hasNontrappingFPToInt())
/* 16530*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FP_TO_UINT_I32_F32),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (fp_to_uint:{ *:[i32] } F32:{ *:[f32] }:$src) - Complexity = 3
               // Dst: (FP_TO_UINT_I32_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 16536*/    0, /*End of Scope*/
/* 16537*/   /*SwitchType*/ 20, MVT::i64,// ->16559
/* 16539*/    OPC_Scope, 8, /*->16549*/ // 2 children in Scope
/* 16541*/     OPC_CheckPatternPredicate, 9, // (Subtarget->hasNontrappingFPToInt())
/* 16543*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_U_SAT_F32),
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (fp_to_uint:{ *:[i64] } F32:{ *:[f32] }:$src) - Complexity = 3
               // Dst: (I64_TRUNC_U_SAT_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 16549*/    /*Scope*/ 8, /*->16558*/
/* 16550*/     OPC_CheckPatternPredicate, 10, // (!Subtarget->hasNontrappingFPToInt())
/* 16552*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FP_TO_UINT_I64_F32),
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (fp_to_uint:{ *:[i64] } F32:{ *:[f32] }:$src) - Complexity = 3
               // Dst: (FP_TO_UINT_I64_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 16558*/    0, /*End of Scope*/
/* 16559*/   0, // EndSwitchType
/* 16560*/  /*Scope*/ 48, /*->16609*/
/* 16561*/   OPC_CheckChild0Type, MVT::f64,
/* 16563*/   OPC_SwitchType /*2 cases */, 20, MVT::i32,// ->16586
/* 16566*/    OPC_Scope, 8, /*->16576*/ // 2 children in Scope
/* 16568*/     OPC_CheckPatternPredicate, 9, // (Subtarget->hasNontrappingFPToInt())
/* 16570*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_U_SAT_F64),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (fp_to_uint:{ *:[i32] } F64:{ *:[f64] }:$src) - Complexity = 3
               // Dst: (I32_TRUNC_U_SAT_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 16576*/    /*Scope*/ 8, /*->16585*/
/* 16577*/     OPC_CheckPatternPredicate, 10, // (!Subtarget->hasNontrappingFPToInt())
/* 16579*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FP_TO_UINT_I32_F64),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (fp_to_uint:{ *:[i32] } F64:{ *:[f64] }:$src) - Complexity = 3
               // Dst: (FP_TO_UINT_I32_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 16585*/    0, /*End of Scope*/
/* 16586*/   /*SwitchType*/ 20, MVT::i64,// ->16608
/* 16588*/    OPC_Scope, 8, /*->16598*/ // 2 children in Scope
/* 16590*/     OPC_CheckPatternPredicate, 9, // (Subtarget->hasNontrappingFPToInt())
/* 16592*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_U_SAT_F64),
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (fp_to_uint:{ *:[i64] } F64:{ *:[f64] }:$src) - Complexity = 3
               // Dst: (I64_TRUNC_U_SAT_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 16598*/    /*Scope*/ 8, /*->16607*/
/* 16599*/     OPC_CheckPatternPredicate, 10, // (!Subtarget->hasNontrappingFPToInt())
/* 16601*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FP_TO_UINT_I64_F64),
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (fp_to_uint:{ *:[i64] } F64:{ *:[f64] }:$src) - Complexity = 3
               // Dst: (FP_TO_UINT_I64_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 16607*/    0, /*End of Scope*/
/* 16608*/   0, // EndSwitchType
/* 16609*/  /*Scope*/ 9, /*->16619*/
/* 16610*/   OPC_CheckType, MVT::v4i32,
/* 16612*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 16613*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::fp_to_uint_I32x4),
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (fp_to_uint:{ *:[v4i32] } V128:{ *:[v4f32] }:$vec) - Complexity = 3
             // Dst: (fp_to_uint_I32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$vec)
/* 16619*/  0, /*End of Scope*/
/* 16620*/ /*SwitchOpcode*/ 72, TARGET_VAL(ISD::FP_TO_SINT_SAT),// ->16695
/* 16623*/  OPC_RecordChild0, // #0 = $src
/* 16624*/  OPC_Scope, 27, /*->16653*/ // 3 children in Scope
/* 16626*/   OPC_CheckChild0Type, MVT::f32,
/* 16628*/   OPC_MoveChild1,
/* 16629*/   OPC_Scope, 10, /*->16641*/ // 2 children in Scope
/* 16631*/    OPC_CheckValueType, MVT::i32,
/* 16633*/    OPC_MoveParent,
/* 16634*/    OPC_CheckTypeI32,
/* 16635*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_S_SAT_F32),
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (fp_to_sint_sat:{ *:[i32] } F32:{ *:[f32] }:$src, i32:{ *:[Other] }) - Complexity = 3
              // Dst: (I32_TRUNC_S_SAT_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 16641*/   /*Scope*/ 10, /*->16652*/
/* 16642*/    OPC_CheckValueType, MVT::i64,
/* 16644*/    OPC_MoveParent,
/* 16645*/    OPC_CheckTypeI64,
/* 16646*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_S_SAT_F32),
                  MVT::i64, 1/*#Ops*/, 0, 
              // Src: (fp_to_sint_sat:{ *:[i64] } F32:{ *:[f32] }:$src, i64:{ *:[Other] }) - Complexity = 3
              // Dst: (I64_TRUNC_S_SAT_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 16652*/   0, /*End of Scope*/
/* 16653*/  /*Scope*/ 27, /*->16681*/
/* 16654*/   OPC_CheckChild0Type, MVT::f64,
/* 16656*/   OPC_MoveChild1,
/* 16657*/   OPC_Scope, 10, /*->16669*/ // 2 children in Scope
/* 16659*/    OPC_CheckValueType, MVT::i32,
/* 16661*/    OPC_MoveParent,
/* 16662*/    OPC_CheckTypeI32,
/* 16663*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_S_SAT_F64),
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (fp_to_sint_sat:{ *:[i32] } F64:{ *:[f64] }:$src, i32:{ *:[Other] }) - Complexity = 3
              // Dst: (I32_TRUNC_S_SAT_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 16669*/   /*Scope*/ 10, /*->16680*/
/* 16670*/    OPC_CheckValueType, MVT::i64,
/* 16672*/    OPC_MoveParent,
/* 16673*/    OPC_CheckTypeI64,
/* 16674*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_S_SAT_F64),
                  MVT::i64, 1/*#Ops*/, 0, 
              // Src: (fp_to_sint_sat:{ *:[i64] } F64:{ *:[f64] }:$src, i64:{ *:[Other] }) - Complexity = 3
              // Dst: (I64_TRUNC_S_SAT_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 16680*/   0, /*End of Scope*/
/* 16681*/  /*Scope*/ 12, /*->16694*/
/* 16682*/   OPC_MoveChild1,
/* 16683*/   OPC_CheckValueType, MVT::i32,
/* 16685*/   OPC_MoveParent,
/* 16686*/   OPC_CheckType, MVT::v4i32,
/* 16688*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::fp_to_sint_I32x4),
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (fp_to_sint_sat:{ *:[v4i32] } V128:{ *:[v4f32] }:$src, i32:{ *:[Other] }) - Complexity = 3
             // Dst: (fp_to_sint_I32x4:{ *:[v4i32] } ?:{ *:[v4f32] }:$src)
/* 16694*/  0, /*End of Scope*/
/* 16695*/ /*SwitchOpcode*/ 72, TARGET_VAL(ISD::FP_TO_UINT_SAT),// ->16770
/* 16698*/  OPC_RecordChild0, // #0 = $src
/* 16699*/  OPC_Scope, 27, /*->16728*/ // 3 children in Scope
/* 16701*/   OPC_CheckChild0Type, MVT::f32,
/* 16703*/   OPC_MoveChild1,
/* 16704*/   OPC_Scope, 10, /*->16716*/ // 2 children in Scope
/* 16706*/    OPC_CheckValueType, MVT::i32,
/* 16708*/    OPC_MoveParent,
/* 16709*/    OPC_CheckTypeI32,
/* 16710*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_U_SAT_F32),
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (fp_to_uint_sat:{ *:[i32] } F32:{ *:[f32] }:$src, i32:{ *:[Other] }) - Complexity = 3
              // Dst: (I32_TRUNC_U_SAT_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 16716*/   /*Scope*/ 10, /*->16727*/
/* 16717*/    OPC_CheckValueType, MVT::i64,
/* 16719*/    OPC_MoveParent,
/* 16720*/    OPC_CheckTypeI64,
/* 16721*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_U_SAT_F32),
                  MVT::i64, 1/*#Ops*/, 0, 
              // Src: (fp_to_uint_sat:{ *:[i64] } F32:{ *:[f32] }:$src, i64:{ *:[Other] }) - Complexity = 3
              // Dst: (I64_TRUNC_U_SAT_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 16727*/   0, /*End of Scope*/
/* 16728*/  /*Scope*/ 27, /*->16756*/
/* 16729*/   OPC_CheckChild0Type, MVT::f64,
/* 16731*/   OPC_MoveChild1,
/* 16732*/   OPC_Scope, 10, /*->16744*/ // 2 children in Scope
/* 16734*/    OPC_CheckValueType, MVT::i32,
/* 16736*/    OPC_MoveParent,
/* 16737*/    OPC_CheckTypeI32,
/* 16738*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_U_SAT_F64),
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (fp_to_uint_sat:{ *:[i32] } F64:{ *:[f64] }:$src, i32:{ *:[Other] }) - Complexity = 3
              // Dst: (I32_TRUNC_U_SAT_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 16744*/   /*Scope*/ 10, /*->16755*/
/* 16745*/    OPC_CheckValueType, MVT::i64,
/* 16747*/    OPC_MoveParent,
/* 16748*/    OPC_CheckTypeI64,
/* 16749*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_U_SAT_F64),
                  MVT::i64, 1/*#Ops*/, 0, 
              // Src: (fp_to_uint_sat:{ *:[i64] } F64:{ *:[f64] }:$src, i64:{ *:[Other] }) - Complexity = 3
              // Dst: (I64_TRUNC_U_SAT_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 16755*/   0, /*End of Scope*/
/* 16756*/  /*Scope*/ 12, /*->16769*/
/* 16757*/   OPC_MoveChild1,
/* 16758*/   OPC_CheckValueType, MVT::i32,
/* 16760*/   OPC_MoveParent,
/* 16761*/   OPC_CheckType, MVT::v4i32,
/* 16763*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::fp_to_uint_I32x4),
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (fp_to_uint_sat:{ *:[v4i32] } V128:{ *:[v4f32] }:$src, i32:{ *:[Other] }) - Complexity = 3
             // Dst: (fp_to_uint_I32x4:{ *:[v4i32] } ?:{ *:[v4f32] }:$src)
/* 16769*/  0, /*End of Scope*/
/* 16770*/ /*SwitchOpcode*/ 95|128,1/*223*/, TARGET_VAL(ISD::BITCAST),// ->16997
/* 16774*/  OPC_RecordChild0, // #0 = $src
/* 16775*/  OPC_Scope, 9, /*->16786*/ // 10 children in Scope
/* 16777*/   OPC_CheckChild0Type, MVT::f32,
/* 16779*/   OPC_CheckTypeI32,
/* 16780*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_REINTERPRET_F32),
                 MVT::i32, 1/*#Ops*/, 0, 
             // Src: (bitconvert:{ *:[i32] } F32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (I32_REINTERPRET_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 16786*/  /*Scope*/ 9, /*->16796*/
/* 16787*/   OPC_CheckChild0Type, MVT::f64,
/* 16789*/   OPC_CheckTypeI64,
/* 16790*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_REINTERPRET_F64),
                 MVT::i64, 1/*#Ops*/, 0, 
             // Src: (bitconvert:{ *:[i64] } F64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (I64_REINTERPRET_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 16796*/  /*Scope*/ 9, /*->16806*/
/* 16797*/   OPC_CheckChild0TypeI32,
/* 16798*/   OPC_CheckType, MVT::f32,
/* 16800*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F32_REINTERPRET_I32),
                 MVT::f32, 1/*#Ops*/, 0, 
             // Src: (bitconvert:{ *:[f32] } I32:{ *:[i32] }:$src) - Complexity = 3
             // Dst: (F32_REINTERPRET_I32:{ *:[f32] } I32:{ *:[i32] }:$src)
/* 16806*/  /*Scope*/ 9, /*->16816*/
/* 16807*/   OPC_CheckChild0TypeI64,
/* 16808*/   OPC_CheckType, MVT::f64,
/* 16810*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F64_REINTERPRET_I64),
                 MVT::f64, 1/*#Ops*/, 0, 
             // Src: (bitconvert:{ *:[f64] } I64:{ *:[i64] }:$src) - Complexity = 3
             // Dst: (F64_REINTERPRET_I64:{ *:[f64] } I64:{ *:[i64] }:$src)
/* 16816*/  /*Scope*/ 29, /*->16846*/
/* 16817*/   OPC_CheckChild0Type, MVT::v8i16,
/* 16819*/   OPC_SwitchType /*5 cases */, 3, MVT::v16i8,// ->16825
/* 16822*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v16i8] } V128:{ *:[v8i16] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v16i8] }:$v
/* 16825*/   /*SwitchType*/ 3, MVT::v4i32,// ->16830
/* 16827*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4i32] } V128:{ *:[v8i16] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4i32] }:$v
/* 16830*/   /*SwitchType*/ 3, MVT::v2i64,// ->16835
/* 16832*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2i64] } V128:{ *:[v8i16] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2i64] }:$v
/* 16835*/   /*SwitchType*/ 3, MVT::v4f32,// ->16840
/* 16837*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4f32] } V128:{ *:[v8i16] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4f32] }:$v
/* 16840*/   /*SwitchType*/ 3, MVT::v2f64,// ->16845
/* 16842*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2f64] } V128:{ *:[v8i16] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2f64] }:$v
/* 16845*/   0, // EndSwitchType
/* 16846*/  /*Scope*/ 29, /*->16876*/
/* 16847*/   OPC_CheckChild0Type, MVT::v4i32,
/* 16849*/   OPC_SwitchType /*5 cases */, 3, MVT::v16i8,// ->16855
/* 16852*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v16i8] } V128:{ *:[v4i32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v16i8] }:$v
/* 16855*/   /*SwitchType*/ 3, MVT::v8i16,// ->16860
/* 16857*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v8i16] } V128:{ *:[v4i32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v8i16] }:$v
/* 16860*/   /*SwitchType*/ 3, MVT::v2i64,// ->16865
/* 16862*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2i64] } V128:{ *:[v4i32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2i64] }:$v
/* 16865*/   /*SwitchType*/ 3, MVT::v4f32,// ->16870
/* 16867*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4f32] } V128:{ *:[v4i32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4f32] }:$v
/* 16870*/   /*SwitchType*/ 3, MVT::v2f64,// ->16875
/* 16872*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2f64] } V128:{ *:[v4i32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2f64] }:$v
/* 16875*/   0, // EndSwitchType
/* 16876*/  /*Scope*/ 29, /*->16906*/
/* 16877*/   OPC_CheckChild0Type, MVT::v2i64,
/* 16879*/   OPC_SwitchType /*5 cases */, 3, MVT::v16i8,// ->16885
/* 16882*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v16i8] } V128:{ *:[v2i64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v16i8] }:$v
/* 16885*/   /*SwitchType*/ 3, MVT::v8i16,// ->16890
/* 16887*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v8i16] } V128:{ *:[v2i64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v8i16] }:$v
/* 16890*/   /*SwitchType*/ 3, MVT::v4i32,// ->16895
/* 16892*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4i32] } V128:{ *:[v2i64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4i32] }:$v
/* 16895*/   /*SwitchType*/ 3, MVT::v4f32,// ->16900
/* 16897*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4f32] } V128:{ *:[v2i64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4f32] }:$v
/* 16900*/   /*SwitchType*/ 3, MVT::v2f64,// ->16905
/* 16902*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2f64] } V128:{ *:[v2i64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2f64] }:$v
/* 16905*/   0, // EndSwitchType
/* 16906*/  /*Scope*/ 29, /*->16936*/
/* 16907*/   OPC_CheckChild0Type, MVT::v4f32,
/* 16909*/   OPC_SwitchType /*5 cases */, 3, MVT::v16i8,// ->16915
/* 16912*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v16i8] } V128:{ *:[v4f32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v16i8] }:$v
/* 16915*/   /*SwitchType*/ 3, MVT::v8i16,// ->16920
/* 16917*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v8i16] } V128:{ *:[v4f32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v8i16] }:$v
/* 16920*/   /*SwitchType*/ 3, MVT::v4i32,// ->16925
/* 16922*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4i32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4i32] }:$v
/* 16925*/   /*SwitchType*/ 3, MVT::v2i64,// ->16930
/* 16927*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2i64] } V128:{ *:[v4f32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2i64] }:$v
/* 16930*/   /*SwitchType*/ 3, MVT::v2f64,// ->16935
/* 16932*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2f64] } V128:{ *:[v4f32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2f64] }:$v
/* 16935*/   0, // EndSwitchType
/* 16936*/  /*Scope*/ 29, /*->16966*/
/* 16937*/   OPC_CheckChild0Type, MVT::v2f64,
/* 16939*/   OPC_SwitchType /*5 cases */, 3, MVT::v16i8,// ->16945
/* 16942*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v16i8] } V128:{ *:[v2f64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v16i8] }:$v
/* 16945*/   /*SwitchType*/ 3, MVT::v8i16,// ->16950
/* 16947*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v8i16] } V128:{ *:[v2f64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v8i16] }:$v
/* 16950*/   /*SwitchType*/ 3, MVT::v4i32,// ->16955
/* 16952*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4i32] } V128:{ *:[v2f64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4i32] }:$v
/* 16955*/   /*SwitchType*/ 3, MVT::v2i64,// ->16960
/* 16957*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2i64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2i64] }:$v
/* 16960*/   /*SwitchType*/ 3, MVT::v4f32,// ->16965
/* 16962*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4f32] } V128:{ *:[v2f64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4f32] }:$v
/* 16965*/   0, // EndSwitchType
/* 16966*/  /*Scope*/ 29, /*->16996*/
/* 16967*/   OPC_CheckChild0Type, MVT::v16i8,
/* 16969*/   OPC_SwitchType /*5 cases */, 3, MVT::v8i16,// ->16975
/* 16972*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v8i16] } V128:{ *:[v16i8] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v8i16] }:$v
/* 16975*/   /*SwitchType*/ 3, MVT::v4i32,// ->16980
/* 16977*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4i32] } V128:{ *:[v16i8] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4i32] }:$v
/* 16980*/   /*SwitchType*/ 3, MVT::v2i64,// ->16985
/* 16982*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2i64] } V128:{ *:[v16i8] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2i64] }:$v
/* 16985*/   /*SwitchType*/ 3, MVT::v4f32,// ->16990
/* 16987*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4f32] } V128:{ *:[v16i8] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4f32] }:$v
/* 16990*/   /*SwitchType*/ 3, MVT::v2f64,// ->16995
/* 16992*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2f64] } V128:{ *:[v16i8] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2f64] }:$v
/* 16995*/   0, // EndSwitchType
/* 16996*/  0, /*End of Scope*/
/* 16997*/ /*SwitchOpcode*/ 21, TARGET_VAL(ISD::ConstantFP),// ->17021
/* 17000*/  OPC_RecordNode, // #0 = $imm
/* 17001*/  OPC_SwitchType /*2 cases */, 7, MVT::f32,// ->17011
/* 17004*/   OPC_EmitConvertToTarget0,
/* 17005*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_F32),
                 MVT::f32, 1/*#Ops*/, 1, 
             // Src: (fpimm:{ *:[f32] }):$imm - Complexity = 3
             // Dst: (CONST_F32:{ *:[f32] } (fpimm:{ *:[f32] }):$imm)
/* 17011*/  /*SwitchType*/ 7, MVT::f64,// ->17020
/* 17013*/   OPC_EmitConvertToTarget0,
/* 17014*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_F64),
                 MVT::f64, 1/*#Ops*/, 1, 
             // Src: (fpimm:{ *:[f64] }):$imm - Complexity = 3
             // Dst: (CONST_F64:{ *:[f64] } (fpimm:{ *:[f64] }):$imm)
/* 17020*/  0, // EndSwitchType
/* 17021*/ /*SwitchOpcode*/ 53, TARGET_VAL(ISD::SINT_TO_FP),// ->17077
/* 17024*/  OPC_RecordChild0, // #0 = $src
/* 17025*/  OPC_Scope, 19, /*->17046*/ // 3 children in Scope
/* 17027*/   OPC_CheckChild0TypeI32,
/* 17028*/   OPC_SwitchType /*2 cases */, 6, MVT::f32,// ->17037
/* 17031*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F32_CONVERT_S_I32),
                  MVT::f32, 1/*#Ops*/, 0, 
              // Src: (sint_to_fp:{ *:[f32] } I32:{ *:[i32] }:$src) - Complexity = 3
              // Dst: (F32_CONVERT_S_I32:{ *:[f32] } I32:{ *:[i32] }:$src)
/* 17037*/   /*SwitchType*/ 6, MVT::f64,// ->17045
/* 17039*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F64_CONVERT_S_I32),
                  MVT::f64, 1/*#Ops*/, 0, 
              // Src: (sint_to_fp:{ *:[f64] } I32:{ *:[i32] }:$src) - Complexity = 3
              // Dst: (F64_CONVERT_S_I32:{ *:[f64] } I32:{ *:[i32] }:$src)
/* 17045*/   0, // EndSwitchType
/* 17046*/  /*Scope*/ 19, /*->17066*/
/* 17047*/   OPC_CheckChild0TypeI64,
/* 17048*/   OPC_SwitchType /*2 cases */, 6, MVT::f32,// ->17057
/* 17051*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F32_CONVERT_S_I64),
                  MVT::f32, 1/*#Ops*/, 0, 
              // Src: (sint_to_fp:{ *:[f32] } I64:{ *:[i64] }:$src) - Complexity = 3
              // Dst: (F32_CONVERT_S_I64:{ *:[f32] } I64:{ *:[i64] }:$src)
/* 17057*/   /*SwitchType*/ 6, MVT::f64,// ->17065
/* 17059*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F64_CONVERT_S_I64),
                  MVT::f64, 1/*#Ops*/, 0, 
              // Src: (sint_to_fp:{ *:[f64] } I64:{ *:[i64] }:$src) - Complexity = 3
              // Dst: (F64_CONVERT_S_I64:{ *:[f64] } I64:{ *:[i64] }:$src)
/* 17065*/   0, // EndSwitchType
/* 17066*/  /*Scope*/ 9, /*->17076*/
/* 17067*/   OPC_CheckType, MVT::v4f32,
/* 17069*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17070*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::sint_to_fp_F32x4),
                 MVT::v4f32, 1/*#Ops*/, 0, 
             // Src: (sint_to_fp:{ *:[v4f32] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
             // Dst: (sint_to_fp_F32x4:{ *:[v4f32] } V128:{ *:[v4i32] }:$vec)
/* 17076*/  0, /*End of Scope*/
/* 17077*/ /*SwitchOpcode*/ 53, TARGET_VAL(ISD::UINT_TO_FP),// ->17133
/* 17080*/  OPC_RecordChild0, // #0 = $src
/* 17081*/  OPC_Scope, 19, /*->17102*/ // 3 children in Scope
/* 17083*/   OPC_CheckChild0TypeI32,
/* 17084*/   OPC_SwitchType /*2 cases */, 6, MVT::f32,// ->17093
/* 17087*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F32_CONVERT_U_I32),
                  MVT::f32, 1/*#Ops*/, 0, 
              // Src: (uint_to_fp:{ *:[f32] } I32:{ *:[i32] }:$src) - Complexity = 3
              // Dst: (F32_CONVERT_U_I32:{ *:[f32] } I32:{ *:[i32] }:$src)
/* 17093*/   /*SwitchType*/ 6, MVT::f64,// ->17101
/* 17095*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F64_CONVERT_U_I32),
                  MVT::f64, 1/*#Ops*/, 0, 
              // Src: (uint_to_fp:{ *:[f64] } I32:{ *:[i32] }:$src) - Complexity = 3
              // Dst: (F64_CONVERT_U_I32:{ *:[f64] } I32:{ *:[i32] }:$src)
/* 17101*/   0, // EndSwitchType
/* 17102*/  /*Scope*/ 19, /*->17122*/
/* 17103*/   OPC_CheckChild0TypeI64,
/* 17104*/   OPC_SwitchType /*2 cases */, 6, MVT::f32,// ->17113
/* 17107*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F32_CONVERT_U_I64),
                  MVT::f32, 1/*#Ops*/, 0, 
              // Src: (uint_to_fp:{ *:[f32] } I64:{ *:[i64] }:$src) - Complexity = 3
              // Dst: (F32_CONVERT_U_I64:{ *:[f32] } I64:{ *:[i64] }:$src)
/* 17113*/   /*SwitchType*/ 6, MVT::f64,// ->17121
/* 17115*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F64_CONVERT_U_I64),
                  MVT::f64, 1/*#Ops*/, 0, 
              // Src: (uint_to_fp:{ *:[f64] } I64:{ *:[i64] }:$src) - Complexity = 3
              // Dst: (F64_CONVERT_U_I64:{ *:[f64] } I64:{ *:[i64] }:$src)
/* 17121*/   0, // EndSwitchType
/* 17122*/  /*Scope*/ 9, /*->17132*/
/* 17123*/   OPC_CheckType, MVT::v4f32,
/* 17125*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17126*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::uint_to_fp_F32x4),
                 MVT::v4f32, 1/*#Ops*/, 0, 
             // Src: (uint_to_fp:{ *:[v4f32] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
             // Dst: (uint_to_fp_F32x4:{ *:[v4f32] } V128:{ *:[v4i32] }:$vec)
/* 17132*/  0, /*End of Scope*/
/* 17133*/ /*SwitchOpcode*/ 7, TARGET_VAL(ISD::FP_EXTEND),// ->17143
/* 17136*/  OPC_RecordChild0, // #0 = $src
/* 17137*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F64_PROMOTE_F32),
                MVT::f64, 1/*#Ops*/, 0, 
            // Src: (fpextend:{ *:[f64] } F32:{ *:[f32] }:$src) - Complexity = 3
            // Dst: (F64_PROMOTE_F32:{ *:[f64] } F32:{ *:[f32] }:$src)
/* 17143*/ /*SwitchOpcode*/ 7, TARGET_VAL(ISD::FP_ROUND),// ->17153
/* 17146*/  OPC_RecordChild0, // #0 = $src
/* 17147*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F32_DEMOTE_F64),
                MVT::f32, 1/*#Ops*/, 0, 
            // Src: (fpround:{ *:[f32] } F64:{ *:[f64] }:$src) - Complexity = 3
            // Dst: (F32_DEMOTE_F64:{ *:[f32] } F64:{ *:[f64] }:$src)
/* 17153*/ /*SwitchOpcode*/ 52, TARGET_VAL(ISD::FADD),// ->17208
/* 17156*/  OPC_RecordChild0, // #0 = $lhs
/* 17157*/  OPC_RecordChild1, // #1 = $rhs
/* 17158*/  OPC_SwitchType /*5 cases */, 7, MVT::f32,// ->17168
/* 17161*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_F32),
                 MVT::f32, 2/*#Ops*/, 0, 1, 
             // Src: (fadd:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
             // Dst: (ADD_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 17168*/  /*SwitchType*/ 7, MVT::f64,// ->17177
/* 17170*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_F64),
                 MVT::f64, 2/*#Ops*/, 0, 1, 
             // Src: (fadd:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
             // Dst: (ADD_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 17177*/  /*SwitchType*/ 8, MVT::v4f32,// ->17187
/* 17179*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17180*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_F32x4),
                 MVT::v4f32, 2/*#Ops*/, 0, 1, 
             // Src: (fadd:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 3
             // Dst: (ADD_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 17187*/  /*SwitchType*/ 8, MVT::v2f64,// ->17197
/* 17189*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17190*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_F64x2),
                 MVT::v2f64, 2/*#Ops*/, 0, 1, 
             // Src: (fadd:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 3
             // Dst: (ADD_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 17197*/  /*SwitchType*/ 8, MVT::v8f16,// ->17207
/* 17199*/   OPC_CheckPatternPredicate6, // (Subtarget->hasHalfPrecision()) && (Subtarget->hasSIMD128())
/* 17200*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_F16x8),
                 MVT::v8f16, 2/*#Ops*/, 0, 1, 
             // Src: (fadd:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs) - Complexity = 3
             // Dst: (ADD_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 17207*/  0, // EndSwitchType
/* 17208*/ /*SwitchOpcode*/ 52, TARGET_VAL(ISD::FSUB),// ->17263
/* 17211*/  OPC_RecordChild0, // #0 = $lhs
/* 17212*/  OPC_RecordChild1, // #1 = $rhs
/* 17213*/  OPC_SwitchType /*5 cases */, 7, MVT::f32,// ->17223
/* 17216*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_F32),
                 MVT::f32, 2/*#Ops*/, 0, 1, 
             // Src: (fsub:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
             // Dst: (SUB_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 17223*/  /*SwitchType*/ 7, MVT::f64,// ->17232
/* 17225*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_F64),
                 MVT::f64, 2/*#Ops*/, 0, 1, 
             // Src: (fsub:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
             // Dst: (SUB_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 17232*/  /*SwitchType*/ 8, MVT::v4f32,// ->17242
/* 17234*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17235*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_F32x4),
                 MVT::v4f32, 2/*#Ops*/, 0, 1, 
             // Src: (fsub:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 3
             // Dst: (SUB_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 17242*/  /*SwitchType*/ 8, MVT::v2f64,// ->17252
/* 17244*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17245*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_F64x2),
                 MVT::v2f64, 2/*#Ops*/, 0, 1, 
             // Src: (fsub:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 3
             // Dst: (SUB_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 17252*/  /*SwitchType*/ 8, MVT::v8f16,// ->17262
/* 17254*/   OPC_CheckPatternPredicate6, // (Subtarget->hasHalfPrecision()) && (Subtarget->hasSIMD128())
/* 17255*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_F16x8),
                 MVT::v8f16, 2/*#Ops*/, 0, 1, 
             // Src: (fsub:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs) - Complexity = 3
             // Dst: (SUB_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 17262*/  0, // EndSwitchType
/* 17263*/ /*SwitchOpcode*/ 52, TARGET_VAL(ISD::FMUL),// ->17318
/* 17266*/  OPC_RecordChild0, // #0 = $lhs
/* 17267*/  OPC_RecordChild1, // #1 = $rhs
/* 17268*/  OPC_SwitchType /*5 cases */, 7, MVT::f32,// ->17278
/* 17271*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_F32),
                 MVT::f32, 2/*#Ops*/, 0, 1, 
             // Src: (fmul:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
             // Dst: (MUL_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 17278*/  /*SwitchType*/ 7, MVT::f64,// ->17287
/* 17280*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_F64),
                 MVT::f64, 2/*#Ops*/, 0, 1, 
             // Src: (fmul:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
             // Dst: (MUL_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 17287*/  /*SwitchType*/ 8, MVT::v4f32,// ->17297
/* 17289*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17290*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_F32x4),
                 MVT::v4f32, 2/*#Ops*/, 0, 1, 
             // Src: (fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 3
             // Dst: (MUL_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 17297*/  /*SwitchType*/ 8, MVT::v2f64,// ->17307
/* 17299*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17300*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_F64x2),
                 MVT::v2f64, 2/*#Ops*/, 0, 1, 
             // Src: (fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 3
             // Dst: (MUL_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 17307*/  /*SwitchType*/ 8, MVT::v8f16,// ->17317
/* 17309*/   OPC_CheckPatternPredicate6, // (Subtarget->hasHalfPrecision()) && (Subtarget->hasSIMD128())
/* 17310*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_F16x8),
                 MVT::v8f16, 2/*#Ops*/, 0, 1, 
             // Src: (fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs) - Complexity = 3
             // Dst: (MUL_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 17317*/  0, // EndSwitchType
/* 17318*/ /*SwitchOpcode*/ 52, TARGET_VAL(ISD::FDIV),// ->17373
/* 17321*/  OPC_RecordChild0, // #0 = $lhs
/* 17322*/  OPC_RecordChild1, // #1 = $rhs
/* 17323*/  OPC_SwitchType /*5 cases */, 7, MVT::f32,// ->17333
/* 17326*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DIV_F32),
                 MVT::f32, 2/*#Ops*/, 0, 1, 
             // Src: (fdiv:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
             // Dst: (DIV_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 17333*/  /*SwitchType*/ 7, MVT::f64,// ->17342
/* 17335*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DIV_F64),
                 MVT::f64, 2/*#Ops*/, 0, 1, 
             // Src: (fdiv:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
             // Dst: (DIV_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 17342*/  /*SwitchType*/ 8, MVT::v4f32,// ->17352
/* 17344*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17345*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DIV_F32x4),
                 MVT::v4f32, 2/*#Ops*/, 0, 1, 
             // Src: (fdiv:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 3
             // Dst: (DIV_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 17352*/  /*SwitchType*/ 8, MVT::v2f64,// ->17362
/* 17354*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17355*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DIV_F64x2),
                 MVT::v2f64, 2/*#Ops*/, 0, 1, 
             // Src: (fdiv:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 3
             // Dst: (DIV_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 17362*/  /*SwitchType*/ 8, MVT::v8f16,// ->17372
/* 17364*/   OPC_CheckPatternPredicate6, // (Subtarget->hasHalfPrecision()) && (Subtarget->hasSIMD128())
/* 17365*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DIV_F16x8),
                 MVT::v8f16, 2/*#Ops*/, 0, 1, 
             // Src: (fdiv:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs) - Complexity = 3
             // Dst: (DIV_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 17372*/  0, // EndSwitchType
/* 17373*/ /*SwitchOpcode*/ 46, TARGET_VAL(ISD::FSQRT),// ->17422
/* 17376*/  OPC_RecordChild0, // #0 = $src
/* 17377*/  OPC_SwitchType /*5 cases */, 6, MVT::f32,// ->17386
/* 17380*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SQRT_F32),
                 MVT::f32, 1/*#Ops*/, 0, 
             // Src: (fsqrt:{ *:[f32] } F32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (SQRT_F32:{ *:[f32] } F32:{ *:[f32] }:$src)
/* 17386*/  /*SwitchType*/ 6, MVT::f64,// ->17394
/* 17388*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SQRT_F64),
                 MVT::f64, 1/*#Ops*/, 0, 
             // Src: (fsqrt:{ *:[f64] } F64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (SQRT_F64:{ *:[f64] } F64:{ *:[f64] }:$src)
/* 17394*/  /*SwitchType*/ 7, MVT::v4f32,// ->17403
/* 17396*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17397*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SQRT_F32x4),
                 MVT::v4f32, 1/*#Ops*/, 0, 
             // Src: (fsqrt:{ *:[v4f32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
             // Dst: (SQRT_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$v)
/* 17403*/  /*SwitchType*/ 7, MVT::v2f64,// ->17412
/* 17405*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17406*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SQRT_F64x2),
                 MVT::v2f64, 1/*#Ops*/, 0, 
             // Src: (fsqrt:{ *:[v2f64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
             // Dst: (SQRT_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$v)
/* 17412*/  /*SwitchType*/ 7, MVT::v8f16,// ->17421
/* 17414*/   OPC_CheckPatternPredicate6, // (Subtarget->hasHalfPrecision()) && (Subtarget->hasSIMD128())
/* 17415*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SQRT_F16x8),
                 MVT::v8f16, 1/*#Ops*/, 0, 
             // Src: (fsqrt:{ *:[v8f16] } V128:{ *:[v8f16] }:$v) - Complexity = 3
             // Dst: (SQRT_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$v)
/* 17421*/  0, // EndSwitchType
/* 17422*/ /*SwitchOpcode*/ 46, TARGET_VAL(ISD::FABS),// ->17471
/* 17425*/  OPC_RecordChild0, // #0 = $src
/* 17426*/  OPC_SwitchType /*5 cases */, 6, MVT::f32,// ->17435
/* 17429*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ABS_F32),
                 MVT::f32, 1/*#Ops*/, 0, 
             // Src: (fabs:{ *:[f32] } F32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (ABS_F32:{ *:[f32] } F32:{ *:[f32] }:$src)
/* 17435*/  /*SwitchType*/ 6, MVT::f64,// ->17443
/* 17437*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ABS_F64),
                 MVT::f64, 1/*#Ops*/, 0, 
             // Src: (fabs:{ *:[f64] } F64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (ABS_F64:{ *:[f64] } F64:{ *:[f64] }:$src)
/* 17443*/  /*SwitchType*/ 7, MVT::v4f32,// ->17452
/* 17445*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17446*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ABS_F32x4),
                 MVT::v4f32, 1/*#Ops*/, 0, 
             // Src: (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
             // Dst: (ABS_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$v)
/* 17452*/  /*SwitchType*/ 7, MVT::v2f64,// ->17461
/* 17454*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17455*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ABS_F64x2),
                 MVT::v2f64, 1/*#Ops*/, 0, 
             // Src: (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
             // Dst: (ABS_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$v)
/* 17461*/  /*SwitchType*/ 7, MVT::v8f16,// ->17470
/* 17463*/   OPC_CheckPatternPredicate6, // (Subtarget->hasHalfPrecision()) && (Subtarget->hasSIMD128())
/* 17464*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ABS_F16x8),
                 MVT::v8f16, 1/*#Ops*/, 0, 
             // Src: (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$v) - Complexity = 3
             // Dst: (ABS_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$v)
/* 17470*/  0, // EndSwitchType
/* 17471*/ /*SwitchOpcode*/ 46, TARGET_VAL(ISD::FNEG),// ->17520
/* 17474*/  OPC_RecordChild0, // #0 = $src
/* 17475*/  OPC_SwitchType /*5 cases */, 6, MVT::f32,// ->17484
/* 17478*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEG_F32),
                 MVT::f32, 1/*#Ops*/, 0, 
             // Src: (fneg:{ *:[f32] } F32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (NEG_F32:{ *:[f32] } F32:{ *:[f32] }:$src)
/* 17484*/  /*SwitchType*/ 6, MVT::f64,// ->17492
/* 17486*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEG_F64),
                 MVT::f64, 1/*#Ops*/, 0, 
             // Src: (fneg:{ *:[f64] } F64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (NEG_F64:{ *:[f64] } F64:{ *:[f64] }:$src)
/* 17492*/  /*SwitchType*/ 7, MVT::v4f32,// ->17501
/* 17494*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17495*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEG_F32x4),
                 MVT::v4f32, 1/*#Ops*/, 0, 
             // Src: (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
             // Dst: (NEG_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$v)
/* 17501*/  /*SwitchType*/ 7, MVT::v2f64,// ->17510
/* 17503*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17504*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEG_F64x2),
                 MVT::v2f64, 1/*#Ops*/, 0, 
             // Src: (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
             // Dst: (NEG_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$v)
/* 17510*/  /*SwitchType*/ 7, MVT::v8f16,// ->17519
/* 17512*/   OPC_CheckPatternPredicate6, // (Subtarget->hasHalfPrecision()) && (Subtarget->hasSIMD128())
/* 17513*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEG_F16x8),
                 MVT::v8f16, 1/*#Ops*/, 0, 
             // Src: (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$v) - Complexity = 3
             // Dst: (NEG_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$v)
/* 17519*/  0, // EndSwitchType
/* 17520*/ /*SwitchOpcode*/ 62, TARGET_VAL(ISD::FCOPYSIGN),// ->17585
/* 17523*/  OPC_RecordChild0, // #0 = $lhs
/* 17524*/  OPC_RecordChild1, // #1 = $rhs
/* 17525*/  OPC_Scope, 28, /*->17555*/ // 2 children in Scope
/* 17527*/   OPC_CheckChild1Type, MVT::f32,
/* 17529*/   OPC_SwitchType /*2 cases */, 7, MVT::f32,// ->17539
/* 17532*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::COPYSIGN_F32),
                  MVT::f32, 2/*#Ops*/, 0, 1, 
              // Src: (fcopysign:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
              // Dst: (COPYSIGN_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 17539*/   /*SwitchType*/ 13, MVT::f64,// ->17554
/* 17541*/    OPC_EmitNode1None, TARGET_VAL(WebAssembly::F64_PROMOTE_F32),
                  MVT::f64, 1/*#Ops*/, 1,  // Results = #2
/* 17547*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::COPYSIGN_F64),
                  MVT::f64, 2/*#Ops*/, 0, 2, 
              // Src: (fcopysign:{ *:[f64] } F64:{ *:[f64] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
              // Dst: (COPYSIGN_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, (F64_PROMOTE_F32:{ *:[f64] } F32:{ *:[f32] }:$rhs))
/* 17554*/   0, // EndSwitchType
/* 17555*/  /*Scope*/ 28, /*->17584*/
/* 17556*/   OPC_CheckChild1Type, MVT::f64,
/* 17558*/   OPC_SwitchType /*2 cases */, 7, MVT::f64,// ->17568
/* 17561*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::COPYSIGN_F64),
                  MVT::f64, 2/*#Ops*/, 0, 1, 
              // Src: (fcopysign:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
              // Dst: (COPYSIGN_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 17568*/   /*SwitchType*/ 13, MVT::f32,// ->17583
/* 17570*/    OPC_EmitNode1None, TARGET_VAL(WebAssembly::F32_DEMOTE_F64),
                  MVT::f32, 1/*#Ops*/, 1,  // Results = #2
/* 17576*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::COPYSIGN_F32),
                  MVT::f32, 2/*#Ops*/, 0, 2, 
              // Src: (fcopysign:{ *:[f32] } F32:{ *:[f32] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
              // Dst: (COPYSIGN_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, (F32_DEMOTE_F64:{ *:[f32] } F64:{ *:[f64] }:$rhs))
/* 17583*/   0, // EndSwitchType
/* 17584*/  0, /*End of Scope*/
/* 17585*/ /*SwitchOpcode*/ 52, TARGET_VAL(ISD::FMINIMUM),// ->17640
/* 17588*/  OPC_RecordChild0, // #0 = $lhs
/* 17589*/  OPC_RecordChild1, // #1 = $rhs
/* 17590*/  OPC_SwitchType /*5 cases */, 7, MVT::f32,// ->17600
/* 17593*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_F32),
                 MVT::f32, 2/*#Ops*/, 0, 1, 
             // Src: (fminimum:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
             // Dst: (MIN_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 17600*/  /*SwitchType*/ 7, MVT::f64,// ->17609
/* 17602*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_F64),
                 MVT::f64, 2/*#Ops*/, 0, 1, 
             // Src: (fminimum:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
             // Dst: (MIN_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 17609*/  /*SwitchType*/ 8, MVT::v4f32,// ->17619
/* 17611*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17612*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_F32x4),
                 MVT::v4f32, 2/*#Ops*/, 0, 1, 
             // Src: (fminimum:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 3
             // Dst: (MIN_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 17619*/  /*SwitchType*/ 8, MVT::v2f64,// ->17629
/* 17621*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17622*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_F64x2),
                 MVT::v2f64, 2/*#Ops*/, 0, 1, 
             // Src: (fminimum:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 3
             // Dst: (MIN_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 17629*/  /*SwitchType*/ 8, MVT::v8f16,// ->17639
/* 17631*/   OPC_CheckPatternPredicate6, // (Subtarget->hasHalfPrecision()) && (Subtarget->hasSIMD128())
/* 17632*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_F16x8),
                 MVT::v8f16, 2/*#Ops*/, 0, 1, 
             // Src: (fminimum:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs) - Complexity = 3
             // Dst: (MIN_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 17639*/  0, // EndSwitchType
/* 17640*/ /*SwitchOpcode*/ 52, TARGET_VAL(ISD::FMAXIMUM),// ->17695
/* 17643*/  OPC_RecordChild0, // #0 = $lhs
/* 17644*/  OPC_RecordChild1, // #1 = $rhs
/* 17645*/  OPC_SwitchType /*5 cases */, 7, MVT::f32,// ->17655
/* 17648*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_F32),
                 MVT::f32, 2/*#Ops*/, 0, 1, 
             // Src: (fmaximum:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
             // Dst: (MAX_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 17655*/  /*SwitchType*/ 7, MVT::f64,// ->17664
/* 17657*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_F64),
                 MVT::f64, 2/*#Ops*/, 0, 1, 
             // Src: (fmaximum:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
             // Dst: (MAX_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 17664*/  /*SwitchType*/ 8, MVT::v4f32,// ->17674
/* 17666*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17667*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_F32x4),
                 MVT::v4f32, 2/*#Ops*/, 0, 1, 
             // Src: (fmaximum:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 3
             // Dst: (MAX_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 17674*/  /*SwitchType*/ 8, MVT::v2f64,// ->17684
/* 17676*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17677*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_F64x2),
                 MVT::v2f64, 2/*#Ops*/, 0, 1, 
             // Src: (fmaximum:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 3
             // Dst: (MAX_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 17684*/  /*SwitchType*/ 8, MVT::v8f16,// ->17694
/* 17686*/   OPC_CheckPatternPredicate6, // (Subtarget->hasHalfPrecision()) && (Subtarget->hasSIMD128())
/* 17687*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_F16x8),
                 MVT::v8f16, 2/*#Ops*/, 0, 1, 
             // Src: (fmaximum:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs) - Complexity = 3
             // Dst: (MAX_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 17694*/  0, // EndSwitchType
/* 17695*/ /*SwitchOpcode*/ 46, TARGET_VAL(ISD::FCEIL),// ->17744
/* 17698*/  OPC_RecordChild0, // #0 = $src
/* 17699*/  OPC_SwitchType /*5 cases */, 6, MVT::f32,// ->17708
/* 17702*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CEIL_F32),
                 MVT::f32, 1/*#Ops*/, 0, 
             // Src: (fceil:{ *:[f32] } F32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (CEIL_F32:{ *:[f32] } F32:{ *:[f32] }:$src)
/* 17708*/  /*SwitchType*/ 6, MVT::f64,// ->17716
/* 17710*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CEIL_F64),
                 MVT::f64, 1/*#Ops*/, 0, 
             // Src: (fceil:{ *:[f64] } F64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (CEIL_F64:{ *:[f64] } F64:{ *:[f64] }:$src)
/* 17716*/  /*SwitchType*/ 7, MVT::v4f32,// ->17725
/* 17718*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17719*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CEIL_F32x4),
                 MVT::v4f32, 1/*#Ops*/, 0, 
             // Src: (fceil:{ *:[v4f32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
             // Dst: (CEIL_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$v)
/* 17725*/  /*SwitchType*/ 7, MVT::v2f64,// ->17734
/* 17727*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17728*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CEIL_F64x2),
                 MVT::v2f64, 1/*#Ops*/, 0, 
             // Src: (fceil:{ *:[v2f64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
             // Dst: (CEIL_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$v)
/* 17734*/  /*SwitchType*/ 7, MVT::v8f16,// ->17743
/* 17736*/   OPC_CheckPatternPredicate6, // (Subtarget->hasHalfPrecision()) && (Subtarget->hasSIMD128())
/* 17737*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CEIL_F16x8),
                 MVT::v8f16, 1/*#Ops*/, 0, 
             // Src: (fceil:{ *:[v8f16] } V128:{ *:[v8f16] }:$v) - Complexity = 3
             // Dst: (CEIL_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$v)
/* 17743*/  0, // EndSwitchType
/* 17744*/ /*SwitchOpcode*/ 46, TARGET_VAL(ISD::FFLOOR),// ->17793
/* 17747*/  OPC_RecordChild0, // #0 = $src
/* 17748*/  OPC_SwitchType /*5 cases */, 6, MVT::f32,// ->17757
/* 17751*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FLOOR_F32),
                 MVT::f32, 1/*#Ops*/, 0, 
             // Src: (ffloor:{ *:[f32] } F32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (FLOOR_F32:{ *:[f32] } F32:{ *:[f32] }:$src)
/* 17757*/  /*SwitchType*/ 6, MVT::f64,// ->17765
/* 17759*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FLOOR_F64),
                 MVT::f64, 1/*#Ops*/, 0, 
             // Src: (ffloor:{ *:[f64] } F64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (FLOOR_F64:{ *:[f64] } F64:{ *:[f64] }:$src)
/* 17765*/  /*SwitchType*/ 7, MVT::v4f32,// ->17774
/* 17767*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17768*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FLOOR_F32x4),
                 MVT::v4f32, 1/*#Ops*/, 0, 
             // Src: (ffloor:{ *:[v4f32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
             // Dst: (FLOOR_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$v)
/* 17774*/  /*SwitchType*/ 7, MVT::v2f64,// ->17783
/* 17776*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17777*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FLOOR_F64x2),
                 MVT::v2f64, 1/*#Ops*/, 0, 
             // Src: (ffloor:{ *:[v2f64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
             // Dst: (FLOOR_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$v)
/* 17783*/  /*SwitchType*/ 7, MVT::v8f16,// ->17792
/* 17785*/   OPC_CheckPatternPredicate6, // (Subtarget->hasHalfPrecision()) && (Subtarget->hasSIMD128())
/* 17786*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FLOOR_F16x8),
                 MVT::v8f16, 1/*#Ops*/, 0, 
             // Src: (ffloor:{ *:[v8f16] } V128:{ *:[v8f16] }:$v) - Complexity = 3
             // Dst: (FLOOR_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$v)
/* 17792*/  0, // EndSwitchType
/* 17793*/ /*SwitchOpcode*/ 46, TARGET_VAL(ISD::FTRUNC),// ->17842
/* 17796*/  OPC_RecordChild0, // #0 = $src
/* 17797*/  OPC_SwitchType /*5 cases */, 6, MVT::f32,// ->17806
/* 17800*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::TRUNC_F32),
                 MVT::f32, 1/*#Ops*/, 0, 
             // Src: (ftrunc:{ *:[f32] } F32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (TRUNC_F32:{ *:[f32] } F32:{ *:[f32] }:$src)
/* 17806*/  /*SwitchType*/ 6, MVT::f64,// ->17814
/* 17808*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::TRUNC_F64),
                 MVT::f64, 1/*#Ops*/, 0, 
             // Src: (ftrunc:{ *:[f64] } F64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (TRUNC_F64:{ *:[f64] } F64:{ *:[f64] }:$src)
/* 17814*/  /*SwitchType*/ 7, MVT::v4f32,// ->17823
/* 17816*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17817*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::TRUNC_F32x4),
                 MVT::v4f32, 1/*#Ops*/, 0, 
             // Src: (ftrunc:{ *:[v4f32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
             // Dst: (TRUNC_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$v)
/* 17823*/  /*SwitchType*/ 7, MVT::v2f64,// ->17832
/* 17825*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17826*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::TRUNC_F64x2),
                 MVT::v2f64, 1/*#Ops*/, 0, 
             // Src: (ftrunc:{ *:[v2f64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
             // Dst: (TRUNC_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$v)
/* 17832*/  /*SwitchType*/ 7, MVT::v8f16,// ->17841
/* 17834*/   OPC_CheckPatternPredicate6, // (Subtarget->hasHalfPrecision()) && (Subtarget->hasSIMD128())
/* 17835*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::TRUNC_F16x8),
                 MVT::v8f16, 1/*#Ops*/, 0, 
             // Src: (ftrunc:{ *:[v8f16] } V128:{ *:[v8f16] }:$v) - Complexity = 3
             // Dst: (TRUNC_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$v)
/* 17841*/  0, // EndSwitchType
/* 17842*/ /*SwitchOpcode*/ 46, TARGET_VAL(ISD::FNEARBYINT),// ->17891
/* 17845*/  OPC_RecordChild0, // #0 = $src
/* 17846*/  OPC_SwitchType /*5 cases */, 6, MVT::f32,// ->17855
/* 17849*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F32),
                 MVT::f32, 1/*#Ops*/, 0, 
             // Src: (fnearbyint:{ *:[f32] } F32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (NEAREST_F32:{ *:[f32] } F32:{ *:[f32] }:$src)
/* 17855*/  /*SwitchType*/ 6, MVT::f64,// ->17863
/* 17857*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F64),
                 MVT::f64, 1/*#Ops*/, 0, 
             // Src: (fnearbyint:{ *:[f64] } F64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (NEAREST_F64:{ *:[f64] } F64:{ *:[f64] }:$src)
/* 17863*/  /*SwitchType*/ 7, MVT::v4f32,// ->17872
/* 17865*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17866*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F32x4),
                 MVT::v4f32, 1/*#Ops*/, 0, 
             // Src: (fnearbyint:{ *:[v4f32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
             // Dst: (NEAREST_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$v)
/* 17872*/  /*SwitchType*/ 7, MVT::v2f64,// ->17881
/* 17874*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17875*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F64x2),
                 MVT::v2f64, 1/*#Ops*/, 0, 
             // Src: (fnearbyint:{ *:[v2f64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
             // Dst: (NEAREST_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$v)
/* 17881*/  /*SwitchType*/ 7, MVT::v8f16,// ->17890
/* 17883*/   OPC_CheckPatternPredicate6, // (Subtarget->hasHalfPrecision()) && (Subtarget->hasSIMD128())
/* 17884*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F16x8),
                 MVT::v8f16, 1/*#Ops*/, 0, 
             // Src: (fnearbyint:{ *:[v8f16] } V128:{ *:[v8f16] }:$v) - Complexity = 3
             // Dst: (NEAREST_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$v)
/* 17890*/  0, // EndSwitchType
/* 17891*/ /*SwitchOpcode*/ 43, TARGET_VAL(ISD::FRINT),// ->17937
/* 17894*/  OPC_RecordChild0, // #0 = $src
/* 17895*/  OPC_SwitchType /*5 cases */, 6, MVT::f32,// ->17904
/* 17898*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F32),
                 MVT::f32, 1/*#Ops*/, 0, 
             // Src: (frint:{ *:[f32] } f32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (NEAREST_F32:{ *:[f32] } f32:{ *:[f32] }:$src)
/* 17904*/  /*SwitchType*/ 6, MVT::f64,// ->17912
/* 17906*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F64),
                 MVT::f64, 1/*#Ops*/, 0, 
             // Src: (frint:{ *:[f64] } f64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (NEAREST_F64:{ *:[f64] } f64:{ *:[f64] }:$src)
/* 17912*/  /*SwitchType*/ 6, MVT::v4f32,// ->17920
/* 17914*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F32x4),
                 MVT::v4f32, 1/*#Ops*/, 0, 
             // Src: (frint:{ *:[v4f32] } V128:{ *:[v4f32] }:$src) - Complexity = 3
             // Dst: (NEAREST_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$src)
/* 17920*/  /*SwitchType*/ 6, MVT::v2f64,// ->17928
/* 17922*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F64x2),
                 MVT::v2f64, 1/*#Ops*/, 0, 
             // Src: (frint:{ *:[v2f64] } V128:{ *:[v2f64] }:$src) - Complexity = 3
             // Dst: (NEAREST_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$src)
/* 17928*/  /*SwitchType*/ 6, MVT::v8f16,// ->17936
/* 17930*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F16x8),
                 MVT::v8f16, 1/*#Ops*/, 0, 
             // Src: (frint:{ *:[v8f16] } V128:{ *:[v8f16] }:$src) - Complexity = 3
             // Dst: (NEAREST_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$src)
/* 17936*/  0, // EndSwitchType
/* 17937*/ /*SwitchOpcode*/ 43, TARGET_VAL(ISD::FROUNDEVEN),// ->17983
/* 17940*/  OPC_RecordChild0, // #0 = $src
/* 17941*/  OPC_SwitchType /*5 cases */, 6, MVT::f32,// ->17950
/* 17944*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F32),
                 MVT::f32, 1/*#Ops*/, 0, 
             // Src: (froundeven:{ *:[f32] } f32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (NEAREST_F32:{ *:[f32] } f32:{ *:[f32] }:$src)
/* 17950*/  /*SwitchType*/ 6, MVT::f64,// ->17958
/* 17952*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F64),
                 MVT::f64, 1/*#Ops*/, 0, 
             // Src: (froundeven:{ *:[f64] } f64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (NEAREST_F64:{ *:[f64] } f64:{ *:[f64] }:$src)
/* 17958*/  /*SwitchType*/ 6, MVT::v4f32,// ->17966
/* 17960*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F32x4),
                 MVT::v4f32, 1/*#Ops*/, 0, 
             // Src: (froundeven:{ *:[v4f32] } V128:{ *:[v4f32] }:$src) - Complexity = 3
             // Dst: (NEAREST_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$src)
/* 17966*/  /*SwitchType*/ 6, MVT::v2f64,// ->17974
/* 17968*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F64x2),
                 MVT::v2f64, 1/*#Ops*/, 0, 
             // Src: (froundeven:{ *:[v2f64] } V128:{ *:[v2f64] }:$src) - Complexity = 3
             // Dst: (NEAREST_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$src)
/* 17974*/  /*SwitchType*/ 6, MVT::v8f16,// ->17982
/* 17976*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F16x8),
                 MVT::v8f16, 1/*#Ops*/, 0, 
             // Src: (froundeven:{ *:[v8f16] } V128:{ *:[v8f16] }:$src) - Complexity = 3
             // Dst: (NEAREST_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$src)
/* 17982*/  0, // EndSwitchType
/* 17983*/ /*SwitchOpcode*/ 20|128,3/*404*/, TARGET_VAL(ISD::BUILD_VECTOR),// ->18391
/* 17987*/  OPC_RecordChild0, // #0 = $i0
/* 17988*/  OPC_MoveChild0,
/* 17989*/  OPC_SwitchOpcode /*2 cases */, 73|128,2/*329*/, TARGET_VAL(ISD::Constant),// ->18323
/* 17994*/   OPC_SwitchType /*2 cases */, 47|128,2/*303*/, MVT::i32,// ->18301
/* 17998*/    OPC_Scope, 51|128,1/*179*/, /*->18180*/ // 3 children in Scope
/* 18001*/     OPC_CheckPredicate, 8, // Predicate_ImmI8
/* 18003*/     OPC_MoveSibling1,
/* 18004*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18007*/     OPC_RecordNode, // #1 = $i1
/* 18008*/     OPC_CheckPredicate, 8, // Predicate_ImmI8
/* 18010*/     OPC_CheckTypeI32,
/* 18011*/     OPC_MoveSibling2,
/* 18012*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18015*/     OPC_RecordNode, // #2 = $i2
/* 18016*/     OPC_CheckPredicate, 8, // Predicate_ImmI8
/* 18018*/     OPC_CheckTypeI32,
/* 18019*/     OPC_MoveSibling3,
/* 18020*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18023*/     OPC_RecordNode, // #3 = $i3
/* 18024*/     OPC_CheckPredicate, 8, // Predicate_ImmI8
/* 18026*/     OPC_CheckTypeI32,
/* 18027*/     OPC_MoveSibling4,
/* 18028*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18031*/     OPC_RecordNode, // #4 = $i4
/* 18032*/     OPC_CheckPredicate, 8, // Predicate_ImmI8
/* 18034*/     OPC_CheckTypeI32,
/* 18035*/     OPC_MoveSibling5,
/* 18036*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18039*/     OPC_RecordNode, // #5 = $i5
/* 18040*/     OPC_CheckPredicate, 8, // Predicate_ImmI8
/* 18042*/     OPC_CheckTypeI32,
/* 18043*/     OPC_MoveSibling6,
/* 18044*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18047*/     OPC_RecordNode, // #6 = $i6
/* 18048*/     OPC_CheckPredicate, 8, // Predicate_ImmI8
/* 18050*/     OPC_CheckTypeI32,
/* 18051*/     OPC_MoveSibling7,
/* 18052*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18055*/     OPC_RecordNode, // #7 = $i7
/* 18056*/     OPC_CheckPredicate, 8, // Predicate_ImmI8
/* 18058*/     OPC_CheckTypeI32,
/* 18059*/     OPC_MoveSibling, 8,
/* 18061*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18064*/     OPC_RecordNode, // #8 = $i8
/* 18065*/     OPC_CheckPredicate, 8, // Predicate_ImmI8
/* 18067*/     OPC_CheckTypeI32,
/* 18068*/     OPC_MoveSibling, 9,
/* 18070*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18073*/     OPC_RecordNode, // #9 = $i9
/* 18074*/     OPC_CheckPredicate, 8, // Predicate_ImmI8
/* 18076*/     OPC_CheckTypeI32,
/* 18077*/     OPC_MoveSibling, 10,
/* 18079*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18082*/     OPC_RecordNode, // #10 = $iA
/* 18083*/     OPC_CheckPredicate, 8, // Predicate_ImmI8
/* 18085*/     OPC_CheckTypeI32,
/* 18086*/     OPC_MoveSibling, 11,
/* 18088*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18091*/     OPC_RecordNode, // #11 = $iB
/* 18092*/     OPC_CheckPredicate, 8, // Predicate_ImmI8
/* 18094*/     OPC_CheckTypeI32,
/* 18095*/     OPC_MoveSibling, 12,
/* 18097*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18100*/     OPC_RecordNode, // #12 = $iC
/* 18101*/     OPC_CheckPredicate, 8, // Predicate_ImmI8
/* 18103*/     OPC_CheckTypeI32,
/* 18104*/     OPC_MoveSibling, 13,
/* 18106*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18109*/     OPC_RecordNode, // #13 = $iD
/* 18110*/     OPC_CheckPredicate, 8, // Predicate_ImmI8
/* 18112*/     OPC_CheckTypeI32,
/* 18113*/     OPC_MoveSibling, 14,
/* 18115*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18118*/     OPC_RecordNode, // #14 = $iE
/* 18119*/     OPC_CheckPredicate, 8, // Predicate_ImmI8
/* 18121*/     OPC_CheckTypeI32,
/* 18122*/     OPC_MoveSibling, 15,
/* 18124*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18127*/     OPC_RecordNode, // #15 = $iF
/* 18128*/     OPC_CheckPredicate, 8, // Predicate_ImmI8
/* 18130*/     OPC_CheckTypeI32,
/* 18131*/     OPC_MoveParent,
/* 18132*/     OPC_CheckType, MVT::v16i8,
/* 18134*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 18135*/     OPC_EmitConvertToTarget0,
/* 18136*/     OPC_EmitConvertToTarget1,
/* 18137*/     OPC_EmitConvertToTarget2,
/* 18138*/     OPC_EmitConvertToTarget3,
/* 18139*/     OPC_EmitConvertToTarget4,
/* 18140*/     OPC_EmitConvertToTarget5,
/* 18141*/     OPC_EmitConvertToTarget6,
/* 18142*/     OPC_EmitConvertToTarget7,
/* 18143*/     OPC_EmitConvertToTarget, 8,
/* 18145*/     OPC_EmitConvertToTarget, 9,
/* 18147*/     OPC_EmitConvertToTarget, 10,
/* 18149*/     OPC_EmitConvertToTarget, 11,
/* 18151*/     OPC_EmitConvertToTarget, 12,
/* 18153*/     OPC_EmitConvertToTarget, 13,
/* 18155*/     OPC_EmitConvertToTarget, 14,
/* 18157*/     OPC_EmitConvertToTarget, 15,
/* 18159*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_I8x16),
                   MVT::v16i8, 16/*#Ops*/, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 
               // Src: (build_vector:{ *:[v16i8] } (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i0, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i1, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i2, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i3, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i4, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i5, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i6, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i7, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i8, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i9, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$iA, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$iB, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$iC, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$iD, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$iE, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$iF) - Complexity = 67
               // Dst: (CONST_V128_I8x16:{ *:[v16i8] } (imm:{ *:[i32] }):$i0, (imm:{ *:[i32] }):$i1, (imm:{ *:[i32] }):$i2, (imm:{ *:[i32] }):$i3, (imm:{ *:[i32] }):$i4, (imm:{ *:[i32] }):$i5, (imm:{ *:[i32] }):$i6, (imm:{ *:[i32] }):$i7, (imm:{ *:[i32] }):$i8, (imm:{ *:[i32] }):$i9, (imm:{ *:[i32] }):$iA, (imm:{ *:[i32] }):$iB, (imm:{ *:[i32] }):$iC, (imm:{ *:[i32] }):$iD, (imm:{ *:[i32] }):$iE, (imm:{ *:[i32] }):$iF)
/* 18180*/    /*Scope*/ 83, /*->18264*/
/* 18181*/     OPC_CheckPredicate, 15, // Predicate_ImmI16
/* 18183*/     OPC_MoveSibling1,
/* 18184*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18187*/     OPC_RecordNode, // #1 = $i1
/* 18188*/     OPC_CheckPredicate, 15, // Predicate_ImmI16
/* 18190*/     OPC_CheckTypeI32,
/* 18191*/     OPC_MoveSibling2,
/* 18192*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18195*/     OPC_RecordNode, // #2 = $i2
/* 18196*/     OPC_CheckPredicate, 15, // Predicate_ImmI16
/* 18198*/     OPC_CheckTypeI32,
/* 18199*/     OPC_MoveSibling3,
/* 18200*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18203*/     OPC_RecordNode, // #3 = $i3
/* 18204*/     OPC_CheckPredicate, 15, // Predicate_ImmI16
/* 18206*/     OPC_CheckTypeI32,
/* 18207*/     OPC_MoveSibling4,
/* 18208*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18211*/     OPC_RecordNode, // #4 = $i4
/* 18212*/     OPC_CheckPredicate, 15, // Predicate_ImmI16
/* 18214*/     OPC_CheckTypeI32,
/* 18215*/     OPC_MoveSibling5,
/* 18216*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18219*/     OPC_RecordNode, // #5 = $i5
/* 18220*/     OPC_CheckPredicate, 15, // Predicate_ImmI16
/* 18222*/     OPC_CheckTypeI32,
/* 18223*/     OPC_MoveSibling6,
/* 18224*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18227*/     OPC_RecordNode, // #6 = $i6
/* 18228*/     OPC_CheckPredicate, 15, // Predicate_ImmI16
/* 18230*/     OPC_CheckTypeI32,
/* 18231*/     OPC_MoveSibling7,
/* 18232*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18235*/     OPC_RecordNode, // #7 = $i7
/* 18236*/     OPC_CheckPredicate, 15, // Predicate_ImmI16
/* 18238*/     OPC_CheckTypeI32,
/* 18239*/     OPC_MoveParent,
/* 18240*/     OPC_CheckType, MVT::v8i16,
/* 18242*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 18243*/     OPC_EmitConvertToTarget0,
/* 18244*/     OPC_EmitConvertToTarget1,
/* 18245*/     OPC_EmitConvertToTarget2,
/* 18246*/     OPC_EmitConvertToTarget3,
/* 18247*/     OPC_EmitConvertToTarget4,
/* 18248*/     OPC_EmitConvertToTarget5,
/* 18249*/     OPC_EmitConvertToTarget6,
/* 18250*/     OPC_EmitConvertToTarget7,
/* 18251*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_I16x8),
                   MVT::v8i16, 8/*#Ops*/, 8, 9, 10, 11, 12, 13, 14, 15, 
               // Src: (build_vector:{ *:[v8i16] } (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i0, (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i1, (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i2, (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i3, (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i4, (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i5, (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i6, (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i7) - Complexity = 35
               // Dst: (CONST_V128_I16x8:{ *:[v8i16] } (imm:{ *:[i32] }):$i0, (imm:{ *:[i32] }):$i1, (imm:{ *:[i32] }):$i2, (imm:{ *:[i32] }):$i3, (imm:{ *:[i32] }):$i4, (imm:{ *:[i32] }):$i5, (imm:{ *:[i32] }):$i6, (imm:{ *:[i32] }):$i7)
/* 18264*/    /*Scope*/ 35, /*->18300*/
/* 18265*/     OPC_MoveSibling1,
/* 18266*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18269*/     OPC_RecordNode, // #1 = $i1
/* 18270*/     OPC_CheckTypeI32,
/* 18271*/     OPC_MoveSibling2,
/* 18272*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18275*/     OPC_RecordNode, // #2 = $i2
/* 18276*/     OPC_CheckTypeI32,
/* 18277*/     OPC_MoveSibling3,
/* 18278*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18281*/     OPC_RecordNode, // #3 = $i3
/* 18282*/     OPC_CheckTypeI32,
/* 18283*/     OPC_MoveParent,
/* 18284*/     OPC_CheckType, MVT::v4i32,
/* 18286*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 18287*/     OPC_EmitConvertToTarget0,
/* 18288*/     OPC_EmitConvertToTarget1,
/* 18289*/     OPC_EmitConvertToTarget2,
/* 18290*/     OPC_EmitConvertToTarget3,
/* 18291*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_I32x4),
                   MVT::v4i32, 4/*#Ops*/, 4, 5, 6, 7, 
               // Src: (build_vector:{ *:[v4i32] } (imm:{ *:[i32] }):$i0, (imm:{ *:[i32] }):$i1, (imm:{ *:[i32] }):$i2, (imm:{ *:[i32] }):$i3) - Complexity = 15
               // Dst: (CONST_V128_I32x4:{ *:[v4i32] } (imm:{ *:[i32] }):$i0, (imm:{ *:[i32] }):$i1, (imm:{ *:[i32] }):$i2, (imm:{ *:[i32] }):$i3)
/* 18300*/    0, /*End of Scope*/
/* 18301*/   /*SwitchType*/ 19, MVT::i64,// ->18322
/* 18303*/    OPC_MoveSibling1,
/* 18304*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18307*/    OPC_RecordNode, // #1 = $i1
/* 18308*/    OPC_CheckTypeI64,
/* 18309*/    OPC_MoveParent,
/* 18310*/    OPC_CheckType, MVT::v2i64,
/* 18312*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 18313*/    OPC_EmitConvertToTarget0,
/* 18314*/    OPC_EmitConvertToTarget1,
/* 18315*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_I64x2),
                  MVT::v2i64, 2/*#Ops*/, 2, 3, 
              // Src: (build_vector:{ *:[v2i64] } (imm:{ *:[i64] }):$i0, (imm:{ *:[i64] }):$i1) - Complexity = 9
              // Dst: (CONST_V128_I64x2:{ *:[v2i64] } (imm:{ *:[i64] }):$i0, (imm:{ *:[i64] }):$i1)
/* 18322*/   0, // EndSwitchType
/* 18323*/  /*SwitchOpcode*/ 64, TARGET_VAL(ISD::ConstantFP),// ->18390
/* 18326*/   OPC_SwitchType /*2 cases */, 38, MVT::f32,// ->18367
/* 18329*/    OPC_MoveSibling1,
/* 18330*/    OPC_CheckOpcode, TARGET_VAL(ISD::ConstantFP),
/* 18333*/    OPC_RecordNode, // #1 = $i1
/* 18334*/    OPC_CheckType, MVT::f32,
/* 18336*/    OPC_MoveSibling2,
/* 18337*/    OPC_CheckOpcode, TARGET_VAL(ISD::ConstantFP),
/* 18340*/    OPC_RecordNode, // #2 = $i2
/* 18341*/    OPC_CheckType, MVT::f32,
/* 18343*/    OPC_MoveSibling3,
/* 18344*/    OPC_CheckOpcode, TARGET_VAL(ISD::ConstantFP),
/* 18347*/    OPC_RecordNode, // #3 = $i3
/* 18348*/    OPC_CheckType, MVT::f32,
/* 18350*/    OPC_MoveParent,
/* 18351*/    OPC_CheckType, MVT::v4f32,
/* 18353*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 18354*/    OPC_EmitConvertToTarget0,
/* 18355*/    OPC_EmitConvertToTarget1,
/* 18356*/    OPC_EmitConvertToTarget2,
/* 18357*/    OPC_EmitConvertToTarget3,
/* 18358*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_F32x4),
                  MVT::v4f32, 4/*#Ops*/, 4, 5, 6, 7, 
              // Src: (build_vector:{ *:[v4f32] } (fpimm:{ *:[f32] }):$i0, (fpimm:{ *:[f32] }):$i1, (fpimm:{ *:[f32] }):$i2, (fpimm:{ *:[f32] }):$i3) - Complexity = 15
              // Dst: (CONST_V128_F32x4:{ *:[v4f32] } (fpimm:{ *:[f32] }):$i0, (fpimm:{ *:[f32] }):$i1, (fpimm:{ *:[f32] }):$i2, (fpimm:{ *:[f32] }):$i3)
/* 18367*/   /*SwitchType*/ 20, MVT::f64,// ->18389
/* 18369*/    OPC_MoveSibling1,
/* 18370*/    OPC_CheckOpcode, TARGET_VAL(ISD::ConstantFP),
/* 18373*/    OPC_RecordNode, // #1 = $i1
/* 18374*/    OPC_CheckType, MVT::f64,
/* 18376*/    OPC_MoveParent,
/* 18377*/    OPC_CheckType, MVT::v2f64,
/* 18379*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 18380*/    OPC_EmitConvertToTarget0,
/* 18381*/    OPC_EmitConvertToTarget1,
/* 18382*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_F64x2),
                  MVT::v2f64, 2/*#Ops*/, 2, 3, 
              // Src: (build_vector:{ *:[v2f64] } (fpimm:{ *:[f64] }):$i0, (fpimm:{ *:[f64] }):$i1) - Complexity = 9
              // Dst: (CONST_V128_F64x2:{ *:[v2f64] } (fpimm:{ *:[f64] }):$i0, (fpimm:{ *:[f64] }):$i1)
/* 18389*/   0, // EndSwitchType
/* 18390*/  0, // EndSwitchOpcode
/* 18391*/ /*SwitchOpcode*/ 1|128,16/*2049*/, TARGET_VAL(WebAssemblyISD::SHUFFLE),// ->20444
/* 18395*/  OPC_RecordChild0, // #0 = $x
/* 18396*/  OPC_Scope, 83|128,2/*339*/, /*->18738*/ // 6 children in Scope
/* 18399*/   OPC_CheckChild0Type, MVT::v16i8,
/* 18401*/   OPC_RecordChild1, // #1 = $y
/* 18402*/   OPC_CheckChild1Type, MVT::v16i8,
/* 18404*/   OPC_RecordChild2, // #2 = $m0
/* 18405*/   OPC_MoveChild2,
/* 18406*/   OPC_SwitchOpcode /*2 cases */, 41|128,1/*169*/, TARGET_VAL(ISD::Constant),// ->18580
/* 18411*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18412*/    OPC_CheckTypeI32,
/* 18413*/    OPC_MoveSibling3,
/* 18414*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18417*/    OPC_RecordNode, // #3 = $m1
/* 18418*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18419*/    OPC_CheckTypeI32,
/* 18420*/    OPC_MoveSibling4,
/* 18421*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18424*/    OPC_RecordNode, // #4 = $m2
/* 18425*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18426*/    OPC_CheckTypeI32,
/* 18427*/    OPC_MoveSibling5,
/* 18428*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18431*/    OPC_RecordNode, // #5 = $m3
/* 18432*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18433*/    OPC_CheckTypeI32,
/* 18434*/    OPC_MoveSibling6,
/* 18435*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18438*/    OPC_RecordNode, // #6 = $m4
/* 18439*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18440*/    OPC_CheckTypeI32,
/* 18441*/    OPC_MoveSibling7,
/* 18442*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18445*/    OPC_RecordNode, // #7 = $m5
/* 18446*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18447*/    OPC_CheckTypeI32,
/* 18448*/    OPC_MoveSibling, 8,
/* 18450*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18453*/    OPC_RecordNode, // #8 = $m6
/* 18454*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18455*/    OPC_CheckTypeI32,
/* 18456*/    OPC_MoveSibling, 9,
/* 18458*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18461*/    OPC_RecordNode, // #9 = $m7
/* 18462*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18463*/    OPC_CheckTypeI32,
/* 18464*/    OPC_MoveSibling, 10,
/* 18466*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18469*/    OPC_RecordNode, // #10 = $m8
/* 18470*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18471*/    OPC_CheckTypeI32,
/* 18472*/    OPC_MoveSibling, 11,
/* 18474*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18477*/    OPC_RecordNode, // #11 = $m9
/* 18478*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18479*/    OPC_CheckTypeI32,
/* 18480*/    OPC_MoveSibling, 12,
/* 18482*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18485*/    OPC_RecordNode, // #12 = $mA
/* 18486*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18487*/    OPC_CheckTypeI32,
/* 18488*/    OPC_MoveSibling, 13,
/* 18490*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18493*/    OPC_RecordNode, // #13 = $mB
/* 18494*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18495*/    OPC_CheckTypeI32,
/* 18496*/    OPC_MoveSibling, 14,
/* 18498*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18501*/    OPC_RecordNode, // #14 = $mC
/* 18502*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18503*/    OPC_CheckTypeI32,
/* 18504*/    OPC_MoveSibling, 15,
/* 18506*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18509*/    OPC_RecordNode, // #15 = $mD
/* 18510*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18511*/    OPC_CheckTypeI32,
/* 18512*/    OPC_MoveSibling, 16,
/* 18514*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18517*/    OPC_RecordNode, // #16 = $mE
/* 18518*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18519*/    OPC_CheckTypeI32,
/* 18520*/    OPC_MoveSibling, 17,
/* 18522*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18525*/    OPC_RecordNode, // #17 = $mF
/* 18526*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18527*/    OPC_CheckTypeI32,
/* 18528*/    OPC_MoveParent,
/* 18529*/    OPC_CheckType, MVT::v16i8,
/* 18531*/    OPC_EmitConvertToTarget2,
/* 18532*/    OPC_EmitConvertToTarget3,
/* 18533*/    OPC_EmitConvertToTarget4,
/* 18534*/    OPC_EmitConvertToTarget5,
/* 18535*/    OPC_EmitConvertToTarget6,
/* 18536*/    OPC_EmitConvertToTarget7,
/* 18537*/    OPC_EmitConvertToTarget, 8,
/* 18539*/    OPC_EmitConvertToTarget, 9,
/* 18541*/    OPC_EmitConvertToTarget, 10,
/* 18543*/    OPC_EmitConvertToTarget, 11,
/* 18545*/    OPC_EmitConvertToTarget, 12,
/* 18547*/    OPC_EmitConvertToTarget, 13,
/* 18549*/    OPC_EmitConvertToTarget, 14,
/* 18551*/    OPC_EmitConvertToTarget, 15,
/* 18553*/    OPC_EmitConvertToTarget, 16,
/* 18555*/    OPC_EmitConvertToTarget, 17,
/* 18557*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  MVT::v16i8, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v16i8] } V128:{ *:[v16i8] }:$x, V128:{ *:[v16i8] }:$y, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m0, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m1, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m2, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m3, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m4, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m5, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m6, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m7, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m8, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m9, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mA, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mB, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mC, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mD, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mE, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mF) - Complexity = 67
              // Dst: (SHUFFLE:{ *:[v16i8] } ?:{ *:[v16i8] }:$x, ?:{ *:[v16i8] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 18580*/   /*SwitchOpcode*/ 25|128,1/*153*/, TARGET_VAL(ISD::TargetConstant),// ->18737
/* 18584*/    OPC_CheckTypeI32,
/* 18585*/    OPC_MoveSibling3,
/* 18586*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18589*/    OPC_RecordNode, // #3 = $m1
/* 18590*/    OPC_CheckTypeI32,
/* 18591*/    OPC_MoveSibling4,
/* 18592*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18595*/    OPC_RecordNode, // #4 = $m2
/* 18596*/    OPC_CheckTypeI32,
/* 18597*/    OPC_MoveSibling5,
/* 18598*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18601*/    OPC_RecordNode, // #5 = $m3
/* 18602*/    OPC_CheckTypeI32,
/* 18603*/    OPC_MoveSibling6,
/* 18604*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18607*/    OPC_RecordNode, // #6 = $m4
/* 18608*/    OPC_CheckTypeI32,
/* 18609*/    OPC_MoveSibling7,
/* 18610*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18613*/    OPC_RecordNode, // #7 = $m5
/* 18614*/    OPC_CheckTypeI32,
/* 18615*/    OPC_MoveSibling, 8,
/* 18617*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18620*/    OPC_RecordNode, // #8 = $m6
/* 18621*/    OPC_CheckTypeI32,
/* 18622*/    OPC_MoveSibling, 9,
/* 18624*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18627*/    OPC_RecordNode, // #9 = $m7
/* 18628*/    OPC_CheckTypeI32,
/* 18629*/    OPC_MoveSibling, 10,
/* 18631*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18634*/    OPC_RecordNode, // #10 = $m8
/* 18635*/    OPC_CheckTypeI32,
/* 18636*/    OPC_MoveSibling, 11,
/* 18638*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18641*/    OPC_RecordNode, // #11 = $m9
/* 18642*/    OPC_CheckTypeI32,
/* 18643*/    OPC_MoveSibling, 12,
/* 18645*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18648*/    OPC_RecordNode, // #12 = $mA
/* 18649*/    OPC_CheckTypeI32,
/* 18650*/    OPC_MoveSibling, 13,
/* 18652*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18655*/    OPC_RecordNode, // #13 = $mB
/* 18656*/    OPC_CheckTypeI32,
/* 18657*/    OPC_MoveSibling, 14,
/* 18659*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18662*/    OPC_RecordNode, // #14 = $mC
/* 18663*/    OPC_CheckTypeI32,
/* 18664*/    OPC_MoveSibling, 15,
/* 18666*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18669*/    OPC_RecordNode, // #15 = $mD
/* 18670*/    OPC_CheckTypeI32,
/* 18671*/    OPC_MoveSibling, 16,
/* 18673*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18676*/    OPC_RecordNode, // #16 = $mE
/* 18677*/    OPC_CheckTypeI32,
/* 18678*/    OPC_MoveSibling, 17,
/* 18680*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18683*/    OPC_RecordNode, // #17 = $mF
/* 18684*/    OPC_CheckTypeI32,
/* 18685*/    OPC_MoveParent,
/* 18686*/    OPC_CheckType, MVT::v16i8,
/* 18688*/    OPC_EmitConvertToTarget2,
/* 18689*/    OPC_EmitConvertToTarget3,
/* 18690*/    OPC_EmitConvertToTarget4,
/* 18691*/    OPC_EmitConvertToTarget5,
/* 18692*/    OPC_EmitConvertToTarget6,
/* 18693*/    OPC_EmitConvertToTarget7,
/* 18694*/    OPC_EmitConvertToTarget, 8,
/* 18696*/    OPC_EmitConvertToTarget, 9,
/* 18698*/    OPC_EmitConvertToTarget, 10,
/* 18700*/    OPC_EmitConvertToTarget, 11,
/* 18702*/    OPC_EmitConvertToTarget, 12,
/* 18704*/    OPC_EmitConvertToTarget, 13,
/* 18706*/    OPC_EmitConvertToTarget, 14,
/* 18708*/    OPC_EmitConvertToTarget, 15,
/* 18710*/    OPC_EmitConvertToTarget, 16,
/* 18712*/    OPC_EmitConvertToTarget, 17,
/* 18714*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  MVT::v16i8, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v16i8] } V128:{ *:[v16i8] }:$x, V128:{ *:[v16i8] }:$y, (timm:{ *:[i32] }):$m0, (timm:{ *:[i32] }):$m1, (timm:{ *:[i32] }):$m2, (timm:{ *:[i32] }):$m3, (timm:{ *:[i32] }):$m4, (timm:{ *:[i32] }):$m5, (timm:{ *:[i32] }):$m6, (timm:{ *:[i32] }):$m7, (timm:{ *:[i32] }):$m8, (timm:{ *:[i32] }):$m9, (timm:{ *:[i32] }):$mA, (timm:{ *:[i32] }):$mB, (timm:{ *:[i32] }):$mC, (timm:{ *:[i32] }):$mD, (timm:{ *:[i32] }):$mE, (timm:{ *:[i32] }):$mF) - Complexity = 51
              // Dst: (SHUFFLE:{ *:[v16i8] } ?:{ *:[v16i8] }:$x, ?:{ *:[v16i8] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 18737*/   0, // EndSwitchOpcode
/* 18738*/  /*Scope*/ 83|128,2/*339*/, /*->19079*/
/* 18740*/   OPC_CheckChild0Type, MVT::v8i16,
/* 18742*/   OPC_RecordChild1, // #1 = $y
/* 18743*/   OPC_CheckChild1Type, MVT::v8i16,
/* 18745*/   OPC_RecordChild2, // #2 = $m0
/* 18746*/   OPC_MoveChild2,
/* 18747*/   OPC_SwitchOpcode /*2 cases */, 41|128,1/*169*/, TARGET_VAL(ISD::Constant),// ->18921
/* 18752*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18753*/    OPC_CheckTypeI32,
/* 18754*/    OPC_MoveSibling3,
/* 18755*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18758*/    OPC_RecordNode, // #3 = $m1
/* 18759*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18760*/    OPC_CheckTypeI32,
/* 18761*/    OPC_MoveSibling4,
/* 18762*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18765*/    OPC_RecordNode, // #4 = $m2
/* 18766*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18767*/    OPC_CheckTypeI32,
/* 18768*/    OPC_MoveSibling5,
/* 18769*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18772*/    OPC_RecordNode, // #5 = $m3
/* 18773*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18774*/    OPC_CheckTypeI32,
/* 18775*/    OPC_MoveSibling6,
/* 18776*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18779*/    OPC_RecordNode, // #6 = $m4
/* 18780*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18781*/    OPC_CheckTypeI32,
/* 18782*/    OPC_MoveSibling7,
/* 18783*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18786*/    OPC_RecordNode, // #7 = $m5
/* 18787*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18788*/    OPC_CheckTypeI32,
/* 18789*/    OPC_MoveSibling, 8,
/* 18791*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18794*/    OPC_RecordNode, // #8 = $m6
/* 18795*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18796*/    OPC_CheckTypeI32,
/* 18797*/    OPC_MoveSibling, 9,
/* 18799*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18802*/    OPC_RecordNode, // #9 = $m7
/* 18803*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18804*/    OPC_CheckTypeI32,
/* 18805*/    OPC_MoveSibling, 10,
/* 18807*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18810*/    OPC_RecordNode, // #10 = $m8
/* 18811*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18812*/    OPC_CheckTypeI32,
/* 18813*/    OPC_MoveSibling, 11,
/* 18815*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18818*/    OPC_RecordNode, // #11 = $m9
/* 18819*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18820*/    OPC_CheckTypeI32,
/* 18821*/    OPC_MoveSibling, 12,
/* 18823*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18826*/    OPC_RecordNode, // #12 = $mA
/* 18827*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18828*/    OPC_CheckTypeI32,
/* 18829*/    OPC_MoveSibling, 13,
/* 18831*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18834*/    OPC_RecordNode, // #13 = $mB
/* 18835*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18836*/    OPC_CheckTypeI32,
/* 18837*/    OPC_MoveSibling, 14,
/* 18839*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18842*/    OPC_RecordNode, // #14 = $mC
/* 18843*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18844*/    OPC_CheckTypeI32,
/* 18845*/    OPC_MoveSibling, 15,
/* 18847*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18850*/    OPC_RecordNode, // #15 = $mD
/* 18851*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18852*/    OPC_CheckTypeI32,
/* 18853*/    OPC_MoveSibling, 16,
/* 18855*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18858*/    OPC_RecordNode, // #16 = $mE
/* 18859*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18860*/    OPC_CheckTypeI32,
/* 18861*/    OPC_MoveSibling, 17,
/* 18863*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18866*/    OPC_RecordNode, // #17 = $mF
/* 18867*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18868*/    OPC_CheckTypeI32,
/* 18869*/    OPC_MoveParent,
/* 18870*/    OPC_CheckType, MVT::v8i16,
/* 18872*/    OPC_EmitConvertToTarget2,
/* 18873*/    OPC_EmitConvertToTarget3,
/* 18874*/    OPC_EmitConvertToTarget4,
/* 18875*/    OPC_EmitConvertToTarget5,
/* 18876*/    OPC_EmitConvertToTarget6,
/* 18877*/    OPC_EmitConvertToTarget7,
/* 18878*/    OPC_EmitConvertToTarget, 8,
/* 18880*/    OPC_EmitConvertToTarget, 9,
/* 18882*/    OPC_EmitConvertToTarget, 10,
/* 18884*/    OPC_EmitConvertToTarget, 11,
/* 18886*/    OPC_EmitConvertToTarget, 12,
/* 18888*/    OPC_EmitConvertToTarget, 13,
/* 18890*/    OPC_EmitConvertToTarget, 14,
/* 18892*/    OPC_EmitConvertToTarget, 15,
/* 18894*/    OPC_EmitConvertToTarget, 16,
/* 18896*/    OPC_EmitConvertToTarget, 17,
/* 18898*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  MVT::v8i16, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v8i16] } V128:{ *:[v8i16] }:$x, V128:{ *:[v8i16] }:$y, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m0, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m1, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m2, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m3, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m4, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m5, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m6, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m7, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m8, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m9, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mA, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mB, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mC, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mD, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mE, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mF) - Complexity = 67
              // Dst: (SHUFFLE:{ *:[v8i16] } ?:{ *:[v8i16] }:$x, ?:{ *:[v8i16] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 18921*/   /*SwitchOpcode*/ 25|128,1/*153*/, TARGET_VAL(ISD::TargetConstant),// ->19078
/* 18925*/    OPC_CheckTypeI32,
/* 18926*/    OPC_MoveSibling3,
/* 18927*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18930*/    OPC_RecordNode, // #3 = $m1
/* 18931*/    OPC_CheckTypeI32,
/* 18932*/    OPC_MoveSibling4,
/* 18933*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18936*/    OPC_RecordNode, // #4 = $m2
/* 18937*/    OPC_CheckTypeI32,
/* 18938*/    OPC_MoveSibling5,
/* 18939*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18942*/    OPC_RecordNode, // #5 = $m3
/* 18943*/    OPC_CheckTypeI32,
/* 18944*/    OPC_MoveSibling6,
/* 18945*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18948*/    OPC_RecordNode, // #6 = $m4
/* 18949*/    OPC_CheckTypeI32,
/* 18950*/    OPC_MoveSibling7,
/* 18951*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18954*/    OPC_RecordNode, // #7 = $m5
/* 18955*/    OPC_CheckTypeI32,
/* 18956*/    OPC_MoveSibling, 8,
/* 18958*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18961*/    OPC_RecordNode, // #8 = $m6
/* 18962*/    OPC_CheckTypeI32,
/* 18963*/    OPC_MoveSibling, 9,
/* 18965*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18968*/    OPC_RecordNode, // #9 = $m7
/* 18969*/    OPC_CheckTypeI32,
/* 18970*/    OPC_MoveSibling, 10,
/* 18972*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18975*/    OPC_RecordNode, // #10 = $m8
/* 18976*/    OPC_CheckTypeI32,
/* 18977*/    OPC_MoveSibling, 11,
/* 18979*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18982*/    OPC_RecordNode, // #11 = $m9
/* 18983*/    OPC_CheckTypeI32,
/* 18984*/    OPC_MoveSibling, 12,
/* 18986*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18989*/    OPC_RecordNode, // #12 = $mA
/* 18990*/    OPC_CheckTypeI32,
/* 18991*/    OPC_MoveSibling, 13,
/* 18993*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18996*/    OPC_RecordNode, // #13 = $mB
/* 18997*/    OPC_CheckTypeI32,
/* 18998*/    OPC_MoveSibling, 14,
/* 19000*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19003*/    OPC_RecordNode, // #14 = $mC
/* 19004*/    OPC_CheckTypeI32,
/* 19005*/    OPC_MoveSibling, 15,
/* 19007*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19010*/    OPC_RecordNode, // #15 = $mD
/* 19011*/    OPC_CheckTypeI32,
/* 19012*/    OPC_MoveSibling, 16,
/* 19014*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19017*/    OPC_RecordNode, // #16 = $mE
/* 19018*/    OPC_CheckTypeI32,
/* 19019*/    OPC_MoveSibling, 17,
/* 19021*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19024*/    OPC_RecordNode, // #17 = $mF
/* 19025*/    OPC_CheckTypeI32,
/* 19026*/    OPC_MoveParent,
/* 19027*/    OPC_CheckType, MVT::v8i16,
/* 19029*/    OPC_EmitConvertToTarget2,
/* 19030*/    OPC_EmitConvertToTarget3,
/* 19031*/    OPC_EmitConvertToTarget4,
/* 19032*/    OPC_EmitConvertToTarget5,
/* 19033*/    OPC_EmitConvertToTarget6,
/* 19034*/    OPC_EmitConvertToTarget7,
/* 19035*/    OPC_EmitConvertToTarget, 8,
/* 19037*/    OPC_EmitConvertToTarget, 9,
/* 19039*/    OPC_EmitConvertToTarget, 10,
/* 19041*/    OPC_EmitConvertToTarget, 11,
/* 19043*/    OPC_EmitConvertToTarget, 12,
/* 19045*/    OPC_EmitConvertToTarget, 13,
/* 19047*/    OPC_EmitConvertToTarget, 14,
/* 19049*/    OPC_EmitConvertToTarget, 15,
/* 19051*/    OPC_EmitConvertToTarget, 16,
/* 19053*/    OPC_EmitConvertToTarget, 17,
/* 19055*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  MVT::v8i16, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v8i16] } V128:{ *:[v8i16] }:$x, V128:{ *:[v8i16] }:$y, (timm:{ *:[i32] }):$m0, (timm:{ *:[i32] }):$m1, (timm:{ *:[i32] }):$m2, (timm:{ *:[i32] }):$m3, (timm:{ *:[i32] }):$m4, (timm:{ *:[i32] }):$m5, (timm:{ *:[i32] }):$m6, (timm:{ *:[i32] }):$m7, (timm:{ *:[i32] }):$m8, (timm:{ *:[i32] }):$m9, (timm:{ *:[i32] }):$mA, (timm:{ *:[i32] }):$mB, (timm:{ *:[i32] }):$mC, (timm:{ *:[i32] }):$mD, (timm:{ *:[i32] }):$mE, (timm:{ *:[i32] }):$mF) - Complexity = 51
              // Dst: (SHUFFLE:{ *:[v8i16] } ?:{ *:[v8i16] }:$x, ?:{ *:[v8i16] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 19078*/   0, // EndSwitchOpcode
/* 19079*/  /*Scope*/ 83|128,2/*339*/, /*->19420*/
/* 19081*/   OPC_CheckChild0Type, MVT::v4i32,
/* 19083*/   OPC_RecordChild1, // #1 = $y
/* 19084*/   OPC_CheckChild1Type, MVT::v4i32,
/* 19086*/   OPC_RecordChild2, // #2 = $m0
/* 19087*/   OPC_MoveChild2,
/* 19088*/   OPC_SwitchOpcode /*2 cases */, 41|128,1/*169*/, TARGET_VAL(ISD::Constant),// ->19262
/* 19093*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19094*/    OPC_CheckTypeI32,
/* 19095*/    OPC_MoveSibling3,
/* 19096*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19099*/    OPC_RecordNode, // #3 = $m1
/* 19100*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19101*/    OPC_CheckTypeI32,
/* 19102*/    OPC_MoveSibling4,
/* 19103*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19106*/    OPC_RecordNode, // #4 = $m2
/* 19107*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19108*/    OPC_CheckTypeI32,
/* 19109*/    OPC_MoveSibling5,
/* 19110*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19113*/    OPC_RecordNode, // #5 = $m3
/* 19114*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19115*/    OPC_CheckTypeI32,
/* 19116*/    OPC_MoveSibling6,
/* 19117*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19120*/    OPC_RecordNode, // #6 = $m4
/* 19121*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19122*/    OPC_CheckTypeI32,
/* 19123*/    OPC_MoveSibling7,
/* 19124*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19127*/    OPC_RecordNode, // #7 = $m5
/* 19128*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19129*/    OPC_CheckTypeI32,
/* 19130*/    OPC_MoveSibling, 8,
/* 19132*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19135*/    OPC_RecordNode, // #8 = $m6
/* 19136*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19137*/    OPC_CheckTypeI32,
/* 19138*/    OPC_MoveSibling, 9,
/* 19140*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19143*/    OPC_RecordNode, // #9 = $m7
/* 19144*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19145*/    OPC_CheckTypeI32,
/* 19146*/    OPC_MoveSibling, 10,
/* 19148*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19151*/    OPC_RecordNode, // #10 = $m8
/* 19152*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19153*/    OPC_CheckTypeI32,
/* 19154*/    OPC_MoveSibling, 11,
/* 19156*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19159*/    OPC_RecordNode, // #11 = $m9
/* 19160*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19161*/    OPC_CheckTypeI32,
/* 19162*/    OPC_MoveSibling, 12,
/* 19164*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19167*/    OPC_RecordNode, // #12 = $mA
/* 19168*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19169*/    OPC_CheckTypeI32,
/* 19170*/    OPC_MoveSibling, 13,
/* 19172*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19175*/    OPC_RecordNode, // #13 = $mB
/* 19176*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19177*/    OPC_CheckTypeI32,
/* 19178*/    OPC_MoveSibling, 14,
/* 19180*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19183*/    OPC_RecordNode, // #14 = $mC
/* 19184*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19185*/    OPC_CheckTypeI32,
/* 19186*/    OPC_MoveSibling, 15,
/* 19188*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19191*/    OPC_RecordNode, // #15 = $mD
/* 19192*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19193*/    OPC_CheckTypeI32,
/* 19194*/    OPC_MoveSibling, 16,
/* 19196*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19199*/    OPC_RecordNode, // #16 = $mE
/* 19200*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19201*/    OPC_CheckTypeI32,
/* 19202*/    OPC_MoveSibling, 17,
/* 19204*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19207*/    OPC_RecordNode, // #17 = $mF
/* 19208*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19209*/    OPC_CheckTypeI32,
/* 19210*/    OPC_MoveParent,
/* 19211*/    OPC_CheckType, MVT::v4i32,
/* 19213*/    OPC_EmitConvertToTarget2,
/* 19214*/    OPC_EmitConvertToTarget3,
/* 19215*/    OPC_EmitConvertToTarget4,
/* 19216*/    OPC_EmitConvertToTarget5,
/* 19217*/    OPC_EmitConvertToTarget6,
/* 19218*/    OPC_EmitConvertToTarget7,
/* 19219*/    OPC_EmitConvertToTarget, 8,
/* 19221*/    OPC_EmitConvertToTarget, 9,
/* 19223*/    OPC_EmitConvertToTarget, 10,
/* 19225*/    OPC_EmitConvertToTarget, 11,
/* 19227*/    OPC_EmitConvertToTarget, 12,
/* 19229*/    OPC_EmitConvertToTarget, 13,
/* 19231*/    OPC_EmitConvertToTarget, 14,
/* 19233*/    OPC_EmitConvertToTarget, 15,
/* 19235*/    OPC_EmitConvertToTarget, 16,
/* 19237*/    OPC_EmitConvertToTarget, 17,
/* 19239*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  MVT::v4i32, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v4i32] } V128:{ *:[v4i32] }:$x, V128:{ *:[v4i32] }:$y, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m0, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m1, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m2, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m3, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m4, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m5, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m6, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m7, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m8, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m9, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mA, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mB, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mC, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mD, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mE, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mF) - Complexity = 67
              // Dst: (SHUFFLE:{ *:[v4i32] } ?:{ *:[v4i32] }:$x, ?:{ *:[v4i32] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 19262*/   /*SwitchOpcode*/ 25|128,1/*153*/, TARGET_VAL(ISD::TargetConstant),// ->19419
/* 19266*/    OPC_CheckTypeI32,
/* 19267*/    OPC_MoveSibling3,
/* 19268*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19271*/    OPC_RecordNode, // #3 = $m1
/* 19272*/    OPC_CheckTypeI32,
/* 19273*/    OPC_MoveSibling4,
/* 19274*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19277*/    OPC_RecordNode, // #4 = $m2
/* 19278*/    OPC_CheckTypeI32,
/* 19279*/    OPC_MoveSibling5,
/* 19280*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19283*/    OPC_RecordNode, // #5 = $m3
/* 19284*/    OPC_CheckTypeI32,
/* 19285*/    OPC_MoveSibling6,
/* 19286*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19289*/    OPC_RecordNode, // #6 = $m4
/* 19290*/    OPC_CheckTypeI32,
/* 19291*/    OPC_MoveSibling7,
/* 19292*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19295*/    OPC_RecordNode, // #7 = $m5
/* 19296*/    OPC_CheckTypeI32,
/* 19297*/    OPC_MoveSibling, 8,
/* 19299*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19302*/    OPC_RecordNode, // #8 = $m6
/* 19303*/    OPC_CheckTypeI32,
/* 19304*/    OPC_MoveSibling, 9,
/* 19306*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19309*/    OPC_RecordNode, // #9 = $m7
/* 19310*/    OPC_CheckTypeI32,
/* 19311*/    OPC_MoveSibling, 10,
/* 19313*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19316*/    OPC_RecordNode, // #10 = $m8
/* 19317*/    OPC_CheckTypeI32,
/* 19318*/    OPC_MoveSibling, 11,
/* 19320*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19323*/    OPC_RecordNode, // #11 = $m9
/* 19324*/    OPC_CheckTypeI32,
/* 19325*/    OPC_MoveSibling, 12,
/* 19327*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19330*/    OPC_RecordNode, // #12 = $mA
/* 19331*/    OPC_CheckTypeI32,
/* 19332*/    OPC_MoveSibling, 13,
/* 19334*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19337*/    OPC_RecordNode, // #13 = $mB
/* 19338*/    OPC_CheckTypeI32,
/* 19339*/    OPC_MoveSibling, 14,
/* 19341*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19344*/    OPC_RecordNode, // #14 = $mC
/* 19345*/    OPC_CheckTypeI32,
/* 19346*/    OPC_MoveSibling, 15,
/* 19348*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19351*/    OPC_RecordNode, // #15 = $mD
/* 19352*/    OPC_CheckTypeI32,
/* 19353*/    OPC_MoveSibling, 16,
/* 19355*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19358*/    OPC_RecordNode, // #16 = $mE
/* 19359*/    OPC_CheckTypeI32,
/* 19360*/    OPC_MoveSibling, 17,
/* 19362*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19365*/    OPC_RecordNode, // #17 = $mF
/* 19366*/    OPC_CheckTypeI32,
/* 19367*/    OPC_MoveParent,
/* 19368*/    OPC_CheckType, MVT::v4i32,
/* 19370*/    OPC_EmitConvertToTarget2,
/* 19371*/    OPC_EmitConvertToTarget3,
/* 19372*/    OPC_EmitConvertToTarget4,
/* 19373*/    OPC_EmitConvertToTarget5,
/* 19374*/    OPC_EmitConvertToTarget6,
/* 19375*/    OPC_EmitConvertToTarget7,
/* 19376*/    OPC_EmitConvertToTarget, 8,
/* 19378*/    OPC_EmitConvertToTarget, 9,
/* 19380*/    OPC_EmitConvertToTarget, 10,
/* 19382*/    OPC_EmitConvertToTarget, 11,
/* 19384*/    OPC_EmitConvertToTarget, 12,
/* 19386*/    OPC_EmitConvertToTarget, 13,
/* 19388*/    OPC_EmitConvertToTarget, 14,
/* 19390*/    OPC_EmitConvertToTarget, 15,
/* 19392*/    OPC_EmitConvertToTarget, 16,
/* 19394*/    OPC_EmitConvertToTarget, 17,
/* 19396*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  MVT::v4i32, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v4i32] } V128:{ *:[v4i32] }:$x, V128:{ *:[v4i32] }:$y, (timm:{ *:[i32] }):$m0, (timm:{ *:[i32] }):$m1, (timm:{ *:[i32] }):$m2, (timm:{ *:[i32] }):$m3, (timm:{ *:[i32] }):$m4, (timm:{ *:[i32] }):$m5, (timm:{ *:[i32] }):$m6, (timm:{ *:[i32] }):$m7, (timm:{ *:[i32] }):$m8, (timm:{ *:[i32] }):$m9, (timm:{ *:[i32] }):$mA, (timm:{ *:[i32] }):$mB, (timm:{ *:[i32] }):$mC, (timm:{ *:[i32] }):$mD, (timm:{ *:[i32] }):$mE, (timm:{ *:[i32] }):$mF) - Complexity = 51
              // Dst: (SHUFFLE:{ *:[v4i32] } ?:{ *:[v4i32] }:$x, ?:{ *:[v4i32] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 19419*/   0, // EndSwitchOpcode
/* 19420*/  /*Scope*/ 83|128,2/*339*/, /*->19761*/
/* 19422*/   OPC_CheckChild0Type, MVT::v2i64,
/* 19424*/   OPC_RecordChild1, // #1 = $y
/* 19425*/   OPC_CheckChild1Type, MVT::v2i64,
/* 19427*/   OPC_RecordChild2, // #2 = $m0
/* 19428*/   OPC_MoveChild2,
/* 19429*/   OPC_SwitchOpcode /*2 cases */, 41|128,1/*169*/, TARGET_VAL(ISD::Constant),// ->19603
/* 19434*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19435*/    OPC_CheckTypeI32,
/* 19436*/    OPC_MoveSibling3,
/* 19437*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19440*/    OPC_RecordNode, // #3 = $m1
/* 19441*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19442*/    OPC_CheckTypeI32,
/* 19443*/    OPC_MoveSibling4,
/* 19444*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19447*/    OPC_RecordNode, // #4 = $m2
/* 19448*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19449*/    OPC_CheckTypeI32,
/* 19450*/    OPC_MoveSibling5,
/* 19451*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19454*/    OPC_RecordNode, // #5 = $m3
/* 19455*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19456*/    OPC_CheckTypeI32,
/* 19457*/    OPC_MoveSibling6,
/* 19458*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19461*/    OPC_RecordNode, // #6 = $m4
/* 19462*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19463*/    OPC_CheckTypeI32,
/* 19464*/    OPC_MoveSibling7,
/* 19465*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19468*/    OPC_RecordNode, // #7 = $m5
/* 19469*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19470*/    OPC_CheckTypeI32,
/* 19471*/    OPC_MoveSibling, 8,
/* 19473*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19476*/    OPC_RecordNode, // #8 = $m6
/* 19477*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19478*/    OPC_CheckTypeI32,
/* 19479*/    OPC_MoveSibling, 9,
/* 19481*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19484*/    OPC_RecordNode, // #9 = $m7
/* 19485*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19486*/    OPC_CheckTypeI32,
/* 19487*/    OPC_MoveSibling, 10,
/* 19489*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19492*/    OPC_RecordNode, // #10 = $m8
/* 19493*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19494*/    OPC_CheckTypeI32,
/* 19495*/    OPC_MoveSibling, 11,
/* 19497*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19500*/    OPC_RecordNode, // #11 = $m9
/* 19501*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19502*/    OPC_CheckTypeI32,
/* 19503*/    OPC_MoveSibling, 12,
/* 19505*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19508*/    OPC_RecordNode, // #12 = $mA
/* 19509*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19510*/    OPC_CheckTypeI32,
/* 19511*/    OPC_MoveSibling, 13,
/* 19513*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19516*/    OPC_RecordNode, // #13 = $mB
/* 19517*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19518*/    OPC_CheckTypeI32,
/* 19519*/    OPC_MoveSibling, 14,
/* 19521*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19524*/    OPC_RecordNode, // #14 = $mC
/* 19525*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19526*/    OPC_CheckTypeI32,
/* 19527*/    OPC_MoveSibling, 15,
/* 19529*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19532*/    OPC_RecordNode, // #15 = $mD
/* 19533*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19534*/    OPC_CheckTypeI32,
/* 19535*/    OPC_MoveSibling, 16,
/* 19537*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19540*/    OPC_RecordNode, // #16 = $mE
/* 19541*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19542*/    OPC_CheckTypeI32,
/* 19543*/    OPC_MoveSibling, 17,
/* 19545*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19548*/    OPC_RecordNode, // #17 = $mF
/* 19549*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19550*/    OPC_CheckTypeI32,
/* 19551*/    OPC_MoveParent,
/* 19552*/    OPC_CheckType, MVT::v2i64,
/* 19554*/    OPC_EmitConvertToTarget2,
/* 19555*/    OPC_EmitConvertToTarget3,
/* 19556*/    OPC_EmitConvertToTarget4,
/* 19557*/    OPC_EmitConvertToTarget5,
/* 19558*/    OPC_EmitConvertToTarget6,
/* 19559*/    OPC_EmitConvertToTarget7,
/* 19560*/    OPC_EmitConvertToTarget, 8,
/* 19562*/    OPC_EmitConvertToTarget, 9,
/* 19564*/    OPC_EmitConvertToTarget, 10,
/* 19566*/    OPC_EmitConvertToTarget, 11,
/* 19568*/    OPC_EmitConvertToTarget, 12,
/* 19570*/    OPC_EmitConvertToTarget, 13,
/* 19572*/    OPC_EmitConvertToTarget, 14,
/* 19574*/    OPC_EmitConvertToTarget, 15,
/* 19576*/    OPC_EmitConvertToTarget, 16,
/* 19578*/    OPC_EmitConvertToTarget, 17,
/* 19580*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  MVT::v2i64, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v2i64] } V128:{ *:[v2i64] }:$x, V128:{ *:[v2i64] }:$y, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m0, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m1, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m2, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m3, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m4, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m5, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m6, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m7, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m8, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m9, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mA, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mB, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mC, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mD, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mE, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mF) - Complexity = 67
              // Dst: (SHUFFLE:{ *:[v2i64] } ?:{ *:[v2i64] }:$x, ?:{ *:[v2i64] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 19603*/   /*SwitchOpcode*/ 25|128,1/*153*/, TARGET_VAL(ISD::TargetConstant),// ->19760
/* 19607*/    OPC_CheckTypeI32,
/* 19608*/    OPC_MoveSibling3,
/* 19609*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19612*/    OPC_RecordNode, // #3 = $m1
/* 19613*/    OPC_CheckTypeI32,
/* 19614*/    OPC_MoveSibling4,
/* 19615*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19618*/    OPC_RecordNode, // #4 = $m2
/* 19619*/    OPC_CheckTypeI32,
/* 19620*/    OPC_MoveSibling5,
/* 19621*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19624*/    OPC_RecordNode, // #5 = $m3
/* 19625*/    OPC_CheckTypeI32,
/* 19626*/    OPC_MoveSibling6,
/* 19627*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19630*/    OPC_RecordNode, // #6 = $m4
/* 19631*/    OPC_CheckTypeI32,
/* 19632*/    OPC_MoveSibling7,
/* 19633*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19636*/    OPC_RecordNode, // #7 = $m5
/* 19637*/    OPC_CheckTypeI32,
/* 19638*/    OPC_MoveSibling, 8,
/* 19640*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19643*/    OPC_RecordNode, // #8 = $m6
/* 19644*/    OPC_CheckTypeI32,
/* 19645*/    OPC_MoveSibling, 9,
/* 19647*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19650*/    OPC_RecordNode, // #9 = $m7
/* 19651*/    OPC_CheckTypeI32,
/* 19652*/    OPC_MoveSibling, 10,
/* 19654*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19657*/    OPC_RecordNode, // #10 = $m8
/* 19658*/    OPC_CheckTypeI32,
/* 19659*/    OPC_MoveSibling, 11,
/* 19661*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19664*/    OPC_RecordNode, // #11 = $m9
/* 19665*/    OPC_CheckTypeI32,
/* 19666*/    OPC_MoveSibling, 12,
/* 19668*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19671*/    OPC_RecordNode, // #12 = $mA
/* 19672*/    OPC_CheckTypeI32,
/* 19673*/    OPC_MoveSibling, 13,
/* 19675*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19678*/    OPC_RecordNode, // #13 = $mB
/* 19679*/    OPC_CheckTypeI32,
/* 19680*/    OPC_MoveSibling, 14,
/* 19682*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19685*/    OPC_RecordNode, // #14 = $mC
/* 19686*/    OPC_CheckTypeI32,
/* 19687*/    OPC_MoveSibling, 15,
/* 19689*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19692*/    OPC_RecordNode, // #15 = $mD
/* 19693*/    OPC_CheckTypeI32,
/* 19694*/    OPC_MoveSibling, 16,
/* 19696*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19699*/    OPC_RecordNode, // #16 = $mE
/* 19700*/    OPC_CheckTypeI32,
/* 19701*/    OPC_MoveSibling, 17,
/* 19703*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19706*/    OPC_RecordNode, // #17 = $mF
/* 19707*/    OPC_CheckTypeI32,
/* 19708*/    OPC_MoveParent,
/* 19709*/    OPC_CheckType, MVT::v2i64,
/* 19711*/    OPC_EmitConvertToTarget2,
/* 19712*/    OPC_EmitConvertToTarget3,
/* 19713*/    OPC_EmitConvertToTarget4,
/* 19714*/    OPC_EmitConvertToTarget5,
/* 19715*/    OPC_EmitConvertToTarget6,
/* 19716*/    OPC_EmitConvertToTarget7,
/* 19717*/    OPC_EmitConvertToTarget, 8,
/* 19719*/    OPC_EmitConvertToTarget, 9,
/* 19721*/    OPC_EmitConvertToTarget, 10,
/* 19723*/    OPC_EmitConvertToTarget, 11,
/* 19725*/    OPC_EmitConvertToTarget, 12,
/* 19727*/    OPC_EmitConvertToTarget, 13,
/* 19729*/    OPC_EmitConvertToTarget, 14,
/* 19731*/    OPC_EmitConvertToTarget, 15,
/* 19733*/    OPC_EmitConvertToTarget, 16,
/* 19735*/    OPC_EmitConvertToTarget, 17,
/* 19737*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  MVT::v2i64, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v2i64] } V128:{ *:[v2i64] }:$x, V128:{ *:[v2i64] }:$y, (timm:{ *:[i32] }):$m0, (timm:{ *:[i32] }):$m1, (timm:{ *:[i32] }):$m2, (timm:{ *:[i32] }):$m3, (timm:{ *:[i32] }):$m4, (timm:{ *:[i32] }):$m5, (timm:{ *:[i32] }):$m6, (timm:{ *:[i32] }):$m7, (timm:{ *:[i32] }):$m8, (timm:{ *:[i32] }):$m9, (timm:{ *:[i32] }):$mA, (timm:{ *:[i32] }):$mB, (timm:{ *:[i32] }):$mC, (timm:{ *:[i32] }):$mD, (timm:{ *:[i32] }):$mE, (timm:{ *:[i32] }):$mF) - Complexity = 51
              // Dst: (SHUFFLE:{ *:[v2i64] } ?:{ *:[v2i64] }:$x, ?:{ *:[v2i64] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 19760*/   0, // EndSwitchOpcode
/* 19761*/  /*Scope*/ 83|128,2/*339*/, /*->20102*/
/* 19763*/   OPC_CheckChild0Type, MVT::v4f32,
/* 19765*/   OPC_RecordChild1, // #1 = $y
/* 19766*/   OPC_CheckChild1Type, MVT::v4f32,
/* 19768*/   OPC_RecordChild2, // #2 = $m0
/* 19769*/   OPC_MoveChild2,
/* 19770*/   OPC_SwitchOpcode /*2 cases */, 41|128,1/*169*/, TARGET_VAL(ISD::Constant),// ->19944
/* 19775*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19776*/    OPC_CheckTypeI32,
/* 19777*/    OPC_MoveSibling3,
/* 19778*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19781*/    OPC_RecordNode, // #3 = $m1
/* 19782*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19783*/    OPC_CheckTypeI32,
/* 19784*/    OPC_MoveSibling4,
/* 19785*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19788*/    OPC_RecordNode, // #4 = $m2
/* 19789*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19790*/    OPC_CheckTypeI32,
/* 19791*/    OPC_MoveSibling5,
/* 19792*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19795*/    OPC_RecordNode, // #5 = $m3
/* 19796*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19797*/    OPC_CheckTypeI32,
/* 19798*/    OPC_MoveSibling6,
/* 19799*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19802*/    OPC_RecordNode, // #6 = $m4
/* 19803*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19804*/    OPC_CheckTypeI32,
/* 19805*/    OPC_MoveSibling7,
/* 19806*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19809*/    OPC_RecordNode, // #7 = $m5
/* 19810*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19811*/    OPC_CheckTypeI32,
/* 19812*/    OPC_MoveSibling, 8,
/* 19814*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19817*/    OPC_RecordNode, // #8 = $m6
/* 19818*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19819*/    OPC_CheckTypeI32,
/* 19820*/    OPC_MoveSibling, 9,
/* 19822*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19825*/    OPC_RecordNode, // #9 = $m7
/* 19826*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19827*/    OPC_CheckTypeI32,
/* 19828*/    OPC_MoveSibling, 10,
/* 19830*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19833*/    OPC_RecordNode, // #10 = $m8
/* 19834*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19835*/    OPC_CheckTypeI32,
/* 19836*/    OPC_MoveSibling, 11,
/* 19838*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19841*/    OPC_RecordNode, // #11 = $m9
/* 19842*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19843*/    OPC_CheckTypeI32,
/* 19844*/    OPC_MoveSibling, 12,
/* 19846*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19849*/    OPC_RecordNode, // #12 = $mA
/* 19850*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19851*/    OPC_CheckTypeI32,
/* 19852*/    OPC_MoveSibling, 13,
/* 19854*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19857*/    OPC_RecordNode, // #13 = $mB
/* 19858*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19859*/    OPC_CheckTypeI32,
/* 19860*/    OPC_MoveSibling, 14,
/* 19862*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19865*/    OPC_RecordNode, // #14 = $mC
/* 19866*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19867*/    OPC_CheckTypeI32,
/* 19868*/    OPC_MoveSibling, 15,
/* 19870*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19873*/    OPC_RecordNode, // #15 = $mD
/* 19874*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19875*/    OPC_CheckTypeI32,
/* 19876*/    OPC_MoveSibling, 16,
/* 19878*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19881*/    OPC_RecordNode, // #16 = $mE
/* 19882*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19883*/    OPC_CheckTypeI32,
/* 19884*/    OPC_MoveSibling, 17,
/* 19886*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19889*/    OPC_RecordNode, // #17 = $mF
/* 19890*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19891*/    OPC_CheckTypeI32,
/* 19892*/    OPC_MoveParent,
/* 19893*/    OPC_CheckType, MVT::v4f32,
/* 19895*/    OPC_EmitConvertToTarget2,
/* 19896*/    OPC_EmitConvertToTarget3,
/* 19897*/    OPC_EmitConvertToTarget4,
/* 19898*/    OPC_EmitConvertToTarget5,
/* 19899*/    OPC_EmitConvertToTarget6,
/* 19900*/    OPC_EmitConvertToTarget7,
/* 19901*/    OPC_EmitConvertToTarget, 8,
/* 19903*/    OPC_EmitConvertToTarget, 9,
/* 19905*/    OPC_EmitConvertToTarget, 10,
/* 19907*/    OPC_EmitConvertToTarget, 11,
/* 19909*/    OPC_EmitConvertToTarget, 12,
/* 19911*/    OPC_EmitConvertToTarget, 13,
/* 19913*/    OPC_EmitConvertToTarget, 14,
/* 19915*/    OPC_EmitConvertToTarget, 15,
/* 19917*/    OPC_EmitConvertToTarget, 16,
/* 19919*/    OPC_EmitConvertToTarget, 17,
/* 19921*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  MVT::v4f32, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v4f32] } V128:{ *:[v4f32] }:$x, V128:{ *:[v4f32] }:$y, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m0, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m1, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m2, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m3, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m4, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m5, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m6, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m7, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m8, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m9, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mA, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mB, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mC, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mD, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mE, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mF) - Complexity = 67
              // Dst: (SHUFFLE:{ *:[v4f32] } ?:{ *:[v4f32] }:$x, ?:{ *:[v4f32] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 19944*/   /*SwitchOpcode*/ 25|128,1/*153*/, TARGET_VAL(ISD::TargetConstant),// ->20101
/* 19948*/    OPC_CheckTypeI32,
/* 19949*/    OPC_MoveSibling3,
/* 19950*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19953*/    OPC_RecordNode, // #3 = $m1
/* 19954*/    OPC_CheckTypeI32,
/* 19955*/    OPC_MoveSibling4,
/* 19956*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19959*/    OPC_RecordNode, // #4 = $m2
/* 19960*/    OPC_CheckTypeI32,
/* 19961*/    OPC_MoveSibling5,
/* 19962*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19965*/    OPC_RecordNode, // #5 = $m3
/* 19966*/    OPC_CheckTypeI32,
/* 19967*/    OPC_MoveSibling6,
/* 19968*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19971*/    OPC_RecordNode, // #6 = $m4
/* 19972*/    OPC_CheckTypeI32,
/* 19973*/    OPC_MoveSibling7,
/* 19974*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19977*/    OPC_RecordNode, // #7 = $m5
/* 19978*/    OPC_CheckTypeI32,
/* 19979*/    OPC_MoveSibling, 8,
/* 19981*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19984*/    OPC_RecordNode, // #8 = $m6
/* 19985*/    OPC_CheckTypeI32,
/* 19986*/    OPC_MoveSibling, 9,
/* 19988*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19991*/    OPC_RecordNode, // #9 = $m7
/* 19992*/    OPC_CheckTypeI32,
/* 19993*/    OPC_MoveSibling, 10,
/* 19995*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19998*/    OPC_RecordNode, // #10 = $m8
/* 19999*/    OPC_CheckTypeI32,
/* 20000*/    OPC_MoveSibling, 11,
/* 20002*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20005*/    OPC_RecordNode, // #11 = $m9
/* 20006*/    OPC_CheckTypeI32,
/* 20007*/    OPC_MoveSibling, 12,
/* 20009*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20012*/    OPC_RecordNode, // #12 = $mA
/* 20013*/    OPC_CheckTypeI32,
/* 20014*/    OPC_MoveSibling, 13,
/* 20016*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20019*/    OPC_RecordNode, // #13 = $mB
/* 20020*/    OPC_CheckTypeI32,
/* 20021*/    OPC_MoveSibling, 14,
/* 20023*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20026*/    OPC_RecordNode, // #14 = $mC
/* 20027*/    OPC_CheckTypeI32,
/* 20028*/    OPC_MoveSibling, 15,
/* 20030*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20033*/    OPC_RecordNode, // #15 = $mD
/* 20034*/    OPC_CheckTypeI32,
/* 20035*/    OPC_MoveSibling, 16,
/* 20037*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20040*/    OPC_RecordNode, // #16 = $mE
/* 20041*/    OPC_CheckTypeI32,
/* 20042*/    OPC_MoveSibling, 17,
/* 20044*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20047*/    OPC_RecordNode, // #17 = $mF
/* 20048*/    OPC_CheckTypeI32,
/* 20049*/    OPC_MoveParent,
/* 20050*/    OPC_CheckType, MVT::v4f32,
/* 20052*/    OPC_EmitConvertToTarget2,
/* 20053*/    OPC_EmitConvertToTarget3,
/* 20054*/    OPC_EmitConvertToTarget4,
/* 20055*/    OPC_EmitConvertToTarget5,
/* 20056*/    OPC_EmitConvertToTarget6,
/* 20057*/    OPC_EmitConvertToTarget7,
/* 20058*/    OPC_EmitConvertToTarget, 8,
/* 20060*/    OPC_EmitConvertToTarget, 9,
/* 20062*/    OPC_EmitConvertToTarget, 10,
/* 20064*/    OPC_EmitConvertToTarget, 11,
/* 20066*/    OPC_EmitConvertToTarget, 12,
/* 20068*/    OPC_EmitConvertToTarget, 13,
/* 20070*/    OPC_EmitConvertToTarget, 14,
/* 20072*/    OPC_EmitConvertToTarget, 15,
/* 20074*/    OPC_EmitConvertToTarget, 16,
/* 20076*/    OPC_EmitConvertToTarget, 17,
/* 20078*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  MVT::v4f32, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v4f32] } V128:{ *:[v4f32] }:$x, V128:{ *:[v4f32] }:$y, (timm:{ *:[i32] }):$m0, (timm:{ *:[i32] }):$m1, (timm:{ *:[i32] }):$m2, (timm:{ *:[i32] }):$m3, (timm:{ *:[i32] }):$m4, (timm:{ *:[i32] }):$m5, (timm:{ *:[i32] }):$m6, (timm:{ *:[i32] }):$m7, (timm:{ *:[i32] }):$m8, (timm:{ *:[i32] }):$m9, (timm:{ *:[i32] }):$mA, (timm:{ *:[i32] }):$mB, (timm:{ *:[i32] }):$mC, (timm:{ *:[i32] }):$mD, (timm:{ *:[i32] }):$mE, (timm:{ *:[i32] }):$mF) - Complexity = 51
              // Dst: (SHUFFLE:{ *:[v4f32] } ?:{ *:[v4f32] }:$x, ?:{ *:[v4f32] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 20101*/   0, // EndSwitchOpcode
/* 20102*/  /*Scope*/ 83|128,2/*339*/, /*->20443*/
/* 20104*/   OPC_CheckChild0Type, MVT::v2f64,
/* 20106*/   OPC_RecordChild1, // #1 = $y
/* 20107*/   OPC_CheckChild1Type, MVT::v2f64,
/* 20109*/   OPC_RecordChild2, // #2 = $m0
/* 20110*/   OPC_MoveChild2,
/* 20111*/   OPC_SwitchOpcode /*2 cases */, 41|128,1/*169*/, TARGET_VAL(ISD::Constant),// ->20285
/* 20116*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20117*/    OPC_CheckTypeI32,
/* 20118*/    OPC_MoveSibling3,
/* 20119*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20122*/    OPC_RecordNode, // #3 = $m1
/* 20123*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20124*/    OPC_CheckTypeI32,
/* 20125*/    OPC_MoveSibling4,
/* 20126*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20129*/    OPC_RecordNode, // #4 = $m2
/* 20130*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20131*/    OPC_CheckTypeI32,
/* 20132*/    OPC_MoveSibling5,
/* 20133*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20136*/    OPC_RecordNode, // #5 = $m3
/* 20137*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20138*/    OPC_CheckTypeI32,
/* 20139*/    OPC_MoveSibling6,
/* 20140*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20143*/    OPC_RecordNode, // #6 = $m4
/* 20144*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20145*/    OPC_CheckTypeI32,
/* 20146*/    OPC_MoveSibling7,
/* 20147*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20150*/    OPC_RecordNode, // #7 = $m5
/* 20151*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20152*/    OPC_CheckTypeI32,
/* 20153*/    OPC_MoveSibling, 8,
/* 20155*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20158*/    OPC_RecordNode, // #8 = $m6
/* 20159*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20160*/    OPC_CheckTypeI32,
/* 20161*/    OPC_MoveSibling, 9,
/* 20163*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20166*/    OPC_RecordNode, // #9 = $m7
/* 20167*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20168*/    OPC_CheckTypeI32,
/* 20169*/    OPC_MoveSibling, 10,
/* 20171*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20174*/    OPC_RecordNode, // #10 = $m8
/* 20175*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20176*/    OPC_CheckTypeI32,
/* 20177*/    OPC_MoveSibling, 11,
/* 20179*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20182*/    OPC_RecordNode, // #11 = $m9
/* 20183*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20184*/    OPC_CheckTypeI32,
/* 20185*/    OPC_MoveSibling, 12,
/* 20187*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20190*/    OPC_RecordNode, // #12 = $mA
/* 20191*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20192*/    OPC_CheckTypeI32,
/* 20193*/    OPC_MoveSibling, 13,
/* 20195*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20198*/    OPC_RecordNode, // #13 = $mB
/* 20199*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20200*/    OPC_CheckTypeI32,
/* 20201*/    OPC_MoveSibling, 14,
/* 20203*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20206*/    OPC_RecordNode, // #14 = $mC
/* 20207*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20208*/    OPC_CheckTypeI32,
/* 20209*/    OPC_MoveSibling, 15,
/* 20211*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20214*/    OPC_RecordNode, // #15 = $mD
/* 20215*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20216*/    OPC_CheckTypeI32,
/* 20217*/    OPC_MoveSibling, 16,
/* 20219*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20222*/    OPC_RecordNode, // #16 = $mE
/* 20223*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20224*/    OPC_CheckTypeI32,
/* 20225*/    OPC_MoveSibling, 17,
/* 20227*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20230*/    OPC_RecordNode, // #17 = $mF
/* 20231*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20232*/    OPC_CheckTypeI32,
/* 20233*/    OPC_MoveParent,
/* 20234*/    OPC_CheckType, MVT::v2f64,
/* 20236*/    OPC_EmitConvertToTarget2,
/* 20237*/    OPC_EmitConvertToTarget3,
/* 20238*/    OPC_EmitConvertToTarget4,
/* 20239*/    OPC_EmitConvertToTarget5,
/* 20240*/    OPC_EmitConvertToTarget6,
/* 20241*/    OPC_EmitConvertToTarget7,
/* 20242*/    OPC_EmitConvertToTarget, 8,
/* 20244*/    OPC_EmitConvertToTarget, 9,
/* 20246*/    OPC_EmitConvertToTarget, 10,
/* 20248*/    OPC_EmitConvertToTarget, 11,
/* 20250*/    OPC_EmitConvertToTarget, 12,
/* 20252*/    OPC_EmitConvertToTarget, 13,
/* 20254*/    OPC_EmitConvertToTarget, 14,
/* 20256*/    OPC_EmitConvertToTarget, 15,
/* 20258*/    OPC_EmitConvertToTarget, 16,
/* 20260*/    OPC_EmitConvertToTarget, 17,
/* 20262*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  MVT::v2f64, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v2f64] } V128:{ *:[v2f64] }:$x, V128:{ *:[v2f64] }:$y, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m0, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m1, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m2, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m3, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m4, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m5, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m6, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m7, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m8, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m9, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mA, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mB, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mC, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mD, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mE, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mF) - Complexity = 67
              // Dst: (SHUFFLE:{ *:[v2f64] } ?:{ *:[v2f64] }:$x, ?:{ *:[v2f64] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 20285*/   /*SwitchOpcode*/ 25|128,1/*153*/, TARGET_VAL(ISD::TargetConstant),// ->20442
/* 20289*/    OPC_CheckTypeI32,
/* 20290*/    OPC_MoveSibling3,
/* 20291*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20294*/    OPC_RecordNode, // #3 = $m1
/* 20295*/    OPC_CheckTypeI32,
/* 20296*/    OPC_MoveSibling4,
/* 20297*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20300*/    OPC_RecordNode, // #4 = $m2
/* 20301*/    OPC_CheckTypeI32,
/* 20302*/    OPC_MoveSibling5,
/* 20303*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20306*/    OPC_RecordNode, // #5 = $m3
/* 20307*/    OPC_CheckTypeI32,
/* 20308*/    OPC_MoveSibling6,
/* 20309*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20312*/    OPC_RecordNode, // #6 = $m4
/* 20313*/    OPC_CheckTypeI32,
/* 20314*/    OPC_MoveSibling7,
/* 20315*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20318*/    OPC_RecordNode, // #7 = $m5
/* 20319*/    OPC_CheckTypeI32,
/* 20320*/    OPC_MoveSibling, 8,
/* 20322*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20325*/    OPC_RecordNode, // #8 = $m6
/* 20326*/    OPC_CheckTypeI32,
/* 20327*/    OPC_MoveSibling, 9,
/* 20329*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20332*/    OPC_RecordNode, // #9 = $m7
/* 20333*/    OPC_CheckTypeI32,
/* 20334*/    OPC_MoveSibling, 10,
/* 20336*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20339*/    OPC_RecordNode, // #10 = $m8
/* 20340*/    OPC_CheckTypeI32,
/* 20341*/    OPC_MoveSibling, 11,
/* 20343*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20346*/    OPC_RecordNode, // #11 = $m9
/* 20347*/    OPC_CheckTypeI32,
/* 20348*/    OPC_MoveSibling, 12,
/* 20350*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20353*/    OPC_RecordNode, // #12 = $mA
/* 20354*/    OPC_CheckTypeI32,
/* 20355*/    OPC_MoveSibling, 13,
/* 20357*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20360*/    OPC_RecordNode, // #13 = $mB
/* 20361*/    OPC_CheckTypeI32,
/* 20362*/    OPC_MoveSibling, 14,
/* 20364*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20367*/    OPC_RecordNode, // #14 = $mC
/* 20368*/    OPC_CheckTypeI32,
/* 20369*/    OPC_MoveSibling, 15,
/* 20371*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20374*/    OPC_RecordNode, // #15 = $mD
/* 20375*/    OPC_CheckTypeI32,
/* 20376*/    OPC_MoveSibling, 16,
/* 20378*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20381*/    OPC_RecordNode, // #16 = $mE
/* 20382*/    OPC_CheckTypeI32,
/* 20383*/    OPC_MoveSibling, 17,
/* 20385*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20388*/    OPC_RecordNode, // #17 = $mF
/* 20389*/    OPC_CheckTypeI32,
/* 20390*/    OPC_MoveParent,
/* 20391*/    OPC_CheckType, MVT::v2f64,
/* 20393*/    OPC_EmitConvertToTarget2,
/* 20394*/    OPC_EmitConvertToTarget3,
/* 20395*/    OPC_EmitConvertToTarget4,
/* 20396*/    OPC_EmitConvertToTarget5,
/* 20397*/    OPC_EmitConvertToTarget6,
/* 20398*/    OPC_EmitConvertToTarget7,
/* 20399*/    OPC_EmitConvertToTarget, 8,
/* 20401*/    OPC_EmitConvertToTarget, 9,
/* 20403*/    OPC_EmitConvertToTarget, 10,
/* 20405*/    OPC_EmitConvertToTarget, 11,
/* 20407*/    OPC_EmitConvertToTarget, 12,
/* 20409*/    OPC_EmitConvertToTarget, 13,
/* 20411*/    OPC_EmitConvertToTarget, 14,
/* 20413*/    OPC_EmitConvertToTarget, 15,
/* 20415*/    OPC_EmitConvertToTarget, 16,
/* 20417*/    OPC_EmitConvertToTarget, 17,
/* 20419*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  MVT::v2f64, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v2f64] } V128:{ *:[v2f64] }:$x, V128:{ *:[v2f64] }:$y, (timm:{ *:[i32] }):$m0, (timm:{ *:[i32] }):$m1, (timm:{ *:[i32] }):$m2, (timm:{ *:[i32] }):$m3, (timm:{ *:[i32] }):$m4, (timm:{ *:[i32] }):$m5, (timm:{ *:[i32] }):$m6, (timm:{ *:[i32] }):$m7, (timm:{ *:[i32] }):$m8, (timm:{ *:[i32] }):$m9, (timm:{ *:[i32] }):$mA, (timm:{ *:[i32] }):$mB, (timm:{ *:[i32] }):$mC, (timm:{ *:[i32] }):$mD, (timm:{ *:[i32] }):$mE, (timm:{ *:[i32] }):$mF) - Complexity = 51
              // Dst: (SHUFFLE:{ *:[v2f64] } ?:{ *:[v2f64] }:$x, ?:{ *:[v2f64] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 20442*/   0, // EndSwitchOpcode
/* 20443*/  0, /*End of Scope*/
/* 20444*/ /*SwitchOpcode*/ 41|128,5/*681*/, TARGET_VAL(ISD::INSERT_VECTOR_ELT),// ->21129
/* 20448*/  OPC_Scope, 6|128,1/*134*/, /*->20585*/ // 2 children in Scope
/* 20451*/   OPC_MoveChild0,
/* 20452*/   OPC_CheckOpcode, TARGET_VAL(ISD::SPLAT_VECTOR),
/* 20455*/   OPC_CheckChild0Integer, 0, 
/* 20457*/   OPC_Scope, 62, /*->20521*/ // 2 children in Scope
/* 20459*/    OPC_CheckChild0TypeI32,
/* 20460*/    OPC_MoveSibling1,
/* 20461*/    OPC_CheckOpcode, TARGET_VAL(ISD::LOAD),
/* 20464*/    OPC_RecordMemRef,
/* 20465*/    OPC_RecordNode, // #0 = 'ld' chained node
/* 20466*/    OPC_CheckFoldableChainNode,
/* 20467*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/* 20468*/    OPC_CheckTypeI32,
/* 20469*/    OPC_Scope, 24, /*->20495*/ // 2 children in Scope
/* 20471*/     OPC_CheckChild1TypeI32,
/* 20472*/     OPC_CheckPredicate, 9, // Predicate_unindexedload
/* 20474*/     OPC_CheckPredicate7,  // Predicate_load
/* 20475*/     OPC_MoveParent,
/* 20476*/     OPC_CheckChild2Integer, 0, 
/* 20478*/     OPC_CheckType, MVT::v4i32,
/* 20480*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/* 20481*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 20483*/     OPC_EmitMergeInputChains1_0,
/* 20484*/     OPC_EmitInteger32, 0, 
/* 20486*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_I32x4_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v4i32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (vector_insert:{ *:[v4i32] } (splat_vector:{ *:[v4i32] } 0:{ *:[i32] }), (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[iPTR] }) - Complexity = 29
               // Dst: (LOAD_ZERO_I32x4_A32:{ *:[v4i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 20495*/    /*Scope*/ 24, /*->20520*/
/* 20496*/     OPC_CheckChild1TypeI64,
/* 20497*/     OPC_CheckPredicate, 9, // Predicate_unindexedload
/* 20499*/     OPC_CheckPredicate7,  // Predicate_load
/* 20500*/     OPC_MoveParent,
/* 20501*/     OPC_CheckChild2Integer, 0, 
/* 20503*/     OPC_CheckType, MVT::v4i32,
/* 20505*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/* 20506*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 20508*/     OPC_EmitMergeInputChains1_0,
/* 20509*/     OPC_EmitInteger32, 0, 
/* 20511*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_I32x4_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v4i32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (vector_insert:{ *:[v4i32] } (splat_vector:{ *:[v4i32] } 0:{ *:[i32] }), (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[iPTR] }) - Complexity = 29
               // Dst: (LOAD_ZERO_I32x4_A64:{ *:[v4i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 20520*/    0, /*End of Scope*/
/* 20521*/   /*Scope*/ 62, /*->20584*/
/* 20522*/    OPC_CheckChild0TypeI64,
/* 20523*/    OPC_MoveSibling1,
/* 20524*/    OPC_CheckOpcode, TARGET_VAL(ISD::LOAD),
/* 20527*/    OPC_RecordMemRef,
/* 20528*/    OPC_RecordNode, // #0 = 'ld' chained node
/* 20529*/    OPC_CheckFoldableChainNode,
/* 20530*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/* 20531*/    OPC_CheckTypeI64,
/* 20532*/    OPC_Scope, 24, /*->20558*/ // 2 children in Scope
/* 20534*/     OPC_CheckChild1TypeI32,
/* 20535*/     OPC_CheckPredicate, 9, // Predicate_unindexedload
/* 20537*/     OPC_CheckPredicate7,  // Predicate_load
/* 20538*/     OPC_MoveParent,
/* 20539*/     OPC_CheckChild2Integer, 0, 
/* 20541*/     OPC_CheckType, MVT::v2i64,
/* 20543*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/* 20544*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 20546*/     OPC_EmitMergeInputChains1_0,
/* 20547*/     OPC_EmitInteger32, 0, 
/* 20549*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_I64x2_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v2i64, 3/*#Ops*/, 4, 2, 3, 
               // Src: (vector_insert:{ *:[v2i64] } (splat_vector:{ *:[v2i64] } 0:{ *:[i64] }), (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[iPTR] }) - Complexity = 29
               // Dst: (LOAD_ZERO_I64x2_A32:{ *:[v2i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 20558*/    /*Scope*/ 24, /*->20583*/
/* 20559*/     OPC_CheckChild1TypeI64,
/* 20560*/     OPC_CheckPredicate, 9, // Predicate_unindexedload
/* 20562*/     OPC_CheckPredicate7,  // Predicate_load
/* 20563*/     OPC_MoveParent,
/* 20564*/     OPC_CheckChild2Integer, 0, 
/* 20566*/     OPC_CheckType, MVT::v2i64,
/* 20568*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/* 20569*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 20571*/     OPC_EmitMergeInputChains1_0,
/* 20572*/     OPC_EmitInteger32, 0, 
/* 20574*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_I64x2_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v2i64, 3/*#Ops*/, 4, 2, 3, 
               // Src: (vector_insert:{ *:[v2i64] } (splat_vector:{ *:[v2i64] } 0:{ *:[i64] }), (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[iPTR] }) - Complexity = 29
               // Dst: (LOAD_ZERO_I64x2_A64:{ *:[v2i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 20583*/    0, /*End of Scope*/
/* 20584*/   0, /*End of Scope*/
/* 20585*/  /*Scope*/ 29|128,4/*541*/, /*->21128*/
/* 20587*/   OPC_RecordChild0, // #0 = $vec
/* 20588*/   OPC_Scope, 36|128,2/*292*/, /*->20883*/ // 2 children in Scope
/* 20591*/    OPC_MoveChild1,
/* 20592*/    OPC_CheckOpcode, TARGET_VAL(ISD::LOAD),
/* 20595*/    OPC_RecordMemRef,
/* 20596*/    OPC_RecordNode, // #1 = 'ld' chained node
/* 20597*/    OPC_CheckFoldableChainNode,
/* 20598*/    OPC_RecordChild1, // #2 = $addr
/* 20599*/    OPC_Scope, 11|128,1/*139*/, /*->20741*/ // 2 children in Scope
/* 20602*/     OPC_CheckChild1TypeI32,
/* 20603*/     OPC_CheckPredicate, 9, // Predicate_unindexedload
/* 20605*/     OPC_Scope, 67, /*->20674*/ // 2 children in Scope
/* 20607*/      OPC_CheckPredicate, 10, // Predicate_extload
/* 20609*/      OPC_CheckTypeI32,
/* 20610*/      OPC_Scope, 30, /*->20642*/ // 2 children in Scope
/* 20612*/       OPC_CheckPredicate1,  // Predicate_extloadi8
/* 20613*/       OPC_MoveSibling2,
/* 20614*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20617*/       OPC_RecordNode, // #3 = $idx
/* 20618*/       OPC_CheckPredicate, 11, // Predicate_LaneIdx16
/* 20620*/       OPC_CheckTypeI32,
/* 20621*/       OPC_MoveParent,
/* 20622*/       OPC_CheckType, MVT::v16i8,
/* 20624*/       OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/* 20625*/       OPC_EmitMergeInputChains1_1,
/* 20626*/       OPC_EmitInteger32, 0, 
/* 20628*/       OPC_EmitInteger32, 0, 
/* 20630*/       OPC_EmitConvertToTarget3,
/* 20631*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_I8x16_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v16i8, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, (ld:{ *:[i32] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_I8x16_A32:{ *:[v16i8] } 0:{ *:[i32] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v16i8] }:$vec)
/* 20642*/      /*Scope*/ 30, /*->20673*/
/* 20643*/       OPC_CheckPredicate2,  // Predicate_extloadi16
/* 20644*/       OPC_MoveSibling2,
/* 20645*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20648*/       OPC_RecordNode, // #3 = $idx
/* 20649*/       OPC_CheckPredicate, 16, // Predicate_LaneIdx8
/* 20651*/       OPC_CheckTypeI32,
/* 20652*/       OPC_MoveParent,
/* 20653*/       OPC_CheckType, MVT::v8i16,
/* 20655*/       OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/* 20656*/       OPC_EmitMergeInputChains1_1,
/* 20657*/       OPC_EmitInteger32, 0, 
/* 20659*/       OPC_EmitInteger32, 0, 
/* 20661*/       OPC_EmitConvertToTarget3,
/* 20662*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_I16x8_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v8i16, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, (ld:{ *:[i32] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_I16x8_A32:{ *:[v8i16] } 0:{ *:[i32] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v8i16] }:$vec)
/* 20673*/      0, /*End of Scope*/
/* 20674*/     /*Scope*/ 65, /*->20740*/
/* 20675*/      OPC_CheckPredicate7,  // Predicate_load
/* 20676*/      OPC_SwitchType /*2 cases */, 29, MVT::i32,// ->20708
/* 20679*/       OPC_MoveSibling2,
/* 20680*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20683*/       OPC_RecordNode, // #3 = $idx
/* 20684*/       OPC_CheckPredicate, 17, // Predicate_LaneIdx4
/* 20686*/       OPC_CheckTypeI32,
/* 20687*/       OPC_MoveParent,
/* 20688*/       OPC_CheckType, MVT::v4i32,
/* 20690*/       OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/* 20691*/       OPC_EmitMergeInputChains1_1,
/* 20692*/       OPC_EmitInteger32, 0, 
/* 20694*/       OPC_EmitInteger32, 0, 
/* 20696*/       OPC_EmitConvertToTarget3,
/* 20697*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_I32x4_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v4i32, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, (ld:{ *:[i32] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_I32x4_A32:{ *:[v4i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v4i32] }:$vec)
/* 20708*/      /*SwitchType*/ 29, MVT::i64,// ->20739
/* 20710*/       OPC_MoveSibling2,
/* 20711*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20714*/       OPC_RecordNode, // #3 = $idx
/* 20715*/       OPC_CheckPredicate, 18, // Predicate_LaneIdx2
/* 20717*/       OPC_CheckTypeI32,
/* 20718*/       OPC_MoveParent,
/* 20719*/       OPC_CheckType, MVT::v2i64,
/* 20721*/       OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/* 20722*/       OPC_EmitMergeInputChains1_1,
/* 20723*/       OPC_EmitInteger32, 0, 
/* 20725*/       OPC_EmitInteger32, 0, 
/* 20727*/       OPC_EmitConvertToTarget3,
/* 20728*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_I64x2_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v2i64, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, (ld:{ *:[i64] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_I64x2_A32:{ *:[v2i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v2i64] }:$vec)
/* 20739*/      0, // EndSwitchType
/* 20740*/     0, /*End of Scope*/
/* 20741*/    /*Scope*/ 11|128,1/*139*/, /*->20882*/
/* 20743*/     OPC_CheckChild1TypeI64,
/* 20744*/     OPC_CheckPredicate, 9, // Predicate_unindexedload
/* 20746*/     OPC_Scope, 67, /*->20815*/ // 2 children in Scope
/* 20748*/      OPC_CheckPredicate, 10, // Predicate_extload
/* 20750*/      OPC_CheckTypeI32,
/* 20751*/      OPC_Scope, 30, /*->20783*/ // 2 children in Scope
/* 20753*/       OPC_CheckPredicate1,  // Predicate_extloadi8
/* 20754*/       OPC_MoveSibling2,
/* 20755*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20758*/       OPC_RecordNode, // #3 = $idx
/* 20759*/       OPC_CheckPredicate, 11, // Predicate_LaneIdx16
/* 20761*/       OPC_CheckTypeI32,
/* 20762*/       OPC_MoveParent,
/* 20763*/       OPC_CheckType, MVT::v16i8,
/* 20765*/       OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/* 20766*/       OPC_EmitMergeInputChains1_1,
/* 20767*/       OPC_EmitInteger32, 0, 
/* 20769*/       OPC_EmitInteger64, 0, 
/* 20771*/       OPC_EmitConvertToTarget3,
/* 20772*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_I8x16_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v16i8, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, (ld:{ *:[i32] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_I8x16_A64:{ *:[v16i8] } 0:{ *:[i32] }, 0:{ *:[i64] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v16i8] }:$vec)
/* 20783*/      /*Scope*/ 30, /*->20814*/
/* 20784*/       OPC_CheckPredicate2,  // Predicate_extloadi16
/* 20785*/       OPC_MoveSibling2,
/* 20786*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20789*/       OPC_RecordNode, // #3 = $idx
/* 20790*/       OPC_CheckPredicate, 16, // Predicate_LaneIdx8
/* 20792*/       OPC_CheckTypeI32,
/* 20793*/       OPC_MoveParent,
/* 20794*/       OPC_CheckType, MVT::v8i16,
/* 20796*/       OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/* 20797*/       OPC_EmitMergeInputChains1_1,
/* 20798*/       OPC_EmitInteger32, 0, 
/* 20800*/       OPC_EmitInteger64, 0, 
/* 20802*/       OPC_EmitConvertToTarget3,
/* 20803*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_I16x8_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v8i16, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, (ld:{ *:[i32] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_I16x8_A64:{ *:[v8i16] } 0:{ *:[i32] }, 0:{ *:[i64] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v8i16] }:$vec)
/* 20814*/      0, /*End of Scope*/
/* 20815*/     /*Scope*/ 65, /*->20881*/
/* 20816*/      OPC_CheckPredicate7,  // Predicate_load
/* 20817*/      OPC_SwitchType /*2 cases */, 29, MVT::i32,// ->20849
/* 20820*/       OPC_MoveSibling2,
/* 20821*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20824*/       OPC_RecordNode, // #3 = $idx
/* 20825*/       OPC_CheckPredicate, 17, // Predicate_LaneIdx4
/* 20827*/       OPC_CheckTypeI32,
/* 20828*/       OPC_MoveParent,
/* 20829*/       OPC_CheckType, MVT::v4i32,
/* 20831*/       OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/* 20832*/       OPC_EmitMergeInputChains1_1,
/* 20833*/       OPC_EmitInteger32, 0, 
/* 20835*/       OPC_EmitInteger64, 0, 
/* 20837*/       OPC_EmitConvertToTarget3,
/* 20838*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_I32x4_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v4i32, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, (ld:{ *:[i32] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_I32x4_A64:{ *:[v4i32] } 0:{ *:[i32] }, 0:{ *:[i64] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v4i32] }:$vec)
/* 20849*/      /*SwitchType*/ 29, MVT::i64,// ->20880
/* 20851*/       OPC_MoveSibling2,
/* 20852*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20855*/       OPC_RecordNode, // #3 = $idx
/* 20856*/       OPC_CheckPredicate, 18, // Predicate_LaneIdx2
/* 20858*/       OPC_CheckTypeI32,
/* 20859*/       OPC_MoveParent,
/* 20860*/       OPC_CheckType, MVT::v2i64,
/* 20862*/       OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/* 20863*/       OPC_EmitMergeInputChains1_1,
/* 20864*/       OPC_EmitInteger32, 0, 
/* 20866*/       OPC_EmitInteger64, 0, 
/* 20868*/       OPC_EmitConvertToTarget3,
/* 20869*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_I64x2_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v2i64, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, (ld:{ *:[i64] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_I64x2_A64:{ *:[v2i64] } 0:{ *:[i32] }, 0:{ *:[i64] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v2i64] }:$vec)
/* 20880*/      0, // EndSwitchType
/* 20881*/     0, /*End of Scope*/
/* 20882*/    0, /*End of Scope*/
/* 20883*/   /*Scope*/ 114|128,1/*242*/, /*->21127*/
/* 20885*/    OPC_RecordChild1, // #1 = $x
/* 20886*/    OPC_Scope, 104, /*->20992*/ // 4 children in Scope
/* 20888*/     OPC_CheckChild1TypeI32,
/* 20889*/     OPC_Scope, 56, /*->20947*/ // 2 children in Scope
/* 20891*/      OPC_RecordChild2, // #2 = $idx
/* 20892*/      OPC_MoveChild2,
/* 20893*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20896*/      OPC_CheckTypeI32,
/* 20897*/      OPC_Scope, 15, /*->20914*/ // 3 children in Scope
/* 20899*/       OPC_CheckPredicate, 11, // Predicate_LaneIdx16
/* 20901*/       OPC_MoveParent,
/* 20902*/       OPC_CheckType, MVT::v16i8,
/* 20904*/       OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 20905*/       OPC_EmitConvertToTarget2,
/* 20906*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_I8x16),
                     MVT::v16i8, 3/*#Ops*/, 0, 3, 1, 
                 // Src: (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx) - Complexity = 7
                 // Dst: (REPLACE_LANE_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, (imm:{ *:[i32] }):$idx, I32:{ *:[i32] }:$x)
/* 20914*/      /*Scope*/ 15, /*->20930*/
/* 20915*/       OPC_CheckPredicate, 16, // Predicate_LaneIdx8
/* 20917*/       OPC_MoveParent,
/* 20918*/       OPC_CheckType, MVT::v8i16,
/* 20920*/       OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 20921*/       OPC_EmitConvertToTarget2,
/* 20922*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_I16x8),
                     MVT::v8i16, 3/*#Ops*/, 0, 3, 1, 
                 // Src: (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx) - Complexity = 7
                 // Dst: (REPLACE_LANE_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, (imm:{ *:[i32] }):$idx, I32:{ *:[i32] }:$x)
/* 20930*/      /*Scope*/ 15, /*->20946*/
/* 20931*/       OPC_CheckPredicate, 17, // Predicate_LaneIdx4
/* 20933*/       OPC_MoveParent,
/* 20934*/       OPC_CheckType, MVT::v4i32,
/* 20936*/       OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 20937*/       OPC_EmitConvertToTarget2,
/* 20938*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_I32x4),
                     MVT::v4i32, 3/*#Ops*/, 0, 3, 1, 
                 // Src: (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 7
                 // Dst: (REPLACE_LANE_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, (imm:{ *:[i32] }):$idx, I32:{ *:[i32] }:$x)
/* 20946*/      0, /*End of Scope*/
/* 20947*/     /*Scope*/ 43, /*->20991*/
/* 20948*/      OPC_MoveChild2,
/* 20949*/      OPC_CheckOpcode, TARGET_VAL(ISD::UNDEF),
/* 20952*/      OPC_MoveParent,
/* 20953*/      OPC_SwitchType /*3 cases */, 10, MVT::v16i8,// ->20966
/* 20956*/       OPC_EmitInteger32, 0, 
/* 20958*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_I8x16),
                     MVT::v16i8, 3/*#Ops*/, 0, 2, 1, 
                 // Src: (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x, (undef:{ *:[iPTR] })) - Complexity = 6
                 // Dst: (REPLACE_LANE_I8x16:{ *:[v16i8] } ?:{ *:[v16i8] }:$vec, 0:{ *:[i32] }, ?:{ *:[i32] }:$x)
/* 20966*/      /*SwitchType*/ 10, MVT::v8i16,// ->20978
/* 20968*/       OPC_EmitInteger32, 0, 
/* 20970*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_I16x8),
                     MVT::v8i16, 3/*#Ops*/, 0, 2, 1, 
                 // Src: (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x, (undef:{ *:[iPTR] })) - Complexity = 6
                 // Dst: (REPLACE_LANE_I16x8:{ *:[v8i16] } ?:{ *:[v8i16] }:$vec, 0:{ *:[i32] }, ?:{ *:[i32] }:$x)
/* 20978*/      /*SwitchType*/ 10, MVT::v4i32,// ->20990
/* 20980*/       OPC_EmitInteger32, 0, 
/* 20982*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_I32x4),
                     MVT::v4i32, 3/*#Ops*/, 0, 2, 1, 
                 // Src: (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x, (undef:{ *:[iPTR] })) - Complexity = 6
                 // Dst: (REPLACE_LANE_I32x4:{ *:[v4i32] } ?:{ *:[v4i32] }:$vec, 0:{ *:[i32] }, ?:{ *:[i32] }:$x)
/* 20990*/      0, // EndSwitchType
/* 20991*/     0, /*End of Scope*/
/* 20992*/    /*Scope*/ 43, /*->21036*/
/* 20993*/     OPC_CheckChild1TypeI64,
/* 20994*/     OPC_Scope, 21, /*->21017*/ // 2 children in Scope
/* 20996*/      OPC_RecordChild2, // #2 = $idx
/* 20997*/      OPC_MoveChild2,
/* 20998*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21001*/      OPC_CheckPredicate, 18, // Predicate_LaneIdx2
/* 21003*/      OPC_CheckTypeI32,
/* 21004*/      OPC_MoveParent,
/* 21005*/      OPC_CheckType, MVT::v2i64,
/* 21007*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 21008*/      OPC_EmitConvertToTarget2,
/* 21009*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_I64x2),
                    MVT::v2i64, 3/*#Ops*/, 0, 3, 1, 
                // Src: (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I64:{ *:[i64] }:$x, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 7
                // Dst: (REPLACE_LANE_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, (imm:{ *:[i32] }):$idx, I64:{ *:[i64] }:$x)
/* 21017*/     /*Scope*/ 17, /*->21035*/
/* 21018*/      OPC_MoveChild2,
/* 21019*/      OPC_CheckOpcode, TARGET_VAL(ISD::UNDEF),
/* 21022*/      OPC_MoveParent,
/* 21023*/      OPC_CheckType, MVT::v2i64,
/* 21025*/      OPC_EmitInteger32, 0, 
/* 21027*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_I64x2),
                    MVT::v2i64, 3/*#Ops*/, 0, 2, 1, 
                // Src: (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I64:{ *:[i64] }:$x, (undef:{ *:[iPTR] })) - Complexity = 6
                // Dst: (REPLACE_LANE_I64x2:{ *:[v2i64] } ?:{ *:[v2i64] }:$vec, 0:{ *:[i32] }, ?:{ *:[i64] }:$x)
/* 21035*/     0, /*End of Scope*/
/* 21036*/    /*Scope*/ 44, /*->21081*/
/* 21037*/     OPC_CheckChild1Type, MVT::f32,
/* 21039*/     OPC_Scope, 21, /*->21062*/ // 2 children in Scope
/* 21041*/      OPC_RecordChild2, // #2 = $idx
/* 21042*/      OPC_MoveChild2,
/* 21043*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21046*/      OPC_CheckPredicate, 17, // Predicate_LaneIdx4
/* 21048*/      OPC_CheckTypeI32,
/* 21049*/      OPC_MoveParent,
/* 21050*/      OPC_CheckType, MVT::v4f32,
/* 21052*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 21053*/      OPC_EmitConvertToTarget2,
/* 21054*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_F32x4),
                    MVT::v4f32, 3/*#Ops*/, 0, 3, 1, 
                // Src: (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$vec, F32:{ *:[f32] }:$x, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 7
                // Dst: (REPLACE_LANE_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$vec, (imm:{ *:[i32] }):$idx, F32:{ *:[f32] }:$x)
/* 21062*/     /*Scope*/ 17, /*->21080*/
/* 21063*/      OPC_MoveChild2,
/* 21064*/      OPC_CheckOpcode, TARGET_VAL(ISD::UNDEF),
/* 21067*/      OPC_MoveParent,
/* 21068*/      OPC_CheckType, MVT::v4f32,
/* 21070*/      OPC_EmitInteger32, 0, 
/* 21072*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_F32x4),
                    MVT::v4f32, 3/*#Ops*/, 0, 2, 1, 
                // Src: (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$vec, F32:{ *:[f32] }:$x, (undef:{ *:[iPTR] })) - Complexity = 6
                // Dst: (REPLACE_LANE_F32x4:{ *:[v4f32] } ?:{ *:[v4f32] }:$vec, 0:{ *:[i32] }, ?:{ *:[f32] }:$x)
/* 21080*/     0, /*End of Scope*/
/* 21081*/    /*Scope*/ 44, /*->21126*/
/* 21082*/     OPC_CheckChild1Type, MVT::f64,
/* 21084*/     OPC_Scope, 21, /*->21107*/ // 2 children in Scope
/* 21086*/      OPC_RecordChild2, // #2 = $idx
/* 21087*/      OPC_MoveChild2,
/* 21088*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21091*/      OPC_CheckPredicate, 18, // Predicate_LaneIdx2
/* 21093*/      OPC_CheckTypeI32,
/* 21094*/      OPC_MoveParent,
/* 21095*/      OPC_CheckType, MVT::v2f64,
/* 21097*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 21098*/      OPC_EmitConvertToTarget2,
/* 21099*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_F64x2),
                    MVT::v2f64, 3/*#Ops*/, 0, 3, 1, 
                // Src: (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$vec, F64:{ *:[f64] }:$x, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 7
                // Dst: (REPLACE_LANE_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$vec, (imm:{ *:[i32] }):$idx, F64:{ *:[f64] }:$x)
/* 21107*/     /*Scope*/ 17, /*->21125*/
/* 21108*/      OPC_MoveChild2,
/* 21109*/      OPC_CheckOpcode, TARGET_VAL(ISD::UNDEF),
/* 21112*/      OPC_MoveParent,
/* 21113*/      OPC_CheckType, MVT::v2f64,
/* 21115*/      OPC_EmitInteger32, 0, 
/* 21117*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_F64x2),
                    MVT::v2f64, 3/*#Ops*/, 0, 2, 1, 
                // Src: (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$vec, F64:{ *:[f64] }:$x, (undef:{ *:[iPTR] })) - Complexity = 6
                // Dst: (REPLACE_LANE_F64x2:{ *:[v2f64] } ?:{ *:[v2f64] }:$vec, 0:{ *:[i32] }, ?:{ *:[f64] }:$x)
/* 21125*/     0, /*End of Scope*/
/* 21126*/    0, /*End of Scope*/
/* 21127*/   0, /*End of Scope*/
/* 21128*/  0, /*End of Scope*/
/* 21129*/ /*SwitchOpcode*/ 96|128,1/*224*/, TARGET_VAL(WebAssemblyISD::VEC_SHR_U),// ->21357
/* 21133*/  OPC_Scope, 87, /*->21222*/ // 2 children in Scope
/* 21135*/   OPC_MoveChild0,
/* 21136*/   OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/* 21139*/   OPC_MoveChild0,
/* 21140*/   OPC_SwitchOpcode /*2 cases */, 37, TARGET_VAL(ISD::ADD),// ->21181
/* 21144*/    OPC_RecordChild0, // #0 = $lhs
/* 21145*/    OPC_RecordChild1, // #1 = $rhs
/* 21146*/    OPC_CheckPredicate, 24, // Predicate_add_nuw
/* 21148*/    OPC_MoveSibling1,
/* 21149*/    OPC_CheckOpcode, TARGET_VAL(ISD::SPLAT_VECTOR),
/* 21152*/    OPC_CheckChild0Integer, 2, 
/* 21154*/    OPC_CheckChild0TypeI32,
/* 21155*/    OPC_MoveParent,
/* 21156*/    OPC_CheckPredicate, 24, // Predicate_add_nuw
/* 21158*/    OPC_MoveParent,
/* 21159*/    OPC_CheckChild1Integer, 2, 
/* 21161*/    OPC_SwitchType /*2 cases */, 7, MVT::v16i8,// ->21171
/* 21164*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AVGR_U_I8x16),
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v16i8] } (add:{ *:[v16i8] } (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)<<P:Predicate_add_nuw>>, (splat_vector:{ *:[v16i8] } 1:{ *:[i32] }))<<P:Predicate_add_nuw>>, 1:{ *:[i32] }) - Complexity = 24
               // Dst: (AVGR_U_I8x16:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs)
/* 21171*/    /*SwitchType*/ 7, MVT::v8i16,// ->21180
/* 21173*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AVGR_U_I16x8),
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v8i16] } (add:{ *:[v8i16] } (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)<<P:Predicate_add_nuw>>, (splat_vector:{ *:[v8i16] } 1:{ *:[i32] }))<<P:Predicate_add_nuw>>, 1:{ *:[i32] }) - Complexity = 24
               // Dst: (AVGR_U_I16x8:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/* 21180*/    0, // EndSwitchType
/* 21181*/   /*SwitchOpcode*/ 37, TARGET_VAL(ISD::SPLAT_VECTOR),// ->21221
/* 21184*/    OPC_CheckChild0Integer, 2, 
/* 21186*/    OPC_CheckChild0TypeI32,
/* 21187*/    OPC_MoveSibling1,
/* 21188*/    OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/* 21191*/    OPC_RecordChild0, // #0 = $lhs
/* 21192*/    OPC_RecordChild1, // #1 = $rhs
/* 21193*/    OPC_CheckPredicate, 24, // Predicate_add_nuw
/* 21195*/    OPC_MoveParent,
/* 21196*/    OPC_CheckPredicate, 24, // Predicate_add_nuw
/* 21198*/    OPC_MoveParent,
/* 21199*/    OPC_CheckChild1Integer, 2, 
/* 21201*/    OPC_SwitchType /*2 cases */, 7, MVT::v16i8,// ->21211
/* 21204*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AVGR_U_I8x16),
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v16i8] } (add:{ *:[v16i8] } (splat_vector:{ *:[v16i8] } 1:{ *:[i32] }), (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)<<P:Predicate_add_nuw>>)<<P:Predicate_add_nuw>>, 1:{ *:[i32] }) - Complexity = 24
               // Dst: (AVGR_U_I8x16:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs)
/* 21211*/    /*SwitchType*/ 7, MVT::v8i16,// ->21220
/* 21213*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AVGR_U_I16x8),
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v8i16] } (add:{ *:[v8i16] } (splat_vector:{ *:[v8i16] } 1:{ *:[i32] }), (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)<<P:Predicate_add_nuw>>)<<P:Predicate_add_nuw>>, 1:{ *:[i32] }) - Complexity = 24
               // Dst: (AVGR_U_I16x8:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/* 21220*/    0, // EndSwitchType
/* 21221*/   0, // EndSwitchOpcode
/* 21222*/  /*Scope*/ 4|128,1/*132*/, /*->21356*/
/* 21224*/   OPC_RecordChild0, // #0 = $lhs
/* 21225*/   OPC_Scope, 84, /*->21311*/ // 2 children in Scope
/* 21227*/    OPC_MoveChild1,
/* 21228*/    OPC_Scope, 24, /*->21254*/ // 5 children in Scope
/* 21230*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 21233*/     OPC_MoveChild0,
/* 21234*/     OPC_CheckAndImm, 63, 
/* 21236*/     OPC_RecordChild0, // #1 = $rhs
/* 21237*/     OPC_MoveParent,
/* 21238*/     OPC_MoveParent,
/* 21239*/     OPC_CheckType, MVT::v2i64,
/* 21241*/     OPC_EmitNode1None, TARGET_VAL(WebAssembly::I32_WRAP_I64),
                   MVT::i32, 1/*#Ops*/, 1,  // Results = #2
/* 21247*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I64x2),
                   MVT::v2i64, 2/*#Ops*/, 0, 2, 
               // Src: (wasm_shr_u:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (trunc:{ *:[i32] } (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] }))) - Complexity = 14
               // Dst: (SHR_U_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (I32_WRAP_I64:{ *:[i32] } I64:{ *:[i64] }:$rhs))
/* 21254*/    /*Scope*/ 13, /*->21268*/
/* 21255*/     OPC_CheckAndImm, 7, 
/* 21257*/     OPC_RecordChild0, // #1 = $rhs
/* 21258*/     OPC_MoveParent,
/* 21259*/     OPC_CheckType, MVT::v16i8,
/* 21261*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I8x16),
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 7:{ *:[i32] })) - Complexity = 11
               // Dst: (SHR_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 21268*/    /*Scope*/ 13, /*->21282*/
/* 21269*/     OPC_CheckAndImm, 15, 
/* 21271*/     OPC_RecordChild0, // #1 = $rhs
/* 21272*/     OPC_MoveParent,
/* 21273*/     OPC_CheckType, MVT::v8i16,
/* 21275*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I16x8),
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 15:{ *:[i32] })) - Complexity = 11
               // Dst: (SHR_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 21282*/    /*Scope*/ 13, /*->21296*/
/* 21283*/     OPC_CheckAndImm, 31, 
/* 21285*/     OPC_RecordChild0, // #1 = $rhs
/* 21286*/     OPC_MoveParent,
/* 21287*/     OPC_CheckType, MVT::v4i32,
/* 21289*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I32x4),
                   MVT::v4i32, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
               // Dst: (SHR_U_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 21296*/    /*Scope*/ 13, /*->21310*/
/* 21297*/     OPC_CheckAndImm, 63, 
/* 21299*/     OPC_RecordChild0, // #1 = $rhs
/* 21300*/     OPC_MoveParent,
/* 21301*/     OPC_CheckType, MVT::v2i64,
/* 21303*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I64x2),
                   MVT::v2i64, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 63:{ *:[i32] })) - Complexity = 11
               // Dst: (SHR_U_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 21310*/    0, /*End of Scope*/
/* 21311*/   /*Scope*/ 43, /*->21355*/
/* 21312*/    OPC_RecordChild1, // #1 = $x
/* 21313*/    OPC_SwitchType /*4 cases */, 8, MVT::v16i8,// ->21324
/* 21316*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 21317*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I8x16),
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SHR_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x)
/* 21324*/    /*SwitchType*/ 8, MVT::v8i16,// ->21334
/* 21326*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 21327*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I16x8),
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SHR_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x)
/* 21334*/    /*SwitchType*/ 8, MVT::v4i32,// ->21344
/* 21336*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 21337*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I32x4),
                   MVT::v4i32, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SHR_U_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x)
/* 21344*/    /*SwitchType*/ 8, MVT::v2i64,// ->21354
/* 21346*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 21347*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I64x2),
                   MVT::v2i64, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SHR_U_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I32:{ *:[i32] }:$x)
/* 21354*/    0, // EndSwitchType
/* 21355*/   0, /*End of Scope*/
/* 21356*/  0, /*End of Scope*/
/* 21357*/ /*SwitchOpcode*/ 14|128,4/*526*/, TARGET_VAL(ISD::SPLAT_VECTOR),// ->21887
/* 21361*/  OPC_Scope, 73|128,1/*201*/, /*->21565*/ // 4 children in Scope
/* 21364*/   OPC_MoveChild0,
/* 21365*/   OPC_CheckOpcode, TARGET_VAL(ISD::LOAD),
/* 21368*/   OPC_RecordMemRef,
/* 21369*/   OPC_RecordNode, // #0 = 'ld' chained node
/* 21370*/   OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/* 21371*/   OPC_Scope, 95, /*->21468*/ // 2 children in Scope
/* 21373*/    OPC_CheckChild1TypeI32,
/* 21374*/    OPC_CheckPredicate, 9, // Predicate_unindexedload
/* 21376*/    OPC_Scope, 45, /*->21423*/ // 2 children in Scope
/* 21378*/     OPC_CheckPredicate, 10, // Predicate_extload
/* 21380*/     OPC_CheckTypeI32,
/* 21381*/     OPC_Scope, 19, /*->21402*/ // 2 children in Scope
/* 21383*/      OPC_CheckPredicate1,  // Predicate_extloadi8
/* 21384*/      OPC_MoveParent,
/* 21385*/      OPC_CheckType, MVT::v16i8,
/* 21387*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/* 21388*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 21390*/      OPC_EmitMergeInputChains1_0,
/* 21391*/      OPC_EmitInteger32, 0, 
/* 21393*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v16i8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (splat_vector:{ *:[v16i8] } (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>) - Complexity = 16
                // Dst: (LOAD8_SPLAT_A32:{ *:[v16i8] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 21402*/     /*Scope*/ 19, /*->21422*/
/* 21403*/      OPC_CheckPredicate2,  // Predicate_extloadi16
/* 21404*/      OPC_MoveParent,
/* 21405*/      OPC_CheckType, MVT::v8i16,
/* 21407*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/* 21408*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 21410*/      OPC_EmitMergeInputChains1_0,
/* 21411*/      OPC_EmitInteger32, 0, 
/* 21413*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v8i16, 3/*#Ops*/, 4, 2, 3, 
                // Src: (splat_vector:{ *:[v8i16] } (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>) - Complexity = 16
                // Dst: (LOAD16_SPLAT_A32:{ *:[v8i16] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 21422*/     0, /*End of Scope*/
/* 21423*/    /*Scope*/ 43, /*->21467*/
/* 21424*/     OPC_CheckPredicate7,  // Predicate_load
/* 21425*/     OPC_SwitchType /*2 cases */, 18, MVT::i32,// ->21446
/* 21428*/      OPC_MoveParent,
/* 21429*/      OPC_CheckType, MVT::v4i32,
/* 21431*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/* 21432*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 21434*/      OPC_EmitMergeInputChains1_0,
/* 21435*/      OPC_EmitInteger32, 0, 
/* 21437*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v4i32, 3/*#Ops*/, 4, 2, 3, 
                // Src: (splat_vector:{ *:[v4i32] } (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
                // Dst: (LOAD32_SPLAT_A32:{ *:[v4i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 21446*/     /*SwitchType*/ 18, MVT::i64,// ->21466
/* 21448*/      OPC_MoveParent,
/* 21449*/      OPC_CheckType, MVT::v2i64,
/* 21451*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/* 21452*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 21454*/      OPC_EmitMergeInputChains1_0,
/* 21455*/      OPC_EmitInteger32, 0, 
/* 21457*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD64_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v2i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (splat_vector:{ *:[v2i64] } (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
                // Dst: (LOAD64_SPLAT_A32:{ *:[v2i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 21466*/     0, // EndSwitchType
/* 21467*/    0, /*End of Scope*/
/* 21468*/   /*Scope*/ 95, /*->21564*/
/* 21469*/    OPC_CheckChild1TypeI64,
/* 21470*/    OPC_CheckPredicate, 9, // Predicate_unindexedload
/* 21472*/    OPC_Scope, 45, /*->21519*/ // 2 children in Scope
/* 21474*/     OPC_CheckPredicate, 10, // Predicate_extload
/* 21476*/     OPC_CheckTypeI32,
/* 21477*/     OPC_Scope, 19, /*->21498*/ // 2 children in Scope
/* 21479*/      OPC_CheckPredicate1,  // Predicate_extloadi8
/* 21480*/      OPC_MoveParent,
/* 21481*/      OPC_CheckType, MVT::v16i8,
/* 21483*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/* 21484*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 21486*/      OPC_EmitMergeInputChains1_0,
/* 21487*/      OPC_EmitInteger32, 0, 
/* 21489*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v16i8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (splat_vector:{ *:[v16i8] } (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>) - Complexity = 16
                // Dst: (LOAD8_SPLAT_A64:{ *:[v16i8] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 21498*/     /*Scope*/ 19, /*->21518*/
/* 21499*/      OPC_CheckPredicate2,  // Predicate_extloadi16
/* 21500*/      OPC_MoveParent,
/* 21501*/      OPC_CheckType, MVT::v8i16,
/* 21503*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/* 21504*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 21506*/      OPC_EmitMergeInputChains1_0,
/* 21507*/      OPC_EmitInteger32, 0, 
/* 21509*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v8i16, 3/*#Ops*/, 4, 2, 3, 
                // Src: (splat_vector:{ *:[v8i16] } (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>) - Complexity = 16
                // Dst: (LOAD16_SPLAT_A64:{ *:[v8i16] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 21518*/     0, /*End of Scope*/
/* 21519*/    /*Scope*/ 43, /*->21563*/
/* 21520*/     OPC_CheckPredicate7,  // Predicate_load
/* 21521*/     OPC_SwitchType /*2 cases */, 18, MVT::i32,// ->21542
/* 21524*/      OPC_MoveParent,
/* 21525*/      OPC_CheckType, MVT::v4i32,
/* 21527*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/* 21528*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 21530*/      OPC_EmitMergeInputChains1_0,
/* 21531*/      OPC_EmitInteger32, 0, 
/* 21533*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v4i32, 3/*#Ops*/, 4, 2, 3, 
                // Src: (splat_vector:{ *:[v4i32] } (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
                // Dst: (LOAD32_SPLAT_A64:{ *:[v4i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 21542*/     /*SwitchType*/ 18, MVT::i64,// ->21562
/* 21544*/      OPC_MoveParent,
/* 21545*/      OPC_CheckType, MVT::v2i64,
/* 21547*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/* 21548*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 21550*/      OPC_EmitMergeInputChains1_0,
/* 21551*/      OPC_EmitInteger32, 0, 
/* 21553*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD64_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v2i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (splat_vector:{ *:[v2i64] } (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
                // Dst: (LOAD64_SPLAT_A64:{ *:[v2i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 21562*/     0, // EndSwitchType
/* 21563*/    0, /*End of Scope*/
/* 21564*/   0, /*End of Scope*/
/* 21565*/  /*Scope*/ 20|128,1/*148*/, /*->21715*/
/* 21567*/   OPC_RecordChild0, // #0 = $x
/* 21568*/   OPC_Scope, 102, /*->21672*/ // 3 children in Scope
/* 21570*/    OPC_MoveChild0,
/* 21571*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21574*/    OPC_SwitchType /*2 cases */, 80, MVT::i32,// ->21657
/* 21577*/     OPC_MoveParent,
/* 21578*/     OPC_SwitchType /*3 cases */, 37, MVT::v16i8,// ->21618
/* 21581*/      OPC_EmitConvertToTarget0,
/* 21582*/      OPC_EmitConvertToTarget0,
/* 21583*/      OPC_EmitConvertToTarget0,
/* 21584*/      OPC_EmitConvertToTarget0,
/* 21585*/      OPC_EmitConvertToTarget0,
/* 21586*/      OPC_EmitConvertToTarget0,
/* 21587*/      OPC_EmitConvertToTarget0,
/* 21588*/      OPC_EmitConvertToTarget0,
/* 21589*/      OPC_EmitConvertToTarget0,
/* 21590*/      OPC_EmitConvertToTarget0,
/* 21591*/      OPC_EmitConvertToTarget0,
/* 21592*/      OPC_EmitConvertToTarget0,
/* 21593*/      OPC_EmitConvertToTarget0,
/* 21594*/      OPC_EmitConvertToTarget0,
/* 21595*/      OPC_EmitConvertToTarget0,
/* 21596*/      OPC_EmitConvertToTarget0,
/* 21597*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_I8x16),
                    MVT::v16i8, 16/*#Ops*/, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 
                // Src: (splat_vector:{ *:[v16i8] } (imm:{ *:[i32] }):$x) - Complexity = 6
                // Dst: (CONST_V128_I8x16:{ *:[v16i8] } (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x)
/* 21618*/     /*SwitchType*/ 21, MVT::v8i16,// ->21641
/* 21620*/      OPC_EmitConvertToTarget0,
/* 21621*/      OPC_EmitConvertToTarget0,
/* 21622*/      OPC_EmitConvertToTarget0,
/* 21623*/      OPC_EmitConvertToTarget0,
/* 21624*/      OPC_EmitConvertToTarget0,
/* 21625*/      OPC_EmitConvertToTarget0,
/* 21626*/      OPC_EmitConvertToTarget0,
/* 21627*/      OPC_EmitConvertToTarget0,
/* 21628*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_I16x8),
                    MVT::v8i16, 8/*#Ops*/, 1, 2, 3, 4, 5, 6, 7, 8, 
                // Src: (splat_vector:{ *:[v8i16] } (imm:{ *:[i32] }):$x) - Complexity = 6
                // Dst: (CONST_V128_I16x8:{ *:[v8i16] } (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x)
/* 21641*/     /*SwitchType*/ 13, MVT::v4i32,// ->21656
/* 21643*/      OPC_EmitConvertToTarget0,
/* 21644*/      OPC_EmitConvertToTarget0,
/* 21645*/      OPC_EmitConvertToTarget0,
/* 21646*/      OPC_EmitConvertToTarget0,
/* 21647*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_I32x4),
                    MVT::v4i32, 4/*#Ops*/, 1, 2, 3, 4, 
                // Src: (splat_vector:{ *:[v4i32] } (imm:{ *:[i32] }):$x) - Complexity = 6
                // Dst: (CONST_V128_I32x4:{ *:[v4i32] } (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x)
/* 21656*/     0, // EndSwitchType
/* 21657*/    /*SwitchType*/ 12, MVT::i64,// ->21671
/* 21659*/     OPC_MoveParent,
/* 21660*/     OPC_CheckType, MVT::v2i64,
/* 21662*/     OPC_EmitConvertToTarget0,
/* 21663*/     OPC_EmitConvertToTarget0,
/* 21664*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_I64x2),
                   MVT::v2i64, 2/*#Ops*/, 1, 2, 
               // Src: (splat_vector:{ *:[v2i64] } (imm:{ *:[i64] }):$x) - Complexity = 6
               // Dst: (CONST_V128_I64x2:{ *:[v2i64] } (imm:{ *:[i64] }):$x, (imm:{ *:[i64] }):$x)
/* 21671*/    0, // EndSwitchType
/* 21672*/   /*Scope*/ 30, /*->21703*/
/* 21673*/    OPC_CheckChild0TypeI32,
/* 21674*/    OPC_SwitchType /*3 cases */, 7, MVT::v16i8,// ->21684
/* 21677*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 21678*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_I8x16),
                   MVT::v16i8, 1/*#Ops*/, 0, 
               // Src: (splat_vector:{ *:[v16i8] } I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SPLAT_I8x16:{ *:[v16i8] } I32:{ *:[i32] }:$x)
/* 21684*/    /*SwitchType*/ 7, MVT::v8i16,// ->21693
/* 21686*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 21687*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_I16x8),
                   MVT::v8i16, 1/*#Ops*/, 0, 
               // Src: (splat_vector:{ *:[v8i16] } I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SPLAT_I16x8:{ *:[v8i16] } I32:{ *:[i32] }:$x)
/* 21693*/    /*SwitchType*/ 7, MVT::v4i32,// ->21702
/* 21695*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 21696*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_I32x4),
                   MVT::v4i32, 1/*#Ops*/, 0, 
               // Src: (splat_vector:{ *:[v4i32] } I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SPLAT_I32x4:{ *:[v4i32] } I32:{ *:[i32] }:$x)
/* 21702*/    0, // EndSwitchType
/* 21703*/   /*Scope*/ 10, /*->21714*/
/* 21704*/    OPC_CheckChild0TypeI64,
/* 21705*/    OPC_CheckType, MVT::v2i64,
/* 21707*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 21708*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_I64x2),
                  MVT::v2i64, 1/*#Ops*/, 0, 
              // Src: (splat_vector:{ *:[v2i64] } I64:{ *:[i64] }:$x) - Complexity = 3
              // Dst: (SPLAT_I64x2:{ *:[v2i64] } I64:{ *:[i64] }:$x)
/* 21714*/   0, /*End of Scope*/
/* 21715*/  /*Scope*/ 103, /*->21819*/
/* 21716*/   OPC_MoveChild0,
/* 21717*/   OPC_CheckOpcode, TARGET_VAL(ISD::LOAD),
/* 21720*/   OPC_RecordMemRef,
/* 21721*/   OPC_RecordNode, // #0 = 'ld' chained node
/* 21722*/   OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/* 21723*/   OPC_Scope, 46, /*->21771*/ // 2 children in Scope
/* 21725*/    OPC_CheckChild1TypeI32,
/* 21726*/    OPC_CheckPredicate, 9, // Predicate_unindexedload
/* 21728*/    OPC_CheckPredicate7,  // Predicate_load
/* 21729*/    OPC_SwitchType /*2 cases */, 18, MVT::f32,// ->21750
/* 21732*/     OPC_MoveParent,
/* 21733*/     OPC_CheckType, MVT::v4f32,
/* 21735*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/* 21736*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 21738*/     OPC_EmitMergeInputChains1_0,
/* 21739*/     OPC_EmitInteger32, 0, 
/* 21741*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v4f32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (splat_vector:{ *:[v4f32] } (ld:{ *:[f32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD32_SPLAT_A32:{ *:[v4f32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 21750*/    /*SwitchType*/ 18, MVT::f64,// ->21770
/* 21752*/     OPC_MoveParent,
/* 21753*/     OPC_CheckType, MVT::v2f64,
/* 21755*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/* 21756*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 21758*/     OPC_EmitMergeInputChains1_0,
/* 21759*/     OPC_EmitInteger32, 0, 
/* 21761*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD64_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v2f64, 3/*#Ops*/, 4, 2, 3, 
               // Src: (splat_vector:{ *:[v2f64] } (ld:{ *:[f64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD64_SPLAT_A32:{ *:[v2f64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 21770*/    0, // EndSwitchType
/* 21771*/   /*Scope*/ 46, /*->21818*/
/* 21772*/    OPC_CheckChild1TypeI64,
/* 21773*/    OPC_CheckPredicate, 9, // Predicate_unindexedload
/* 21775*/    OPC_CheckPredicate7,  // Predicate_load
/* 21776*/    OPC_SwitchType /*2 cases */, 18, MVT::f32,// ->21797
/* 21779*/     OPC_MoveParent,
/* 21780*/     OPC_CheckType, MVT::v4f32,
/* 21782*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/* 21783*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 21785*/     OPC_EmitMergeInputChains1_0,
/* 21786*/     OPC_EmitInteger32, 0, 
/* 21788*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v4f32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (splat_vector:{ *:[v4f32] } (ld:{ *:[f32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD32_SPLAT_A64:{ *:[v4f32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 21797*/    /*SwitchType*/ 18, MVT::f64,// ->21817
/* 21799*/     OPC_MoveParent,
/* 21800*/     OPC_CheckType, MVT::v2f64,
/* 21802*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/* 21803*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 21805*/     OPC_EmitMergeInputChains1_0,
/* 21806*/     OPC_EmitInteger32, 0, 
/* 21808*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD64_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v2f64, 3/*#Ops*/, 4, 2, 3, 
               // Src: (splat_vector:{ *:[v2f64] } (ld:{ *:[f64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD64_SPLAT_A64:{ *:[v2f64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 21817*/    0, // EndSwitchType
/* 21818*/   0, /*End of Scope*/
/* 21819*/  /*Scope*/ 66, /*->21886*/
/* 21820*/   OPC_RecordChild0, // #0 = $x
/* 21821*/   OPC_Scope, 38, /*->21861*/ // 3 children in Scope
/* 21823*/    OPC_MoveChild0,
/* 21824*/    OPC_CheckOpcode, TARGET_VAL(ISD::ConstantFP),
/* 21827*/    OPC_SwitchType /*2 cases */, 16, MVT::f32,// ->21846
/* 21830*/     OPC_MoveParent,
/* 21831*/     OPC_CheckType, MVT::v4f32,
/* 21833*/     OPC_EmitConvertToTarget0,
/* 21834*/     OPC_EmitConvertToTarget0,
/* 21835*/     OPC_EmitConvertToTarget0,
/* 21836*/     OPC_EmitConvertToTarget0,
/* 21837*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_F32x4),
                   MVT::v4f32, 4/*#Ops*/, 1, 2, 3, 4, 
               // Src: (splat_vector:{ *:[v4f32] } (fpimm:{ *:[f32] }):$x) - Complexity = 6
               // Dst: (CONST_V128_F32x4:{ *:[v4f32] } (fpimm:{ *:[f32] }):$x, (fpimm:{ *:[f32] }):$x, (fpimm:{ *:[f32] }):$x, (fpimm:{ *:[f32] }):$x)
/* 21846*/    /*SwitchType*/ 12, MVT::f64,// ->21860
/* 21848*/     OPC_MoveParent,
/* 21849*/     OPC_CheckType, MVT::v2f64,
/* 21851*/     OPC_EmitConvertToTarget0,
/* 21852*/     OPC_EmitConvertToTarget0,
/* 21853*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_F64x2),
                   MVT::v2f64, 2/*#Ops*/, 1, 2, 
               // Src: (splat_vector:{ *:[v2f64] } (fpimm:{ *:[f64] }):$x) - Complexity = 6
               // Dst: (CONST_V128_F64x2:{ *:[v2f64] } (fpimm:{ *:[f64] }):$x, (fpimm:{ *:[f64] }):$x)
/* 21860*/    0, // EndSwitchType
/* 21861*/   /*Scope*/ 11, /*->21873*/
/* 21862*/    OPC_CheckChild0Type, MVT::f32,
/* 21864*/    OPC_CheckType, MVT::v4f32,
/* 21866*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 21867*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_F32x4),
                  MVT::v4f32, 1/*#Ops*/, 0, 
              // Src: (splat_vector:{ *:[v4f32] } F32:{ *:[f32] }:$x) - Complexity = 3
              // Dst: (SPLAT_F32x4:{ *:[v4f32] } F32:{ *:[f32] }:$x)
/* 21873*/   /*Scope*/ 11, /*->21885*/
/* 21874*/    OPC_CheckChild0Type, MVT::f64,
/* 21876*/    OPC_CheckType, MVT::v2f64,
/* 21878*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 21879*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_F64x2),
                  MVT::v2f64, 1/*#Ops*/, 0, 
              // Src: (splat_vector:{ *:[v2f64] } F64:{ *:[f64] }:$x) - Complexity = 3
              // Dst: (SPLAT_F64x2:{ *:[v2f64] } F64:{ *:[f64] }:$x)
/* 21885*/   0, /*End of Scope*/
/* 21886*/  0, /*End of Scope*/
/* 21887*/ /*SwitchOpcode*/ 42|128,1/*170*/, TARGET_VAL(ISD::SCALAR_TO_VECTOR),// ->22061
/* 21891*/  OPC_Scope, 103, /*->21996*/ // 2 children in Scope
/* 21893*/   OPC_MoveChild0,
/* 21894*/   OPC_CheckOpcode, TARGET_VAL(ISD::LOAD),
/* 21897*/   OPC_RecordMemRef,
/* 21898*/   OPC_RecordNode, // #0 = 'ld' chained node
/* 21899*/   OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/* 21900*/   OPC_Scope, 46, /*->21948*/ // 2 children in Scope
/* 21902*/    OPC_CheckChild1TypeI32,
/* 21903*/    OPC_CheckPredicate, 9, // Predicate_unindexedload
/* 21905*/    OPC_CheckPredicate7,  // Predicate_load
/* 21906*/    OPC_SwitchType /*2 cases */, 18, MVT::i32,// ->21927
/* 21909*/     OPC_MoveParent,
/* 21910*/     OPC_CheckType, MVT::v4i32,
/* 21912*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/* 21913*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 21915*/     OPC_EmitMergeInputChains1_0,
/* 21916*/     OPC_EmitInteger32, 0, 
/* 21918*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_I32x4_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v4i32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (scalar_to_vector:{ *:[v4i32] } (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD_ZERO_I32x4_A32:{ *:[v4i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 21927*/    /*SwitchType*/ 18, MVT::i64,// ->21947
/* 21929*/     OPC_MoveParent,
/* 21930*/     OPC_CheckType, MVT::v2i64,
/* 21932*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/* 21933*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 21935*/     OPC_EmitMergeInputChains1_0,
/* 21936*/     OPC_EmitInteger32, 0, 
/* 21938*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_I64x2_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v2i64, 3/*#Ops*/, 4, 2, 3, 
               // Src: (scalar_to_vector:{ *:[v2i64] } (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD_ZERO_I64x2_A32:{ *:[v2i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 21947*/    0, // EndSwitchType
/* 21948*/   /*Scope*/ 46, /*->21995*/
/* 21949*/    OPC_CheckChild1TypeI64,
/* 21950*/    OPC_CheckPredicate, 9, // Predicate_unindexedload
/* 21952*/    OPC_CheckPredicate7,  // Predicate_load
/* 21953*/    OPC_SwitchType /*2 cases */, 18, MVT::i32,// ->21974
/* 21956*/     OPC_MoveParent,
/* 21957*/     OPC_CheckType, MVT::v4i32,
/* 21959*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/* 21960*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 21962*/     OPC_EmitMergeInputChains1_0,
/* 21963*/     OPC_EmitInteger32, 0, 
/* 21965*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_I32x4_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v4i32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (scalar_to_vector:{ *:[v4i32] } (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD_ZERO_I32x4_A64:{ *:[v4i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 21974*/    /*SwitchType*/ 18, MVT::i64,// ->21994
/* 21976*/     OPC_MoveParent,
/* 21977*/     OPC_CheckType, MVT::v2i64,
/* 21979*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/* 21980*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 21982*/     OPC_EmitMergeInputChains1_0,
/* 21983*/     OPC_EmitInteger32, 0, 
/* 21985*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_I64x2_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v2i64, 3/*#Ops*/, 4, 2, 3, 
               // Src: (scalar_to_vector:{ *:[v2i64] } (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD_ZERO_I64x2_A64:{ *:[v2i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 21994*/    0, // EndSwitchType
/* 21995*/   0, /*End of Scope*/
/* 21996*/  /*Scope*/ 63, /*->22060*/
/* 21997*/   OPC_RecordChild0, // #0 = $x
/* 21998*/   OPC_Scope, 27, /*->22027*/ // 4 children in Scope
/* 22000*/    OPC_CheckChild0TypeI32,
/* 22001*/    OPC_SwitchType /*3 cases */, 6, MVT::v16i8,// ->22010
/* 22004*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_I8x16),
                   MVT::v16i8, 1/*#Ops*/, 0, 
               // Src: (scalar_to_vector:{ *:[v16i8] } I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SPLAT_I8x16:{ *:[v16i8] } ?:{ *:[i32] }:$x)
/* 22010*/    /*SwitchType*/ 6, MVT::v8i16,// ->22018
/* 22012*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_I16x8),
                   MVT::v8i16, 1/*#Ops*/, 0, 
               // Src: (scalar_to_vector:{ *:[v8i16] } I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SPLAT_I16x8:{ *:[v8i16] } ?:{ *:[i32] }:$x)
/* 22018*/    /*SwitchType*/ 6, MVT::v4i32,// ->22026
/* 22020*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_I32x4),
                   MVT::v4i32, 1/*#Ops*/, 0, 
               // Src: (scalar_to_vector:{ *:[v4i32] } I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SPLAT_I32x4:{ *:[v4i32] } ?:{ *:[i32] }:$x)
/* 22026*/    0, // EndSwitchType
/* 22027*/   /*Scope*/ 9, /*->22037*/
/* 22028*/    OPC_CheckChild0TypeI64,
/* 22029*/    OPC_CheckType, MVT::v2i64,
/* 22031*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_I64x2),
                  MVT::v2i64, 1/*#Ops*/, 0, 
              // Src: (scalar_to_vector:{ *:[v2i64] } I64:{ *:[i64] }:$x) - Complexity = 3
              // Dst: (SPLAT_I64x2:{ *:[v2i64] } ?:{ *:[i64] }:$x)
/* 22037*/   /*Scope*/ 10, /*->22048*/
/* 22038*/    OPC_CheckChild0Type, MVT::f32,
/* 22040*/    OPC_CheckType, MVT::v4f32,
/* 22042*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_F32x4),
                  MVT::v4f32, 1/*#Ops*/, 0, 
              // Src: (scalar_to_vector:{ *:[v4f32] } F32:{ *:[f32] }:$x) - Complexity = 3
              // Dst: (SPLAT_F32x4:{ *:[v4f32] } ?:{ *:[f32] }:$x)
/* 22048*/   /*Scope*/ 10, /*->22059*/
/* 22049*/    OPC_CheckChild0Type, MVT::f64,
/* 22051*/    OPC_CheckType, MVT::v2f64,
/* 22053*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_F64x2),
                  MVT::v2f64, 1/*#Ops*/, 0, 
              // Src: (scalar_to_vector:{ *:[v2f64] } F64:{ *:[f64] }:$x) - Complexity = 3
              // Dst: (SPLAT_F64x2:{ *:[v2f64] } ?:{ *:[f64] }:$x)
/* 22059*/   0, /*End of Scope*/
/* 22060*/  0, /*End of Scope*/
/* 22061*/ /*SwitchOpcode*/ 4|128,1/*132*/, TARGET_VAL(WebAssemblyISD::VEC_SHL),// ->22197
/* 22065*/  OPC_RecordChild0, // #0 = $lhs
/* 22066*/  OPC_Scope, 84, /*->22152*/ // 2 children in Scope
/* 22068*/   OPC_MoveChild1,
/* 22069*/   OPC_Scope, 24, /*->22095*/ // 5 children in Scope
/* 22071*/    OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 22074*/    OPC_MoveChild0,
/* 22075*/    OPC_CheckAndImm, 63, 
/* 22077*/    OPC_RecordChild0, // #1 = $rhs
/* 22078*/    OPC_MoveParent,
/* 22079*/    OPC_MoveParent,
/* 22080*/    OPC_CheckType, MVT::v2i64,
/* 22082*/    OPC_EmitNode1None, TARGET_VAL(WebAssembly::I32_WRAP_I64),
                  MVT::i32, 1/*#Ops*/, 1,  // Results = #2
/* 22088*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I64x2),
                  MVT::v2i64, 2/*#Ops*/, 0, 2, 
              // Src: (wasm_shl:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (trunc:{ *:[i32] } (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] }))) - Complexity = 14
              // Dst: (SHL_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (I32_WRAP_I64:{ *:[i32] } I64:{ *:[i64] }:$rhs))
/* 22095*/   /*Scope*/ 13, /*->22109*/
/* 22096*/    OPC_CheckAndImm, 7, 
/* 22098*/    OPC_RecordChild0, // #1 = $rhs
/* 22099*/    OPC_MoveParent,
/* 22100*/    OPC_CheckType, MVT::v16i8,
/* 22102*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I8x16),
                  MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shl:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 7:{ *:[i32] })) - Complexity = 11
              // Dst: (SHL_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 22109*/   /*Scope*/ 13, /*->22123*/
/* 22110*/    OPC_CheckAndImm, 15, 
/* 22112*/    OPC_RecordChild0, // #1 = $rhs
/* 22113*/    OPC_MoveParent,
/* 22114*/    OPC_CheckType, MVT::v8i16,
/* 22116*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I16x8),
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shl:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 15:{ *:[i32] })) - Complexity = 11
              // Dst: (SHL_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 22123*/   /*Scope*/ 13, /*->22137*/
/* 22124*/    OPC_CheckAndImm, 31, 
/* 22126*/    OPC_RecordChild0, // #1 = $rhs
/* 22127*/    OPC_MoveParent,
/* 22128*/    OPC_CheckType, MVT::v4i32,
/* 22130*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I32x4),
                  MVT::v4i32, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shl:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
              // Dst: (SHL_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 22137*/   /*Scope*/ 13, /*->22151*/
/* 22138*/    OPC_CheckAndImm, 63, 
/* 22140*/    OPC_RecordChild0, // #1 = $rhs
/* 22141*/    OPC_MoveParent,
/* 22142*/    OPC_CheckType, MVT::v2i64,
/* 22144*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I64x2),
                  MVT::v2i64, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shl:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 63:{ *:[i32] })) - Complexity = 11
              // Dst: (SHL_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 22151*/   0, /*End of Scope*/
/* 22152*/  /*Scope*/ 43, /*->22196*/
/* 22153*/   OPC_RecordChild1, // #1 = $x
/* 22154*/   OPC_SwitchType /*4 cases */, 8, MVT::v16i8,// ->22165
/* 22157*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22158*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I8x16),
                  MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shl:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHL_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x)
/* 22165*/   /*SwitchType*/ 8, MVT::v8i16,// ->22175
/* 22167*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22168*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I16x8),
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shl:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHL_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x)
/* 22175*/   /*SwitchType*/ 8, MVT::v4i32,// ->22185
/* 22177*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22178*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I32x4),
                  MVT::v4i32, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shl:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHL_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x)
/* 22185*/   /*SwitchType*/ 8, MVT::v2i64,// ->22195
/* 22187*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22188*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I64x2),
                  MVT::v2i64, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shl:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHL_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I32:{ *:[i32] }:$x)
/* 22195*/   0, // EndSwitchType
/* 22196*/  0, /*End of Scope*/
/* 22197*/ /*SwitchOpcode*/ 4|128,1/*132*/, TARGET_VAL(WebAssemblyISD::VEC_SHR_S),// ->22333
/* 22201*/  OPC_RecordChild0, // #0 = $lhs
/* 22202*/  OPC_Scope, 84, /*->22288*/ // 2 children in Scope
/* 22204*/   OPC_MoveChild1,
/* 22205*/   OPC_Scope, 24, /*->22231*/ // 5 children in Scope
/* 22207*/    OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 22210*/    OPC_MoveChild0,
/* 22211*/    OPC_CheckAndImm, 63, 
/* 22213*/    OPC_RecordChild0, // #1 = $rhs
/* 22214*/    OPC_MoveParent,
/* 22215*/    OPC_MoveParent,
/* 22216*/    OPC_CheckType, MVT::v2i64,
/* 22218*/    OPC_EmitNode1None, TARGET_VAL(WebAssembly::I32_WRAP_I64),
                  MVT::i32, 1/*#Ops*/, 1,  // Results = #2
/* 22224*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I64x2),
                  MVT::v2i64, 2/*#Ops*/, 0, 2, 
              // Src: (wasm_shr_s:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (trunc:{ *:[i32] } (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] }))) - Complexity = 14
              // Dst: (SHR_S_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (I32_WRAP_I64:{ *:[i32] } I64:{ *:[i64] }:$rhs))
/* 22231*/   /*Scope*/ 13, /*->22245*/
/* 22232*/    OPC_CheckAndImm, 7, 
/* 22234*/    OPC_RecordChild0, // #1 = $rhs
/* 22235*/    OPC_MoveParent,
/* 22236*/    OPC_CheckType, MVT::v16i8,
/* 22238*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I8x16),
                  MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shr_s:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 7:{ *:[i32] })) - Complexity = 11
              // Dst: (SHR_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 22245*/   /*Scope*/ 13, /*->22259*/
/* 22246*/    OPC_CheckAndImm, 15, 
/* 22248*/    OPC_RecordChild0, // #1 = $rhs
/* 22249*/    OPC_MoveParent,
/* 22250*/    OPC_CheckType, MVT::v8i16,
/* 22252*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I16x8),
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shr_s:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 15:{ *:[i32] })) - Complexity = 11
              // Dst: (SHR_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 22259*/   /*Scope*/ 13, /*->22273*/
/* 22260*/    OPC_CheckAndImm, 31, 
/* 22262*/    OPC_RecordChild0, // #1 = $rhs
/* 22263*/    OPC_MoveParent,
/* 22264*/    OPC_CheckType, MVT::v4i32,
/* 22266*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I32x4),
                  MVT::v4i32, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shr_s:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
              // Dst: (SHR_S_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 22273*/   /*Scope*/ 13, /*->22287*/
/* 22274*/    OPC_CheckAndImm, 63, 
/* 22276*/    OPC_RecordChild0, // #1 = $rhs
/* 22277*/    OPC_MoveParent,
/* 22278*/    OPC_CheckType, MVT::v2i64,
/* 22280*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I64x2),
                  MVT::v2i64, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shr_s:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 63:{ *:[i32] })) - Complexity = 11
              // Dst: (SHR_S_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 22287*/   0, /*End of Scope*/
/* 22288*/  /*Scope*/ 43, /*->22332*/
/* 22289*/   OPC_RecordChild1, // #1 = $x
/* 22290*/   OPC_SwitchType /*4 cases */, 8, MVT::v16i8,// ->22301
/* 22293*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22294*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I8x16),
                  MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shr_s:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHR_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x)
/* 22301*/   /*SwitchType*/ 8, MVT::v8i16,// ->22311
/* 22303*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22304*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I16x8),
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shr_s:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHR_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x)
/* 22311*/   /*SwitchType*/ 8, MVT::v4i32,// ->22321
/* 22313*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22314*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I32x4),
                  MVT::v4i32, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shr_s:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHR_S_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x)
/* 22321*/   /*SwitchType*/ 8, MVT::v2i64,// ->22331
/* 22323*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22324*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I64x2),
                  MVT::v2i64, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shr_s:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHR_S_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I32:{ *:[i32] }:$x)
/* 22331*/   0, // EndSwitchType
/* 22332*/  0, /*End of Scope*/
/* 22333*/ /*SwitchOpcode*/ 14|128,5/*654*/, TARGET_VAL(ISD::VSELECT),// ->22991
/* 22337*/  OPC_Scope, 12|128,1/*140*/, /*->22480*/ // 4 children in Scope
/* 22340*/   OPC_MoveChild0,
/* 22341*/   OPC_CheckOpcode, TARGET_VAL(ISD::SETCC),
/* 22344*/   OPC_MoveChild0,
/* 22345*/   OPC_CheckOpcode, TARGET_VAL(ISD::BITCAST),
/* 22348*/   OPC_RecordChild0, // #0 = $rhs
/* 22349*/   OPC_SwitchType /*3 cases */, 41, MVT::v4f32,// ->22393
/* 22352*/    OPC_CheckChild0Type, MVT::v4i32,
/* 22354*/    OPC_MoveSibling1,
/* 22355*/    OPC_CheckOpcode, TARGET_VAL(ISD::BITCAST),
/* 22358*/    OPC_RecordChild0, // #1 = $lhs
/* 22359*/    OPC_CheckChild0Type, MVT::v4i32,
/* 22361*/    OPC_MoveParent,
/* 22362*/    OPC_CheckChild2CondCode, ISD::SETOLT,
/* 22364*/    OPC_MoveParent,
/* 22365*/    OPC_CheckType, MVT::v4i32,
/* 22367*/    OPC_Scope, 11, /*->22380*/ // 2 children in Scope
/* 22369*/     OPC_CheckChild1Same, 0,
/* 22371*/     OPC_CheckChild2Same, 1,
/* 22373*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F32x4),
                   MVT::v4i32, 2/*#Ops*/, 1, 0, 
               // Src: (vselect:{ *:[v4i32] } (setcc:{ *:[v4i32] } (bitconvert:{ *:[v4f32] } V128:{ *:[v4i32] }:$rhs), (bitconvert:{ *:[v4f32] } V128:{ *:[v4i32] }:$lhs), SETOLT:{ *:[Other] }), V128:{ *:[v4i32] }:$rhs, V128:{ *:[v4i32] }:$lhs) - Complexity = 12
               // Dst: (PMIN_F32x4:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs)
/* 22380*/    /*Scope*/ 11, /*->22392*/
/* 22381*/     OPC_CheckChild1Same, 1,
/* 22383*/     OPC_CheckChild2Same, 0,
/* 22385*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F32x4),
                   MVT::v4i32, 2/*#Ops*/, 0, 1, 
               // Src: (vselect:{ *:[v4i32] } (setcc:{ *:[v4i32] } (bitconvert:{ *:[v4f32] } V128:{ *:[v4i32] }:$lhs), (bitconvert:{ *:[v4f32] } V128:{ *:[v4i32] }:$rhs), SETOLT:{ *:[Other] }), V128:{ *:[v4i32] }:$rhs, V128:{ *:[v4i32] }:$lhs) - Complexity = 12
               // Dst: (PMAX_F32x4:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs)
/* 22392*/    0, /*End of Scope*/
/* 22393*/   /*SwitchType*/ 41, MVT::v2f64,// ->22436
/* 22395*/    OPC_CheckChild0Type, MVT::v2i64,
/* 22397*/    OPC_MoveSibling1,
/* 22398*/    OPC_CheckOpcode, TARGET_VAL(ISD::BITCAST),
/* 22401*/    OPC_RecordChild0, // #1 = $lhs
/* 22402*/    OPC_CheckChild0Type, MVT::v2i64,
/* 22404*/    OPC_MoveParent,
/* 22405*/    OPC_CheckChild2CondCode, ISD::SETOLT,
/* 22407*/    OPC_MoveParent,
/* 22408*/    OPC_CheckType, MVT::v2i64,
/* 22410*/    OPC_Scope, 11, /*->22423*/ // 2 children in Scope
/* 22412*/     OPC_CheckChild1Same, 0,
/* 22414*/     OPC_CheckChild2Same, 1,
/* 22416*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F64x2),
                   MVT::v2i64, 2/*#Ops*/, 1, 0, 
               // Src: (vselect:{ *:[v2i64] } (setcc:{ *:[v2i64] } (bitconvert:{ *:[v2f64] } V128:{ *:[v2i64] }:$rhs), (bitconvert:{ *:[v2f64] } V128:{ *:[v2i64] }:$lhs), SETOLT:{ *:[Other] }), V128:{ *:[v2i64] }:$rhs, V128:{ *:[v2i64] }:$lhs) - Complexity = 12
               // Dst: (PMIN_F64x2:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs)
/* 22423*/    /*Scope*/ 11, /*->22435*/
/* 22424*/     OPC_CheckChild1Same, 1,
/* 22426*/     OPC_CheckChild2Same, 0,
/* 22428*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F64x2),
                   MVT::v2i64, 2/*#Ops*/, 0, 1, 
               // Src: (vselect:{ *:[v2i64] } (setcc:{ *:[v2i64] } (bitconvert:{ *:[v2f64] } V128:{ *:[v2i64] }:$lhs), (bitconvert:{ *:[v2f64] } V128:{ *:[v2i64] }:$rhs), SETOLT:{ *:[Other] }), V128:{ *:[v2i64] }:$rhs, V128:{ *:[v2i64] }:$lhs) - Complexity = 12
               // Dst: (PMAX_F64x2:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs)
/* 22435*/    0, /*End of Scope*/
/* 22436*/   /*SwitchType*/ 41, MVT::v8f16,// ->22479
/* 22438*/    OPC_CheckChild0Type, MVT::v8i16,
/* 22440*/    OPC_MoveSibling1,
/* 22441*/    OPC_CheckOpcode, TARGET_VAL(ISD::BITCAST),
/* 22444*/    OPC_RecordChild0, // #1 = $lhs
/* 22445*/    OPC_CheckChild0Type, MVT::v8i16,
/* 22447*/    OPC_MoveParent,
/* 22448*/    OPC_CheckChild2CondCode, ISD::SETOLT,
/* 22450*/    OPC_MoveParent,
/* 22451*/    OPC_CheckType, MVT::v8i16,
/* 22453*/    OPC_Scope, 11, /*->22466*/ // 2 children in Scope
/* 22455*/     OPC_CheckChild1Same, 0,
/* 22457*/     OPC_CheckChild2Same, 1,
/* 22459*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F16x8),
                   MVT::v8i16, 2/*#Ops*/, 1, 0, 
               // Src: (vselect:{ *:[v8i16] } (setcc:{ *:[v8i16] } (bitconvert:{ *:[v8f16] } V128:{ *:[v8i16] }:$rhs), (bitconvert:{ *:[v8f16] } V128:{ *:[v8i16] }:$lhs), SETOLT:{ *:[Other] }), V128:{ *:[v8i16] }:$rhs, V128:{ *:[v8i16] }:$lhs) - Complexity = 12
               // Dst: (PMIN_F16x8:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/* 22466*/    /*Scope*/ 11, /*->22478*/
/* 22467*/     OPC_CheckChild1Same, 1,
/* 22469*/     OPC_CheckChild2Same, 0,
/* 22471*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F16x8),
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (vselect:{ *:[v8i16] } (setcc:{ *:[v8i16] } (bitconvert:{ *:[v8f16] } V128:{ *:[v8i16] }:$lhs), (bitconvert:{ *:[v8f16] } V128:{ *:[v8i16] }:$rhs), SETOLT:{ *:[Other] }), V128:{ *:[v8i16] }:$rhs, V128:{ *:[v8i16] }:$lhs) - Complexity = 12
               // Dst: (PMAX_F16x8:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/* 22478*/    0, /*End of Scope*/
/* 22479*/   0, // EndSwitchType
/* 22480*/  /*Scope*/ 45, /*->22526*/
/* 22481*/   OPC_RecordChild0, // #0 = $c
/* 22482*/   OPC_RecordChild1, // #1 = $v1
/* 22483*/   OPC_RecordChild2, // #2 = $v2
/* 22484*/   OPC_SwitchType /*4 cases */, 8, MVT::v16i8,// ->22495
/* 22487*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v16i8, 3/*#Ops*/, 1, 2, 0, 
              // Src: (vselect:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2) - Complexity = 3
              // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 22495*/   /*SwitchType*/ 8, MVT::v8i16,// ->22505
/* 22497*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v8i16, 3/*#Ops*/, 1, 2, 0, 
              // Src: (vselect:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2) - Complexity = 3
              // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 22505*/   /*SwitchType*/ 8, MVT::v4i32,// ->22515
/* 22507*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v4i32, 3/*#Ops*/, 1, 2, 0, 
              // Src: (vselect:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2) - Complexity = 3
              // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 22515*/   /*SwitchType*/ 8, MVT::v2i64,// ->22525
/* 22517*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v2i64, 3/*#Ops*/, 1, 2, 0, 
              // Src: (vselect:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2) - Complexity = 3
              // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 22525*/   0, // EndSwitchType
/* 22526*/  /*Scope*/ 52|128,3/*436*/, /*->22964*/
/* 22528*/   OPC_MoveChild0,
/* 22529*/   OPC_CheckOpcode, TARGET_VAL(ISD::SETCC),
/* 22532*/   OPC_RecordChild0, // #0 = $rhs
/* 22533*/   OPC_Scope, 13|128,1/*141*/, /*->22677*/ // 3 children in Scope
/* 22536*/    OPC_CheckChild0Type, MVT::v4f32,
/* 22538*/    OPC_RecordChild1, // #1 = $lhs
/* 22539*/    OPC_Scope, 33, /*->22574*/ // 4 children in Scope
/* 22541*/     OPC_CheckChild2CondCode, ISD::SETOLT,
/* 22543*/     OPC_MoveParent,
/* 22544*/     OPC_CheckType, MVT::v4f32,
/* 22546*/     OPC_Scope, 12, /*->22560*/ // 2 children in Scope
/* 22548*/      OPC_CheckChild1Same, 0,
/* 22550*/      OPC_CheckChild2Same, 1,
/* 22552*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22553*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F32x4),
                    MVT::v4f32, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs, SETOLT:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 22560*/     /*Scope*/ 12, /*->22573*/
/* 22561*/      OPC_CheckChild1Same, 1,
/* 22563*/      OPC_CheckChild2Same, 0,
/* 22565*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22566*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F32x4),
                    MVT::v4f32, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOLT:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 22573*/     0, /*End of Scope*/
/* 22574*/    /*Scope*/ 33, /*->22608*/
/* 22575*/     OPC_CheckChild2CondCode, ISD::SETOLE,
/* 22577*/     OPC_MoveParent,
/* 22578*/     OPC_CheckType, MVT::v4f32,
/* 22580*/     OPC_Scope, 12, /*->22594*/ // 2 children in Scope
/* 22582*/      OPC_CheckChild1Same, 0,
/* 22584*/      OPC_CheckChild2Same, 1,
/* 22586*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22587*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F32x4),
                    MVT::v4f32, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs, SETOLE:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 22594*/     /*Scope*/ 12, /*->22607*/
/* 22595*/      OPC_CheckChild1Same, 1,
/* 22597*/      OPC_CheckChild2Same, 0,
/* 22599*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22600*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F32x4),
                    MVT::v4f32, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOLE:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 22607*/     0, /*End of Scope*/
/* 22608*/    /*Scope*/ 33, /*->22642*/
/* 22609*/     OPC_CheckChild2CondCode, ISD::SETOGT,
/* 22611*/     OPC_MoveParent,
/* 22612*/     OPC_CheckType, MVT::v4f32,
/* 22614*/     OPC_Scope, 12, /*->22628*/ // 2 children in Scope
/* 22616*/      OPC_CheckChild1Same, 1,
/* 22618*/      OPC_CheckChild2Same, 0,
/* 22620*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22621*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F32x4),
                    MVT::v4f32, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOGT:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 22628*/     /*Scope*/ 12, /*->22641*/
/* 22629*/      OPC_CheckChild1Same, 0,
/* 22631*/      OPC_CheckChild2Same, 1,
/* 22633*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22634*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F32x4),
                    MVT::v4f32, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs, SETOGT:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 22641*/     0, /*End of Scope*/
/* 22642*/    /*Scope*/ 33, /*->22676*/
/* 22643*/     OPC_CheckChild2CondCode, ISD::SETOGE,
/* 22645*/     OPC_MoveParent,
/* 22646*/     OPC_CheckType, MVT::v4f32,
/* 22648*/     OPC_Scope, 12, /*->22662*/ // 2 children in Scope
/* 22650*/      OPC_CheckChild1Same, 1,
/* 22652*/      OPC_CheckChild2Same, 0,
/* 22654*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22655*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F32x4),
                    MVT::v4f32, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOGE:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 22662*/     /*Scope*/ 12, /*->22675*/
/* 22663*/      OPC_CheckChild1Same, 0,
/* 22665*/      OPC_CheckChild2Same, 1,
/* 22667*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22668*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F32x4),
                    MVT::v4f32, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs, SETOGE:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 22675*/     0, /*End of Scope*/
/* 22676*/    0, /*End of Scope*/
/* 22677*/   /*Scope*/ 13|128,1/*141*/, /*->22820*/
/* 22679*/    OPC_CheckChild0Type, MVT::v2f64,
/* 22681*/    OPC_RecordChild1, // #1 = $lhs
/* 22682*/    OPC_Scope, 33, /*->22717*/ // 4 children in Scope
/* 22684*/     OPC_CheckChild2CondCode, ISD::SETOLT,
/* 22686*/     OPC_MoveParent,
/* 22687*/     OPC_CheckType, MVT::v2f64,
/* 22689*/     OPC_Scope, 12, /*->22703*/ // 2 children in Scope
/* 22691*/      OPC_CheckChild1Same, 0,
/* 22693*/      OPC_CheckChild2Same, 1,
/* 22695*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22696*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F64x2),
                    MVT::v2f64, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs, SETOLT:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 22703*/     /*Scope*/ 12, /*->22716*/
/* 22704*/      OPC_CheckChild1Same, 1,
/* 22706*/      OPC_CheckChild2Same, 0,
/* 22708*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22709*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F64x2),
                    MVT::v2f64, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOLT:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 22716*/     0, /*End of Scope*/
/* 22717*/    /*Scope*/ 33, /*->22751*/
/* 22718*/     OPC_CheckChild2CondCode, ISD::SETOLE,
/* 22720*/     OPC_MoveParent,
/* 22721*/     OPC_CheckType, MVT::v2f64,
/* 22723*/     OPC_Scope, 12, /*->22737*/ // 2 children in Scope
/* 22725*/      OPC_CheckChild1Same, 0,
/* 22727*/      OPC_CheckChild2Same, 1,
/* 22729*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22730*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F64x2),
                    MVT::v2f64, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs, SETOLE:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 22737*/     /*Scope*/ 12, /*->22750*/
/* 22738*/      OPC_CheckChild1Same, 1,
/* 22740*/      OPC_CheckChild2Same, 0,
/* 22742*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22743*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F64x2),
                    MVT::v2f64, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOLE:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 22750*/     0, /*End of Scope*/
/* 22751*/    /*Scope*/ 33, /*->22785*/
/* 22752*/     OPC_CheckChild2CondCode, ISD::SETOGT,
/* 22754*/     OPC_MoveParent,
/* 22755*/     OPC_CheckType, MVT::v2f64,
/* 22757*/     OPC_Scope, 12, /*->22771*/ // 2 children in Scope
/* 22759*/      OPC_CheckChild1Same, 1,
/* 22761*/      OPC_CheckChild2Same, 0,
/* 22763*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22764*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F64x2),
                    MVT::v2f64, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOGT:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 22771*/     /*Scope*/ 12, /*->22784*/
/* 22772*/      OPC_CheckChild1Same, 0,
/* 22774*/      OPC_CheckChild2Same, 1,
/* 22776*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22777*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F64x2),
                    MVT::v2f64, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs, SETOGT:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 22784*/     0, /*End of Scope*/
/* 22785*/    /*Scope*/ 33, /*->22819*/
/* 22786*/     OPC_CheckChild2CondCode, ISD::SETOGE,
/* 22788*/     OPC_MoveParent,
/* 22789*/     OPC_CheckType, MVT::v2f64,
/* 22791*/     OPC_Scope, 12, /*->22805*/ // 2 children in Scope
/* 22793*/      OPC_CheckChild1Same, 1,
/* 22795*/      OPC_CheckChild2Same, 0,
/* 22797*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22798*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F64x2),
                    MVT::v2f64, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOGE:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 22805*/     /*Scope*/ 12, /*->22818*/
/* 22806*/      OPC_CheckChild1Same, 0,
/* 22808*/      OPC_CheckChild2Same, 1,
/* 22810*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22811*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F64x2),
                    MVT::v2f64, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs, SETOGE:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 22818*/     0, /*End of Scope*/
/* 22819*/    0, /*End of Scope*/
/* 22820*/   /*Scope*/ 13|128,1/*141*/, /*->22963*/
/* 22822*/    OPC_CheckChild0Type, MVT::v8f16,
/* 22824*/    OPC_RecordChild1, // #1 = $lhs
/* 22825*/    OPC_Scope, 33, /*->22860*/ // 4 children in Scope
/* 22827*/     OPC_CheckChild2CondCode, ISD::SETOLT,
/* 22829*/     OPC_MoveParent,
/* 22830*/     OPC_CheckType, MVT::v8f16,
/* 22832*/     OPC_Scope, 12, /*->22846*/ // 2 children in Scope
/* 22834*/      OPC_CheckChild1Same, 0,
/* 22836*/      OPC_CheckChild2Same, 1,
/* 22838*/      OPC_CheckPatternPredicate6, // (Subtarget->hasHalfPrecision()) && (Subtarget->hasSIMD128())
/* 22839*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F16x8),
                    MVT::v8f16, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v8f16] } (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs, SETOLT:{ *:[Other] }), V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 22846*/     /*Scope*/ 12, /*->22859*/
/* 22847*/      OPC_CheckChild1Same, 1,
/* 22849*/      OPC_CheckChild2Same, 0,
/* 22851*/      OPC_CheckPatternPredicate6, // (Subtarget->hasHalfPrecision()) && (Subtarget->hasSIMD128())
/* 22852*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F16x8),
                    MVT::v8f16, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v8f16] } (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETOLT:{ *:[Other] }), V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 22859*/     0, /*End of Scope*/
/* 22860*/    /*Scope*/ 33, /*->22894*/
/* 22861*/     OPC_CheckChild2CondCode, ISD::SETOLE,
/* 22863*/     OPC_MoveParent,
/* 22864*/     OPC_CheckType, MVT::v8f16,
/* 22866*/     OPC_Scope, 12, /*->22880*/ // 2 children in Scope
/* 22868*/      OPC_CheckChild1Same, 0,
/* 22870*/      OPC_CheckChild2Same, 1,
/* 22872*/      OPC_CheckPatternPredicate6, // (Subtarget->hasHalfPrecision()) && (Subtarget->hasSIMD128())
/* 22873*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F16x8),
                    MVT::v8f16, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v8f16] } (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs, SETOLE:{ *:[Other] }), V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 22880*/     /*Scope*/ 12, /*->22893*/
/* 22881*/      OPC_CheckChild1Same, 1,
/* 22883*/      OPC_CheckChild2Same, 0,
/* 22885*/      OPC_CheckPatternPredicate6, // (Subtarget->hasHalfPrecision()) && (Subtarget->hasSIMD128())
/* 22886*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F16x8),
                    MVT::v8f16, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v8f16] } (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETOLE:{ *:[Other] }), V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 22893*/     0, /*End of Scope*/
/* 22894*/    /*Scope*/ 33, /*->22928*/
/* 22895*/     OPC_CheckChild2CondCode, ISD::SETOGT,
/* 22897*/     OPC_MoveParent,
/* 22898*/     OPC_CheckType, MVT::v8f16,
/* 22900*/     OPC_Scope, 12, /*->22914*/ // 2 children in Scope
/* 22902*/      OPC_CheckChild1Same, 1,
/* 22904*/      OPC_CheckChild2Same, 0,
/* 22906*/      OPC_CheckPatternPredicate6, // (Subtarget->hasHalfPrecision()) && (Subtarget->hasSIMD128())
/* 22907*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F16x8),
                    MVT::v8f16, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v8f16] } (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETOGT:{ *:[Other] }), V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 22914*/     /*Scope*/ 12, /*->22927*/
/* 22915*/      OPC_CheckChild1Same, 0,
/* 22917*/      OPC_CheckChild2Same, 1,
/* 22919*/      OPC_CheckPatternPredicate6, // (Subtarget->hasHalfPrecision()) && (Subtarget->hasSIMD128())
/* 22920*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F16x8),
                    MVT::v8f16, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v8f16] } (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs, SETOGT:{ *:[Other] }), V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 22927*/     0, /*End of Scope*/
/* 22928*/    /*Scope*/ 33, /*->22962*/
/* 22929*/     OPC_CheckChild2CondCode, ISD::SETOGE,
/* 22931*/     OPC_MoveParent,
/* 22932*/     OPC_CheckType, MVT::v8f16,
/* 22934*/     OPC_Scope, 12, /*->22948*/ // 2 children in Scope
/* 22936*/      OPC_CheckChild1Same, 1,
/* 22938*/      OPC_CheckChild2Same, 0,
/* 22940*/      OPC_CheckPatternPredicate6, // (Subtarget->hasHalfPrecision()) && (Subtarget->hasSIMD128())
/* 22941*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F16x8),
                    MVT::v8f16, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v8f16] } (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETOGE:{ *:[Other] }), V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 22948*/     /*Scope*/ 12, /*->22961*/
/* 22949*/      OPC_CheckChild1Same, 0,
/* 22951*/      OPC_CheckChild2Same, 1,
/* 22953*/      OPC_CheckPatternPredicate6, // (Subtarget->hasHalfPrecision()) && (Subtarget->hasSIMD128())
/* 22954*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F16x8),
                    MVT::v8f16, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v8f16] } (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs, SETOGE:{ *:[Other] }), V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 22961*/     0, /*End of Scope*/
/* 22962*/    0, /*End of Scope*/
/* 22963*/   0, /*End of Scope*/
/* 22964*/  /*Scope*/ 25, /*->22990*/
/* 22965*/   OPC_RecordChild0, // #0 = $c
/* 22966*/   OPC_RecordChild1, // #1 = $v1
/* 22967*/   OPC_RecordChild2, // #2 = $v2
/* 22968*/   OPC_SwitchType /*2 cases */, 8, MVT::v4f32,// ->22979
/* 22971*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v4f32, 3/*#Ops*/, 1, 2, 0, 
              // Src: (vselect:{ *:[v4f32] } V128:{ *:[v4i32] }:$c, V128:{ *:[v4f32] }:$v1, V128:{ *:[v4f32] }:$v2) - Complexity = 3
              // Dst: (BITSELECT:{ *:[v4f32] } ?:{ *:[v4f32] }:$v1, ?:{ *:[v4f32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 22979*/   /*SwitchType*/ 8, MVT::v2f64,// ->22989
/* 22981*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v2f64, 3/*#Ops*/, 1, 2, 0, 
              // Src: (vselect:{ *:[v2f64] } V128:{ *:[v2i64] }:$c, V128:{ *:[v2f64] }:$v1, V128:{ *:[v2f64] }:$v2) - Complexity = 3
              // Dst: (BITSELECT:{ *:[v2f64] } ?:{ *:[v2f64] }:$v1, ?:{ *:[v2f64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 22989*/   0, // EndSwitchType
/* 22990*/  0, /*End of Scope*/
/* 22991*/ /*SwitchOpcode*/ 16, TARGET_VAL(WebAssemblyISD::SWIZZLE),// ->23010
/* 22994*/  OPC_RecordChild0, // #0 = $src
/* 22995*/  OPC_CheckChild0Type, MVT::v16i8,
/* 22997*/  OPC_RecordChild1, // #1 = $mask
/* 22998*/  OPC_CheckChild1Type, MVT::v16i8,
/* 23000*/  OPC_CheckType, MVT::v16i8,
/* 23002*/  OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23003*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SWIZZLE),
                MVT::v16i8, 2/*#Ops*/, 0, 1, 
            // Src: (wasm_swizzle:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, V128:{ *:[v16i8] }:$mask) - Complexity = 3
            // Dst: (SWIZZLE:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, V128:{ *:[v16i8] }:$mask)
/* 23010*/ /*SwitchOpcode*/ 39, TARGET_VAL(ISD::ABS),// ->23052
/* 23013*/  OPC_RecordChild0, // #0 = $v
/* 23014*/  OPC_SwitchType /*4 cases */, 7, MVT::v16i8,// ->23024
/* 23017*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23018*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ABS_I8x16),
                 MVT::v16i8, 1/*#Ops*/, 0, 
             // Src: (abs:{ *:[v16i8] } V128:{ *:[v16i8] }:$v) - Complexity = 3
             // Dst: (ABS_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$v)
/* 23024*/  /*SwitchType*/ 7, MVT::v8i16,// ->23033
/* 23026*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23027*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ABS_I16x8),
                 MVT::v8i16, 1/*#Ops*/, 0, 
             // Src: (abs:{ *:[v8i16] } V128:{ *:[v8i16] }:$v) - Complexity = 3
             // Dst: (ABS_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$v)
/* 23033*/  /*SwitchType*/ 7, MVT::v4i32,// ->23042
/* 23035*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23036*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ABS_I32x4),
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (abs:{ *:[v4i32] } V128:{ *:[v4i32] }:$v) - Complexity = 3
             // Dst: (ABS_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$v)
/* 23042*/  /*SwitchType*/ 7, MVT::v2i64,// ->23051
/* 23044*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23045*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ABS_I64x2),
                 MVT::v2i64, 1/*#Ops*/, 0, 
             // Src: (abs:{ *:[v2i64] } V128:{ *:[v2i64] }:$v) - Complexity = 3
             // Dst: (ABS_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$v)
/* 23051*/  0, // EndSwitchType
/* 23052*/ /*SwitchOpcode*/ 24, TARGET_VAL(ISD::SADDSAT),// ->23079
/* 23055*/  OPC_RecordChild0, // #0 = $lhs
/* 23056*/  OPC_RecordChild1, // #1 = $rhs
/* 23057*/  OPC_SwitchType /*2 cases */, 8, MVT::v16i8,// ->23068
/* 23060*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23061*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_SAT_S_I8x16),
                 MVT::v16i8, 2/*#Ops*/, 0, 1, 
             // Src: (saddsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
             // Dst: (ADD_SAT_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 23068*/  /*SwitchType*/ 8, MVT::v8i16,// ->23078
/* 23070*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23071*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_SAT_S_I16x8),
                 MVT::v8i16, 2/*#Ops*/, 0, 1, 
             // Src: (saddsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
             // Dst: (ADD_SAT_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 23078*/  0, // EndSwitchType
/* 23079*/ /*SwitchOpcode*/ 24, TARGET_VAL(ISD::UADDSAT),// ->23106
/* 23082*/  OPC_RecordChild0, // #0 = $lhs
/* 23083*/  OPC_RecordChild1, // #1 = $rhs
/* 23084*/  OPC_SwitchType /*2 cases */, 8, MVT::v16i8,// ->23095
/* 23087*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23088*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_SAT_U_I8x16),
                 MVT::v16i8, 2/*#Ops*/, 0, 1, 
             // Src: (uaddsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
             // Dst: (ADD_SAT_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 23095*/  /*SwitchType*/ 8, MVT::v8i16,// ->23105
/* 23097*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23098*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_SAT_U_I16x8),
                 MVT::v8i16, 2/*#Ops*/, 0, 1, 
             // Src: (uaddsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
             // Dst: (ADD_SAT_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 23105*/  0, // EndSwitchType
/* 23106*/ /*SwitchOpcode*/ 34, TARGET_VAL(ISD::SMIN),// ->23143
/* 23109*/  OPC_RecordChild0, // #0 = $lhs
/* 23110*/  OPC_RecordChild1, // #1 = $rhs
/* 23111*/  OPC_SwitchType /*3 cases */, 8, MVT::v16i8,// ->23122
/* 23114*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23115*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_S_I8x16),
                 MVT::v16i8, 2/*#Ops*/, 0, 1, 
             // Src: (smin:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
             // Dst: (MIN_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 23122*/  /*SwitchType*/ 8, MVT::v8i16,// ->23132
/* 23124*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23125*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_S_I16x8),
                 MVT::v8i16, 2/*#Ops*/, 0, 1, 
             // Src: (smin:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
             // Dst: (MIN_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 23132*/  /*SwitchType*/ 8, MVT::v4i32,// ->23142
/* 23134*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23135*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_S_I32x4),
                 MVT::v4i32, 2/*#Ops*/, 0, 1, 
             // Src: (smin:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
             // Dst: (MIN_S_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 23142*/  0, // EndSwitchType
/* 23143*/ /*SwitchOpcode*/ 34, TARGET_VAL(ISD::UMIN),// ->23180
/* 23146*/  OPC_RecordChild0, // #0 = $lhs
/* 23147*/  OPC_RecordChild1, // #1 = $rhs
/* 23148*/  OPC_SwitchType /*3 cases */, 8, MVT::v16i8,// ->23159
/* 23151*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23152*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_U_I8x16),
                 MVT::v16i8, 2/*#Ops*/, 0, 1, 
             // Src: (umin:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
             // Dst: (MIN_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 23159*/  /*SwitchType*/ 8, MVT::v8i16,// ->23169
/* 23161*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23162*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_U_I16x8),
                 MVT::v8i16, 2/*#Ops*/, 0, 1, 
             // Src: (umin:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
             // Dst: (MIN_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 23169*/  /*SwitchType*/ 8, MVT::v4i32,// ->23179
/* 23171*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23172*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_U_I32x4),
                 MVT::v4i32, 2/*#Ops*/, 0, 1, 
             // Src: (umin:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
             // Dst: (MIN_U_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 23179*/  0, // EndSwitchType
/* 23180*/ /*SwitchOpcode*/ 34, TARGET_VAL(ISD::SMAX),// ->23217
/* 23183*/  OPC_RecordChild0, // #0 = $lhs
/* 23184*/  OPC_RecordChild1, // #1 = $rhs
/* 23185*/  OPC_SwitchType /*3 cases */, 8, MVT::v16i8,// ->23196
/* 23188*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23189*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_S_I8x16),
                 MVT::v16i8, 2/*#Ops*/, 0, 1, 
             // Src: (smax:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
             // Dst: (MAX_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 23196*/  /*SwitchType*/ 8, MVT::v8i16,// ->23206
/* 23198*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23199*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_S_I16x8),
                 MVT::v8i16, 2/*#Ops*/, 0, 1, 
             // Src: (smax:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
             // Dst: (MAX_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 23206*/  /*SwitchType*/ 8, MVT::v4i32,// ->23216
/* 23208*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23209*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_S_I32x4),
                 MVT::v4i32, 2/*#Ops*/, 0, 1, 
             // Src: (smax:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
             // Dst: (MAX_S_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 23216*/  0, // EndSwitchType
/* 23217*/ /*SwitchOpcode*/ 34, TARGET_VAL(ISD::UMAX),// ->23254
/* 23220*/  OPC_RecordChild0, // #0 = $lhs
/* 23221*/  OPC_RecordChild1, // #1 = $rhs
/* 23222*/  OPC_SwitchType /*3 cases */, 8, MVT::v16i8,// ->23233
/* 23225*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23226*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_U_I8x16),
                 MVT::v16i8, 2/*#Ops*/, 0, 1, 
             // Src: (umax:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
             // Dst: (MAX_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 23233*/  /*SwitchType*/ 8, MVT::v8i16,// ->23243
/* 23235*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23236*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_U_I16x8),
                 MVT::v8i16, 2/*#Ops*/, 0, 1, 
             // Src: (umax:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
             // Dst: (MAX_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 23243*/  /*SwitchType*/ 8, MVT::v4i32,// ->23253
/* 23245*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23246*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_U_I32x4),
                 MVT::v4i32, 2/*#Ops*/, 0, 1, 
             // Src: (umax:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
             // Dst: (MAX_U_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 23253*/  0, // EndSwitchType
/* 23254*/ /*SwitchOpcode*/ 12, TARGET_VAL(WebAssemblyISD::TRUNC_SAT_ZERO_S),// ->23269
/* 23257*/  OPC_RecordChild0, // #0 = $vec
/* 23258*/  OPC_CheckChild0Type, MVT::v2f64,
/* 23260*/  OPC_CheckType, MVT::v4i32,
/* 23262*/  OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23263*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::trunc_sat_zero_s_I32x4),
                MVT::v4i32, 1/*#Ops*/, 0, 
            // Src: (trunc_sat_zero_s:{ *:[v4i32] } V128:{ *:[v2f64] }:$vec) - Complexity = 3
            // Dst: (trunc_sat_zero_s_I32x4:{ *:[v4i32] } V128:{ *:[v2f64] }:$vec)
/* 23269*/ /*SwitchOpcode*/ 12, TARGET_VAL(WebAssemblyISD::TRUNC_SAT_ZERO_U),// ->23284
/* 23272*/  OPC_RecordChild0, // #0 = $vec
/* 23273*/  OPC_CheckChild0Type, MVT::v2f64,
/* 23275*/  OPC_CheckType, MVT::v4i32,
/* 23277*/  OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23278*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::trunc_sat_zero_u_I32x4),
                MVT::v4i32, 1/*#Ops*/, 0, 
            // Src: (trunc_sat_zero_u:{ *:[v4i32] } V128:{ *:[v2f64] }:$vec) - Complexity = 3
            // Dst: (trunc_sat_zero_u_I32x4:{ *:[v4i32] } V128:{ *:[v2f64] }:$vec)
/* 23284*/ /*SwitchOpcode*/ 36, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_S),// ->23323
/* 23287*/  OPC_RecordChild0, // #0 = $vec
/* 23288*/  OPC_SwitchType /*3 cases */, 9, MVT::v8i16,// ->23300
/* 23291*/   OPC_CheckChild0Type, MVT::v16i8,
/* 23293*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23294*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_low_s_I16x8),
                 MVT::v8i16, 1/*#Ops*/, 0, 
             // Src: (extend_low_s:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec) - Complexity = 3
             // Dst: (extend_low_s_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec)
/* 23300*/  /*SwitchType*/ 9, MVT::v4i32,// ->23311
/* 23302*/   OPC_CheckChild0Type, MVT::v8i16,
/* 23304*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23305*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_low_s_I32x4),
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (extend_low_s:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec) - Complexity = 3
             // Dst: (extend_low_s_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec)
/* 23311*/  /*SwitchType*/ 9, MVT::v2i64,// ->23322
/* 23313*/   OPC_CheckChild0Type, MVT::v4i32,
/* 23315*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23316*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_low_s_I64x2),
                 MVT::v2i64, 1/*#Ops*/, 0, 
             // Src: (extend_low_s:{ *:[v2i64] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
             // Dst: (extend_low_s_I64x2:{ *:[v2i64] } V128:{ *:[v4i32] }:$vec)
/* 23322*/  0, // EndSwitchType
/* 23323*/ /*SwitchOpcode*/ 36, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_S),// ->23362
/* 23326*/  OPC_RecordChild0, // #0 = $vec
/* 23327*/  OPC_SwitchType /*3 cases */, 9, MVT::v8i16,// ->23339
/* 23330*/   OPC_CheckChild0Type, MVT::v16i8,
/* 23332*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23333*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_high_s_I16x8),
                 MVT::v8i16, 1/*#Ops*/, 0, 
             // Src: (extend_high_s:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec) - Complexity = 3
             // Dst: (extend_high_s_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec)
/* 23339*/  /*SwitchType*/ 9, MVT::v4i32,// ->23350
/* 23341*/   OPC_CheckChild0Type, MVT::v8i16,
/* 23343*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23344*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_high_s_I32x4),
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (extend_high_s:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec) - Complexity = 3
             // Dst: (extend_high_s_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec)
/* 23350*/  /*SwitchType*/ 9, MVT::v2i64,// ->23361
/* 23352*/   OPC_CheckChild0Type, MVT::v4i32,
/* 23354*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23355*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_high_s_I64x2),
                 MVT::v2i64, 1/*#Ops*/, 0, 
             // Src: (extend_high_s:{ *:[v2i64] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
             // Dst: (extend_high_s_I64x2:{ *:[v2i64] } V128:{ *:[v4i32] }:$vec)
/* 23361*/  0, // EndSwitchType
/* 23362*/ /*SwitchOpcode*/ 36, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_U),// ->23401
/* 23365*/  OPC_RecordChild0, // #0 = $vec
/* 23366*/  OPC_SwitchType /*3 cases */, 9, MVT::v8i16,// ->23378
/* 23369*/   OPC_CheckChild0Type, MVT::v16i8,
/* 23371*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23372*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_low_u_I16x8),
                 MVT::v8i16, 1/*#Ops*/, 0, 
             // Src: (extend_low_u:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec) - Complexity = 3
             // Dst: (extend_low_u_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec)
/* 23378*/  /*SwitchType*/ 9, MVT::v4i32,// ->23389
/* 23380*/   OPC_CheckChild0Type, MVT::v8i16,
/* 23382*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23383*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_low_u_I32x4),
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (extend_low_u:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec) - Complexity = 3
             // Dst: (extend_low_u_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec)
/* 23389*/  /*SwitchType*/ 9, MVT::v2i64,// ->23400
/* 23391*/   OPC_CheckChild0Type, MVT::v4i32,
/* 23393*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23394*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_low_u_I64x2),
                 MVT::v2i64, 1/*#Ops*/, 0, 
             // Src: (extend_low_u:{ *:[v2i64] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
             // Dst: (extend_low_u_I64x2:{ *:[v2i64] } V128:{ *:[v4i32] }:$vec)
/* 23400*/  0, // EndSwitchType
/* 23401*/ /*SwitchOpcode*/ 36, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_U),// ->23440
/* 23404*/  OPC_RecordChild0, // #0 = $vec
/* 23405*/  OPC_SwitchType /*3 cases */, 9, MVT::v8i16,// ->23417
/* 23408*/   OPC_CheckChild0Type, MVT::v16i8,
/* 23410*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23411*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_high_u_I16x8),
                 MVT::v8i16, 1/*#Ops*/, 0, 
             // Src: (extend_high_u:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec) - Complexity = 3
             // Dst: (extend_high_u_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec)
/* 23417*/  /*SwitchType*/ 9, MVT::v4i32,// ->23428
/* 23419*/   OPC_CheckChild0Type, MVT::v8i16,
/* 23421*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23422*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_high_u_I32x4),
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (extend_high_u:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec) - Complexity = 3
             // Dst: (extend_high_u_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec)
/* 23428*/  /*SwitchType*/ 9, MVT::v2i64,// ->23439
/* 23430*/   OPC_CheckChild0Type, MVT::v4i32,
/* 23432*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23433*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_high_u_I64x2),
                 MVT::v2i64, 1/*#Ops*/, 0, 
             // Src: (extend_high_u:{ *:[v2i64] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
             // Dst: (extend_high_u_I64x2:{ *:[v2i64] } V128:{ *:[v4i32] }:$vec)
/* 23439*/  0, // EndSwitchType
/* 23440*/ /*SwitchOpcode*/ 31, TARGET_VAL(WebAssemblyISD::NARROW_U),// ->23474
/* 23443*/  OPC_RecordChild0, // #0 = $left
/* 23444*/  OPC_SwitchType /*2 cases */, 12, MVT::v16i8,// ->23459
/* 23447*/   OPC_CheckChild0Type, MVT::v8i16,
/* 23449*/   OPC_RecordChild1, // #1 = $right
/* 23450*/   OPC_CheckChild1Type, MVT::v8i16,
/* 23452*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NARROW_U_I8x16),
                 MVT::v16i8, 2/*#Ops*/, 0, 1, 
             // Src: (wasm_narrow_u:{ *:[v16i8] } V128:{ *:[v8i16] }:$left, V128:{ *:[v8i16] }:$right) - Complexity = 3
             // Dst: (NARROW_U_I8x16:{ *:[v16i8] } ?:{ *:[v8i16] }:$left, ?:{ *:[v8i16] }:$right)
/* 23459*/  /*SwitchType*/ 12, MVT::v8i16,// ->23473
/* 23461*/   OPC_CheckChild0Type, MVT::v4i32,
/* 23463*/   OPC_RecordChild1, // #1 = $right
/* 23464*/   OPC_CheckChild1Type, MVT::v4i32,
/* 23466*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NARROW_U_I16x8),
                 MVT::v8i16, 2/*#Ops*/, 0, 1, 
             // Src: (wasm_narrow_u:{ *:[v8i16] } V128:{ *:[v4i32] }:$left, V128:{ *:[v4i32] }:$right) - Complexity = 3
             // Dst: (NARROW_U_I16x8:{ *:[v8i16] } ?:{ *:[v4i32] }:$left, ?:{ *:[v4i32] }:$right)
/* 23473*/  0, // EndSwitchType
/* 23474*/ /*SwitchOpcode*/ 12, TARGET_VAL(WebAssemblyISD::CONVERT_LOW_S),// ->23489
/* 23477*/  OPC_RecordChild0, // #0 = $vec
/* 23478*/  OPC_CheckChild0Type, MVT::v4i32,
/* 23480*/  OPC_CheckType, MVT::v2f64,
/* 23482*/  OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23483*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::convert_low_s_F64x2),
                MVT::v2f64, 1/*#Ops*/, 0, 
            // Src: (convert_low_s:{ *:[v2f64] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
            // Dst: (convert_low_s_F64x2:{ *:[v2f64] } V128:{ *:[v4i32] }:$vec)
/* 23489*/ /*SwitchOpcode*/ 12, TARGET_VAL(WebAssemblyISD::CONVERT_LOW_U),// ->23504
/* 23492*/  OPC_RecordChild0, // #0 = $vec
/* 23493*/  OPC_CheckChild0Type, MVT::v4i32,
/* 23495*/  OPC_CheckType, MVT::v2f64,
/* 23497*/  OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23498*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::convert_low_u_F64x2),
                MVT::v2f64, 1/*#Ops*/, 0, 
            // Src: (convert_low_u:{ *:[v2f64] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
            // Dst: (convert_low_u_F64x2:{ *:[v2f64] } V128:{ *:[v4i32] }:$vec)
/* 23504*/ /*SwitchOpcode*/ 12, TARGET_VAL(WebAssemblyISD::DEMOTE_ZERO),// ->23519
/* 23507*/  OPC_RecordChild0, // #0 = $vec
/* 23508*/  OPC_CheckChild0Type, MVT::v2f64,
/* 23510*/  OPC_CheckType, MVT::v4f32,
/* 23512*/  OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23513*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::demote_zero_F32x4),
                MVT::v4f32, 1/*#Ops*/, 0, 
            // Src: (demote_zero:{ *:[v4f32] } V128:{ *:[v2f64] }:$vec) - Complexity = 3
            // Dst: (demote_zero_F32x4:{ *:[v4f32] } V128:{ *:[v2f64] }:$vec)
/* 23519*/ /*SwitchOpcode*/ 12, TARGET_VAL(WebAssemblyISD::PROMOTE_LOW),// ->23534
/* 23522*/  OPC_RecordChild0, // #0 = $vec
/* 23523*/  OPC_CheckChild0Type, MVT::v4f32,
/* 23525*/  OPC_CheckType, MVT::v2f64,
/* 23527*/  OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23528*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::promote_low_F64x2),
                MVT::v2f64, 1/*#Ops*/, 0, 
            // Src: (promote_low:{ *:[v2f64] } V128:{ *:[v4f32] }:$vec) - Complexity = 3
            // Dst: (promote_low_F64x2:{ *:[v2f64] } V128:{ *:[v4f32] }:$vec)
/* 23534*/ 0, // EndSwitchOpcode
    0
  }; // Total Array size is 23536 bytes

  // Opcode Histogram:
  // #OPC_Scope                                = 342
  // #OPC_RecordNode                           = 285
  // #OPC_RecordChild                          = 740
  // #OPC_RecordMemRef                         = 41
  // #OPC_CaptureGlueInput                     = 1
  // #OPC_MoveChild                            = 294
  // #OPC_MoveSibling                          = 285
  // #OPC_MoveParent                           = 580
  // #OPC_CheckSame                            = 0
  // #OPC_CheckChildSame                       = 147
  // #OPC_CheckPatternPredicate                = 713
  // #OPC_CheckPredicate                       = 532
  // #OPC_CheckOpcode                          = 503
  // #OPC_SwitchOpcode                         = 15
  // #OPC_CheckType                            = 522
  // #OPC_SwitchType                           = 178
  // #OPC_CheckChildType                       = 456
  // #OPC_CheckInteger                         = 0
  // #OPC_CheckChildInteger                    = 107
  // #OPC_CheckCondCode                        = 0
  // #OPC_CheckChild2CondCode                  = 153
  // #OPC_CheckValueType                       = 15
  // #OPC_CheckComplexPat                      = 322
  // #OPC_CheckAndImm                          = 27
  // #OPC_CheckOrImm                           = 0
  // #OPC_CheckImmAllOnesV                     = 44
  // #OPC_CheckImmAllZerosV                    = 1
  // #OPC_CheckFoldableChainNode               = 5
  // #OPC_EmitInteger                          = 349
  // #OPC_EmitStringInteger                    = 0
  // #OPC_EmitRegister                         = 0
  // #OPC_EmitConvertToTarget                  = 311
  // #OPC_EmitMergeInputChains                 = 432
  // #OPC_EmitCopyToReg                        = 0
  // #OPC_EmitNode                             = 9
  // #OPC_EmitNodeXForm                        = 0
  // #OPC_CompleteMatch                        = 32
  // #OPC_MorphNodeTo                          = 1211

  #undef TARGET_VAL
  SelectCodeCommon(N, MatcherTable, sizeof(MatcherTable));
}
#endif // GET_DAGISEL_BODY

#ifdef GET_DAGISEL_DECL
bool CheckPatternPredicate(unsigned PredNo) const override;
#endif
#if defined(GET_DAGISEL_BODY) || DAGISEL_INLINE
bool DAGISEL_CLASS_COLONCOLON CheckPatternPredicate(unsigned PredNo) const
#if DAGISEL_INLINE
  override
#endif
{
  switch (PredNo) {
  default: llvm_unreachable("Invalid predicate in table?");
  case 0: return (Subtarget->hasSIMD128());
  case 1: return (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics());
  case 2: return (Subtarget->hasAddr64()) && (Subtarget->hasAtomics());
  case 3: return (!Subtarget->hasAddr64());
  case 4: return (Subtarget->hasAddr64());
  case 5: return (Subtarget->hasReferenceTypes());
  case 6: return (Subtarget->hasHalfPrecision()) && (Subtarget->hasSIMD128());
  case 7: return (Subtarget->hasRelaxedSIMD());
  case 8: return (Subtarget->hasExceptionHandling()) && (Subtarget->hasReferenceTypes());
  case 9: return (Subtarget->hasNontrappingFPToInt());
  case 10: return (!Subtarget->hasNontrappingFPToInt());
  case 11: return (Subtarget->hasSignExt());
  case 12: return (Subtarget->hasBulkMemory());
  case 13: return (Subtarget->hasRelaxedSIMD()) && (Subtarget->hasSIMD128());
  case 14: return (!Subtarget->hasAddr64()) && (TM.isPositionIndependent());
  case 15: return (Subtarget->hasAddr64()) && (TM.isPositionIndependent());
  case 16: return (Subtarget->hasExceptionHandling());
  case 17: return (Subtarget->hasHalfPrecision());
  case 18: return (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent());
  case 19: return (Subtarget->hasAddr64()) && (!TM.isPositionIndependent());
  }
}
#endif // GET_DAGISEL_BODY

#ifdef GET_DAGISEL_DECL
bool CheckNodePredicate(SDNode *Node, unsigned PredNo) const override;
#endif
#if defined(GET_DAGISEL_BODY) || DAGISEL_INLINE
bool DAGISEL_CLASS_COLONCOLON CheckNodePredicate(SDNode *Node, unsigned PredNo) const
#if DAGISEL_INLINE
  override
#endif
{
  switch (PredNo) {
  default: llvm_unreachable("Invalid predicate in table?");
  case 0: {
    // Predicate_LaneIdx32
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return 0 <= Imm && Imm < 32;
  }
  case 1: {
    // Predicate_atomic_cmp_swap_i8
    // Predicate_atomic_load_8
    // Predicate_atomic_load_add_i8
    // Predicate_atomic_load_and_i8
    // Predicate_atomic_load_or_i8
    // Predicate_atomic_load_sub_i8
    // Predicate_atomic_load_xor_i8
    // Predicate_atomic_store_8
    // Predicate_atomic_swap_i8
    // Predicate_extloadi8
    // Predicate_sextloadi8
    // Predicate_zextloadi8
    SDNode *N = Node;
    (void)N;
if (cast<MemSDNode>(N)->getMemoryVT() != MVT::i8) return false;
return true;

  }
  case 2: {
    // Predicate_atomic_cmp_swap_i16
    // Predicate_atomic_load_16
    // Predicate_atomic_load_add_i16
    // Predicate_atomic_load_and_i16
    // Predicate_atomic_load_or_i16
    // Predicate_atomic_load_sub_i16
    // Predicate_atomic_load_xor_i16
    // Predicate_atomic_store_16
    // Predicate_atomic_swap_i16
    // Predicate_extloadi16
    // Predicate_sextloadi16
    // Predicate_zextloadi16
    SDNode *N = Node;
    (void)N;
if (cast<MemSDNode>(N)->getMemoryVT() != MVT::i16) return false;
return true;

  }
  case 3: {
    // Predicate_atomic_cmp_swap_i32
    // Predicate_atomic_load_32
    // Predicate_atomic_load_add_i32
    // Predicate_atomic_load_and_i32
    // Predicate_atomic_load_or_i32
    // Predicate_atomic_load_sub_i32
    // Predicate_atomic_load_xor_i32
    // Predicate_atomic_store_32
    // Predicate_atomic_swap_i32
    // Predicate_extloadi32
    // Predicate_sextloadi32
    // Predicate_zextloadi32
    SDNode *N = Node;
    (void)N;
if (cast<MemSDNode>(N)->getMemoryVT() != MVT::i32) return false;
return true;

  }
  case 4: {
    // Predicate_unindexedstore
    SDNode *N = Node;
    (void)N;
if (cast<StoreSDNode>(N)->getAddressingMode() != ISD::UNINDEXED) return false;
return true;

  }
  case 5: {
    // Predicate_store
    SDNode *N = Node;
    (void)N;
 if (cast<StoreSDNode>(N)->isTruncatingStore()) return false;
return true;

  }
  case 6: {
    // Predicate_atomic_cmp_swap_i64
    // Predicate_atomic_load_64
    // Predicate_atomic_load_add_i64
    // Predicate_atomic_load_and_i64
    // Predicate_atomic_load_or_i64
    // Predicate_atomic_load_sub_i64
    // Predicate_atomic_load_xor_i64
    // Predicate_atomic_store_64
    // Predicate_atomic_swap_i64
    SDNode *N = Node;
    (void)N;
if (cast<MemSDNode>(N)->getMemoryVT() != MVT::i64) return false;
return true;

  }
  case 7: {
    // Predicate_load
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getExtensionType() != ISD::NON_EXTLOAD) return false;
return true;

  }
  case 8: {
    // Predicate_ImmI8
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return -(1 << (8 - 1)) <= Imm && Imm < (1 << 8);
  }
  case 9: {
    // Predicate_unindexedload
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getAddressingMode() != ISD::UNINDEXED) return false;
return true;

  }
  case 10: {
    // Predicate_extload
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getExtensionType() != ISD::EXTLOAD) return false;
return true;

  }
  case 11: {
    // Predicate_LaneIdx16
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return 0 <= Imm && Imm < 16;
  }
  case 12: {
    // Predicate_truncstore
    SDNode *N = Node;
    (void)N;
 if (!cast<StoreSDNode>(N)->isTruncatingStore()) return false;
return true;

  }
  case 13: {
    // Predicate_sextload
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getExtensionType() != ISD::SEXTLOAD) return false;
return true;

  }
  case 14: {
    // Predicate_zextload
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getExtensionType() != ISD::ZEXTLOAD) return false;
return true;

  }
  case 15: {
    // Predicate_ImmI16
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return -(1 << (16 - 1)) <= Imm && Imm < (1 << 16);
  }
  case 16: {
    // Predicate_LaneIdx8
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return 0 <= Imm && Imm < 8;
  }
  case 17: {
    // Predicate_LaneIdx4
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return 0 <= Imm && Imm < 4;
  }
  case 18: {
    // Predicate_LaneIdx2
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return 0 <= Imm && Imm < 2;
  }
  case 19: {
    // Predicate_truncstorei8
    SDNode *N = Node;
    (void)N;
if (cast<MemSDNode>(N)->getMemoryVT() != MVT::i8) return false;
 if (!cast<StoreSDNode>(N)->isTruncatingStore()) return false;
return true;

  }
  case 20: {
    // Predicate_truncstorei16
    SDNode *N = Node;
    (void)N;
if (cast<MemSDNode>(N)->getMemoryVT() != MVT::i16) return false;
 if (!cast<StoreSDNode>(N)->isTruncatingStore()) return false;
return true;

  }
  case 21: {
    // Predicate_extloadvi8
    // Predicate_sextloadvi8
    // Predicate_zextloadvi8
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getMemoryVT().getScalarType() != MVT::i8) return false;
return true;

  }
  case 22: {
    // Predicate_extloadvi16
    // Predicate_sextloadvi16
    // Predicate_zextloadvi16
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getMemoryVT().getScalarType() != MVT::i16) return false;
return true;

  }
  case 23: {
    // Predicate_extloadvi32
    // Predicate_sextloadvi32
    // Predicate_zextloadvi32
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getMemoryVT().getScalarType() != MVT::i32) return false;
return true;

  }
  case 24: {
    // Predicate_add_nuw
    SDNode *N = Node;
    (void)N;
return N->getFlags().hasNoUnsignedWrap();
  }
  case 25: {
    // Predicate_truncstorei32
    SDNode *N = Node;
    (void)N;
if (cast<MemSDNode>(N)->getMemoryVT() != MVT::i32) return false;
 if (!cast<StoreSDNode>(N)->isTruncatingStore()) return false;
return true;

  }
  case 26: {
    // Predicate_bool_node
    SDNode *N = Node;
    (void)N;

  return CurDAG->computeKnownBits(SDValue(N, 0)).countMinLeadingZeros() == 31;

  }
  }
}
#endif // GET_DAGISEL_BODY

#ifdef GET_DAGISEL_DECL
bool CheckComplexPattern(SDNode *Root, SDNode *Parent,
      SDValue N, unsigned PatternNo,
      SmallVectorImpl<std::pair<SDValue, SDNode *>> &Result) override;
#endif
#if defined(GET_DAGISEL_BODY) || DAGISEL_INLINE
bool DAGISEL_CLASS_COLONCOLON CheckComplexPattern(SDNode *Root, SDNode *Parent,
      SDValue N, unsigned PatternNo,
      SmallVectorImpl<std::pair<SDValue, SDNode *>> &Result)
#if DAGISEL_INLINE
  override
#endif
{
  unsigned NextRes = Result.size();
  switch (PatternNo) {
  default: llvm_unreachable("Invalid pattern # in table?");
  case 0:
    Result.resize(NextRes+2);
  return SelectAddrOperands32(N, Result[NextRes+0].first, Result[NextRes+1].first);
  case 1:
    Result.resize(NextRes+2);
  return SelectAddrOperands64(N, Result[NextRes+0].first, Result[NextRes+1].first);
  }
}
#endif // GET_DAGISEL_BODY


#ifdef DAGISEL_INLINE
#undef DAGISEL_INLINE
#endif
#ifdef DAGISEL_CLASS_COLONCOLON
#undef DAGISEL_CLASS_COLONCOLON
#endif
#ifdef GET_DAGISEL_DECL
#undef GET_DAGISEL_DECL
#endif
#ifdef GET_DAGISEL_BODY
#undef GET_DAGISEL_BODY
#endif
